/* avatar-details.c generated by valac 0.56.17, the Vala compiler
 * generated from avatar-details.vala, do not modify */

/*
 * Copyright (C) 2010 Collabora Ltd.
 * Copyright (C) 2011 Philip Withnall
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 *       Philip Withnall <philip@tecnocode.co.uk>
 */

#include "folks/folks.h"
#include <gio/gio.h>
#include <glib.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _FolksAvatarDetailsChangeAvatarData FolksAvatarDetailsChangeAvatarData;

struct _FolksAvatarDetailsChangeAvatarData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksAvatarDetails* self;
	GLoadableIcon* avatar;
	GError* _tmp0_;
	GError* _inner_error0_;
};

static void folks_avatar_details_real_change_avatar_data_free (gpointer _data);
static void folks_avatar_details_real_change_avatar (FolksAvatarDetails* self,
                                              GLoadableIcon* avatar,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static gboolean folks_avatar_details_real_change_avatar_co (FolksAvatarDetailsChangeAvatarData* _data_);
static GType folks_avatar_details_get_type_once (void);

static void
folks_avatar_details_real_change_avatar_data_free (gpointer _data)
{
	FolksAvatarDetailsChangeAvatarData* _data_;
	_data_ = _data;
#line 33 "../folks/avatar-details.vala"
	_g_object_unref0 (_data_->avatar);
#line 33 "../folks/avatar-details.vala"
	_g_object_unref0 (_data_->self);
#line 33 "../folks/avatar-details.vala"
	g_slice_free (FolksAvatarDetailsChangeAvatarData, _data_);
#line 74 "avatar-details.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 33 "../folks/avatar-details.vala"
	return self ? g_object_ref (self) : NULL;
#line 82 "avatar-details.c"
}

static void
folks_avatar_details_real_change_avatar (FolksAvatarDetails* self,
                                         GLoadableIcon* avatar,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	FolksAvatarDetailsChangeAvatarData* _data_;
	FolksAvatarDetails* _tmp0_;
	GLoadableIcon* _tmp1_;
#line 33 "../folks/avatar-details.vala"
	_data_ = g_slice_new0 (FolksAvatarDetailsChangeAvatarData);
#line 33 "../folks/avatar-details.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 33 "../folks/avatar-details.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_avatar_details_real_change_avatar_data_free);
#line 33 "../folks/avatar-details.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 33 "../folks/avatar-details.vala"
	_data_->self = _tmp0_;
#line 33 "../folks/avatar-details.vala"
	_tmp1_ = _g_object_ref0 (avatar);
#line 33 "../folks/avatar-details.vala"
	_g_object_unref0 (_data_->avatar);
#line 33 "../folks/avatar-details.vala"
	_data_->avatar = _tmp1_;
#line 33 "../folks/avatar-details.vala"
	folks_avatar_details_real_change_avatar_co (_data_);
#line 112 "avatar-details.c"
}

static void
folks_avatar_details_real_change_avatar_finish (FolksAvatarDetails* self,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	FolksAvatarDetailsChangeAvatarData* _data_;
#line 33 "../folks/avatar-details.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 33 "../folks/avatar-details.vala"
	if (NULL == _data_) {
#line 33 "../folks/avatar-details.vala"
		return;
#line 127 "avatar-details.c"
	}
}

/**
   * Change the contact's avatar.
   *
   * It's preferred to call this rather than setting
   * {@link AvatarDetails.avatar} directly, as this method gives error
   * notification and will only return once the avatar has been written to the
   * relevant backing store (or the operation's failed).
   *
   * @param avatar the new avatar (or ``null`` to unset the avatar)
   * @throws PropertyError if setting the avatar failed
   * @since 0.6.2
   */
static gboolean
folks_avatar_details_real_change_avatar_co (FolksAvatarDetailsChangeAvatarData* _data_)
{
#line 58 "../folks/avatar-details.vala"
	switch (_data_->_state_) {
#line 58 "../folks/avatar-details.vala"
		case 0:
#line 150 "avatar-details.c"
		goto _state_0;
		default:
#line 58 "../folks/avatar-details.vala"
		g_assert_not_reached ();
#line 155 "avatar-details.c"
	}
	_state_0:
#line 62 "../folks/avatar-details.vala"
	_data_->_tmp0_ = g_error_new_literal (FOLKS_PROPERTY_ERROR, FOLKS_PROPERTY_ERROR_NOT_WRITEABLE, _ ("Avatar is not writeable on this contact."));
#line 62 "../folks/avatar-details.vala"
	_data_->_inner_error0_ = _data_->_tmp0_;
#line 62 "../folks/avatar-details.vala"
	if (_data_->_inner_error0_->domain == FOLKS_PROPERTY_ERROR) {
#line 62 "../folks/avatar-details.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 62 "../folks/avatar-details.vala"
		g_object_unref (_data_->_async_result);
#line 62 "../folks/avatar-details.vala"
		return FALSE;
#line 170 "avatar-details.c"
	} else {
#line 62 "../folks/avatar-details.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 62 "../folks/avatar-details.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 62 "../folks/avatar-details.vala"
		g_object_unref (_data_->_async_result);
#line 62 "../folks/avatar-details.vala"
		return FALSE;
#line 180 "avatar-details.c"
	}
#line 58 "../folks/avatar-details.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 58 "../folks/avatar-details.vala"
	if (_data_->_state_ != 0) {
#line 58 "../folks/avatar-details.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 58 "../folks/avatar-details.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 190 "avatar-details.c"
		}
	}
#line 58 "../folks/avatar-details.vala"
	g_object_unref (_data_->_async_result);
#line 58 "../folks/avatar-details.vala"
	return FALSE;
#line 197 "avatar-details.c"
}

void
folks_avatar_details_change_avatar (FolksAvatarDetails* self,
                                    GLoadableIcon* avatar,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	FolksAvatarDetailsIface* _iface_;
#line 33 "../folks/avatar-details.vala"
	_iface_ = FOLKS_AVATAR_DETAILS_GET_INTERFACE (self);
#line 33 "../folks/avatar-details.vala"
	if (_iface_->change_avatar) {
#line 33 "../folks/avatar-details.vala"
		_iface_->change_avatar (self, avatar, _callback_, _user_data_);
#line 213 "avatar-details.c"
	}
}

void
folks_avatar_details_change_avatar_finish (FolksAvatarDetails* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	FolksAvatarDetailsIface* _iface_;
#line 33 "../folks/avatar-details.vala"
	_iface_ = FOLKS_AVATAR_DETAILS_GET_INTERFACE (self);
#line 33 "../folks/avatar-details.vala"
	if (_iface_->change_avatar_finish) {
#line 33 "../folks/avatar-details.vala"
		_iface_->change_avatar_finish (self, _res_, error);
#line 229 "avatar-details.c"
	}
}

GLoadableIcon*
folks_avatar_details_get_avatar (FolksAvatarDetails* self)
{
	FolksAvatarDetailsIface* _iface_;
#line 44 "../folks/avatar-details.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../folks/avatar-details.vala"
	_iface_ = FOLKS_AVATAR_DETAILS_GET_INTERFACE (self);
#line 44 "../folks/avatar-details.vala"
	if (_iface_->get_avatar) {
#line 44 "../folks/avatar-details.vala"
		return _iface_->get_avatar (self);
#line 245 "avatar-details.c"
	}
#line 44 "../folks/avatar-details.vala"
	return NULL;
#line 249 "avatar-details.c"
}

void
folks_avatar_details_set_avatar (FolksAvatarDetails* self,
                                 GLoadableIcon* value)
{
	FolksAvatarDetailsIface* _iface_;
#line 44 "../folks/avatar-details.vala"
	g_return_if_fail (self != NULL);
#line 44 "../folks/avatar-details.vala"
	_iface_ = FOLKS_AVATAR_DETAILS_GET_INTERFACE (self);
#line 44 "../folks/avatar-details.vala"
	if (_iface_->set_avatar) {
#line 44 "../folks/avatar-details.vala"
		_iface_->set_avatar (self, value);
#line 265 "avatar-details.c"
	}
}

static void
folks_avatar_details_default_init (FolksAvatarDetailsIface * iface,
                                   gpointer iface_data)
{
	/**
	   * An avatar for the contact.
	   *
	   * The avatar may be ``null`` if unset. Otherwise, the image data may be
	   * asynchronously loaded using the methods of the {@link GLib.LoadableIcon}
	   * implementation.
	   *
	   * @since 0.6.0
	   */
#line 33 "../folks/avatar-details.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("avatar", "avatar", "avatar", g_loadable_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 33 "../folks/avatar-details.vala"
	iface->change_avatar = folks_avatar_details_real_change_avatar;
#line 33 "../folks/avatar-details.vala"
	iface->change_avatar_finish = folks_avatar_details_real_change_avatar_finish;
#line 288 "avatar-details.c"
}

/**
 * Avatar for a contact.
 *
 * This allows avatars to be associated with contacts. An avatar is a small
 * image file which represents the contact, such as a photo of them.
 *
 * @since 0.6.0
 */
static GType
folks_avatar_details_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksAvatarDetailsIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_avatar_details_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType folks_avatar_details_type_id;
	folks_avatar_details_type_id = g_type_register_static (G_TYPE_INTERFACE, "FolksAvatarDetails", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (folks_avatar_details_type_id, G_TYPE_OBJECT);
	return folks_avatar_details_type_id;
}

GType
folks_avatar_details_get_type (void)
{
	static volatile gsize folks_avatar_details_type_id__once = 0;
	if (g_once_init_enter (&folks_avatar_details_type_id__once)) {
		GType folks_avatar_details_type_id;
		folks_avatar_details_type_id = folks_avatar_details_get_type_once ();
		g_once_init_leave (&folks_avatar_details_type_id__once, folks_avatar_details_type_id);
	}
	return folks_avatar_details_type_id__once;
}

