/* bluez-backend.c generated by valac 0.56.17, the Vala compiler
 * generated from bluez-backend.vala, do not modify */

/*
 * Copyright (C) 2012-2013 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Arun Raghavan <arun.raghavan@collabora.co.uk>
 *       Jeremy Whiting <jeremy.whiting@collabora.com>
 *       Simon McVittie <simon.mcvittie@collabora.co.uk>
 *       Gustavo Padovan <gustavo.padovan@collabora.co.uk>
 *       Matthieu Bouron <matthieu.bouron@collabora.com>
 *       Philip Withnall <philip.withnall@collabora.co.uk>
 *
 * Based on kf-backend.vala by:
 *       Philip Withnall <philip.withnall@collabora.co.uk>
 */

#include "bluez.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include "folks/small-set.h"
#include "folks/folks.h"
#include "folks/small-set-internal.h"
#include "folks-internal.h"
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_BACKENDS_BLUE_Z_BACKEND_0_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_BACKEND_IS_PREPARED_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_BACKEND_IS_QUIESCENT_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_BACKEND_NAME_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_BACKEND_PERSONA_STORES_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_BACKEND_NUM_PROPERTIES
};
static GParamSpec* folks_backends_blue_z_backend_properties[FOLKS_BACKENDS_BLUE_Z_BACKEND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _FolksBackendsBlueZBackendAddPersonaStoreData FolksBackendsBlueZBackendAddPersonaStoreData;
typedef struct _FolksBackendsBlueZBackendRefreshDevicesData FolksBackendsBlueZBackendRefreshDevicesData;
typedef struct _FolksBackendsBlueZBackendAddDeviceData FolksBackendsBlueZBackendAddDeviceData;
typedef struct _FolksBackendsBlueZBackendRemoveDeviceData FolksBackendsBlueZBackendRemoveDeviceData;
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
typedef struct _FolksBackendsBlueZBackendSaveEnabledDevicesData FolksBackendsBlueZBackendSaveEnabledDevicesData;
typedef struct _FolksBackendsBlueZBackendLoadEnabledDevicesData FolksBackendsBlueZBackendLoadEnabledDevicesData;
#define _folks_internal_profile_block_free0(var) ((var == NULL) ? NULL : (var = (folks_internal_profile_block_free (var), NULL)))
typedef GType (*FolksBackendsBlueZBackendTypeFunc) (gpointer user_data);
typedef struct _FolksBackendsBlueZBackendPrepareData FolksBackendsBlueZBackendPrepareData;
typedef struct _FolksBackendsBlueZBackendUnprepareData FolksBackendsBlueZBackendUnprepareData;

struct _FolksBackendsBlueZBackendPrivate {
	gboolean _is_prepared;
	gboolean _prepare_pending;
	gboolean _is_quiescent;
	GeeHashMap* _persona_stores;
	GeeMap* _persona_stores_ro;
	GDBusObjectManagerClient* _manager;
	gulong _object_added_handler;
	gulong _object_removed_handler;
	gulong _properties_changed_handler;
	GeeHashMap* _watched_devices;
	orgbluezobexClient* _obex_client;
	FolksSmallSet* _enabled_devices;
};

struct _Block1Data {
	int _ref_count_;
	FolksBackendsBlueZBackend* self;
	orgbluezDevice* device;
	FolksBackendsBlueZPersonaStore* store;
};

struct _FolksBackendsBlueZBackendAddPersonaStoreData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZBackend* self;
	orgbluezDevice* device;
	gchar* path;
	FolksBackendsBlueZPersonaStore* store;
	orgbluezobexClient* _tmp0_;
	FolksBackendsBlueZPersonaStore* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GeeHashMap* _tmp7_;
	GeeHashMap* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
};

struct _FolksBackendsBlueZBackendRefreshDevicesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZBackend* self;
	GList* objs;
	GDBusObjectManagerClient* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* obj_collection;
	GList* obj_it;
	GDBusObject* _tmp3_;
	GDBusObject* obj;
	GDBusObject* _tmp4_;
};

struct _FolksBackendsBlueZBackendAddDeviceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZBackend* self;
	GDBusObject* obj;
	const gchar* _tmp0_;
	orgbluezDevice* device;
	GDBusInterface* _tmp1_;
	orgbluezDevice* _tmp2_;
	orgbluezDevice* _tmp3_;
	gchar* path;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	orgbluezDevice* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	orgbluezDevice* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	orgbluezDevice* _tmp14_;
	FolksSmallSet* _tmp15_;
	orgbluezDevice* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_;
	orgbluezDevice* _tmp21_;
	const gchar* _tmp22_;
};

struct _FolksBackendsBlueZBackendRemoveDeviceData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZBackend* self;
	GDBusObject* obj;
	gchar* path;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	FolksBackendsBlueZPersonaStore* store;
	const gchar* _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	gpointer _tmp5_;
	gboolean _tmp6_;
	const gchar* _tmp7_;
	FolksBackendsBlueZPersonaStore* _tmp8_;
};

struct _FolksBackendsBlueZBackendSaveEnabledDevicesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZBackend* self;
	GKeyFile* kf;
	GKeyFile* _tmp0_;
	gchar* kf_path;
	gchar* _tmp1_;
	FolksSmallSet* _address_list;
	FolksSmallSet* _tmp2_;
	gint _address_size;
	FolksSmallSet* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _address_index;
	gint _tmp6_;
	gint _tmp7_;
	gchar* address;
	FolksSmallSet* _tmp8_;
	gconstpointer _tmp9_;
	gchar* _tmp10_;
	GKeyFile* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GFile* file;
	const gchar* _tmp14_;
	GFile* _tmp15_;
	gchar* data;
	GKeyFile* _tmp16_;
	gchar* _tmp17_;
	guint8* _tmp18_;
	gint _tmp18__length1;
	gint _tmp19_;
	guint8* _tmp20_;
	gint _tmp20__length1;
	GError* e;
	const gchar* _tmp21_;
	GError* _tmp22_;
	const gchar* _tmp23_;
	GError* _inner_error0_;
};

struct _FolksBackendsBlueZBackendLoadEnabledDevicesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZBackend* self;
	GKeyFile* kf;
	GKeyFile* _tmp0_;
	gchar* kf_path;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	guint8* contents;
	gint contents_length1;
	gint _contents_size_;
	GFile* file;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	guint8* _tmp6_;
	gsize _tmp7_;
	const gchar* contents_s;
	guint8* _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	GKeyFile* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GError* e1;
	GError* _tmp17_;
	const gchar* _tmp18_;
	GError* _tmp19_;
	const gchar* _tmp20_;
	FolksSmallSet* _tmp21_;
	gchar** groups;
	GKeyFile* _tmp22_;
	gsize _tmp23_;
	gchar** _tmp24_;
	gint groups_length1;
	gint _groups_size_;
	gchar** _tmp25_;
	gint _tmp25__length1;
	gchar** address_collection;
	gint address_collection_length1;
	gint _address_collection_size_;
	gint address_it;
	gchar* _tmp26_;
	gchar* address;
	gboolean _tmp27_;
	GKeyFile* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	FolksSmallSet* _tmp31_;
	const gchar* _tmp32_;
	GError* _inner_error0_;
};

struct _FolksBackendsBlueZBackendPrepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZBackend* self;
	FolksInternalProfileBlock* profiling;
	FolksInternalProfileBlock* _tmp0_;
	gboolean _tmp1_;
	GDBusObjectManagerClient* _tmp2_;
	GDBusObjectManagerClient* _tmp3_;
	GDBusObjectManagerClient* _tmp4_;
	GError* _tmp5_;
	orgbluezobexClient* _tmp6_;
	orgbluezobexClient* _tmp7_;
	orgbluezobexClient* _tmp8_;
	GError* _tmp9_;
	GDBusObjectManagerClient* _tmp10_;
	gulong _tmp11_;
	GDBusObjectManagerClient* _tmp12_;
	gulong _tmp13_;
	GDBusObjectManagerClient* _tmp14_;
	gulong _tmp15_;
	GError* _inner_error1_;
	FolksInternalProfileBlock* _tmp16_;
	GError* _inner_error0_;
};

struct _FolksBackendsBlueZBackendUnprepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZBackend* self;
	gboolean _tmp0_;
	GDBusObjectManagerClient* _tmp1_;
	GDBusObjectManagerClient* _tmp2_;
	GDBusObjectManagerClient* _tmp3_;
	GDBusObjectManagerClient* _tmp4_;
	GeeMapIterator* iter;
	GeeHashMap* _tmp5_;
	GeeMapIterator* _tmp6_;
	GeeMapIterator* _tmp7_;
	GeeMapIterator* _tmp8_;
	gpointer _tmp9_;
	FolksBackendsBlueZPersonaStore* _tmp10_;
	GeeMapIterator* _tmp11_;
	GError* _inner_error0_;
};

static gint FolksBackendsBlueZBackend_private_offset;
static gpointer folks_backends_blue_z_backend_parent_class = NULL;

static void folks_backends_blue_z_backend_real_disable_persona_store (FolksBackend* base,
                                                               FolksPersonaStore* store);
static void _folks_backends_blue_z_backend_save_enabled_devices (FolksBackendsBlueZBackend* self,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static void _folks_backends_blue_z_backend_save_enabled_devices_finish (FolksBackendsBlueZBackend* self,
                                                                 GAsyncResult* _res_);
static void __lambda9_ (FolksBackendsBlueZBackend* self,
                 GObject* o,
                 GAsyncResult* r);
static void ___lambda9__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static void _folks_backends_blue_z_backend_remove_persona_store (FolksBackendsBlueZBackend* self,
                                                          FolksBackendsBlueZPersonaStore* store,
                                                          gboolean remove_from_persona_stores,
                                                          gboolean remove_from_watched_devices);
static void folks_backends_blue_z_backend_real_enable_persona_store (FolksBackend* base,
                                                              FolksPersonaStore* store);
static void __lambda10_ (FolksBackendsBlueZBackend* self,
                  GObject* o,
                  GAsyncResult* r);
static void ___lambda10__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void _folks_backends_blue_z_backend_refresh_devices (FolksBackendsBlueZBackend* self,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static void _folks_backends_blue_z_backend_refresh_devices_finish (FolksBackendsBlueZBackend* self,
                                                            GAsyncResult* _res_);
static void __lambda11_ (FolksBackendsBlueZBackend* self,
                  GObject* o,
                  GAsyncResult* r);
static void ___lambda11__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void folks_backends_blue_z_backend_real_set_persona_stores (FolksBackend* base,
                                                            GeeSet* storeids);
static void _folks_backends_blue_z_backend_add_device (FolksBackendsBlueZBackend* self,
                                                GDBusObject* obj,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static void _folks_backends_blue_z_backend_add_device_finish (FolksBackendsBlueZBackend* self,
                                                       GAsyncResult* _res_);
static void _____lambda12_ (FolksBackendsBlueZBackend* self,
                     GObject* o,
                     GAsyncResult* r);
static void ______lambda12__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
static void ___lambda13_ (FolksBackendsBlueZBackend* self,
                   GObject* o,
                   GAsyncResult* r);
static void ____lambda13__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void __lambda14_ (FolksBackendsBlueZBackend* self,
                  GObject* o,
                  GAsyncResult* r);
static void ___lambda14__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void __lambda15_ (FolksBackendsBlueZBackend* self,
                  GObject* o,
                  GAsyncResult* r);
static void ___lambda15__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void _folks_backends_blue_z_backend_device_properties_changed_cb (FolksBackendsBlueZBackend* self,
                                                                  GDBusObjectProxy* obj_proxy,
                                                                  GDBusProxy* iface_proxy,
                                                                  GVariant* changed,
                                                                  gchar** invalidated,
                                                                  gint invalidated_length1);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean _folks_backends_blue_z_backend_device_supports_pbap_pse (FolksBackendsBlueZBackend* self,
                                                                  orgbluezDevice* device);
static void ____lambda16_ (FolksBackendsBlueZBackend* self,
                    GObject* o,
                    GAsyncResult* r);
static void _____lambda16__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void _folks_backends_blue_z_backend_remove_device (FolksBackendsBlueZBackend* self,
                                                   GDBusObject* obj,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static void _folks_backends_blue_z_backend_remove_device_finish (FolksBackendsBlueZBackend* self,
                                                          GAsyncResult* _res_);
static void ____lambda17_ (FolksBackendsBlueZBackend* self,
                    GObject* o,
                    GAsyncResult* r);
static void _____lambda17__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN void folks_backends_blue_z_persona_store_set_connection_state (FolksBackendsBlueZPersonaStore* self,
                                                               gboolean connected,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
VALA_EXTERN void folks_backends_blue_z_persona_store_set_connection_state_finish (FolksBackendsBlueZPersonaStore* self,
                                                                      GAsyncResult* _res_,
                                                                      GError** error);
static void ___lambda18_ (Block1Data* _data1_,
                   GObject* o,
                   GAsyncResult* r);
static void ____lambda18__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
VALA_EXTERN void folks_backends_blue_z_persona_store_set_is_trusted (FolksBackendsBlueZPersonaStore* self,
                                                         gboolean trusted);
VALA_EXTERN void folks_backends_blue_z_persona_store_set_alias (FolksBackendsBlueZPersonaStore* self,
                                                    const gchar* alias);
static void _folks_backends_blue_z_backend_add_persona_store_data_free (gpointer _data);
static void _folks_backends_blue_z_backend_add_persona_store (FolksBackendsBlueZBackend* self,
                                                       orgbluezDevice* device,
                                                       const gchar* path,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static void _folks_backends_blue_z_backend_add_persona_store_finish (FolksBackendsBlueZBackend* self,
                                                              GAsyncResult* _res_);
static gboolean _folks_backends_blue_z_backend_add_persona_store_co (FolksBackendsBlueZBackendAddPersonaStoreData* _data_);
static void _folks_backends_blue_z_backend_persona_store_removed_cb (FolksBackendsBlueZBackend* self,
                                                              FolksPersonaStore* store);
static void __folks_backends_blue_z_backend_persona_store_removed_cb_folks_persona_store_removed (FolksPersonaStore* _sender,
                                                                                           gpointer self);
VALA_EXTERN void folks_backends_blue_z_persona_store_cancel_updates (FolksBackendsBlueZPersonaStore* self);
static void _folks_backends_blue_z_backend_refresh_devices_data_free (gpointer _data);
static gboolean _folks_backends_blue_z_backend_refresh_devices_co (FolksBackendsBlueZBackendRefreshDevicesData* _data_);
static void _folks_backends_blue_z_backend_refresh_devices_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_);
static void _folks_backends_blue_z_backend_add_device_data_free (gpointer _data);
static gboolean _folks_backends_blue_z_backend_add_device_co (FolksBackendsBlueZBackendAddDeviceData* _data_);
static void _folks_backends_blue_z_backend_add_device_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void _folks_backends_blue_z_backend_remove_device_data_free (gpointer _data);
static gboolean _folks_backends_blue_z_backend_remove_device_co (FolksBackendsBlueZBackendRemoveDeviceData* _data_);
static gchar* _folks_backends_blue_z_backend_get_enabled_devices_key_file_path (FolksBackendsBlueZBackend* self);
static void _folks_backends_blue_z_backend_save_enabled_devices_data_free (gpointer _data);
static gboolean _folks_backends_blue_z_backend_save_enabled_devices_co (FolksBackendsBlueZBackendSaveEnabledDevicesData* _data_);
static void _folks_backends_blue_z_backend_load_enabled_devices_data_free (gpointer _data);
static void _folks_backends_blue_z_backend_load_enabled_devices (FolksBackendsBlueZBackend* self,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static void _folks_backends_blue_z_backend_load_enabled_devices_finish (FolksBackendsBlueZBackend* self,
                                                                 GAsyncResult* _res_);
static gboolean _folks_backends_blue_z_backend_load_enabled_devices_co (FolksBackendsBlueZBackendLoadEnabledDevicesData* _data_);
static void _folks_backends_blue_z_backend_load_enabled_devices_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
static void folks_backends_blue_z_backend_real_prepare_data_free (gpointer _data);
static void folks_backends_blue_z_backend_real_prepare (FolksBackend* base,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static gboolean folks_backends_blue_z_backend_real_prepare_co (FolksBackendsBlueZBackendPrepareData* _data_);
static void folks_backends_blue_z_backend_prepare_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static GType ____lambda19_ (FolksBackendsBlueZBackend* self,
                     GDBusObjectManagerClient* manager,
                     const gchar* path,
                     const gchar* iface_name);
static GType _____lambda19__gd_bus_proxy_type_func (GDBusObjectManagerClient* manager,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             gpointer self);
static void ___lambda20_ (FolksBackendsBlueZBackend* self,
                   GDBusObject* obj);
static void __lambda21_ (FolksBackendsBlueZBackend* self,
                  GObject* o,
                  GAsyncResult* r);
static void ___lambda21__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void ____lambda20__g_dbus_object_manager_object_added (GDBusObjectManager* _sender,
                                                       GDBusObject* object,
                                                       gpointer self);
static void ___lambda22_ (FolksBackendsBlueZBackend* self,
                   GDBusObject* obj);
static void __lambda23_ (FolksBackendsBlueZBackend* self,
                  GObject* o,
                  GAsyncResult* r);
static void ___lambda23__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void ____lambda22__g_dbus_object_manager_object_removed (GDBusObjectManager* _sender,
                                                         GDBusObject* object,
                                                         gpointer self);
static void __folks_backends_blue_z_backend_device_properties_changed_cb_g_dbus_object_manager_client_interface_proxy_properties_changed (GDBusObjectManagerClient* _sender,
                                                                                                                                   GDBusObjectProxy* object_proxy,
                                                                                                                                   GDBusProxy* interface_proxy,
                                                                                                                                   GVariant* changed_properties,
                                                                                                                                   gchar** invalidated_properties,
                                                                                                                                   gpointer self);
static void folks_backends_blue_z_backend_real_unprepare_data_free (gpointer _data);
static void folks_backends_blue_z_backend_real_unprepare (FolksBackend* base,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
static gboolean folks_backends_blue_z_backend_real_unprepare_co (FolksBackendsBlueZBackendUnprepareData* _data_);
static GObject * folks_backends_blue_z_backend_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static void folks_backends_blue_z_backend_finalize (GObject * obj);
static GType folks_backends_blue_z_backend_get_type_once (void);
static void _vala_folks_backends_blue_z_backend_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
folks_backends_blue_z_backend_get_instance_private (FolksBackendsBlueZBackend* self)
{
	return G_STRUCT_MEMBER_P (self, FolksBackendsBlueZBackend_private_offset);
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.6
   */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 161 "../backends/bluez/bluez-backend.vala"
	return self ? g_object_ref (self) : NULL;
#line 590 "bluez-backend.c"
}

static void
__lambda9_ (FolksBackendsBlueZBackend* self,
            GObject* o,
            GAsyncResult* r)
{
#line 169 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 171 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_save_enabled_devices_finish (self, r);
#line 602 "bluez-backend.c"
}

static void
___lambda9__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 169 "../backends/bluez/bluez-backend.vala"
	__lambda9_ ((FolksBackendsBlueZBackend*) self, source_object, res);
#line 169 "../backends/bluez/bluez-backend.vala"
	g_object_unref (self);
#line 614 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_real_disable_persona_store (FolksBackend* base,
                                                          FolksPersonaStore* store)
{
	FolksBackendsBlueZBackend * self;
	FolksBackendsBlueZPersonaStore* _store = NULL;
	FolksBackendsBlueZPersonaStore* _tmp0_;
	FolksBackendsBlueZPersonaStore* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* device_address = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	FolksSmallSet* _tmp7_;
	const gchar* _tmp8_;
	GeeHashMap* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	FolksBackendsBlueZPersonaStore* _tmp12_;
#line 159 "../backends/bluez/bluez-backend.vala"
	self = (FolksBackendsBlueZBackend*) base;
#line 159 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (store != NULL);
#line 161 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = _g_object_ref0 (FOLKS_BACKENDS_BLUE_Z_IS_PERSONA_STORE (store) ? ((FolksBackendsBlueZPersonaStore*) store) : NULL);
#line 161 "../backends/bluez/bluez-backend.vala"
	_store = _tmp0_;
#line 162 "../backends/bluez/bluez-backend.vala"
	_tmp1_ = _store;
#line 162 "../backends/bluez/bluez-backend.vala"
	if (_tmp1_ == NULL) {
#line 163 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_store);
#line 163 "../backends/bluez/bluez-backend.vala"
		return;
#line 653 "bluez-backend.c"
	}
#line 165 "../backends/bluez/bluez-backend.vala"
	_tmp2_ = folks_persona_store_get_id (store);
#line 165 "../backends/bluez/bluez-backend.vala"
	_tmp3_ = _tmp2_;
#line 165 "../backends/bluez/bluez-backend.vala"
	g_debug ("bluez-backend.vala:165: Disabling persona store ‘%s’.", _tmp3_);
#line 167 "../backends/bluez/bluez-backend.vala"
	_tmp4_ = folks_persona_store_get_id (store);
#line 167 "../backends/bluez/bluez-backend.vala"
	_tmp5_ = _tmp4_;
#line 167 "../backends/bluez/bluez-backend.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 167 "../backends/bluez/bluez-backend.vala"
	device_address = _tmp6_;
#line 168 "../backends/bluez/bluez-backend.vala"
	_tmp7_ = self->priv->_enabled_devices;
#line 168 "../backends/bluez/bluez-backend.vala"
	_tmp8_ = device_address;
#line 168 "../backends/bluez/bluez-backend.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 169 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_save_enabled_devices (self, ___lambda9__gasync_ready_callback, g_object_ref (self));
#line 174 "../backends/bluez/bluez-backend.vala"
	_tmp9_ = self->priv->_persona_stores;
#line 174 "../backends/bluez/bluez-backend.vala"
	_tmp10_ = folks_persona_store_get_id (store);
#line 174 "../backends/bluez/bluez-backend.vala"
	_tmp11_ = _tmp10_;
#line 174 "../backends/bluez/bluez-backend.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp9_, _tmp11_)) {
#line 175 "../backends/bluez/bluez-backend.vala"
		_g_free0 (device_address);
#line 175 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_store);
#line 175 "../backends/bluez/bluez-backend.vala"
		return;
#line 691 "bluez-backend.c"
	}
#line 177 "../backends/bluez/bluez-backend.vala"
	_tmp12_ = _store;
#line 177 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_remove_persona_store (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA_STORE, FolksBackendsBlueZPersonaStore), TRUE, TRUE);
#line 159 "../backends/bluez/bluez-backend.vala"
	_g_free0 (device_address);
#line 159 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_store);
#line 701 "bluez-backend.c"
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.6
   */
static void
__lambda10_ (FolksBackendsBlueZBackend* self,
             GObject* o,
             GAsyncResult* r)
{
#line 195 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 197 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_save_enabled_devices_finish (self, r);
#line 718 "bluez-backend.c"
}

static void
___lambda10__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 195 "../backends/bluez/bluez-backend.vala"
	__lambda10_ ((FolksBackendsBlueZBackend*) self, source_object, res);
#line 195 "../backends/bluez/bluez-backend.vala"
	g_object_unref (self);
#line 730 "bluez-backend.c"
}

static void
__lambda11_ (FolksBackendsBlueZBackend* self,
             GObject* o,
             GAsyncResult* r)
{
#line 201 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 203 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_refresh_devices_finish (self, r);
#line 742 "bluez-backend.c"
}

static void
___lambda11__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 201 "../backends/bluez/bluez-backend.vala"
	__lambda11_ ((FolksBackendsBlueZBackend*) self, source_object, res);
#line 201 "../backends/bluez/bluez-backend.vala"
	g_object_unref (self);
#line 754 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_real_enable_persona_store (FolksBackend* base,
                                                         FolksPersonaStore* store)
{
	FolksBackendsBlueZBackend * self;
	FolksBackendsBlueZPersonaStore* _store = NULL;
	FolksBackendsBlueZPersonaStore* _tmp0_;
	FolksBackendsBlueZPersonaStore* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* device_address = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	FolksSmallSet* _tmp7_;
	const gchar* _tmp8_;
#line 185 "../backends/bluez/bluez-backend.vala"
	self = (FolksBackendsBlueZBackend*) base;
#line 185 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (store != NULL);
#line 187 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = _g_object_ref0 (FOLKS_BACKENDS_BLUE_Z_IS_PERSONA_STORE (store) ? ((FolksBackendsBlueZPersonaStore*) store) : NULL);
#line 187 "../backends/bluez/bluez-backend.vala"
	_store = _tmp0_;
#line 188 "../backends/bluez/bluez-backend.vala"
	_tmp1_ = _store;
#line 188 "../backends/bluez/bluez-backend.vala"
	if (_tmp1_ == NULL) {
#line 189 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_store);
#line 189 "../backends/bluez/bluez-backend.vala"
		return;
#line 789 "bluez-backend.c"
	}
#line 191 "../backends/bluez/bluez-backend.vala"
	_tmp2_ = folks_persona_store_get_id (store);
#line 191 "../backends/bluez/bluez-backend.vala"
	_tmp3_ = _tmp2_;
#line 191 "../backends/bluez/bluez-backend.vala"
	g_debug ("bluez-backend.vala:191: Enabling persona store ‘%s’.", _tmp3_);
#line 193 "../backends/bluez/bluez-backend.vala"
	_tmp4_ = folks_persona_store_get_id (store);
#line 193 "../backends/bluez/bluez-backend.vala"
	_tmp5_ = _tmp4_;
#line 193 "../backends/bluez/bluez-backend.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 193 "../backends/bluez/bluez-backend.vala"
	device_address = _tmp6_;
#line 194 "../backends/bluez/bluez-backend.vala"
	_tmp7_ = self->priv->_enabled_devices;
#line 194 "../backends/bluez/bluez-backend.vala"
	_tmp8_ = device_address;
#line 194 "../backends/bluez/bluez-backend.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp7_, _tmp8_);
#line 195 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_save_enabled_devices (self, ___lambda10__gasync_ready_callback, g_object_ref (self));
#line 201 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_refresh_devices (self, ___lambda11__gasync_ready_callback, g_object_ref (self));
#line 185 "../backends/bluez/bluez-backend.vala"
	_g_free0 (device_address);
#line 185 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_store);
#line 819 "bluez-backend.c"
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.6
   */
static void
_____lambda12_ (FolksBackendsBlueZBackend* self,
                GObject* o,
                GAsyncResult* r)
{
#line 226 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 228 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_add_device_finish (self, r);
#line 836 "bluez-backend.c"
}

static void
______lambda12__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
#line 226 "../backends/bluez/bluez-backend.vala"
	_____lambda12_ ((FolksBackendsBlueZBackend*) self, source_object, res);
#line 226 "../backends/bluez/bluez-backend.vala"
	g_object_unref (self);
#line 848 "bluez-backend.c"
}

static void
___lambda13_ (FolksBackendsBlueZBackend* self,
              GObject* o,
              GAsyncResult* r)
{
#line 232 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 234 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_save_enabled_devices_finish (self, r);
#line 860 "bluez-backend.c"
}

static void
____lambda13__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 232 "../backends/bluez/bluez-backend.vala"
	___lambda13_ ((FolksBackendsBlueZBackend*) self, source_object, res);
#line 232 "../backends/bluez/bluez-backend.vala"
	g_object_unref (self);
#line 872 "bluez-backend.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 237 "../backends/bluez/bluez-backend.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 880 "bluez-backend.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 237 "../backends/bluez/bluez-backend.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 888 "bluez-backend.c"
}

static void
__lambda14_ (FolksBackendsBlueZBackend* self,
             GObject* o,
             GAsyncResult* r)
{
#line 249 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 251 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_save_enabled_devices_finish (self, r);
#line 900 "bluez-backend.c"
}

static void
___lambda14__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 249 "../backends/bluez/bluez-backend.vala"
	__lambda14_ ((FolksBackendsBlueZBackend*) self, source_object, res);
#line 249 "../backends/bluez/bluez-backend.vala"
	g_object_unref (self);
#line 912 "bluez-backend.c"
}

static void
__lambda15_ (FolksBackendsBlueZBackend* self,
             GObject* o,
             GAsyncResult* r)
{
#line 254 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 256 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_refresh_devices_finish (self, r);
#line 924 "bluez-backend.c"
}

static void
___lambda15__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 254 "../backends/bluez/bluez-backend.vala"
	__lambda15_ ((FolksBackendsBlueZBackend*) self, source_object, res);
#line 254 "../backends/bluez/bluez-backend.vala"
	g_object_unref (self);
#line 936 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_real_set_persona_stores (FolksBackend* base,
                                                       GeeSet* storeids)
{
	FolksBackendsBlueZBackend * self;
	FolksSmallSet* _tmp14_;
#line 212 "../backends/bluez/bluez-backend.vala"
	self = (FolksBackendsBlueZBackend*) base;
#line 214 "../backends/bluez/bluez-backend.vala"
	if (storeids == NULL) {
#line 949 "bluez-backend.c"
		GList* objs = NULL;
		GDBusObjectManagerClient* _tmp0_;
		GList* _tmp1_;
		GList* _tmp2_;
#line 217 "../backends/bluez/bluez-backend.vala"
		_tmp0_ = self->priv->_manager;
#line 217 "../backends/bluez/bluez-backend.vala"
		_tmp1_ = g_dbus_object_manager_get_objects ((GDBusObjectManager*) _tmp0_);
#line 217 "../backends/bluez/bluez-backend.vala"
		objs = _tmp1_;
#line 219 "../backends/bluez/bluez-backend.vala"
		_tmp2_ = objs;
#line 962 "bluez-backend.c"
		{
			GList* obj_collection = NULL;
			GList* obj_it = NULL;
#line 219 "../backends/bluez/bluez-backend.vala"
			obj_collection = _tmp2_;
#line 219 "../backends/bluez/bluez-backend.vala"
			for (obj_it = obj_collection; obj_it != NULL; obj_it = obj_it->next) {
#line 970 "bluez-backend.c"
				GDBusObject* _tmp3_;
				GDBusObject* obj = NULL;
#line 219 "../backends/bluez/bluez-backend.vala"
				_tmp3_ = _g_object_ref0 ((GDBusObject*) obj_it->data);
#line 219 "../backends/bluez/bluez-backend.vala"
				obj = _tmp3_;
#line 977 "bluez-backend.c"
				{
					orgbluezDevice* device = NULL;
					GDBusObject* _tmp4_;
					GDBusInterface* _tmp5_;
					orgbluezDevice* _tmp6_;
					orgbluezDevice* _tmp7_;
					FolksSmallSet* _tmp8_;
					orgbluezDevice* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					GDBusObject* _tmp13_;
#line 221 "../backends/bluez/bluez-backend.vala"
					_tmp4_ = obj;
#line 221 "../backends/bluez/bluez-backend.vala"
					_tmp5_ = g_dbus_object_get_interface (_tmp4_, "org.bluez.Device1");
#line 221 "../backends/bluez/bluez-backend.vala"
					_tmp6_ = ORG_BLUEZ_IS_DEVICE (_tmp5_) ? ((orgbluezDevice*) _tmp5_) : NULL;
#line 221 "../backends/bluez/bluez-backend.vala"
					if (_tmp6_ == NULL) {
#line 221 "../backends/bluez/bluez-backend.vala"
						_g_object_unref0 (_tmp5_);
#line 1000 "bluez-backend.c"
					}
#line 221 "../backends/bluez/bluez-backend.vala"
					device = _tmp6_;
#line 222 "../backends/bluez/bluez-backend.vala"
					_tmp7_ = device;
#line 222 "../backends/bluez/bluez-backend.vala"
					if (_tmp7_ == NULL) {
#line 223 "../backends/bluez/bluez-backend.vala"
						_g_object_unref0 (device);
#line 223 "../backends/bluez/bluez-backend.vala"
						_g_object_unref0 (obj);
#line 223 "../backends/bluez/bluez-backend.vala"
						continue;
#line 1014 "bluez-backend.c"
					}
#line 225 "../backends/bluez/bluez-backend.vala"
					_tmp8_ = self->priv->_enabled_devices;
#line 225 "../backends/bluez/bluez-backend.vala"
					_tmp9_ = device;
#line 225 "../backends/bluez/bluez-backend.vala"
					_tmp10_ = org_bluez_device_get_address (_tmp9_);
#line 225 "../backends/bluez/bluez-backend.vala"
					_tmp11_ = _tmp10_;
#line 225 "../backends/bluez/bluez-backend.vala"
					_tmp12_ = _tmp11_;
#line 225 "../backends/bluez/bluez-backend.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp12_);
#line 225 "../backends/bluez/bluez-backend.vala"
					_g_free0 (_tmp12_);
#line 226 "../backends/bluez/bluez-backend.vala"
					_tmp13_ = obj;
#line 226 "../backends/bluez/bluez-backend.vala"
					_folks_backends_blue_z_backend_add_device (self, _tmp13_, ______lambda12__gasync_ready_callback, g_object_ref (self));
#line 219 "../backends/bluez/bluez-backend.vala"
					_g_object_unref0 (device);
#line 219 "../backends/bluez/bluez-backend.vala"
					_g_object_unref0 (obj);
#line 1038 "bluez-backend.c"
				}
			}
		}
#line 232 "../backends/bluez/bluez-backend.vala"
		_folks_backends_blue_z_backend_save_enabled_devices (self, ____lambda13__gasync_ready_callback, g_object_ref (self));
#line 237 "../backends/bluez/bluez-backend.vala"
		(objs == NULL) ? NULL : (objs = (_g_list_free__g_object_unref0_ (objs), NULL));
#line 237 "../backends/bluez/bluez-backend.vala"
		return;
#line 1048 "bluez-backend.c"
	}
#line 242 "../backends/bluez/bluez-backend.vala"
	_tmp14_ = self->priv->_enabled_devices;
#line 242 "../backends/bluez/bluez-backend.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp14_);
#line 1054 "bluez-backend.c"
	{
		GeeIterator* _store_id_it = NULL;
		GeeIterator* _tmp15_;
#line 243 "../backends/bluez/bluez-backend.vala"
		_tmp15_ = gee_iterable_iterator ((GeeIterable*) storeids);
#line 243 "../backends/bluez/bluez-backend.vala"
		_store_id_it = _tmp15_;
#line 243 "../backends/bluez/bluez-backend.vala"
		while (TRUE) {
#line 1064 "bluez-backend.c"
			GeeIterator* _tmp16_;
			gchar* store_id = NULL;
			GeeIterator* _tmp17_;
			gpointer _tmp18_;
			gchar* device_address = NULL;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			FolksSmallSet* _tmp21_;
			const gchar* _tmp22_;
#line 243 "../backends/bluez/bluez-backend.vala"
			_tmp16_ = _store_id_it;
#line 243 "../backends/bluez/bluez-backend.vala"
			if (!gee_iterator_next (_tmp16_)) {
#line 243 "../backends/bluez/bluez-backend.vala"
				break;
#line 1080 "bluez-backend.c"
			}
#line 243 "../backends/bluez/bluez-backend.vala"
			_tmp17_ = _store_id_it;
#line 243 "../backends/bluez/bluez-backend.vala"
			_tmp18_ = gee_iterator_get (_tmp17_);
#line 243 "../backends/bluez/bluez-backend.vala"
			store_id = (gchar*) _tmp18_;
#line 245 "../backends/bluez/bluez-backend.vala"
			_tmp19_ = store_id;
#line 245 "../backends/bluez/bluez-backend.vala"
			_tmp20_ = g_strdup (_tmp19_);
#line 245 "../backends/bluez/bluez-backend.vala"
			device_address = _tmp20_;
#line 246 "../backends/bluez/bluez-backend.vala"
			_tmp21_ = self->priv->_enabled_devices;
#line 246 "../backends/bluez/bluez-backend.vala"
			_tmp22_ = device_address;
#line 246 "../backends/bluez/bluez-backend.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
#line 243 "../backends/bluez/bluez-backend.vala"
			_g_free0 (device_address);
#line 243 "../backends/bluez/bluez-backend.vala"
			_g_free0 (store_id);
#line 1104 "bluez-backend.c"
		}
#line 243 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_store_id_it);
#line 1108 "bluez-backend.c"
	}
#line 249 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_save_enabled_devices (self, ___lambda14__gasync_ready_callback, g_object_ref (self));
#line 254 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_refresh_devices (self, ___lambda15__gasync_ready_callback, g_object_ref (self));
#line 1114 "bluez-backend.c"
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.6
   */
FolksBackendsBlueZBackend*
folks_backends_blue_z_backend_construct (GType object_type)
{
	FolksBackendsBlueZBackend * self = NULL;
#line 267 "../backends/bluez/bluez-backend.vala"
	self = (FolksBackendsBlueZBackend*) g_object_new (object_type, NULL);
#line 265 "../backends/bluez/bluez-backend.vala"
	return self;
#line 1130 "bluez-backend.c"
}

FolksBackendsBlueZBackend*
folks_backends_blue_z_backend_new (void)
{
#line 265 "../backends/bluez/bluez-backend.vala"
	return folks_backends_blue_z_backend_construct (FOLKS_BACKENDS_BLUE_Z_TYPE_BACKEND);
#line 1138 "bluez-backend.c"
}

/**
   * Callback executed when a device property has changed.
   *
   * The callback is executed when a PropertiesChanged signal is received
   * on device. If the device is seen as connected it tries to update the
   * Persona store associated with it. If the device is seen as disconnected,
   * the OBEX session used by the {@link PersonaStore} is removed.
   *
   * @param obj_proxy D-Bus proxy for the object
   * @param iface_proxy D-Bus proxy for the interface on which the property
   * changed
   * @param changed the list of properties that have changed
   * @param invalidated the list of properties that have been invalidated
   *
   * @since 0.9.6
   */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 294 "../backends/bluez/bluez-backend.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 294 "../backends/bluez/bluez-backend.vala"
	return _data1_;
#line 1164 "bluez-backend.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 294 "../backends/bluez/bluez-backend.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1174 "bluez-backend.c"
		FolksBackendsBlueZBackend* self;
#line 294 "../backends/bluez/bluez-backend.vala"
		self = _data1_->self;
#line 294 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data1_->store);
#line 294 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data1_->device);
#line 294 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (self);
#line 294 "../backends/bluez/bluez-backend.vala"
		g_slice_free (Block1Data, _data1_);
#line 1186 "bluez-backend.c"
	}
}

static void
____lambda16_ (FolksBackendsBlueZBackend* self,
               GObject* o,
               GAsyncResult* r)
{
#line 323 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 325 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_add_device_finish (self, r);
#line 1199 "bluez-backend.c"
}

static void
_____lambda16__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 323 "../backends/bluez/bluez-backend.vala"
	____lambda16_ ((FolksBackendsBlueZBackend*) self, source_object, res);
#line 323 "../backends/bluez/bluez-backend.vala"
	g_object_unref (self);
#line 1211 "bluez-backend.c"
}

static void
____lambda17_ (FolksBackendsBlueZBackend* self,
               GObject* o,
               GAsyncResult* r)
{
#line 330 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 332 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_remove_device_finish (self, r);
#line 1223 "bluez-backend.c"
}

static void
_____lambda17__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 330 "../backends/bluez/bluez-backend.vala"
	____lambda17_ ((FolksBackendsBlueZBackend*) self, source_object, res);
#line 330 "../backends/bluez/bluez-backend.vala"
	g_object_unref (self);
#line 1235 "bluez-backend.c"
}

static void
___lambda18_ (Block1Data* _data1_,
              GObject* o,
              GAsyncResult* r)
{
	FolksBackendsBlueZBackend* self;
	GError* _inner_error0_ = NULL;
#line 346 "../backends/bluez/bluez-backend.vala"
	self = _data1_->self;
#line 346 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 1249 "bluez-backend.c"
	{
		FolksBackendsBlueZPersonaStore* _tmp0_;
#line 350 "../backends/bluez/bluez-backend.vala"
		_tmp0_ = _data1_->store;
#line 350 "../backends/bluez/bluez-backend.vala"
		folks_backends_blue_z_persona_store_set_connection_state_finish (_tmp0_, r, &_inner_error0_);
#line 350 "../backends/bluez/bluez-backend.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 350 "../backends/bluez/bluez-backend.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 1260 "bluez-backend.c"
				goto __catch0_g_io_error;
			}
#line 350 "../backends/bluez/bluez-backend.vala"
			if (_inner_error0_->domain == FOLKS_PERSONA_STORE_ERROR) {
#line 1265 "bluez-backend.c"
				goto __catch0_folks_persona_store_error;
			}
#line 350 "../backends/bluez/bluez-backend.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 350 "../backends/bluez/bluez-backend.vala"
			g_clear_error (&_inner_error0_);
#line 350 "../backends/bluez/bluez-backend.vala"
			return;
#line 1274 "bluez-backend.c"
		}
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		orgbluezDevice* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		orgbluezDevice* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 348 "../backends/bluez/bluez-backend.vala"
		g_clear_error (&_inner_error0_);
#line 354 "../backends/bluez/bluez-backend.vala"
		_tmp1_ = _data1_->device;
#line 354 "../backends/bluez/bluez-backend.vala"
		_tmp2_ = org_bluez_device_get_alias (_tmp1_);
#line 354 "../backends/bluez/bluez-backend.vala"
		_tmp3_ = _tmp2_;
#line 354 "../backends/bluez/bluez-backend.vala"
		_tmp4_ = _tmp3_;
#line 354 "../backends/bluez/bluez-backend.vala"
		_tmp5_ = _data1_->device;
#line 354 "../backends/bluez/bluez-backend.vala"
		_tmp6_ = org_bluez_device_get_address (_tmp5_);
#line 354 "../backends/bluez/bluez-backend.vala"
		_tmp7_ = _tmp6_;
#line 354 "../backends/bluez/bluez-backend.vala"
		_tmp8_ = _tmp7_;
#line 354 "../backends/bluez/bluez-backend.vala"
		g_debug ("Changing connection state for device ‘%s’ (%s) " "was cancelled.", _tmp4_, _tmp8_);
#line 354 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_tmp8_);
#line 354 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_tmp4_);
#line 1312 "bluez-backend.c"
	}
	goto __finally0;
	__catch0_folks_persona_store_error:
	{
		GError* e2 = NULL;
		orgbluezDevice* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		orgbluezDevice* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 348 "../backends/bluez/bluez-backend.vala"
		e2 = _inner_error0_;
#line 348 "../backends/bluez/bluez-backend.vala"
		_inner_error0_ = NULL;
#line 359 "../backends/bluez/bluez-backend.vala"
		_tmp9_ = _data1_->device;
#line 359 "../backends/bluez/bluez-backend.vala"
		_tmp10_ = org_bluez_device_get_alias (_tmp9_);
#line 359 "../backends/bluez/bluez-backend.vala"
		_tmp11_ = _tmp10_;
#line 359 "../backends/bluez/bluez-backend.vala"
		_tmp12_ = _tmp11_;
#line 359 "../backends/bluez/bluez-backend.vala"
		_tmp13_ = _data1_->device;
#line 359 "../backends/bluez/bluez-backend.vala"
		_tmp14_ = org_bluez_device_get_address (_tmp13_);
#line 359 "../backends/bluez/bluez-backend.vala"
		_tmp15_ = _tmp14_;
#line 359 "../backends/bluez/bluez-backend.vala"
		_tmp16_ = _tmp15_;
#line 359 "../backends/bluez/bluez-backend.vala"
		_tmp17_ = e2;
#line 359 "../backends/bluez/bluez-backend.vala"
		_tmp18_ = _tmp17_->message;
#line 359 "../backends/bluez/bluez-backend.vala"
		g_warning ("Error changing connection state for device " "‘%s’ (%s): %s", _tmp12_, _tmp16_, _tmp18_);
#line 359 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_tmp16_);
#line 359 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_tmp12_);
#line 348 "../backends/bluez/bluez-backend.vala"
		_g_error_free0 (e2);
#line 1360 "bluez-backend.c"
	}
	__finally0:
#line 348 "../backends/bluez/bluez-backend.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 348 "../backends/bluez/bluez-backend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 348 "../backends/bluez/bluez-backend.vala"
		g_clear_error (&_inner_error0_);
#line 348 "../backends/bluez/bluez-backend.vala"
		return;
#line 1371 "bluez-backend.c"
	}
}

static void
____lambda18__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 346 "../backends/bluez/bluez-backend.vala"
	___lambda18_ (self, source_object, res);
#line 346 "../backends/bluez/bluez-backend.vala"
	block1_data_unref (self);
#line 1384 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_device_properties_changed_cb (FolksBackendsBlueZBackend* self,
                                                             GDBusObjectProxy* obj_proxy,
                                                             GDBusProxy* iface_proxy,
                                                             GVariant* changed,
                                                             gchar** invalidated,
                                                             gint invalidated_length1)
{
	Block1Data* _data1_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GVariantIter* iter = NULL;
	GVariantIter* _tmp6_;
	gchar* key = NULL;
	GVariant* variant = NULL;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gboolean _tmp15_;
	orgbluezDevice* _tmp16_;
	GVariant* uuids = NULL;
	GVariant* _tmp17_;
	GVariant* paired = NULL;
	const GVariantType* _tmp18_;
	GVariant* _tmp19_;
	GVariant* blocked = NULL;
	const GVariantType* _tmp20_;
	GVariant* _tmp21_;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	GVariant* _tmp24_;
	GeeHashMap* _tmp36_;
	orgbluezDevice* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gpointer _tmp41_;
	FolksBackendsBlueZPersonaStore* _tmp42_;
	FolksBackendsBlueZPersonaStore* _tmp43_;
	GVariant* connected = NULL;
	const GVariantType* _tmp44_;
	GVariant* _tmp45_;
	GVariant* _tmp46_;
	GVariant* trusted = NULL;
	const GVariantType* _tmp49_;
	GVariant* _tmp50_;
	GVariant* _tmp51_;
	GVariant* alias = NULL;
	const GVariantType* _tmp54_;
	GVariant* _tmp55_;
	GVariant* _tmp56_;
#line 294 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (self != NULL);
#line 294 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (obj_proxy != NULL);
#line 294 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (iface_proxy != NULL);
#line 294 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (changed != NULL);
#line 294 "../backends/bluez/bluez-backend.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 294 "../backends/bluez/bluez-backend.vala"
	_data1_->_ref_count_ = 1;
#line 294 "../backends/bluez/bluez-backend.vala"
	_data1_->self = g_object_ref (self);
#line 297 "../backends/bluez/bluez-backend.vala"
	g_object_get (iface_proxy, "g-interface-name", &_tmp0_, NULL);
#line 297 "../backends/bluez/bluez-backend.vala"
	_tmp1_ = _tmp0_;
#line 297 "../backends/bluez/bluez-backend.vala"
	_tmp2_ = _tmp1_;
#line 297 "../backends/bluez/bluez-backend.vala"
	g_object_get (obj_proxy, "g-object-path", &_tmp3_, NULL);
#line 297 "../backends/bluez/bluez-backend.vala"
	_tmp4_ = _tmp3_;
#line 297 "../backends/bluez/bluez-backend.vala"
	_tmp5_ = _tmp4_;
#line 297 "../backends/bluez/bluez-backend.vala"
	g_debug ("bluez-backend.vala:297: Properties changed on interface ‘%s’ of object" \
" ‘%s’:", _tmp2_, _tmp5_);
#line 297 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_tmp5_);
#line 297 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_tmp2_);
#line 299 "../backends/bluez/bluez-backend.vala"
	_tmp6_ = g_variant_iter_new (changed);
#line 299 "../backends/bluez/bluez-backend.vala"
	iter = _tmp6_;
#line 302 "../backends/bluez/bluez-backend.vala"
	while (TRUE) {
#line 1480 "bluez-backend.c"
		GVariantIter* _tmp7_;
		gchar* _tmp8_ = NULL;
		GVariant* _tmp9_ = NULL;
		gboolean _tmp10_;
		const gchar* _tmp11_;
#line 302 "../backends/bluez/bluez-backend.vala"
		_tmp7_ = iter;
#line 302 "../backends/bluez/bluez-backend.vala"
		_tmp10_ = g_variant_iter_next (_tmp7_, "{sv}", &_tmp8_, &_tmp9_, NULL);
#line 302 "../backends/bluez/bluez-backend.vala"
		_g_free0 (key);
#line 302 "../backends/bluez/bluez-backend.vala"
		key = _tmp8_;
#line 302 "../backends/bluez/bluez-backend.vala"
		_g_variant_unref0 (variant);
#line 302 "../backends/bluez/bluez-backend.vala"
		variant = _tmp9_;
#line 302 "../backends/bluez/bluez-backend.vala"
		if (!(_tmp10_ == TRUE)) {
#line 302 "../backends/bluez/bluez-backend.vala"
			break;
#line 1502 "bluez-backend.c"
		}
#line 303 "../backends/bluez/bluez-backend.vala"
		_tmp11_ = key;
#line 303 "../backends/bluez/bluez-backend.vala"
		g_debug ("bluez-backend.vala:303:     %s", _tmp11_);
#line 1508 "bluez-backend.c"
	}
#line 305 "../backends/bluez/bluez-backend.vala"
	g_object_get (iface_proxy, "g-interface-name", &_tmp12_, NULL);
#line 305 "../backends/bluez/bluez-backend.vala"
	_tmp13_ = _tmp12_;
#line 305 "../backends/bluez/bluez-backend.vala"
	_tmp14_ = _tmp13_;
#line 305 "../backends/bluez/bluez-backend.vala"
	_tmp15_ = g_strcmp0 (_tmp14_, "org.bluez.Device1") != 0;
#line 305 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_tmp14_);
#line 305 "../backends/bluez/bluez-backend.vala"
	if (_tmp15_) {
#line 306 "../backends/bluez/bluez-backend.vala"
		_g_variant_unref0 (variant);
#line 306 "../backends/bluez/bluez-backend.vala"
		_g_free0 (key);
#line 306 "../backends/bluez/bluez-backend.vala"
		_g_variant_iter_free0 (iter);
#line 306 "../backends/bluez/bluez-backend.vala"
		block1_data_unref (_data1_);
#line 306 "../backends/bluez/bluez-backend.vala"
		_data1_ = NULL;
#line 306 "../backends/bluez/bluez-backend.vala"
		return;
#line 1534 "bluez-backend.c"
	}
#line 308 "../backends/bluez/bluez-backend.vala"
	_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (iface_proxy, ORG_BLUEZ_TYPE_DEVICE, orgbluezDevice));
#line 308 "../backends/bluez/bluez-backend.vala"
	_data1_->device = _tmp16_;
#line 312 "../backends/bluez/bluez-backend.vala"
	_tmp17_ = g_variant_lookup_value (changed, "UUIDs", NULL);
#line 312 "../backends/bluez/bluez-backend.vala"
	uuids = _tmp17_;
#line 313 "../backends/bluez/bluez-backend.vala"
	_tmp18_ = G_VARIANT_TYPE_BOOLEAN;
#line 313 "../backends/bluez/bluez-backend.vala"
	_tmp19_ = g_variant_lookup_value (changed, "Paired", _tmp18_);
#line 313 "../backends/bluez/bluez-backend.vala"
	paired = _tmp19_;
#line 314 "../backends/bluez/bluez-backend.vala"
	_tmp20_ = G_VARIANT_TYPE_BOOLEAN;
#line 314 "../backends/bluez/bluez-backend.vala"
	_tmp21_ = g_variant_lookup_value (changed, "Blocked", _tmp20_);
#line 314 "../backends/bluez/bluez-backend.vala"
	blocked = _tmp21_;
#line 316 "../backends/bluez/bluez-backend.vala"
	_tmp24_ = uuids;
#line 316 "../backends/bluez/bluez-backend.vala"
	if (_tmp24_ != NULL) {
#line 316 "../backends/bluez/bluez-backend.vala"
		_tmp23_ = TRUE;
#line 1562 "bluez-backend.c"
	} else {
		GVariant* _tmp25_;
#line 316 "../backends/bluez/bluez-backend.vala"
		_tmp25_ = paired;
#line 316 "../backends/bluez/bluez-backend.vala"
		_tmp23_ = _tmp25_ != NULL;
#line 1569 "bluez-backend.c"
	}
#line 316 "../backends/bluez/bluez-backend.vala"
	if (_tmp23_) {
#line 316 "../backends/bluez/bluez-backend.vala"
		_tmp22_ = TRUE;
#line 1575 "bluez-backend.c"
	} else {
		GVariant* _tmp26_;
#line 316 "../backends/bluez/bluez-backend.vala"
		_tmp26_ = blocked;
#line 316 "../backends/bluez/bluez-backend.vala"
		_tmp22_ = _tmp26_ != NULL;
#line 1582 "bluez-backend.c"
	}
#line 316 "../backends/bluez/bluez-backend.vala"
	if (_tmp22_) {
#line 1586 "bluez-backend.c"
		gboolean _tmp27_ = FALSE;
		gboolean _tmp28_ = FALSE;
		orgbluezDevice* _tmp29_;
		gboolean _tmp30_;
		gboolean _tmp31_;
#line 320 "../backends/bluez/bluez-backend.vala"
		_tmp29_ = _data1_->device;
#line 320 "../backends/bluez/bluez-backend.vala"
		_tmp30_ = org_bluez_device_get_paired (_tmp29_);
#line 320 "../backends/bluez/bluez-backend.vala"
		_tmp31_ = _tmp30_;
#line 320 "../backends/bluez/bluez-backend.vala"
		if (_tmp31_ == TRUE) {
#line 1600 "bluez-backend.c"
			orgbluezDevice* _tmp32_;
			gboolean _tmp33_;
			gboolean _tmp34_;
#line 320 "../backends/bluez/bluez-backend.vala"
			_tmp32_ = _data1_->device;
#line 320 "../backends/bluez/bluez-backend.vala"
			_tmp33_ = org_bluez_device_get_blocked (_tmp32_);
#line 320 "../backends/bluez/bluez-backend.vala"
			_tmp34_ = _tmp33_;
#line 320 "../backends/bluez/bluez-backend.vala"
			_tmp28_ = _tmp34_ == FALSE;
#line 1612 "bluez-backend.c"
		} else {
#line 320 "../backends/bluez/bluez-backend.vala"
			_tmp28_ = FALSE;
#line 1616 "bluez-backend.c"
		}
#line 320 "../backends/bluez/bluez-backend.vala"
		if (_tmp28_) {
#line 1620 "bluez-backend.c"
			orgbluezDevice* _tmp35_;
#line 321 "../backends/bluez/bluez-backend.vala"
			_tmp35_ = _data1_->device;
#line 321 "../backends/bluez/bluez-backend.vala"
			_tmp27_ = _folks_backends_blue_z_backend_device_supports_pbap_pse (self, _tmp35_);
#line 1626 "bluez-backend.c"
		} else {
#line 320 "../backends/bluez/bluez-backend.vala"
			_tmp27_ = FALSE;
#line 1630 "bluez-backend.c"
		}
#line 320 "../backends/bluez/bluez-backend.vala"
		if (_tmp27_) {
#line 323 "../backends/bluez/bluez-backend.vala"
			_folks_backends_blue_z_backend_add_device (self, (GDBusObject*) obj_proxy, _____lambda16__gasync_ready_callback, g_object_ref (self));
#line 1636 "bluez-backend.c"
		} else {
#line 330 "../backends/bluez/bluez-backend.vala"
			_folks_backends_blue_z_backend_remove_device (self, (GDBusObject*) obj_proxy, _____lambda17__gasync_ready_callback, g_object_ref (self));
#line 1640 "bluez-backend.c"
		}
	}
#line 337 "../backends/bluez/bluez-backend.vala"
	_tmp36_ = self->priv->_persona_stores;
#line 337 "../backends/bluez/bluez-backend.vala"
	_tmp37_ = _data1_->device;
#line 337 "../backends/bluez/bluez-backend.vala"
	_tmp38_ = org_bluez_device_get_address (_tmp37_);
#line 337 "../backends/bluez/bluez-backend.vala"
	_tmp39_ = _tmp38_;
#line 337 "../backends/bluez/bluez-backend.vala"
	_tmp40_ = _tmp39_;
#line 337 "../backends/bluez/bluez-backend.vala"
	_tmp41_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp36_, _tmp40_);
#line 337 "../backends/bluez/bluez-backend.vala"
	_tmp42_ = (FolksBackendsBlueZPersonaStore*) _tmp41_;
#line 337 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_tmp40_);
#line 337 "../backends/bluez/bluez-backend.vala"
	_data1_->store = _tmp42_;
#line 339 "../backends/bluez/bluez-backend.vala"
	_tmp43_ = _data1_->store;
#line 339 "../backends/bluez/bluez-backend.vala"
	if (_tmp43_ == NULL) {
#line 340 "../backends/bluez/bluez-backend.vala"
		_g_variant_unref0 (blocked);
#line 340 "../backends/bluez/bluez-backend.vala"
		_g_variant_unref0 (paired);
#line 340 "../backends/bluez/bluez-backend.vala"
		_g_variant_unref0 (uuids);
#line 340 "../backends/bluez/bluez-backend.vala"
		_g_variant_unref0 (variant);
#line 340 "../backends/bluez/bluez-backend.vala"
		_g_free0 (key);
#line 340 "../backends/bluez/bluez-backend.vala"
		_g_variant_iter_free0 (iter);
#line 340 "../backends/bluez/bluez-backend.vala"
		block1_data_unref (_data1_);
#line 340 "../backends/bluez/bluez-backend.vala"
		_data1_ = NULL;
#line 340 "../backends/bluez/bluez-backend.vala"
		return;
#line 1683 "bluez-backend.c"
	}
#line 343 "../backends/bluez/bluez-backend.vala"
	_tmp44_ = G_VARIANT_TYPE_BOOLEAN;
#line 343 "../backends/bluez/bluez-backend.vala"
	_tmp45_ = g_variant_lookup_value (changed, "Connected", _tmp44_);
#line 343 "../backends/bluez/bluez-backend.vala"
	connected = _tmp45_;
#line 344 "../backends/bluez/bluez-backend.vala"
	_tmp46_ = connected;
#line 344 "../backends/bluez/bluez-backend.vala"
	if (_tmp46_ != NULL) {
#line 1695 "bluez-backend.c"
		FolksBackendsBlueZPersonaStore* _tmp47_;
		GVariant* _tmp48_;
#line 346 "../backends/bluez/bluez-backend.vala"
		_tmp47_ = _data1_->store;
#line 346 "../backends/bluez/bluez-backend.vala"
		_tmp48_ = connected;
#line 346 "../backends/bluez/bluez-backend.vala"
		folks_backends_blue_z_persona_store_set_connection_state (_tmp47_, g_variant_get_boolean (_tmp48_), ____lambda18__gasync_ready_callback, block1_data_ref (_data1_));
#line 1704 "bluez-backend.c"
	}
#line 367 "../backends/bluez/bluez-backend.vala"
	_tmp49_ = G_VARIANT_TYPE_BOOLEAN;
#line 367 "../backends/bluez/bluez-backend.vala"
	_tmp50_ = g_variant_lookup_value (changed, "Trusted", _tmp49_);
#line 367 "../backends/bluez/bluez-backend.vala"
	trusted = _tmp50_;
#line 368 "../backends/bluez/bluez-backend.vala"
	_tmp51_ = trusted;
#line 368 "../backends/bluez/bluez-backend.vala"
	if (_tmp51_ != NULL) {
#line 1716 "bluez-backend.c"
		FolksBackendsBlueZPersonaStore* _tmp52_;
		GVariant* _tmp53_;
#line 370 "../backends/bluez/bluez-backend.vala"
		_tmp52_ = _data1_->store;
#line 370 "../backends/bluez/bluez-backend.vala"
		_tmp53_ = trusted;
#line 370 "../backends/bluez/bluez-backend.vala"
		folks_backends_blue_z_persona_store_set_is_trusted (_tmp52_, g_variant_get_boolean (_tmp53_));
#line 1725 "bluez-backend.c"
	}
#line 374 "../backends/bluez/bluez-backend.vala"
	_tmp54_ = G_VARIANT_TYPE_STRING;
#line 374 "../backends/bluez/bluez-backend.vala"
	_tmp55_ = g_variant_lookup_value (changed, "Alias", _tmp54_);
#line 374 "../backends/bluez/bluez-backend.vala"
	alias = _tmp55_;
#line 375 "../backends/bluez/bluez-backend.vala"
	_tmp56_ = alias;
#line 375 "../backends/bluez/bluez-backend.vala"
	if (_tmp56_ != NULL) {
#line 1737 "bluez-backend.c"
		FolksBackendsBlueZPersonaStore* _tmp57_;
		GVariant* _tmp58_;
		const gchar* _tmp59_;
#line 377 "../backends/bluez/bluez-backend.vala"
		_tmp57_ = _data1_->store;
#line 377 "../backends/bluez/bluez-backend.vala"
		_tmp58_ = alias;
#line 377 "../backends/bluez/bluez-backend.vala"
		_tmp59_ = g_variant_get_string (_tmp58_, NULL);
#line 377 "../backends/bluez/bluez-backend.vala"
		folks_backends_blue_z_persona_store_set_alias (_tmp57_, _tmp59_);
#line 1749 "bluez-backend.c"
	}
#line 294 "../backends/bluez/bluez-backend.vala"
	_g_variant_unref0 (alias);
#line 294 "../backends/bluez/bluez-backend.vala"
	_g_variant_unref0 (trusted);
#line 294 "../backends/bluez/bluez-backend.vala"
	_g_variant_unref0 (connected);
#line 294 "../backends/bluez/bluez-backend.vala"
	_g_variant_unref0 (blocked);
#line 294 "../backends/bluez/bluez-backend.vala"
	_g_variant_unref0 (paired);
#line 294 "../backends/bluez/bluez-backend.vala"
	_g_variant_unref0 (uuids);
#line 294 "../backends/bluez/bluez-backend.vala"
	_g_variant_unref0 (variant);
#line 294 "../backends/bluez/bluez-backend.vala"
	_g_free0 (key);
#line 294 "../backends/bluez/bluez-backend.vala"
	_g_variant_iter_free0 (iter);
#line 294 "../backends/bluez/bluez-backend.vala"
	block1_data_unref (_data1_);
#line 294 "../backends/bluez/bluez-backend.vala"
	_data1_ = NULL;
#line 1773 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_add_persona_store_data_free (gpointer _data)
{
	FolksBackendsBlueZBackendAddPersonaStoreData* _data_;
	_data_ = _data;
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->device);
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_data_->path);
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->self);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_slice_free (FolksBackendsBlueZBackendAddPersonaStoreData, _data_);
#line 1789 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_add_persona_store (FolksBackendsBlueZBackend* self,
                                                  orgbluezDevice* device,
                                                  const gchar* path,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	FolksBackendsBlueZBackendAddPersonaStoreData* _data_;
	FolksBackendsBlueZBackend* _tmp0_;
	orgbluezDevice* _tmp1_;
	gchar* _tmp2_;
#line 94 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (self != NULL);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (device != NULL);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (path != NULL);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZBackendAddPersonaStoreData);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backends_blue_z_backend_add_persona_store_data_free);
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->self = _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp1_ = _g_object_ref0 (device);
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->device);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->device = _tmp1_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp2_ = g_strdup (path);
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_data_->path);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->path = _tmp2_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_add_persona_store_co (_data_);
#line 1833 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_add_persona_store_finish (FolksBackendsBlueZBackend* self,
                                                         GAsyncResult* _res_)
{
	FolksBackendsBlueZBackendAddPersonaStoreData* _data_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1843 "bluez-backend.c"
}

/**
   * Add a new Persona store to this backend.
   *
   * Add a new Persona store associated with a device identified by
   * its address and alias. The function takes care of creating all
   * the D-Bus object and path required by the Personna store.
   *
   * @param device the D-Bus object for the Bluetooth device
   * @param path the path of the D-Bus device object.
   *
   * @since 0.9.6
   */
static void
__folks_backends_blue_z_backend_persona_store_removed_cb_folks_persona_store_removed (FolksPersonaStore* _sender,
                                                                                      gpointer self)
{
#line 405 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_persona_store_removed_cb ((FolksBackendsBlueZBackend*) self, _sender);
#line 1864 "bluez-backend.c"
}

static gboolean
_folks_backends_blue_z_backend_add_persona_store_co (FolksBackendsBlueZBackendAddPersonaStoreData* _data_)
{
#line 393 "../backends/bluez/bluez-backend.vala"
	switch (_data_->_state_) {
#line 393 "../backends/bluez/bluez-backend.vala"
		case 0:
#line 1874 "bluez-backend.c"
		goto _state_0;
		default:
#line 393 "../backends/bluez/bluez-backend.vala"
		g_assert_not_reached ();
#line 1879 "bluez-backend.c"
	}
	_state_0:
#line 395 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp0_ = _data_->self->priv->_obex_client;
#line 395 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp1_ = folks_backends_blue_z_persona_store_new (_data_->device, _data_->path, _data_->_tmp0_);
#line 395 "../backends/bluez/bluez-backend.vala"
	_data_->store = _data_->_tmp1_;
#line 399 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp2_ = org_bluez_device_get_trusted (_data_->device);
#line 399 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 399 "../backends/bluez/bluez-backend.vala"
	folks_backends_blue_z_persona_store_set_is_trusted (_data_->store, _data_->_tmp3_);
#line 400 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp4_ = org_bluez_device_get_alias (_data_->device);
#line 400 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 400 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 400 "../backends/bluez/bluez-backend.vala"
	folks_backends_blue_z_persona_store_set_alias (_data_->store, _data_->_tmp6_);
#line 400 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_data_->_tmp6_);
#line 402 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp7_ = _data_->self->priv->_watched_devices;
#line 402 "../backends/bluez/bluez-backend.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp7_, _data_->path, _data_->store);
#line 403 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp8_ = _data_->self->priv->_persona_stores;
#line 403 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp9_ = folks_persona_store_get_id ((FolksPersonaStore*) _data_->store);
#line 403 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 403 "../backends/bluez/bluez-backend.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp8_, _data_->_tmp10_, _data_->store);
#line 405 "../backends/bluez/bluez-backend.vala"
	g_signal_connect_object ((FolksPersonaStore*) _data_->store, "removed", (GCallback) __folks_backends_blue_z_backend_persona_store_removed_cb_folks_persona_store_removed, _data_->self, 0);
#line 406 "../backends/bluez/bluez-backend.vala"
	g_signal_emit_by_name ((FolksBackend*) _data_->self, "persona-store-added", (FolksPersonaStore*) _data_->store);
#line 407 "../backends/bluez/bluez-backend.vala"
	g_object_notify ((GObject*) _data_->self, "persona-stores");
#line 393 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->store);
#line 393 "../backends/bluez/bluez-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 393 "../backends/bluez/bluez-backend.vala"
	if (_data_->_state_ != 0) {
#line 393 "../backends/bluez/bluez-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 393 "../backends/bluez/bluez-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1932 "bluez-backend.c"
		}
	}
#line 393 "../backends/bluez/bluez-backend.vala"
	g_object_unref (_data_->_async_result);
#line 393 "../backends/bluez/bluez-backend.vala"
	return FALSE;
#line 1939 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_remove_persona_store (FolksBackendsBlueZBackend* self,
                                                     FolksBackendsBlueZPersonaStore* store,
                                                     gboolean remove_from_persona_stores,
                                                     gboolean remove_from_watched_devices)
{
	guint _tmp0_;
#line 410 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (self != NULL);
#line 410 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (store != NULL);
#line 413 "../backends/bluez/bluez-backend.vala"
	g_signal_parse_name ("removed", FOLKS_TYPE_PERSONA_STORE, &_tmp0_, NULL, FALSE);
#line 413 "../backends/bluez/bluez-backend.vala"
	g_signal_handlers_disconnect_matched ((FolksPersonaStore*) store, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) __folks_backends_blue_z_backend_persona_store_removed_cb_folks_persona_store_removed, self);
#line 417 "../backends/bluez/bluez-backend.vala"
	folks_backends_blue_z_persona_store_cancel_updates (store);
#line 419 "../backends/bluez/bluez-backend.vala"
	g_signal_emit_by_name ((FolksBackend*) self, "persona-store-removed", (FolksPersonaStore*) store);
#line 421 "../backends/bluez/bluez-backend.vala"
	if (remove_from_persona_stores == TRUE) {
#line 1963 "bluez-backend.c"
		GeeHashMap* _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 422 "../backends/bluez/bluez-backend.vala"
		_tmp1_ = self->priv->_persona_stores;
#line 422 "../backends/bluez/bluez-backend.vala"
		_tmp2_ = folks_persona_store_get_id ((FolksPersonaStore*) store);
#line 422 "../backends/bluez/bluez-backend.vala"
		_tmp3_ = _tmp2_;
#line 422 "../backends/bluez/bluez-backend.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, _tmp3_, NULL);
#line 1975 "bluez-backend.c"
	}
#line 423 "../backends/bluez/bluez-backend.vala"
	if (remove_from_watched_devices == TRUE) {
#line 1979 "bluez-backend.c"
		GeeHashMap* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 424 "../backends/bluez/bluez-backend.vala"
		_tmp4_ = self->priv->_watched_devices;
#line 424 "../backends/bluez/bluez-backend.vala"
		_tmp5_ = folks_backends_blue_z_persona_store_get_object_path (store);
#line 424 "../backends/bluez/bluez-backend.vala"
		_tmp6_ = _tmp5_;
#line 424 "../backends/bluez/bluez-backend.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, _tmp6_, NULL);
#line 1991 "bluez-backend.c"
	}
#line 426 "../backends/bluez/bluez-backend.vala"
	g_object_notify ((GObject*) self, "persona-stores");
#line 1995 "bluez-backend.c"
}

/**
   * Check if a device supports PSE (Phone Book Server Equipment.
   *
   * We assume that UUIDs won’t change after we initially see the device, so
   * don’t listen for changes to it.
   *
   * @param device the D-Bus device object
   * @return ``true`` if the device supports PSE, ``false`` otherwise.
   *
   * @since 0.9.6
   */
static gboolean
_folks_backends_blue_z_backend_device_supports_pbap_pse (FolksBackendsBlueZBackend* self,
                                                         orgbluezDevice* device)
{
	gchar** uuids = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gint uuids_length1;
	gint _uuids_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gboolean result;
#line 440 "../backends/bluez/bluez-backend.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 440 "../backends/bluez/bluez-backend.vala"
	g_return_val_if_fail (device != NULL, FALSE);
#line 442 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = org_bluez_device_get_uuids (device, &_tmp1_);
#line 442 "../backends/bluez/bluez-backend.vala"
	_tmp0__length1 = _tmp1_;
#line 442 "../backends/bluez/bluez-backend.vala"
	_tmp2_ = _tmp0_;
#line 442 "../backends/bluez/bluez-backend.vala"
	_tmp2__length1 = _tmp0__length1;
#line 442 "../backends/bluez/bluez-backend.vala"
	uuids = _tmp2_;
#line 442 "../backends/bluez/bluez-backend.vala"
	uuids_length1 = _tmp2__length1;
#line 442 "../backends/bluez/bluez-backend.vala"
	_uuids_size_ = uuids_length1;
#line 445 "../backends/bluez/bluez-backend.vala"
	_tmp3_ = uuids;
#line 445 "../backends/bluez/bluez-backend.vala"
	_tmp3__length1 = uuids_length1;
#line 445 "../backends/bluez/bluez-backend.vala"
	if (_tmp3_ == NULL) {
#line 446 "../backends/bluez/bluez-backend.vala"
		result = FALSE;
#line 446 "../backends/bluez/bluez-backend.vala"
		uuids = (_vala_array_free (uuids, uuids_length1, (GDestroyNotify) g_free), NULL);
#line 446 "../backends/bluez/bluez-backend.vala"
		return result;
#line 2056 "bluez-backend.c"
	}
#line 448 "../backends/bluez/bluez-backend.vala"
	_tmp4_ = uuids;
#line 448 "../backends/bluez/bluez-backend.vala"
	_tmp4__length1 = uuids_length1;
#line 2062 "bluez-backend.c"
	{
		gchar** uuid_collection = NULL;
		gint uuid_collection_length1 = 0;
		gint _uuid_collection_size_ = 0;
		gint uuid_it = 0;
#line 448 "../backends/bluez/bluez-backend.vala"
		uuid_collection = (gchar**) _tmp4_;
#line 448 "../backends/bluez/bluez-backend.vala"
		uuid_collection_length1 = (_tmp4__length1 * sizeof (gchar*)) / sizeof (gchar*);
#line 448 "../backends/bluez/bluez-backend.vala"
		for (uuid_it = 0; uuid_it < uuid_collection_length1; uuid_it = uuid_it + 1) {
#line 2074 "bluez-backend.c"
			gchar* _tmp5_;
			gchar* uuid = NULL;
#line 448 "../backends/bluez/bluez-backend.vala"
			_tmp5_ = g_strdup (uuid_collection[uuid_it]);
#line 448 "../backends/bluez/bluez-backend.vala"
			uuid = _tmp5_;
#line 2081 "bluez-backend.c"
			{
				const gchar* _tmp6_;
#line 452 "../backends/bluez/bluez-backend.vala"
				_tmp6_ = uuid;
#line 452 "../backends/bluez/bluez-backend.vala"
				if (g_strcmp0 (_tmp6_, "0000112f-0000-1000-8000-00805f9b34fb") == 0) {
#line 453 "../backends/bluez/bluez-backend.vala"
					result = TRUE;
#line 453 "../backends/bluez/bluez-backend.vala"
					_g_free0 (uuid);
#line 453 "../backends/bluez/bluez-backend.vala"
					uuids = (_vala_array_free (uuids, uuids_length1, (GDestroyNotify) g_free), NULL);
#line 453 "../backends/bluez/bluez-backend.vala"
					return result;
#line 2096 "bluez-backend.c"
				}
#line 448 "../backends/bluez/bluez-backend.vala"
				_g_free0 (uuid);
#line 2100 "bluez-backend.c"
			}
		}
	}
#line 456 "../backends/bluez/bluez-backend.vala"
	result = FALSE;
#line 456 "../backends/bluez/bluez-backend.vala"
	uuids = (_vala_array_free (uuids, uuids_length1, (GDestroyNotify) g_free), NULL);
#line 456 "../backends/bluez/bluez-backend.vala"
	return result;
#line 2110 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_refresh_devices_data_free (gpointer _data)
{
	FolksBackendsBlueZBackendRefreshDevicesData* _data_;
	_data_ = _data;
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->self);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_slice_free (FolksBackendsBlueZBackendRefreshDevicesData, _data_);
#line 2122 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_refresh_devices (FolksBackendsBlueZBackend* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	FolksBackendsBlueZBackendRefreshDevicesData* _data_;
	FolksBackendsBlueZBackend* _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (self != NULL);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZBackendRefreshDevicesData);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backends_blue_z_backend_refresh_devices_data_free);
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->self = _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_refresh_devices_co (_data_);
#line 2146 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_refresh_devices_finish (FolksBackendsBlueZBackend* self,
                                                       GAsyncResult* _res_)
{
	FolksBackendsBlueZBackendRefreshDevicesData* _data_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2156 "bluez-backend.c"
}

/**
   * Refresh the list of devices from D-Bus.
   *
   * Add any new devices which are on D-Bus but aren’t in the BlueZ backend.
   * This does not currently remove devices which have disappeared from D-Bus.
   *
   * @since 0.9.7
   */
static void
_folks_backends_blue_z_backend_refresh_devices_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_)
{
	FolksBackendsBlueZBackendRefreshDevicesData* _data_;
#line 473 "../backends/bluez/bluez-backend.vala"
	_data_ = _user_data_;
#line 473 "../backends/bluez/bluez-backend.vala"
	_data_->_source_object_ = source_object;
#line 473 "../backends/bluez/bluez-backend.vala"
	_data_->_res_ = _res_;
#line 473 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_refresh_devices_co (_data_);
#line 2181 "bluez-backend.c"
}

static gboolean
_folks_backends_blue_z_backend_refresh_devices_co (FolksBackendsBlueZBackendRefreshDevicesData* _data_)
{
#line 467 "../backends/bluez/bluez-backend.vala"
	switch (_data_->_state_) {
#line 467 "../backends/bluez/bluez-backend.vala"
		case 0:
#line 2191 "bluez-backend.c"
		goto _state_0;
#line 467 "../backends/bluez/bluez-backend.vala"
		case 1:
#line 2195 "bluez-backend.c"
		goto _state_1;
		default:
#line 467 "../backends/bluez/bluez-backend.vala"
		g_assert_not_reached ();
#line 2200 "bluez-backend.c"
	}
	_state_0:
#line 469 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp0_ = _data_->self->priv->_manager;
#line 469 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp1_ = g_dbus_object_manager_get_objects ((GDBusObjectManager*) _data_->_tmp0_);
#line 469 "../backends/bluez/bluez-backend.vala"
	_data_->objs = _data_->_tmp1_;
#line 471 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp2_ = _data_->objs;
#line 2211 "bluez-backend.c"
	{
#line 471 "../backends/bluez/bluez-backend.vala"
		_data_->obj_collection = _data_->_tmp2_;
#line 471 "../backends/bluez/bluez-backend.vala"
		for (_data_->obj_it = _data_->obj_collection; _data_->obj_it != NULL; _data_->obj_it = _data_->obj_it->next) {
#line 471 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp3_ = _g_object_ref0 ((GDBusObject*) _data_->obj_it->data);
#line 471 "../backends/bluez/bluez-backend.vala"
			_data_->obj = _data_->_tmp3_;
#line 2221 "bluez-backend.c"
			{
#line 473 "../backends/bluez/bluez-backend.vala"
				_data_->_tmp4_ = _data_->obj;
#line 473 "../backends/bluez/bluez-backend.vala"
				_data_->_state_ = 1;
#line 473 "../backends/bluez/bluez-backend.vala"
				_folks_backends_blue_z_backend_add_device (_data_->self, _data_->_tmp4_, _folks_backends_blue_z_backend_refresh_devices_ready, _data_);
#line 473 "../backends/bluez/bluez-backend.vala"
				return FALSE;
#line 2231 "bluez-backend.c"
				_state_1:
#line 473 "../backends/bluez/bluez-backend.vala"
				_folks_backends_blue_z_backend_add_device_finish (_data_->self, _data_->_res_);
#line 471 "../backends/bluez/bluez-backend.vala"
				_g_object_unref0 (_data_->obj);
#line 2237 "bluez-backend.c"
			}
		}
	}
#line 467 "../backends/bluez/bluez-backend.vala"
	(_data_->objs == NULL) ? NULL : (_data_->objs = (_g_list_free__g_object_unref0_ (_data_->objs), NULL));
#line 467 "../backends/bluez/bluez-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 467 "../backends/bluez/bluez-backend.vala"
	if (_data_->_state_ != 0) {
#line 467 "../backends/bluez/bluez-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 467 "../backends/bluez/bluez-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2251 "bluez-backend.c"
		}
	}
#line 467 "../backends/bluez/bluez-backend.vala"
	g_object_unref (_data_->_async_result);
#line 467 "../backends/bluez/bluez-backend.vala"
	return FALSE;
#line 2258 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_add_device_data_free (gpointer _data)
{
	FolksBackendsBlueZBackendAddDeviceData* _data_;
	_data_ = _data;
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->obj);
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->self);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_slice_free (FolksBackendsBlueZBackendAddDeviceData, _data_);
#line 2272 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_add_device (FolksBackendsBlueZBackend* self,
                                           GDBusObject* obj,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	FolksBackendsBlueZBackendAddDeviceData* _data_;
	FolksBackendsBlueZBackend* _tmp0_;
	GDBusObject* _tmp1_;
#line 94 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (self != NULL);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (obj != NULL);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZBackendAddDeviceData);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backends_blue_z_backend_add_device_data_free);
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->self = _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp1_ = _g_object_ref0 (obj);
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->obj);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->obj = _tmp1_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_add_device_co (_data_);
#line 2306 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_add_device_finish (FolksBackendsBlueZBackend* self,
                                                  GAsyncResult* _res_)
{
	FolksBackendsBlueZBackendAddDeviceData* _data_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2316 "bluez-backend.c"
}

/**
   * Add a device to the backend.
   *
   * @param _obj the device's D-Bus object
   *
   * @since 0.9.6
   */
static void
_folks_backends_blue_z_backend_add_device_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	FolksBackendsBlueZBackendAddDeviceData* _data_;
#line 529 "../backends/bluez/bluez-backend.vala"
	_data_ = _user_data_;
#line 529 "../backends/bluez/bluez-backend.vala"
	_data_->_source_object_ = source_object;
#line 529 "../backends/bluez/bluez-backend.vala"
	_data_->_res_ = _res_;
#line 529 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_add_device_co (_data_);
#line 2340 "bluez-backend.c"
}

static gboolean
_folks_backends_blue_z_backend_add_device_co (FolksBackendsBlueZBackendAddDeviceData* _data_)
{
#line 484 "../backends/bluez/bluez-backend.vala"
	switch (_data_->_state_) {
#line 484 "../backends/bluez/bluez-backend.vala"
		case 0:
#line 2350 "bluez-backend.c"
		goto _state_0;
#line 484 "../backends/bluez/bluez-backend.vala"
		case 1:
#line 2354 "bluez-backend.c"
		goto _state_1;
		default:
#line 484 "../backends/bluez/bluez-backend.vala"
		g_assert_not_reached ();
#line 2359 "bluez-backend.c"
	}
	_state_0:
#line 486 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp0_ = g_dbus_object_get_object_path (_data_->obj);
#line 486 "../backends/bluez/bluez-backend.vala"
	g_debug ("bluez-backend.vala:486: Adding device at path ‘%s’.", _data_->_tmp0_);
#line 488 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp1_ = g_dbus_object_get_interface (_data_->obj, "org.bluez.Device1");
#line 488 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp2_ = ORG_BLUEZ_IS_DEVICE (_data_->_tmp1_) ? ((orgbluezDevice*) _data_->_tmp1_) : NULL;
#line 488 "../backends/bluez/bluez-backend.vala"
	if (_data_->_tmp2_ == NULL) {
#line 488 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data_->_tmp1_);
#line 2374 "bluez-backend.c"
	}
#line 488 "../backends/bluez/bluez-backend.vala"
	_data_->device = _data_->_tmp2_;
#line 489 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp3_ = _data_->device;
#line 489 "../backends/bluez/bluez-backend.vala"
	if (_data_->_tmp3_ == NULL) {
#line 491 "../backends/bluez/bluez-backend.vala"
		g_debug ("bluez-backend.vala:491: %s", "    Device doesn’t implement org.bluez.Device1 " "interface. Ignoring.");
#line 493 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data_->device);
#line 493 "../backends/bluez/bluez-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 493 "../backends/bluez/bluez-backend.vala"
		if (_data_->_state_ != 0) {
#line 493 "../backends/bluez/bluez-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 493 "../backends/bluez/bluez-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2394 "bluez-backend.c"
			}
		}
#line 493 "../backends/bluez/bluez-backend.vala"
		g_object_unref (_data_->_async_result);
#line 493 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 2401 "bluez-backend.c"
	}
#line 496 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp4_ = g_dbus_object_get_object_path (_data_->obj);
#line 496 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp5_ = g_strdup (_data_->_tmp4_);
#line 496 "../backends/bluez/bluez-backend.vala"
	_data_->path = _data_->_tmp5_;
#line 498 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp6_ = _data_->self->priv->_watched_devices;
#line 498 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp7_ = _data_->path;
#line 498 "../backends/bluez/bluez-backend.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _data_->_tmp6_, _data_->_tmp7_)) {
#line 500 "../backends/bluez/bluez-backend.vala"
		g_debug ("bluez-backend.vala:500:     Device already watched. Ignoring.");
#line 501 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_data_->path);
#line 501 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data_->device);
#line 501 "../backends/bluez/bluez-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 501 "../backends/bluez/bluez-backend.vala"
		if (_data_->_state_ != 0) {
#line 501 "../backends/bluez/bluez-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 501 "../backends/bluez/bluez-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2429 "bluez-backend.c"
			}
		}
#line 501 "../backends/bluez/bluez-backend.vala"
		g_object_unref (_data_->_async_result);
#line 501 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 2436 "bluez-backend.c"
	}
#line 504 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp8_ = _data_->device;
#line 504 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp9_ = org_bluez_device_get_paired (_data_->_tmp8_);
#line 504 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 504 "../backends/bluez/bluez-backend.vala"
	if (_data_->_tmp10_ == FALSE) {
#line 506 "../backends/bluez/bluez-backend.vala"
		g_debug ("bluez-backend.vala:506: %s", "    Device isn’t paired. Ignoring. Manually pair the device" " to start downloading contacts.");
#line 508 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_data_->path);
#line 508 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data_->device);
#line 508 "../backends/bluez/bluez-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 508 "../backends/bluez/bluez-backend.vala"
		if (_data_->_state_ != 0) {
#line 508 "../backends/bluez/bluez-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 508 "../backends/bluez/bluez-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2460 "bluez-backend.c"
			}
		}
#line 508 "../backends/bluez/bluez-backend.vala"
		g_object_unref (_data_->_async_result);
#line 508 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 2467 "bluez-backend.c"
	}
#line 511 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp11_ = _data_->device;
#line 511 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp12_ = org_bluez_device_get_blocked (_data_->_tmp11_);
#line 511 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp13_ = _data_->_tmp12_;
#line 511 "../backends/bluez/bluez-backend.vala"
	if (_data_->_tmp13_ == TRUE) {
#line 513 "../backends/bluez/bluez-backend.vala"
		g_debug ("bluez-backend.vala:513:     Device is blocked. Ignoring.");
#line 514 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_data_->path);
#line 514 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data_->device);
#line 514 "../backends/bluez/bluez-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 514 "../backends/bluez/bluez-backend.vala"
		if (_data_->_state_ != 0) {
#line 514 "../backends/bluez/bluez-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 514 "../backends/bluez/bluez-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2491 "bluez-backend.c"
			}
		}
#line 514 "../backends/bluez/bluez-backend.vala"
		g_object_unref (_data_->_async_result);
#line 514 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 2498 "bluez-backend.c"
	}
#line 517 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp14_ = _data_->device;
#line 517 "../backends/bluez/bluez-backend.vala"
	if (!_folks_backends_blue_z_backend_device_supports_pbap_pse (_data_->self, _data_->_tmp14_)) {
#line 519 "../backends/bluez/bluez-backend.vala"
		g_debug ("bluez-backend.vala:519:     Doesn’t support PBAP PSE. Ignoring.");
#line 520 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_data_->path);
#line 520 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data_->device);
#line 520 "../backends/bluez/bluez-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 520 "../backends/bluez/bluez-backend.vala"
		if (_data_->_state_ != 0) {
#line 520 "../backends/bluez/bluez-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 520 "../backends/bluez/bluez-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2518 "bluez-backend.c"
			}
		}
#line 520 "../backends/bluez/bluez-backend.vala"
		g_object_unref (_data_->_async_result);
#line 520 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 2525 "bluez-backend.c"
	}
#line 523 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp15_ = _data_->self->priv->_enabled_devices;
#line 523 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp16_ = _data_->device;
#line 523 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp17_ = org_bluez_device_get_address (_data_->_tmp16_);
#line 523 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 523 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 523 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp20_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) _data_->_tmp15_, _data_->_tmp19_);
#line 523 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_data_->_tmp19_);
#line 523 "../backends/bluez/bluez-backend.vala"
	if (_data_->_tmp20_) {
#line 525 "../backends/bluez/bluez-backend.vala"
		g_debug ("bluez-backend.vala:525:     Device not in enabled devices list.");
#line 526 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_data_->path);
#line 526 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data_->device);
#line 526 "../backends/bluez/bluez-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 526 "../backends/bluez/bluez-backend.vala"
		if (_data_->_state_ != 0) {
#line 526 "../backends/bluez/bluez-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 526 "../backends/bluez/bluez-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2557 "bluez-backend.c"
			}
		}
#line 526 "../backends/bluez/bluez-backend.vala"
		g_object_unref (_data_->_async_result);
#line 526 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 2564 "bluez-backend.c"
	}
#line 529 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp21_ = _data_->device;
#line 529 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp22_ = _data_->path;
#line 529 "../backends/bluez/bluez-backend.vala"
	_data_->_state_ = 1;
#line 529 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_add_persona_store (_data_->self, _data_->_tmp21_, _data_->_tmp22_, _folks_backends_blue_z_backend_add_device_ready, _data_);
#line 529 "../backends/bluez/bluez-backend.vala"
	return FALSE;
#line 2576 "bluez-backend.c"
	_state_1:
#line 529 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_add_persona_store_finish (_data_->self, _data_->_res_);
#line 484 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_data_->path);
#line 484 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->device);
#line 484 "../backends/bluez/bluez-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 484 "../backends/bluez/bluez-backend.vala"
	if (_data_->_state_ != 0) {
#line 484 "../backends/bluez/bluez-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 484 "../backends/bluez/bluez-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2592 "bluez-backend.c"
		}
	}
#line 484 "../backends/bluez/bluez-backend.vala"
	g_object_unref (_data_->_async_result);
#line 484 "../backends/bluez/bluez-backend.vala"
	return FALSE;
#line 2599 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_remove_device_data_free (gpointer _data)
{
	FolksBackendsBlueZBackendRemoveDeviceData* _data_;
	_data_ = _data;
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->obj);
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->self);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_slice_free (FolksBackendsBlueZBackendRemoveDeviceData, _data_);
#line 2613 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_remove_device (FolksBackendsBlueZBackend* self,
                                              GDBusObject* obj,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	FolksBackendsBlueZBackendRemoveDeviceData* _data_;
	FolksBackendsBlueZBackend* _tmp0_;
	GDBusObject* _tmp1_;
#line 94 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (self != NULL);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (obj != NULL);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZBackendRemoveDeviceData);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backends_blue_z_backend_remove_device_data_free);
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->self = _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp1_ = _g_object_ref0 (obj);
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->obj);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->obj = _tmp1_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_remove_device_co (_data_);
#line 2647 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_remove_device_finish (FolksBackendsBlueZBackend* self,
                                                     GAsyncResult* _res_)
{
	FolksBackendsBlueZBackendRemoveDeviceData* _data_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2657 "bluez-backend.c"
}

/**
   * Remove a device from the backend.
   *
   * @param obj the device's D-Bus object
   *
   * @since 0.9.6
   */
static gboolean
_folks_backends_blue_z_backend_remove_device_co (FolksBackendsBlueZBackendRemoveDeviceData* _data_)
{
#line 539 "../backends/bluez/bluez-backend.vala"
	switch (_data_->_state_) {
#line 539 "../backends/bluez/bluez-backend.vala"
		case 0:
#line 2674 "bluez-backend.c"
		goto _state_0;
		default:
#line 539 "../backends/bluez/bluez-backend.vala"
		g_assert_not_reached ();
#line 2679 "bluez-backend.c"
	}
	_state_0:
#line 541 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp0_ = g_dbus_object_get_object_path (_data_->obj);
#line 541 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp1_ = g_strdup (_data_->_tmp0_);
#line 541 "../backends/bluez/bluez-backend.vala"
	_data_->path = _data_->_tmp1_;
#line 542 "../backends/bluez/bluez-backend.vala"
	_data_->store = NULL;
#line 544 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp2_ = _data_->path;
#line 544 "../backends/bluez/bluez-backend.vala"
	g_debug ("bluez-backend.vala:544: Removing device at ‘%s’.", _data_->_tmp2_);
#line 546 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp3_ = _data_->self->priv->_watched_devices;
#line 546 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp4_ = _data_->path;
#line 546 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp5_ = NULL;
#line 546 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp6_ = gee_abstract_map_unset ((GeeAbstractMap*) _data_->_tmp3_, _data_->_tmp4_, &_data_->_tmp5_);
#line 546 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->store);
#line 546 "../backends/bluez/bluez-backend.vala"
	_data_->store = (FolksBackendsBlueZPersonaStore*) _data_->_tmp5_;
#line 546 "../backends/bluez/bluez-backend.vala"
	if (_data_->_tmp6_ == TRUE) {
#line 548 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp7_ = _data_->path;
#line 548 "../backends/bluez/bluez-backend.vala"
		g_debug ("bluez-backend.vala:548: Device ‘%s’ removed", _data_->_tmp7_);
#line 549 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp8_ = _data_->store;
#line 549 "../backends/bluez/bluez-backend.vala"
		_folks_backends_blue_z_backend_remove_persona_store (_data_->self, _data_->_tmp8_, TRUE, FALSE);
#line 2716 "bluez-backend.c"
	}
#line 539 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->store);
#line 539 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_data_->path);
#line 539 "../backends/bluez/bluez-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 539 "../backends/bluez/bluez-backend.vala"
	if (_data_->_state_ != 0) {
#line 539 "../backends/bluez/bluez-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 539 "../backends/bluez/bluez-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2730 "bluez-backend.c"
		}
	}
#line 539 "../backends/bluez/bluez-backend.vala"
	g_object_unref (_data_->_async_result);
#line 539 "../backends/bluez/bluez-backend.vala"
	return FALSE;
#line 2737 "bluez-backend.c"
}

static gchar*
_folks_backends_blue_z_backend_get_enabled_devices_key_file_path (FolksBackendsBlueZBackend* self)
{
	GFile* file = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 553 "../backends/bluez/bluez-backend.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 555 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 555 "../backends/bluez/bluez-backend.vala"
	_tmp1_ = g_file_new_for_path (_tmp0_);
#line 555 "../backends/bluez/bluez-backend.vala"
	file = _tmp1_;
#line 556 "../backends/bluez/bluez-backend.vala"
	_tmp2_ = file;
#line 556 "../backends/bluez/bluez-backend.vala"
	_tmp3_ = g_file_get_child (_tmp2_, "folks");
#line 556 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (file);
#line 556 "../backends/bluez/bluez-backend.vala"
	file = _tmp3_;
#line 557 "../backends/bluez/bluez-backend.vala"
	_tmp4_ = file;
#line 557 "../backends/bluez/bluez-backend.vala"
	_tmp5_ = g_file_get_child (_tmp4_, "bluez-persona-stores.ini");
#line 557 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (file);
#line 557 "../backends/bluez/bluez-backend.vala"
	file = _tmp5_;
#line 559 "../backends/bluez/bluez-backend.vala"
	_tmp6_ = file;
#line 559 "../backends/bluez/bluez-backend.vala"
	_tmp7_ = g_file_get_path (_tmp6_);
#line 559 "../backends/bluez/bluez-backend.vala"
	result = _tmp7_;
#line 559 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (file);
#line 559 "../backends/bluez/bluez-backend.vala"
	return result;
#line 2787 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_save_enabled_devices_data_free (gpointer _data)
{
	FolksBackendsBlueZBackendSaveEnabledDevicesData* _data_;
	_data_ = _data;
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->self);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_slice_free (FolksBackendsBlueZBackendSaveEnabledDevicesData, _data_);
#line 2799 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_save_enabled_devices (FolksBackendsBlueZBackend* self,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	FolksBackendsBlueZBackendSaveEnabledDevicesData* _data_;
	FolksBackendsBlueZBackend* _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (self != NULL);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZBackendSaveEnabledDevicesData);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backends_blue_z_backend_save_enabled_devices_data_free);
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->self = _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_save_enabled_devices_co (_data_);
#line 2823 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_save_enabled_devices_finish (FolksBackendsBlueZBackend* self,
                                                            GAsyncResult* _res_)
{
	FolksBackendsBlueZBackendSaveEnabledDevicesData* _data_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2833 "bluez-backend.c"
}

/**
   * Save the list of enabled devices to a configuration file.
   *
   * @since 0.11.4
   */
static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 2875 "bluez-backend.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 2881 "bluez-backend.c"
}

static gboolean
_folks_backends_blue_z_backend_save_enabled_devices_co (FolksBackendsBlueZBackendSaveEnabledDevicesData* _data_)
{
#line 567 "../backends/bluez/bluez-backend.vala"
	switch (_data_->_state_) {
#line 567 "../backends/bluez/bluez-backend.vala"
		case 0:
#line 2891 "bluez-backend.c"
		goto _state_0;
		default:
#line 567 "../backends/bluez/bluez-backend.vala"
		g_assert_not_reached ();
#line 2896 "bluez-backend.c"
	}
	_state_0:
#line 569 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp0_ = g_key_file_new ();
#line 569 "../backends/bluez/bluez-backend.vala"
	_data_->kf = _data_->_tmp0_;
#line 570 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp1_ = _folks_backends_blue_z_backend_get_enabled_devices_key_file_path (_data_->self);
#line 570 "../backends/bluez/bluez-backend.vala"
	_data_->kf_path = _data_->_tmp1_;
#line 2907 "bluez-backend.c"
	{
#line 572 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp2_ = _data_->self->priv->_enabled_devices;
#line 572 "../backends/bluez/bluez-backend.vala"
		_data_->_address_list = _data_->_tmp2_;
#line 572 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp3_ = _data_->_address_list;
#line 572 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp4_ = gee_collection_get_size ((GeeCollection*) _data_->_tmp3_);
#line 572 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 572 "../backends/bluez/bluez-backend.vala"
		_data_->_address_size = _data_->_tmp5_;
#line 572 "../backends/bluez/bluez-backend.vala"
		_data_->_address_index = -1;
#line 572 "../backends/bluez/bluez-backend.vala"
		while (TRUE) {
#line 572 "../backends/bluez/bluez-backend.vala"
			_data_->_address_index = _data_->_address_index + 1;
#line 572 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp6_ = _data_->_address_index;
#line 572 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp7_ = _data_->_address_size;
#line 572 "../backends/bluez/bluez-backend.vala"
			if (!(_data_->_tmp6_ < _data_->_tmp7_)) {
#line 572 "../backends/bluez/bluez-backend.vala"
				break;
#line 2935 "bluez-backend.c"
			}
#line 572 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp8_ = _data_->_address_list;
#line 572 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp9_ = folks_small_set_get (_data_->_tmp8_, _data_->_address_index);
#line 572 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp10_ = g_strdup ((const gchar*) _data_->_tmp9_);
#line 572 "../backends/bluez/bluez-backend.vala"
			_data_->address = _data_->_tmp10_;
#line 573 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp11_ = _data_->kf;
#line 573 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp12_ = _data_->address;
#line 573 "../backends/bluez/bluez-backend.vala"
			g_key_file_set_boolean (_data_->_tmp11_, _data_->_tmp12_, "enabled", TRUE);
#line 572 "../backends/bluez/bluez-backend.vala"
			_g_free0 (_data_->address);
#line 2953 "bluez-backend.c"
		}
	}
#line 575 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp13_ = _data_->kf_path;
#line 575 "../backends/bluez/bluez-backend.vala"
	g_debug ("bluez-backend.vala:575: Saving BlueZ enabled devices key file ‘%s’.", _data_->_tmp13_);
#line 2960 "bluez-backend.c"
	{
#line 579 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp14_ = _data_->kf_path;
#line 579 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp15_ = g_file_new_for_path (_data_->_tmp14_);
#line 579 "../backends/bluez/bluez-backend.vala"
		_data_->file = _data_->_tmp15_;
#line 580 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp16_ = _data_->kf;
#line 580 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp17_ = g_key_file_to_data (_data_->_tmp16_, NULL, NULL);
#line 580 "../backends/bluez/bluez-backend.vala"
		_data_->data = _data_->_tmp17_;
#line 581 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp19_ = 0;
#line 581 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp18_ = string_get_data (_data_->data, &_data_->_tmp19_);
#line 581 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp18__length1 = _data_->_tmp19_;
#line 581 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp20_ = _data_->_tmp18_;
#line 581 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp20__length1 = _data_->_tmp18__length1;
#line 581 "../backends/bluez/bluez-backend.vala"
		g_file_replace_contents (_data_->file, (const char*) _data_->_tmp20_, (gsize) _data_->_tmp20__length1, NULL, FALSE, G_FILE_CREATE_PRIVATE, NULL, NULL, &_data_->_inner_error0_);
#line 581 "../backends/bluez/bluez-backend.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 581 "../backends/bluez/bluez-backend.vala"
			_g_free0 (_data_->data);
#line 581 "../backends/bluez/bluez-backend.vala"
			_g_object_unref0 (_data_->file);
#line 2992 "bluez-backend.c"
			goto __catch0_g_error;
		}
#line 577 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_data_->data);
#line 577 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data_->file);
#line 2999 "bluez-backend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 577 "../backends/bluez/bluez-backend.vala"
		_data_->e = _data_->_inner_error0_;
#line 577 "../backends/bluez/bluez-backend.vala"
		_data_->_inner_error0_ = NULL;
#line 587 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp21_ = _data_->kf_path;
#line 587 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp22_ = _data_->e;
#line 587 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp23_ = _data_->_tmp22_->message;
#line 587 "../backends/bluez/bluez-backend.vala"
		g_warning ("Could not write updated BlueZ enabled devices key file " "‘%s’: %s", _data_->_tmp21_, _data_->_tmp23_);
#line 577 "../backends/bluez/bluez-backend.vala"
		_g_error_free0 (_data_->e);
#line 3018 "bluez-backend.c"
	}
	__finally0:
#line 577 "../backends/bluez/bluez-backend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 577 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_data_->kf_path);
#line 577 "../backends/bluez/bluez-backend.vala"
		_g_key_file_unref0 (_data_->kf);
#line 577 "../backends/bluez/bluez-backend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 577 "../backends/bluez/bluez-backend.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 577 "../backends/bluez/bluez-backend.vala"
		g_object_unref (_data_->_async_result);
#line 577 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 3035 "bluez-backend.c"
	}
#line 567 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_data_->kf_path);
#line 567 "../backends/bluez/bluez-backend.vala"
	_g_key_file_unref0 (_data_->kf);
#line 567 "../backends/bluez/bluez-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 567 "../backends/bluez/bluez-backend.vala"
	if (_data_->_state_ != 0) {
#line 567 "../backends/bluez/bluez-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 567 "../backends/bluez/bluez-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3049 "bluez-backend.c"
		}
	}
#line 567 "../backends/bluez/bluez-backend.vala"
	g_object_unref (_data_->_async_result);
#line 567 "../backends/bluez/bluez-backend.vala"
	return FALSE;
#line 3056 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_load_enabled_devices_data_free (gpointer _data)
{
	FolksBackendsBlueZBackendLoadEnabledDevicesData* _data_;
	_data_ = _data;
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->self);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_slice_free (FolksBackendsBlueZBackendLoadEnabledDevicesData, _data_);
#line 3068 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_load_enabled_devices (FolksBackendsBlueZBackend* self,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	FolksBackendsBlueZBackendLoadEnabledDevicesData* _data_;
	FolksBackendsBlueZBackend* _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (self != NULL);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZBackendLoadEnabledDevicesData);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backends_blue_z_backend_load_enabled_devices_data_free);
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->self = _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_load_enabled_devices_co (_data_);
#line 3092 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_load_enabled_devices_finish (FolksBackendsBlueZBackend* self,
                                                            GAsyncResult* _res_)
{
	FolksBackendsBlueZBackendLoadEnabledDevicesData* _data_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3102 "bluez-backend.c"
}

/**
   * Load the list of enabled devices from a configuration file.
   *
   * @since 0.11.4
   */
static void
_folks_backends_blue_z_backend_load_enabled_devices_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	FolksBackendsBlueZBackendLoadEnabledDevicesData* _data_;
#line 609 "../backends/bluez/bluez-backend.vala"
	_data_ = _user_data_;
#line 609 "../backends/bluez/bluez-backend.vala"
	_data_->_source_object_ = source_object;
#line 609 "../backends/bluez/bluez-backend.vala"
	_data_->_res_ = _res_;
#line 609 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_load_enabled_devices_co (_data_);
#line 3124 "bluez-backend.c"
}

static gboolean
_folks_backends_blue_z_backend_load_enabled_devices_co (FolksBackendsBlueZBackendLoadEnabledDevicesData* _data_)
{
#line 597 "../backends/bluez/bluez-backend.vala"
	switch (_data_->_state_) {
#line 597 "../backends/bluez/bluez-backend.vala"
		case 0:
#line 3134 "bluez-backend.c"
		goto _state_0;
#line 597 "../backends/bluez/bluez-backend.vala"
		case 1:
#line 3138 "bluez-backend.c"
		goto _state_1;
		default:
#line 597 "../backends/bluez/bluez-backend.vala"
		g_assert_not_reached ();
#line 3143 "bluez-backend.c"
	}
	_state_0:
#line 599 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp0_ = g_key_file_new ();
#line 599 "../backends/bluez/bluez-backend.vala"
	_data_->kf = _data_->_tmp0_;
#line 600 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp1_ = _folks_backends_blue_z_backend_get_enabled_devices_key_file_path (_data_->self);
#line 600 "../backends/bluez/bluez-backend.vala"
	_data_->kf_path = _data_->_tmp1_;
#line 602 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp2_ = _data_->kf_path;
#line 602 "../backends/bluez/bluez-backend.vala"
	g_debug ("bluez-backend.vala:602: Loading BlueZ enabled devices key file ‘%s’.", _data_->_tmp2_);
#line 3158 "bluez-backend.c"
	{
#line 606 "../backends/bluez/bluez-backend.vala"
		_data_->contents_length1 = 0;
#line 606 "../backends/bluez/bluez-backend.vala"
		_data_->_contents_size_ = 0;
#line 608 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp3_ = _data_->kf_path;
#line 608 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp4_ = g_file_new_for_path (_data_->_tmp3_);
#line 608 "../backends/bluez/bluez-backend.vala"
		_data_->file = _data_->_tmp4_;
#line 609 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp5_ = _data_->file;
#line 609 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp6_ = NULL;
#line 609 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp7_ = 0;
#line 609 "../backends/bluez/bluez-backend.vala"
		_data_->_state_ = 1;
#line 609 "../backends/bluez/bluez-backend.vala"
		g_file_load_contents_async (_data_->_tmp5_, NULL, _folks_backends_blue_z_backend_load_enabled_devices_ready, _data_);
#line 609 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 3182 "bluez-backend.c"
		_state_1:
#line 609 "../backends/bluez/bluez-backend.vala"
		g_file_load_contents_finish (_data_->_tmp5_, _data_->_res_, &_data_->_tmp6_, &_data_->_tmp7_, NULL, &_data_->_inner_error0_);
#line 609 "../backends/bluez/bluez-backend.vala"
		_data_->contents = (g_free (_data_->contents), NULL);
#line 609 "../backends/bluez/bluez-backend.vala"
		_data_->contents = _data_->_tmp6_;
#line 609 "../backends/bluez/bluez-backend.vala"
		_data_->contents_length1 = _data_->_tmp7_;
#line 609 "../backends/bluez/bluez-backend.vala"
		_data_->_contents_size_ = _data_->contents_length1;
#line 609 "../backends/bluez/bluez-backend.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 609 "../backends/bluez/bluez-backend.vala"
			_g_object_unref0 (_data_->file);
#line 609 "../backends/bluez/bluez-backend.vala"
			_data_->contents = (g_free (_data_->contents), NULL);
#line 3200 "bluez-backend.c"
			goto __catch0_g_error;
		}
#line 610 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp8_ = _data_->contents;
#line 610 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp8__length1 = _data_->contents_length1;
#line 610 "../backends/bluez/bluez-backend.vala"
		_data_->contents_s = (const gchar*) _data_->_tmp8_;
#line 612 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp9_ = _data_->contents_s;
#line 612 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp10_ = strlen (_data_->_tmp9_);
#line 612 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 612 "../backends/bluez/bluez-backend.vala"
		if (_data_->_tmp11_ > 0) {
#line 614 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp12_ = _data_->kf;
#line 614 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp13_ = _data_->contents_s;
#line 614 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp14_ = _data_->contents_s;
#line 614 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp15_ = strlen (_data_->_tmp14_);
#line 614 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp16_ = _data_->_tmp15_;
#line 614 "../backends/bluez/bluez-backend.vala"
			g_key_file_load_from_data (_data_->_tmp12_, _data_->_tmp13_, (gsize) _data_->_tmp16_, G_KEY_FILE_KEEP_COMMENTS, &_data_->_inner_error0_);
#line 614 "../backends/bluez/bluez-backend.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 614 "../backends/bluez/bluez-backend.vala"
				_g_object_unref0 (_data_->file);
#line 614 "../backends/bluez/bluez-backend.vala"
				_data_->contents = (g_free (_data_->contents), NULL);
#line 3235 "bluez-backend.c"
				goto __catch0_g_error;
			}
		}
#line 604 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data_->file);
#line 604 "../backends/bluez/bluez-backend.vala"
		_data_->contents = (g_free (_data_->contents), NULL);
#line 3243 "bluez-backend.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 604 "../backends/bluez/bluez-backend.vala"
		_data_->e1 = _data_->_inner_error0_;
#line 604 "../backends/bluez/bluez-backend.vala"
		_data_->_inner_error0_ = NULL;
#line 620 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp17_ = _data_->e1;
#line 620 "../backends/bluez/bluez-backend.vala"
		if (!g_error_matches (_data_->_tmp17_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 622 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp18_ = _data_->kf_path;
#line 622 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp19_ = _data_->e1;
#line 622 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp20_ = _data_->_tmp19_->message;
#line 622 "../backends/bluez/bluez-backend.vala"
			g_warning ("The BlueZ enabled devices key file ‘%s’ could not be " "loaded: %s", _data_->_tmp18_, _data_->_tmp20_);
#line 624 "../backends/bluez/bluez-backend.vala"
			_g_error_free0 (_data_->e1);
#line 624 "../backends/bluez/bluez-backend.vala"
			_g_free0 (_data_->kf_path);
#line 624 "../backends/bluez/bluez-backend.vala"
			_g_key_file_unref0 (_data_->kf);
#line 624 "../backends/bluez/bluez-backend.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 624 "../backends/bluez/bluez-backend.vala"
			if (_data_->_state_ != 0) {
#line 624 "../backends/bluez/bluez-backend.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 624 "../backends/bluez/bluez-backend.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3278 "bluez-backend.c"
				}
			}
#line 624 "../backends/bluez/bluez-backend.vala"
			g_object_unref (_data_->_async_result);
#line 624 "../backends/bluez/bluez-backend.vala"
			return FALSE;
#line 3285 "bluez-backend.c"
		} else {
#line 628 "../backends/bluez/bluez-backend.vala"
			g_debug ("bluez-backend.vala:628:     Not found.");
#line 3289 "bluez-backend.c"
		}
#line 604 "../backends/bluez/bluez-backend.vala"
		_g_error_free0 (_data_->e1);
#line 3293 "bluez-backend.c"
	}
	__finally0:
#line 604 "../backends/bluez/bluez-backend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 604 "../backends/bluez/bluez-backend.vala"
		_g_free0 (_data_->kf_path);
#line 604 "../backends/bluez/bluez-backend.vala"
		_g_key_file_unref0 (_data_->kf);
#line 604 "../backends/bluez/bluez-backend.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 604 "../backends/bluez/bluez-backend.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 604 "../backends/bluez/bluez-backend.vala"
		g_object_unref (_data_->_async_result);
#line 604 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 3310 "bluez-backend.c"
	}
#line 633 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp21_ = _data_->self->priv->_enabled_devices;
#line 633 "../backends/bluez/bluez-backend.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _data_->_tmp21_);
#line 634 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp22_ = _data_->kf;
#line 634 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp23_ = 0;
#line 634 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp24_ = g_key_file_get_groups (_data_->_tmp22_, &_data_->_tmp23_);
#line 634 "../backends/bluez/bluez-backend.vala"
	_data_->groups = _data_->_tmp24_;
#line 634 "../backends/bluez/bluez-backend.vala"
	_data_->groups_length1 = _data_->_tmp23_;
#line 634 "../backends/bluez/bluez-backend.vala"
	_data_->_groups_size_ = _data_->groups_length1;
#line 635 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp25_ = _data_->groups;
#line 635 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp25__length1 = _data_->groups_length1;
#line 3332 "bluez-backend.c"
	{
#line 635 "../backends/bluez/bluez-backend.vala"
		_data_->address_collection_length1 = 0;
#line 635 "../backends/bluez/bluez-backend.vala"
		_data_->_address_collection_size_ = 0;
#line 635 "../backends/bluez/bluez-backend.vala"
		_data_->address_collection = _data_->_tmp25_;
#line 635 "../backends/bluez/bluez-backend.vala"
		_data_->address_collection_length1 = _data_->_tmp25__length1;
#line 635 "../backends/bluez/bluez-backend.vala"
		for (_data_->address_it = 0; _data_->address_it < _data_->address_collection_length1; _data_->address_it = _data_->address_it + 1) {
#line 635 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp26_ = g_strdup (_data_->address_collection[_data_->address_it]);
#line 635 "../backends/bluez/bluez-backend.vala"
			_data_->address = _data_->_tmp26_;
#line 3348 "bluez-backend.c"
			{
				{
#line 639 "../backends/bluez/bluez-backend.vala"
					_data_->_tmp28_ = _data_->kf;
#line 639 "../backends/bluez/bluez-backend.vala"
					_data_->_tmp29_ = _data_->address;
#line 639 "../backends/bluez/bluez-backend.vala"
					_data_->_tmp27_ = g_key_file_get_boolean (_data_->_tmp28_, _data_->_tmp29_, "enabled", &_data_->_inner_error0_);
#line 639 "../backends/bluez/bluez-backend.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 639 "../backends/bluez/bluez-backend.vala"
						if (_data_->_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3361 "bluez-backend.c"
							goto __catch1_g_key_file_error;
						}
#line 639 "../backends/bluez/bluez-backend.vala"
						_g_free0 (_data_->address);
#line 639 "../backends/bluez/bluez-backend.vala"
						_data_->groups = (_vala_array_free (_data_->groups, _data_->groups_length1, (GDestroyNotify) g_free), NULL);
#line 639 "../backends/bluez/bluez-backend.vala"
						_g_free0 (_data_->kf_path);
#line 639 "../backends/bluez/bluez-backend.vala"
						_g_key_file_unref0 (_data_->kf);
#line 639 "../backends/bluez/bluez-backend.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 639 "../backends/bluez/bluez-backend.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 639 "../backends/bluez/bluez-backend.vala"
						g_object_unref (_data_->_async_result);
#line 639 "../backends/bluez/bluez-backend.vala"
						return FALSE;
#line 3380 "bluez-backend.c"
					}
#line 639 "../backends/bluez/bluez-backend.vala"
					if (_data_->_tmp27_) {
#line 641 "../backends/bluez/bluez-backend.vala"
						_data_->_tmp30_ = _data_->address;
#line 641 "../backends/bluez/bluez-backend.vala"
						g_debug ("bluez-backend.vala:641:     Enabling device ‘%s’", _data_->_tmp30_);
#line 642 "../backends/bluez/bluez-backend.vala"
						_data_->_tmp31_ = _data_->self->priv->_enabled_devices;
#line 642 "../backends/bluez/bluez-backend.vala"
						_data_->_tmp32_ = _data_->address;
#line 642 "../backends/bluez/bluez-backend.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp31_, _data_->_tmp32_);
#line 3394 "bluez-backend.c"
					}
				}
				goto __finally1;
				__catch1_g_key_file_error:
				{
#line 637 "../backends/bluez/bluez-backend.vala"
					g_clear_error (&_data_->_inner_error0_);
#line 3402 "bluez-backend.c"
				}
				__finally1:
#line 637 "../backends/bluez/bluez-backend.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 637 "../backends/bluez/bluez-backend.vala"
					_g_free0 (_data_->address);
#line 637 "../backends/bluez/bluez-backend.vala"
					_data_->groups = (_vala_array_free (_data_->groups, _data_->groups_length1, (GDestroyNotify) g_free), NULL);
#line 637 "../backends/bluez/bluez-backend.vala"
					_g_free0 (_data_->kf_path);
#line 637 "../backends/bluez/bluez-backend.vala"
					_g_key_file_unref0 (_data_->kf);
#line 637 "../backends/bluez/bluez-backend.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 637 "../backends/bluez/bluez-backend.vala"
					g_clear_error (&_data_->_inner_error0_);
#line 637 "../backends/bluez/bluez-backend.vala"
					g_object_unref (_data_->_async_result);
#line 637 "../backends/bluez/bluez-backend.vala"
					return FALSE;
#line 3423 "bluez-backend.c"
				}
#line 635 "../backends/bluez/bluez-backend.vala"
				_g_free0 (_data_->address);
#line 3427 "bluez-backend.c"
			}
		}
	}
#line 597 "../backends/bluez/bluez-backend.vala"
	_data_->groups = (_vala_array_free (_data_->groups, _data_->groups_length1, (GDestroyNotify) g_free), NULL);
#line 597 "../backends/bluez/bluez-backend.vala"
	_g_free0 (_data_->kf_path);
#line 597 "../backends/bluez/bluez-backend.vala"
	_g_key_file_unref0 (_data_->kf);
#line 597 "../backends/bluez/bluez-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 597 "../backends/bluez/bluez-backend.vala"
	if (_data_->_state_ != 0) {
#line 597 "../backends/bluez/bluez-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 597 "../backends/bluez/bluez-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3445 "bluez-backend.c"
		}
	}
#line 597 "../backends/bluez/bluez-backend.vala"
	g_object_unref (_data_->_async_result);
#line 597 "../backends/bluez/bluez-backend.vala"
	return FALSE;
#line 3452 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_real_prepare_data_free (gpointer _data)
{
	FolksBackendsBlueZBackendPrepareData* _data_;
	_data_ = _data;
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->self);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_slice_free (FolksBackendsBlueZBackendPrepareData, _data_);
#line 3464 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_real_prepare (FolksBackend* base,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	FolksBackendsBlueZBackend * self;
	FolksBackendsBlueZBackendPrepareData* _data_;
	FolksBackendsBlueZBackend* _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	self = (FolksBackendsBlueZBackend*) base;
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZBackendPrepareData);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backends_blue_z_backend_real_prepare_data_free);
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->self = _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	folks_backends_blue_z_backend_real_prepare_co (_data_);
#line 3489 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_prepare_finish (FolksBackend* base,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	FolksBackendsBlueZBackendPrepareData* _data_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 94 "../backends/bluez/bluez-backend.vala"
	if (NULL == _data_) {
#line 94 "../backends/bluez/bluez-backend.vala"
		return;
#line 3504 "bluez-backend.c"
	}
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.6
   */
static void
folks_backends_blue_z_backend_prepare_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	FolksBackendsBlueZBackendPrepareData* _data_;
#line 686 "../backends/bluez/bluez-backend.vala"
	_data_ = _user_data_;
#line 686 "../backends/bluez/bluez-backend.vala"
	_data_->_source_object_ = source_object;
#line 686 "../backends/bluez/bluez-backend.vala"
	_data_->_res_ = _res_;
#line 686 "../backends/bluez/bluez-backend.vala"
	folks_backends_blue_z_backend_real_prepare_co (_data_);
#line 3527 "bluez-backend.c"
}

static GType
____lambda19_ (FolksBackendsBlueZBackend* self,
               GDBusObjectManagerClient* manager,
               const gchar* path,
               const gchar* iface_name)
{
	GType retval = 0UL;
	const gchar* _tmp1_;
	GType result;
#line 698 "../backends/bluez/bluez-backend.vala"
	g_return_val_if_fail (manager != NULL, 0UL);
#line 698 "../backends/bluez/bluez-backend.vala"
	g_return_val_if_fail (path != NULL, 0UL);
#line 700 "../backends/bluez/bluez-backend.vala"
	g_debug ("DBusProxyTypeFunc for path ‘%s’ and " "interface ‘%s’.", path, iface_name);
#line 713 "../backends/bluez/bluez-backend.vala"
	if (g_strcmp0 (iface_name, "org.bluez.Device1") == 0) {
#line 3547 "bluez-backend.c"
		GQuark q = 0U;
		GType dev_type = 0UL;
		void* _tmp0_;
#line 715 "../backends/bluez/bluez-backend.vala"
		q = g_quark_from_string ("vala-dbus-proxy-type");
#line 717 "../backends/bluez/bluez-backend.vala"
		dev_type = ORG_BLUEZ_TYPE_DEVICE;
#line 718 "../backends/bluez/bluez-backend.vala"
		_tmp0_ = g_type_get_qdata (dev_type, q);
#line 718 "../backends/bluez/bluez-backend.vala"
		retval = ((FolksBackendsBlueZBackendTypeFunc) _tmp0_) (NULL);
#line 3559 "bluez-backend.c"
	} else {
#line 721 "../backends/bluez/bluez-backend.vala"
		if (iface_name == NULL) {
#line 722 "../backends/bluez/bluez-backend.vala"
			retval = g_dbus_object_proxy_get_type ();
#line 3565 "bluez-backend.c"
		} else {
#line 724 "../backends/bluez/bluez-backend.vala"
			retval = g_dbus_proxy_get_type ();
#line 3569 "bluez-backend.c"
		}
	}
#line 726 "../backends/bluez/bluez-backend.vala"
	_tmp1_ = g_type_name (retval);
#line 726 "../backends/bluez/bluez-backend.vala"
	g_debug ("bluez-backend.vala:726:     Returning: %s", _tmp1_);
#line 728 "../backends/bluez/bluez-backend.vala"
	result = retval;
#line 728 "../backends/bluez/bluez-backend.vala"
	return result;
#line 3580 "bluez-backend.c"
}

static GType
_____lambda19__gd_bus_proxy_type_func (GDBusObjectManagerClient* manager,
                                       const gchar* object_path,
                                       const gchar* interface_name,
                                       gpointer self)
{
	GType result;
	result = ____lambda19_ ((FolksBackendsBlueZBackend*) self, manager, object_path, interface_name);
#line 692 "../backends/bluez/bluez-backend.vala"
	return result;
#line 3593 "bluez-backend.c"
}

static void
__lambda21_ (FolksBackendsBlueZBackend* self,
             GObject* o,
             GAsyncResult* r)
{
#line 755 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 757 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_add_device_finish (self, r);
#line 3605 "bluez-backend.c"
}

static void
___lambda21__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 755 "../backends/bluez/bluez-backend.vala"
	__lambda21_ ((FolksBackendsBlueZBackend*) self, source_object, res);
#line 755 "../backends/bluez/bluez-backend.vala"
	g_object_unref (self);
#line 3617 "bluez-backend.c"
}

static void
___lambda20_ (FolksBackendsBlueZBackend* self,
              GDBusObject* obj)
{
#line 753 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (obj != NULL);
#line 755 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_add_device (self, obj, ___lambda21__gasync_ready_callback, g_object_ref (self));
#line 3628 "bluez-backend.c"
}

static void
____lambda20__g_dbus_object_manager_object_added (GDBusObjectManager* _sender,
                                                  GDBusObject* object,
                                                  gpointer self)
{
#line 752 "../backends/bluez/bluez-backend.vala"
	___lambda20_ ((FolksBackendsBlueZBackend*) self, object);
#line 3638 "bluez-backend.c"
}

static void
__lambda23_ (FolksBackendsBlueZBackend* self,
             GObject* o,
             GAsyncResult* r)
{
#line 764 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (r != NULL);
#line 766 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_remove_device_finish (self, r);
#line 3650 "bluez-backend.c"
}

static void
___lambda23__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 764 "../backends/bluez/bluez-backend.vala"
	__lambda23_ ((FolksBackendsBlueZBackend*) self, source_object, res);
#line 764 "../backends/bluez/bluez-backend.vala"
	g_object_unref (self);
#line 3662 "bluez-backend.c"
}

static void
___lambda22_ (FolksBackendsBlueZBackend* self,
              GDBusObject* obj)
{
#line 762 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (obj != NULL);
#line 764 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_remove_device (self, obj, ___lambda23__gasync_ready_callback, g_object_ref (self));
#line 3673 "bluez-backend.c"
}

static void
____lambda22__g_dbus_object_manager_object_removed (GDBusObjectManager* _sender,
                                                    GDBusObject* object,
                                                    gpointer self)
{
#line 761 "../backends/bluez/bluez-backend.vala"
	___lambda22_ ((FolksBackendsBlueZBackend*) self, object);
#line 3683 "bluez-backend.c"
}

static void
__folks_backends_blue_z_backend_device_properties_changed_cb_g_dbus_object_manager_client_interface_proxy_properties_changed (GDBusObjectManagerClient* _sender,
                                                                                                                              GDBusObjectProxy* object_proxy,
                                                                                                                              GDBusProxy* interface_proxy,
                                                                                                                              GVariant* changed_properties,
                                                                                                                              gchar** invalidated_properties,
                                                                                                                              gpointer self)
{
#line 770 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_device_properties_changed_cb ((FolksBackendsBlueZBackend*) self, object_proxy, interface_proxy, changed_properties, invalidated_properties, _vala_array_length (invalidated_properties));
#line 3696 "bluez-backend.c"
}

static gboolean
folks_backends_blue_z_backend_real_prepare_co (FolksBackendsBlueZBackendPrepareData* _data_)
{
#line 659 "../backends/bluez/bluez-backend.vala"
	switch (_data_->_state_) {
#line 659 "../backends/bluez/bluez-backend.vala"
		case 0:
#line 3706 "bluez-backend.c"
		goto _state_0;
#line 659 "../backends/bluez/bluez-backend.vala"
		case 1:
#line 3710 "bluez-backend.c"
		goto _state_1;
#line 659 "../backends/bluez/bluez-backend.vala"
		case 2:
#line 3714 "bluez-backend.c"
		goto _state_2;
#line 659 "../backends/bluez/bluez-backend.vala"
		case 3:
#line 3718 "bluez-backend.c"
		goto _state_3;
#line 659 "../backends/bluez/bluez-backend.vala"
		case 4:
#line 3722 "bluez-backend.c"
		goto _state_4;
		default:
#line 659 "../backends/bluez/bluez-backend.vala"
		g_assert_not_reached ();
#line 3727 "bluez-backend.c"
	}
	_state_0:
#line 661 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp0_ = folks_internal_profiling_start ("preparing BlueZ.Backend", NULL);
#line 661 "../backends/bluez/bluez-backend.vala"
	_data_->profiling = _data_->_tmp0_;
#line 663 "../backends/bluez/bluez-backend.vala"
	if (_data_->self->priv->_is_prepared) {
#line 663 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp1_ = TRUE;
#line 3738 "bluez-backend.c"
	} else {
#line 663 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp1_ = _data_->self->priv->_prepare_pending;
#line 3742 "bluez-backend.c"
	}
#line 663 "../backends/bluez/bluez-backend.vala"
	if (_data_->_tmp1_) {
#line 665 "../backends/bluez/bluez-backend.vala"
		_folks_internal_profile_block_free0 (_data_->profiling);
#line 665 "../backends/bluez/bluez-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 665 "../backends/bluez/bluez-backend.vala"
		if (_data_->_state_ != 0) {
#line 665 "../backends/bluez/bluez-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 665 "../backends/bluez/bluez-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3756 "bluez-backend.c"
			}
		}
#line 665 "../backends/bluez/bluez-backend.vala"
		g_object_unref (_data_->_async_result);
#line 665 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 3763 "bluez-backend.c"
	}
	{
#line 682 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_prepare_pending = TRUE;
#line 683 "../backends/bluez/bluez-backend.vala"
		g_object_freeze_notify ((GObject*) _data_->self);
#line 686 "../backends/bluez/bluez-backend.vala"
		_data_->_state_ = 1;
#line 686 "../backends/bluez/bluez-backend.vala"
		_folks_backends_blue_z_backend_load_enabled_devices (_data_->self, folks_backends_blue_z_backend_prepare_ready, _data_);
#line 686 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 3776 "bluez-backend.c"
		_state_1:
#line 686 "../backends/bluez/bluez-backend.vala"
		_folks_backends_blue_z_backend_load_enabled_devices_finish (_data_->self, _data_->_res_);
#line 3780 "bluez-backend.c"
		{
#line 692 "../backends/bluez/bluez-backend.vala"
			_data_->_state_ = 2;
#line 692 "../backends/bluez/bluez-backend.vala"
			g_dbus_object_manager_client_new_for_bus (G_BUS_TYPE_SYSTEM, G_DBUS_OBJECT_MANAGER_CLIENT_FLAGS_NONE, "org.bluez", "/", _____lambda19__gd_bus_proxy_type_func, g_object_ref (_data_->self), g_object_unref, NULL, folks_backends_blue_z_backend_prepare_ready, _data_);
#line 692 "../backends/bluez/bluez-backend.vala"
			return FALSE;
#line 3788 "bluez-backend.c"
			_state_2:
#line 692 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp3_ = g_dbus_object_manager_client_new_for_bus_finish (_data_->_res_, &_data_->_inner_error0_);
#line 692 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp2_ = _data_->_tmp3_;
#line 692 "../backends/bluez/bluez-backend.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3796 "bluez-backend.c"
				goto __catch1_g_error;
			}
#line 690 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp4_ = _data_->_tmp2_;
#line 690 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp2_ = NULL;
#line 690 "../backends/bluez/bluez-backend.vala"
			_g_object_unref0 (_data_->self->priv->_manager);
#line 690 "../backends/bluez/bluez-backend.vala"
			_data_->self->priv->_manager = _data_->_tmp4_;
#line 688 "../backends/bluez/bluez-backend.vala"
			_g_object_unref0 (_data_->_tmp2_);
#line 3809 "bluez-backend.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 688 "../backends/bluez/bluez-backend.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 733 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp5_ = g_error_new_literal (G_DBUS_ERROR, G_DBUS_ERROR_SERVICE_UNKNOWN, _ ("No BlueZ 5 object manager running, so the BlueZ backend will be inacti" \
"ve. Either your BlueZ installation is too old (only version 5 is suppo" \
"rted) or the service can’t be started."));
#line 733 "../backends/bluez/bluez-backend.vala"
			_data_->_inner_error0_ = _data_->_tmp5_;
#line 3820 "bluez-backend.c"
			goto __finally1;
		}
		__finally1:
#line 688 "../backends/bluez/bluez-backend.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3826 "bluez-backend.c"
			goto __finally0;
		}
		{
#line 741 "../backends/bluez/bluez-backend.vala"
			_data_->_state_ = 3;
#line 741 "../backends/bluez/bluez-backend.vala"
			g_async_initable_new_async (ORG_BLUEZ_OBEX_TYPE_CLIENT_PROXY, 0, NULL, folks_backends_blue_z_backend_prepare_ready, _data_, "g-flags", 0, "g-name", "org.bluez.obex", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/bluez/obex", "g-interface-name", "org.bluez.obex.Client1", NULL);
#line 741 "../backends/bluez/bluez-backend.vala"
			return FALSE;
#line 3836 "bluez-backend.c"
			_state_3:
#line 741 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp7_ = (orgbluezobexClient*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 741 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp6_ = (orgbluezobexClient*) _data_->_tmp7_;
#line 741 "../backends/bluez/bluez-backend.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3844 "bluez-backend.c"
				goto __catch2_g_error;
			}
#line 740 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp8_ = _data_->_tmp6_;
#line 740 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp6_ = NULL;
#line 740 "../backends/bluez/bluez-backend.vala"
			_g_object_unref0 (_data_->self->priv->_obex_client);
#line 740 "../backends/bluez/bluez-backend.vala"
			_data_->self->priv->_obex_client = _data_->_tmp8_;
#line 738 "../backends/bluez/bluez-backend.vala"
			_g_object_unref0 (_data_->_tmp6_);
#line 3857 "bluez-backend.c"
		}
		goto __finally2;
		__catch2_g_error:
		{
#line 738 "../backends/bluez/bluez-backend.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 746 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp9_ = g_error_new_literal (G_DBUS_ERROR, G_DBUS_ERROR_SERVICE_UNKNOWN, _ ("Error connecting to OBEX transfer daemon over D-Bus. Ensure BlueZ and " \
"obexd are installed."));
#line 746 "../backends/bluez/bluez-backend.vala"
			_data_->_inner_error0_ = _data_->_tmp9_;
#line 3868 "bluez-backend.c"
			goto __finally2;
		}
		__finally2:
#line 738 "../backends/bluez/bluez-backend.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3874 "bluez-backend.c"
			goto __finally0;
		}
#line 752 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp10_ = _data_->self->priv->_manager;
#line 752 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp11_ = g_signal_connect_object ((GDBusObjectManager*) _data_->_tmp10_, "object-added", (GCallback) ____lambda20__g_dbus_object_manager_object_added, _data_->self, 0);
#line 752 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_object_added_handler = _data_->_tmp11_;
#line 761 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp12_ = _data_->self->priv->_manager;
#line 761 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp13_ = g_signal_connect_object ((GDBusObjectManager*) _data_->_tmp12_, "object-removed", (GCallback) ____lambda22__g_dbus_object_manager_object_removed, _data_->self, 0);
#line 761 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_object_removed_handler = _data_->_tmp13_;
#line 770 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp14_ = _data_->self->priv->_manager;
#line 770 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp15_ = g_signal_connect_object (_data_->_tmp14_, "interface-proxy-properties-changed", (GCallback) __folks_backends_blue_z_backend_device_properties_changed_cb_g_dbus_object_manager_client_interface_proxy_properties_changed, _data_->self, 0);
#line 770 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_properties_changed_handler = _data_->_tmp15_;
#line 775 "../backends/bluez/bluez-backend.vala"
		_data_->_state_ = 4;
#line 775 "../backends/bluez/bluez-backend.vala"
		_folks_backends_blue_z_backend_refresh_devices (_data_->self, folks_backends_blue_z_backend_prepare_ready, _data_);
#line 775 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 3901 "bluez-backend.c"
		_state_4:
#line 775 "../backends/bluez/bluez-backend.vala"
		_folks_backends_blue_z_backend_refresh_devices_finish (_data_->self, _data_->_res_);
#line 777 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_is_prepared = TRUE;
#line 778 "../backends/bluez/bluez-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-prepared");
#line 780 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_is_quiescent = TRUE;
#line 781 "../backends/bluez/bluez-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-quiescent");
#line 3913 "bluez-backend.c"
	}
	__finally0:
	{
#line 785 "../backends/bluez/bluez-backend.vala"
		g_object_thaw_notify ((GObject*) _data_->self);
#line 786 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 3921 "bluez-backend.c"
	}
#line 680 "../backends/bluez/bluez-backend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 680 "../backends/bluez/bluez-backend.vala"
		if (_data_->_inner_error0_->domain == G_DBUS_ERROR) {
#line 680 "../backends/bluez/bluez-backend.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 680 "../backends/bluez/bluez-backend.vala"
			_folks_internal_profile_block_free0 (_data_->profiling);
#line 680 "../backends/bluez/bluez-backend.vala"
			g_object_unref (_data_->_async_result);
#line 680 "../backends/bluez/bluez-backend.vala"
			return FALSE;
#line 3935 "bluez-backend.c"
		} else {
#line 680 "../backends/bluez/bluez-backend.vala"
			_folks_internal_profile_block_free0 (_data_->profiling);
#line 680 "../backends/bluez/bluez-backend.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 680 "../backends/bluez/bluez-backend.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 680 "../backends/bluez/bluez-backend.vala"
			g_object_unref (_data_->_async_result);
#line 680 "../backends/bluez/bluez-backend.vala"
			return FALSE;
#line 3947 "bluez-backend.c"
		}
	}
#line 789 "../backends/bluez/bluez-backend.vala"
	_data_->_tmp16_ = _data_->profiling;
#line 789 "../backends/bluez/bluez-backend.vala"
	_data_->profiling = NULL;
#line 789 "../backends/bluez/bluez-backend.vala"
	folks_internal_profiling_end (_data_->_tmp16_);
#line 659 "../backends/bluez/bluez-backend.vala"
	_folks_internal_profile_block_free0 (_data_->profiling);
#line 659 "../backends/bluez/bluez-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 659 "../backends/bluez/bluez-backend.vala"
	if (_data_->_state_ != 0) {
#line 659 "../backends/bluez/bluez-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 659 "../backends/bluez/bluez-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3966 "bluez-backend.c"
		}
	}
#line 659 "../backends/bluez/bluez-backend.vala"
	g_object_unref (_data_->_async_result);
#line 659 "../backends/bluez/bluez-backend.vala"
	return FALSE;
#line 3973 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_real_unprepare_data_free (gpointer _data)
{
	FolksBackendsBlueZBackendUnprepareData* _data_;
	_data_ = _data;
#line 94 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (_data_->self);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_slice_free (FolksBackendsBlueZBackendUnprepareData, _data_);
#line 3985 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_real_unprepare (FolksBackend* base,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
	FolksBackendsBlueZBackend * self;
	FolksBackendsBlueZBackendUnprepareData* _data_;
	FolksBackendsBlueZBackend* _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	self = (FolksBackendsBlueZBackend*) base;
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZBackendUnprepareData);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backends_blue_z_backend_real_unprepare_data_free);
#line 94 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_->self = _tmp0_;
#line 94 "../backends/bluez/bluez-backend.vala"
	folks_backends_blue_z_backend_real_unprepare_co (_data_);
#line 4010 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_unprepare_finish (FolksBackend* base,
                                                GAsyncResult* _res_,
                                                GError** error)
{
	FolksBackendsBlueZBackendUnprepareData* _data_;
#line 94 "../backends/bluez/bluez-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 94 "../backends/bluez/bluez-backend.vala"
	if (NULL == _data_) {
#line 94 "../backends/bluez/bluez-backend.vala"
		return;
#line 4025 "bluez-backend.c"
	}
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.6
   */
static gboolean
folks_backends_blue_z_backend_real_unprepare_co (FolksBackendsBlueZBackendUnprepareData* _data_)
{
#line 797 "../backends/bluez/bluez-backend.vala"
	switch (_data_->_state_) {
#line 797 "../backends/bluez/bluez-backend.vala"
		case 0:
#line 4041 "bluez-backend.c"
		goto _state_0;
		default:
#line 797 "../backends/bluez/bluez-backend.vala"
		g_assert_not_reached ();
#line 4046 "bluez-backend.c"
	}
	_state_0:
#line 799 "../backends/bluez/bluez-backend.vala"
	if (!_data_->self->priv->_is_prepared) {
#line 799 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp0_ = TRUE;
#line 4053 "bluez-backend.c"
	} else {
#line 799 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp0_ = _data_->self->priv->_prepare_pending == TRUE;
#line 4057 "bluez-backend.c"
	}
#line 799 "../backends/bluez/bluez-backend.vala"
	if (_data_->_tmp0_) {
#line 801 "../backends/bluez/bluez-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 801 "../backends/bluez/bluez-backend.vala"
		if (_data_->_state_ != 0) {
#line 801 "../backends/bluez/bluez-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 801 "../backends/bluez/bluez-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4069 "bluez-backend.c"
			}
		}
#line 801 "../backends/bluez/bluez-backend.vala"
		g_object_unref (_data_->_async_result);
#line 801 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 4076 "bluez-backend.c"
	}
	{
#line 806 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_prepare_pending = TRUE;
#line 808 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp1_ = _data_->self->priv->_manager;
#line 808 "../backends/bluez/bluez-backend.vala"
		if (_data_->_tmp1_ != NULL) {
#line 810 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp2_ = _data_->self->priv->_manager;
#line 810 "../backends/bluez/bluez-backend.vala"
			g_signal_handler_disconnect ((GObject*) _data_->_tmp2_, _data_->self->priv->_object_added_handler);
#line 811 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp3_ = _data_->self->priv->_manager;
#line 811 "../backends/bluez/bluez-backend.vala"
			g_signal_handler_disconnect ((GObject*) _data_->_tmp3_, _data_->self->priv->_object_removed_handler);
#line 812 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp4_ = _data_->self->priv->_manager;
#line 812 "../backends/bluez/bluez-backend.vala"
			g_signal_handler_disconnect ((GObject*) _data_->_tmp4_, _data_->self->priv->_properties_changed_handler);
#line 813 "../backends/bluez/bluez-backend.vala"
			_g_object_unref0 (_data_->self->priv->_manager);
#line 813 "../backends/bluez/bluez-backend.vala"
			_data_->self->priv->_manager = NULL;
#line 814 "../backends/bluez/bluez-backend.vala"
			_data_->self->priv->_object_added_handler = (gulong) 0;
#line 815 "../backends/bluez/bluez-backend.vala"
			_data_->self->priv->_object_removed_handler = (gulong) 0;
#line 816 "../backends/bluez/bluez-backend.vala"
			_data_->self->priv->_properties_changed_handler = (gulong) 0;
#line 4107 "bluez-backend.c"
		}
#line 819 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data_->self->priv->_obex_client);
#line 819 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_obex_client = NULL;
#line 821 "../backends/bluez/bluez-backend.vala"
		g_object_freeze_notify ((GObject*) _data_->self);
#line 823 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp5_ = _data_->self->priv->_persona_stores;
#line 823 "../backends/bluez/bluez-backend.vala"
		_data_->_tmp6_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _data_->_tmp5_);
#line 823 "../backends/bluez/bluez-backend.vala"
		_data_->iter = _data_->_tmp6_;
#line 824 "../backends/bluez/bluez-backend.vala"
		while (TRUE) {
#line 824 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp7_ = _data_->iter;
#line 824 "../backends/bluez/bluez-backend.vala"
			if (!(gee_map_iterator_next (_data_->_tmp7_) == TRUE)) {
#line 824 "../backends/bluez/bluez-backend.vala"
				break;
#line 4129 "bluez-backend.c"
			}
#line 826 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp8_ = _data_->iter;
#line 826 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp9_ = gee_map_iterator_get_value (_data_->_tmp8_);
#line 826 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp10_ = (FolksBackendsBlueZPersonaStore*) _data_->_tmp9_;
#line 826 "../backends/bluez/bluez-backend.vala"
			_folks_backends_blue_z_backend_remove_persona_store (_data_->self, _data_->_tmp10_, FALSE, TRUE);
#line 826 "../backends/bluez/bluez-backend.vala"
			_g_object_unref0 (_data_->_tmp10_);
#line 827 "../backends/bluez/bluez-backend.vala"
			_data_->_tmp11_ = _data_->iter;
#line 827 "../backends/bluez/bluez-backend.vala"
			gee_map_iterator_unset (_data_->_tmp11_);
#line 4145 "bluez-backend.c"
		}
#line 830 "../backends/bluez/bluez-backend.vala"
		g_object_notify ((GObject*) _data_->self, "persona-stores");
#line 832 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_is_quiescent = FALSE;
#line 833 "../backends/bluez/bluez-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-quiescent");
#line 835 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_is_prepared = FALSE;
#line 836 "../backends/bluez/bluez-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-prepared");
#line 838 "../backends/bluez/bluez-backend.vala"
		g_object_thaw_notify ((GObject*) _data_->self);
#line 804 "../backends/bluez/bluez-backend.vala"
		_g_object_unref0 (_data_->iter);
#line 4161 "bluez-backend.c"
	}
	__finally0:
	{
#line 842 "../backends/bluez/bluez-backend.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 4167 "bluez-backend.c"
	}
#line 804 "../backends/bluez/bluez-backend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 804 "../backends/bluez/bluez-backend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 804 "../backends/bluez/bluez-backend.vala"
		g_object_unref (_data_->_async_result);
#line 804 "../backends/bluez/bluez-backend.vala"
		return FALSE;
#line 4177 "bluez-backend.c"
	}
#line 797 "../backends/bluez/bluez-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 797 "../backends/bluez/bluez-backend.vala"
	if (_data_->_state_ != 0) {
#line 797 "../backends/bluez/bluez-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 797 "../backends/bluez/bluez-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4187 "bluez-backend.c"
		}
	}
#line 797 "../backends/bluez/bluez-backend.vala"
	g_object_unref (_data_->_async_result);
#line 797 "../backends/bluez/bluez-backend.vala"
	return FALSE;
#line 4194 "bluez-backend.c"
}

static void
_folks_backends_blue_z_backend_persona_store_removed_cb (FolksBackendsBlueZBackend* self,
                                                         FolksPersonaStore* store)
{
#line 846 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (self != NULL);
#line 846 "../backends/bluez/bluez-backend.vala"
	g_return_if_fail (store != NULL);
#line 848 "../backends/bluez/bluez-backend.vala"
	_folks_backends_blue_z_backend_remove_persona_store (self, G_TYPE_CHECK_INSTANCE_CAST (store, FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA_STORE, FolksBackendsBlueZPersonaStore), TRUE, TRUE);
#line 4207 "bluez-backend.c"
}

static gboolean
folks_backends_blue_z_backend_real_get_is_prepared (FolksBackend* base)
{
	gboolean result;
	FolksBackendsBlueZBackend* self;
#line 122 "../backends/bluez/bluez-backend.vala"
	self = (FolksBackendsBlueZBackend*) base;
#line 122 "../backends/bluez/bluez-backend.vala"
	result = self->priv->_is_prepared;
#line 122 "../backends/bluez/bluez-backend.vala"
	return result;
#line 4221 "bluez-backend.c"
}

static gboolean
folks_backends_blue_z_backend_real_get_is_quiescent (FolksBackend* base)
{
	gboolean result;
	FolksBackendsBlueZBackend* self;
#line 134 "../backends/bluez/bluez-backend.vala"
	self = (FolksBackendsBlueZBackend*) base;
#line 134 "../backends/bluez/bluez-backend.vala"
	result = self->priv->_is_quiescent;
#line 134 "../backends/bluez/bluez-backend.vala"
	return result;
#line 4235 "bluez-backend.c"
}

static const gchar*
folks_backends_blue_z_backend_real_get_name (FolksBackend* base)
{
	const gchar* result;
	FolksBackendsBlueZBackend* self;
#line 142 "../backends/bluez/bluez-backend.vala"
	self = (FolksBackendsBlueZBackend*) base;
#line 142 "../backends/bluez/bluez-backend.vala"
	result = BACKEND_NAME;
#line 142 "../backends/bluez/bluez-backend.vala"
	return result;
#line 4249 "bluez-backend.c"
}

static GeeMap*
folks_backends_blue_z_backend_real_get_persona_stores (FolksBackend* base)
{
	GeeMap* result;
	FolksBackendsBlueZBackend* self;
	GeeMap* _tmp0_;
#line 151 "../backends/bluez/bluez-backend.vala"
	self = (FolksBackendsBlueZBackend*) base;
#line 151 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = self->priv->_persona_stores_ro;
#line 151 "../backends/bluez/bluez-backend.vala"
	result = _tmp0_;
#line 151 "../backends/bluez/bluez-backend.vala"
	return result;
#line 4266 "bluez-backend.c"
}

static GObject *
folks_backends_blue_z_backend_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FolksBackendsBlueZBackend * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* _tmp3_;
	GeeHashMap* _tmp4_;
	FolksSmallSet* _tmp5_;
#line 270 "../backends/bluez/bluez-backend.vala"
	parent_class = G_OBJECT_CLASS (folks_backends_blue_z_backend_parent_class);
#line 270 "../backends/bluez/bluez-backend.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 270 "../backends/bluez/bluez-backend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_BACKENDS_BLUE_Z_TYPE_BACKEND, FolksBackendsBlueZBackend);
#line 272 "../backends/bluez/bluez-backend.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA_STORE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 272 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores);
#line 272 "../backends/bluez/bluez-backend.vala"
	self->priv->_persona_stores = _tmp0_;
#line 273 "../backends/bluez/bluez-backend.vala"
	_tmp1_ = self->priv->_persona_stores;
#line 273 "../backends/bluez/bluez-backend.vala"
	_tmp2_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp1_);
#line 273 "../backends/bluez/bluez-backend.vala"
	_tmp3_ = _tmp2_;
#line 273 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores_ro);
#line 273 "../backends/bluez/bluez-backend.vala"
	self->priv->_persona_stores_ro = _tmp3_;
#line 274 "../backends/bluez/bluez-backend.vala"
	_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA_STORE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 274 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (self->priv->_watched_devices);
#line 274 "../backends/bluez/bluez-backend.vala"
	self->priv->_watched_devices = _tmp4_;
#line 275 "../backends/bluez/bluez-backend.vala"
	_tmp5_ = folks_small_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 275 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (self->priv->_enabled_devices);
#line 275 "../backends/bluez/bluez-backend.vala"
	self->priv->_enabled_devices = _tmp5_;
#line 270 "../backends/bluez/bluez-backend.vala"
	return obj;
#line 4319 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_class_init (FolksBackendsBlueZBackendClass * klass,
                                          gpointer klass_data)
{
#line 94 "../backends/bluez/bluez-backend.vala"
	folks_backends_blue_z_backend_parent_class = g_type_class_peek_parent (klass);
#line 94 "../backends/bluez/bluez-backend.vala"
	g_type_class_adjust_private_offset (klass, &FolksBackendsBlueZBackend_private_offset);
#line 94 "../backends/bluez/bluez-backend.vala"
	((FolksBackendClass *) klass)->disable_persona_store = (void (*) (FolksBackend*, FolksPersonaStore*)) folks_backends_blue_z_backend_real_disable_persona_store;
#line 94 "../backends/bluez/bluez-backend.vala"
	((FolksBackendClass *) klass)->enable_persona_store = (void (*) (FolksBackend*, FolksPersonaStore*)) folks_backends_blue_z_backend_real_enable_persona_store;
#line 94 "../backends/bluez/bluez-backend.vala"
	((FolksBackendClass *) klass)->set_persona_stores = (void (*) (FolksBackend*, GeeSet*)) folks_backends_blue_z_backend_real_set_persona_stores;
#line 94 "../backends/bluez/bluez-backend.vala"
	((FolksBackendClass *) klass)->prepare = (void (*) (FolksBackend*, GAsyncReadyCallback, gpointer)) folks_backends_blue_z_backend_real_prepare;
#line 94 "../backends/bluez/bluez-backend.vala"
	((FolksBackendClass *) klass)->prepare_finish = (void (*) (FolksBackend*, GAsyncResult*, GError**)) folks_backends_blue_z_backend_prepare_finish;
#line 94 "../backends/bluez/bluez-backend.vala"
	((FolksBackendClass *) klass)->unprepare = (void (*) (FolksBackend*, GAsyncReadyCallback, gpointer)) folks_backends_blue_z_backend_real_unprepare;
#line 94 "../backends/bluez/bluez-backend.vala"
	((FolksBackendClass *) klass)->unprepare_finish = (void (*) (FolksBackend*, GAsyncResult*, GError**)) folks_backends_blue_z_backend_unprepare_finish;
#line 94 "../backends/bluez/bluez-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_is_prepared = (gboolean (*) (FolksBackend*)) folks_backends_blue_z_backend_real_get_is_prepared;
#line 94 "../backends/bluez/bluez-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_is_quiescent = (gboolean (*) (FolksBackend*)) folks_backends_blue_z_backend_real_get_is_quiescent;
#line 94 "../backends/bluez/bluez-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_name = (const gchar* (*) (FolksBackend*)) folks_backends_blue_z_backend_real_get_name;
#line 94 "../backends/bluez/bluez-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_persona_stores = (GeeMap* (*) (FolksBackend*)) folks_backends_blue_z_backend_real_get_persona_stores;
#line 94 "../backends/bluez/bluez-backend.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folks_backends_blue_z_backend_get_property;
#line 94 "../backends/bluez/bluez-backend.vala"
	G_OBJECT_CLASS (klass)->constructor = folks_backends_blue_z_backend_constructor;
#line 94 "../backends/bluez/bluez-backend.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_backends_blue_z_backend_finalize;
#line 4358 "bluez-backend.c"
	/**
	   * Whether this Backend has been prepared.
	   *
	   * See {@link Folks.Backend.is_prepared}.
	   *
	   * @since 0.9.6
	   */
#line 94 "../backends/bluez/bluez-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_BACKEND_IS_PREPARED_PROPERTY, folks_backends_blue_z_backend_properties[FOLKS_BACKENDS_BLUE_Z_BACKEND_IS_PREPARED_PROPERTY] = g_param_spec_boolean ("is-prepared", "is-prepared", "is-prepared", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4368 "bluez-backend.c"
	/**
	   * Whether this Backend has reached a quiescent state.
	   *
	   * See {@link Folks.Backend.is_quiescent}.
	   *
	   * @since 0.9.6
	   */
#line 94 "../backends/bluez/bluez-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_BACKEND_IS_QUIESCENT_PROPERTY, folks_backends_blue_z_backend_properties[FOLKS_BACKENDS_BLUE_Z_BACKEND_IS_QUIESCENT_PROPERTY] = g_param_spec_boolean ("is-quiescent", "is-quiescent", "is-quiescent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4378 "bluez-backend.c"
	/**
	   * {@inheritDoc}
	   *
	   * @since 0.9.6
	   */
#line 94 "../backends/bluez/bluez-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_BACKEND_NAME_PROPERTY, folks_backends_blue_z_backend_properties[FOLKS_BACKENDS_BLUE_Z_BACKEND_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4386 "bluez-backend.c"
	/**
	   * {@inheritDoc}
	   *
	   * @since 0.9.6
	   */
#line 94 "../backends/bluez/bluez-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_BACKEND_PERSONA_STORES_PROPERTY, folks_backends_blue_z_backend_properties[FOLKS_BACKENDS_BLUE_Z_BACKEND_PERSONA_STORES_PROPERTY] = g_param_spec_object ("persona-stores", "persona-stores", "persona-stores", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4394 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_instance_init (FolksBackendsBlueZBackend * self,
                                             gpointer klass)
{
#line 94 "../backends/bluez/bluez-backend.vala"
	self->priv = folks_backends_blue_z_backend_get_instance_private (self);
#line 96 "../backends/bluez/bluez-backend.vala"
	self->priv->_is_prepared = FALSE;
#line 97 "../backends/bluez/bluez-backend.vala"
	self->priv->_prepare_pending = FALSE;
#line 98 "../backends/bluez/bluez-backend.vala"
	self->priv->_is_quiescent = FALSE;
#line 108 "../backends/bluez/bluez-backend.vala"
	self->priv->_obex_client = NULL;
#line 4411 "bluez-backend.c"
}

static void
folks_backends_blue_z_backend_finalize (GObject * obj)
{
	FolksBackendsBlueZBackend * self;
#line 94 "../backends/bluez/bluez-backend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_BACKENDS_BLUE_Z_TYPE_BACKEND, FolksBackendsBlueZBackend);
#line 100 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores);
#line 101 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (self->priv->_persona_stores_ro);
#line 102 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (self->priv->_manager);
#line 107 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (self->priv->_watched_devices);
#line 108 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (self->priv->_obex_client);
#line 111 "../backends/bluez/bluez-backend.vala"
	_g_object_unref0 (self->priv->_enabled_devices);
#line 94 "../backends/bluez/bluez-backend.vala"
	G_OBJECT_CLASS (folks_backends_blue_z_backend_parent_class)->finalize (obj);
#line 4434 "bluez-backend.c"
}

/**
 * A backend which loads {@link Persona}s from paired Bluetooth
 * devices using the Phonebook Access Protocol (PBAP) and presents them
 * using one {@link PersonaStore} per device.
 *
 * Each device can be in four states:
 *  - Unpaired and unconnected
 *  - Unpaired but connected
 *  - Paired but unconnected
 *  - Paired and connected
 *
 * The default state for a device is unpaired. The user must explicitly pair
 * their device and enable it using {@link Backend.enable_persona_store} or
 * {@link Backend.set_persona_stores} before folks will begin to use it — folks
 * ignores unpaired devices. Once a device is paired and enabled, folks will
 * attempt to do an OBEX PBAP transfer to copy the device’s address book; this
 * will automatically connect the device. After the transfer is complete, the
 * device will go back to being paired and unconnected.
 *
 * Note that by requiring that devices are explicitly enabled by calling
 * {@link Backend.set_persona_stores}, the BlueZ backend is empty by default
 * every time libfolks is loaded, until the client explicitly enables a device.
 * This may change in future, and the state of enabled devices may be retained
 * between runs.
 *
 * Every time the user explicitly connects to the device, folks will re-download
 * its address book. Currently, folks will not otherwise re-download it (i.e.
 * there are no change notifications and no polling).
 *
 * If a transfer is started from an unpaired device, the device will move to the
 * unpaired but connected state, and will pop up a notification asking the user
 * whether they want to pair to the computer. This should be avoided, and is why
 * folks ignores all unpaired devices.
 *
 * If a connection timeout occurs (e.g. because the user took too long to
 * approve a pairing request, or explicitly denied it), the device will become
 * disconnected again.
 *
 * If the phone user explicitly denies the phone’s request to share address book
 * data with the laptop (which happens after pairing is successful), creating an
 * OBEX transfer session will fail with an explicit error, which is handled in
 * the {@link PersonaStore}.
 *
 * No caching is implemented by libfolks at the moment, so the address book
 * will be downloaded every time folks starts up.
 *
 * Each device can be advertised by BlueZ as trusted or untrusted, a property
 * which is explicitly set by the user on the laptop (not on the device). Folks
 * will set the PersonaStore’s trust level appropriately, fully trusting devices
 * marked as trusted, and only partially trusting others.
 *
 * Each device can also be advertised by BlueZ as being blocked or non-blocked.
 * Blocked devices are not made available as persona stores, even if they are
 * paired with the laptop.
 *
 * @since 0.9.6
 */
static GType
folks_backends_blue_z_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksBackendsBlueZBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_backends_blue_z_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksBackendsBlueZBackend), 0, (GInstanceInitFunc) folks_backends_blue_z_backend_instance_init, NULL };
	GType folks_backends_blue_z_backend_type_id;
	folks_backends_blue_z_backend_type_id = g_type_register_static (FOLKS_TYPE_BACKEND, "FolksBackendsBlueZBackend", &g_define_type_info, 0);
	FolksBackendsBlueZBackend_private_offset = g_type_add_instance_private (folks_backends_blue_z_backend_type_id, sizeof (FolksBackendsBlueZBackendPrivate));
	return folks_backends_blue_z_backend_type_id;
}

GType
folks_backends_blue_z_backend_get_type (void)
{
	static volatile gsize folks_backends_blue_z_backend_type_id__once = 0;
	if (g_once_init_enter (&folks_backends_blue_z_backend_type_id__once)) {
		GType folks_backends_blue_z_backend_type_id;
		folks_backends_blue_z_backend_type_id = folks_backends_blue_z_backend_get_type_once ();
		g_once_init_leave (&folks_backends_blue_z_backend_type_id__once, folks_backends_blue_z_backend_type_id);
	}
	return folks_backends_blue_z_backend_type_id__once;
}

static void
_vala_folks_backends_blue_z_backend_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	FolksBackendsBlueZBackend * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_BACKENDS_BLUE_Z_TYPE_BACKEND, FolksBackendsBlueZBackend);
#line 94 "../backends/bluez/bluez-backend.vala"
	switch (property_id) {
#line 94 "../backends/bluez/bluez-backend.vala"
		case FOLKS_BACKENDS_BLUE_Z_BACKEND_IS_PREPARED_PROPERTY:
#line 94 "../backends/bluez/bluez-backend.vala"
		g_value_set_boolean (value, folks_backend_get_is_prepared ((FolksBackend*) self));
#line 94 "../backends/bluez/bluez-backend.vala"
		break;
#line 94 "../backends/bluez/bluez-backend.vala"
		case FOLKS_BACKENDS_BLUE_Z_BACKEND_IS_QUIESCENT_PROPERTY:
#line 94 "../backends/bluez/bluez-backend.vala"
		g_value_set_boolean (value, folks_backend_get_is_quiescent ((FolksBackend*) self));
#line 94 "../backends/bluez/bluez-backend.vala"
		break;
#line 94 "../backends/bluez/bluez-backend.vala"
		case FOLKS_BACKENDS_BLUE_Z_BACKEND_NAME_PROPERTY:
#line 94 "../backends/bluez/bluez-backend.vala"
		g_value_set_string (value, folks_backend_get_name ((FolksBackend*) self));
#line 94 "../backends/bluez/bluez-backend.vala"
		break;
#line 94 "../backends/bluez/bluez-backend.vala"
		case FOLKS_BACKENDS_BLUE_Z_BACKEND_PERSONA_STORES_PROPERTY:
#line 94 "../backends/bluez/bluez-backend.vala"
		g_value_set_object (value, folks_backend_get_persona_stores ((FolksBackend*) self));
#line 94 "../backends/bluez/bluez-backend.vala"
		break;
#line 4550 "bluez-backend.c"
		default:
#line 94 "../backends/bluez/bluez-backend.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 94 "../backends/bluez/bluez-backend.vala"
		break;
#line 4556 "bluez-backend.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

