/* bluez-persona-store.c generated by valac 0.56.17, the Vala compiler
 * generated from bluez-persona-store.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *          Arun Raghavan <arun.raghavan@collabora.co.uk>
 *          Jeremy Whiting <jeremy.whiting@collabora.com>
 *          Simon McVittie <simon.mcvittie@collabora.co.uk>
 *          Gustavo Padovan <gustavo.padovan@collabora.co.uk>
 *          Matthieu Bouron <matthieu.bouron@collabora.com>
 *          Philip Withnall <philip.withnall@collabora.co.uk>
 *
 * Based on kf-persona-store.vala by:
 *       Travis Reitter <travis.reitter@collabora.co.uk>
 *       Philip Withnall <philip.withnall@collabora.co.uk>
 */

#include "bluez.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include "folks/folks.h"
#include <libebook-contacts/libebook-contacts.h>
#include <glib/gi18n-lib.h>
#include "folks-internal.h"
#include <math.h>
#include <float.h>
#include <errno.h>

#define FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE__TIMEOUT_MIN ((guint) 4)
#define FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE__TIMEOUT_BASE ((guint) 2)
#define FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE__TIMEOUT_MAX ((guint) (5 * 60))
#define FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE__MAX_CONSECUTIVE_FAILURES ((guint) 3)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_0_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_TYPE_ID_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_ADD_PERSONAS_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_ALIAS_PERSONAS_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_GROUP_PERSONAS_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_REMOVE_PERSONAS_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_IS_PREPARED_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_IS_QUIESCENT_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_ALWAYS_WRITEABLE_PROPERTIES_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_PERSONAS_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_DISPLAY_NAME_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_OBJECT_PATH_PROPERTY,
	FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_NUM_PROPERTIES
};
static GParamSpec* folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define __vala_EVCardAttribute_free0(var) ((var == NULL) ? NULL : (var = (_vala_EVCardAttribute_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _FolksBackendsBlueZPersonaStoreUpdateContactsFromFileData FolksBackendsBlueZPersonaStoreUpdateContactsFromFileData;
typedef struct _FolksBackendsBlueZPersonaStoreSetConnectionStateData FolksBackendsBlueZPersonaStoreSetConnectionStateData;
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _FolksBackendsBlueZPersonaStoreNewObexSessionData FolksBackendsBlueZPersonaStoreNewObexSessionData;
typedef struct _FolksBackendsBlueZPersonaStoreRemoveObexSessionData FolksBackendsBlueZPersonaStoreRemoveObexSessionData;
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _FolksBackendsBlueZPersonaStorePerformObexTransferData FolksBackendsBlueZPersonaStorePerformObexTransferData;
#define _folks_internal_profile_block_free0(var) ((var == NULL) ? NULL : (var = (folks_internal_profile_block_free (var), NULL)))
typedef struct _FolksBackendsBlueZPersonaStoreUpdateContactsData FolksBackendsBlueZPersonaStoreUpdateContactsData;
typedef struct _Block5Data Block5Data;
typedef struct _FolksBackendsBlueZPersonaStorePrepareData FolksBackendsBlueZPersonaStorePrepareData;
typedef struct _FolksBackendsBlueZPersonaStoreRemovePersonaData FolksBackendsBlueZPersonaStoreRemovePersonaData;
typedef struct _FolksBackendsBlueZPersonaStoreAddPersonaFromDetailsData FolksBackendsBlueZPersonaStoreAddPersonaFromDetailsData;

struct _FolksBackendsBlueZPersonaStorePrivate {
	GeeHashMap* _personas;
	GeeMap* _personas_ro;
	gboolean _is_prepared;
	gboolean _prepare_pending;
	gboolean _is_quiescent;
	orgbluezobexClient* _obex_client;
	gchar* _object_path;
	orgbluezDevice* _device;
	gchar* _display_name;
	GCancellable* _update_contacts_cancellable;
	guint _update_contacts_id;
	gboolean _photos_up_to_date;
	guint _update_contacts_n;
	guint _update_contacts_failures;
};

struct _FolksBackendsBlueZPersonaStoreUpdateContactsFromFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZPersonaStore* self;
	GFile* file;
	GeeHashSet* added_personas;
	GeeHashSet* _tmp0_;
	GeeHashSet* removed_personas;
	GeeHashSet* _tmp1_;
	gboolean photos_up_to_date;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GeeHashSet* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* _tmp7_;
	GeeCollection* _tmp8_;
	GFileInputStream* _tmp9_;
	GFileInputStream* _tmp10_;
	GDataInputStream* dis;
	GDataInputStream* _tmp11_;
	guint i;
	gchar* line;
	GString* vcard;
	GString* _tmp12_;
	GString* vcard_without_photo;
	GString* _tmp13_;
	gchar* _tmp14_;
	GDataInputStream* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gboolean _tmp19_;
	GString* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GString* _tmp24_;
	const gchar* _tmp25_;
	GString* _tmp26_;
	gboolean _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	GString* _tmp30_;
	const gchar* _tmp31_;
	GString* _tmp32_;
	const gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gboolean _tmp36_;
	EVCard* card;
	GString* _tmp37_;
	const gchar* _tmp38_;
	EVCard* _tmp39_;
	gboolean is_user;
	gboolean iid_is_checksum;
	gchar* iid;
	EVCardAttribute* attribute;
	EVCard* _tmp40_;
	EVCardAttribute* _tmp41_;
	EVCardAttribute* _tmp42_;
	EVCardAttribute* _tmp43_;
	EVCardAttribute* _tmp44_;
	GString* _tmp45_;
	GString* _tmp46_;
	const gchar* _tmp47_;
	gchar* _tmp48_;
	GString* _tmp49_;
	const gchar* _tmp50_;
	gchar* _tmp51_;
	FolksBackendsBlueZPersona* persona;
	GeeHashMap* _tmp52_;
	const gchar* _tmp53_;
	gpointer _tmp54_;
	FolksBackendsBlueZPersona* _tmp55_;
	GString* _tmp56_;
	const gchar* _tmp57_;
	EVCard* _tmp58_;
	const gchar* _tmp59_;
	FolksBackendsBlueZPersona* _tmp60_;
	gboolean _tmp61_;
	GString* _tmp62_;
	GString* _tmp63_;
	FolksBackendsBlueZPersona* _tmp64_;
	EVCard* _tmp65_;
	GeeHashSet* _tmp66_;
	FolksBackendsBlueZPersona* _tmp67_;
	GeeHashSet* _tmp68_;
	FolksBackendsBlueZPersona* _tmp69_;
	guint _tmp70_;
	GString* _tmp71_;
	GString* _tmp72_;
	GError* e1;
	GError* _tmp73_;
	const gchar* _tmp74_;
	GError* _tmp75_;
	GeeHashSet* _tmp76_;
	gint _tmp77_;
	gint _tmp78_;
	GeeHashSet* _tmp79_;
	gint _tmp80_;
	gint _tmp81_;
	GeeIterator* _p_it;
	GeeHashSet* _tmp82_;
	GeeIterator* _tmp83_;
	GeeIterator* _tmp84_;
	FolksBackendsBlueZPersona* p;
	GeeIterator* _tmp85_;
	gpointer _tmp86_;
	GeeHashMap* _tmp87_;
	FolksBackendsBlueZPersona* _tmp88_;
	const gchar* _tmp89_;
	const gchar* _tmp90_;
	FolksBackendsBlueZPersona* _tmp91_;
	GeeIterator* _vala1__p_it;
	GeeHashSet* _tmp92_;
	GeeIterator* _tmp93_;
	GeeIterator* _tmp94_;
	FolksBackendsBlueZPersona* _vala1_p;
	GeeIterator* _tmp95_;
	gpointer _tmp96_;
	GeeHashMap* _tmp97_;
	FolksBackendsBlueZPersona* _tmp98_;
	const gchar* _tmp99_;
	const gchar* _tmp100_;
	gboolean _tmp101_;
	GeeHashSet* _tmp102_;
	gboolean _tmp103_;
	gboolean _tmp104_;
	GeeHashSet* _tmp105_;
	gboolean _tmp106_;
	gboolean _tmp107_;
	GeeHashSet* _tmp108_;
	GeeHashSet* _tmp109_;
	GError* _inner_error0_;
};

struct _FolksBackendsBlueZPersonaStoreSetConnectionStateData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZPersonaStore* self;
	gboolean connected;
	orgbluezDevice* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	orgbluezDevice* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	orgbluezDevice* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	orgbluezDevice* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GError* _inner_error0_;
};

struct _FolksBackendsBlueZPersonaStoreNewObexSessionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZPersonaStore* self;
	orgbluezobexPhonebookAccess* obex_pbap;
	char* result;
	GHashTable* args;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	gchar* _tmp2_;
	GVariant* _tmp3_;
	char* session_path;
	orgbluezobexClient* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GHashTable* _tmp7_;
	char* _tmp8_;
	const char* _tmp9_;
	orgbluezobexPhonebookAccess* _tmp10_;
	const char* _tmp11_;
	orgbluezobexPhonebookAccess* _tmp12_;
	orgbluezobexPhonebookAccess* _tmp13_;
	orgbluezobexPhonebookAccess* _tmp14_;
	GError* _inner_error0_;
};

struct _FolksBackendsBlueZPersonaStoreRemoveObexSessionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZPersonaStore* self;
	char* session_path;
	orgbluezobexClient* _tmp0_;
	GError* ie;
	gboolean _tmp1_;
	GError* _tmp2_;
	GError* _tmp3_;
	gboolean _tmp4_;
	GError* _tmp5_;
	GError* _tmp6_;
	const gchar* _tmp7_;
	GError* _tmp8_;
	const gchar* _tmp9_;
	GError* de;
	GError* _tmp10_;
	const gchar* _tmp11_;
	GError* _inner_error0_;
};

struct _Block2Data {
	int _ref_count_;
	FolksBackendsBlueZPersonaStore* self;
	gpointer _async_data_;
};

struct _Block3Data {
	int _ref_count_;
	Block2Data * _data2_;
	gboolean has_yielded;
	gchar* transfer_status;
};

struct _Block4Data {
	int _ref_count_;
	Block2Data * _data2_;
	GFile* file;
};

struct _FolksBackendsBlueZPersonaStorePerformObexTransferData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZPersonaStore* self;
	gchar* path;
	GCancellable* cancellable;
	Block2Data* _data2_;
	orgbluezobexTransfer* transfer;
	Block3Data* _data3_;
	orgbluezobexTransfer* _tmp0_;
	orgbluezobexTransfer* _tmp1_;
	orgbluezobexTransfer* _tmp2_;
	GDBusProxy* transfer_proxy;
	orgbluezobexTransfer* _tmp3_;
	GDBusProxy* _tmp4_;
	gulong signal_id;
	gulong cancellable_id;
	orgbluezobexTransfer* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GDBusProxy* _tmp8_;
	gulong _tmp9_;
	gboolean _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GDBusProxy* _tmp13_;
	const gchar* _tmp14_;
	gchar* filename;
	orgbluezobexTransfer* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	orgbluezobexTransfer* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	GError* _tmp24_;
	GError* _tmp25_;
	GFile* file;
	const gchar* _tmp26_;
	GFile* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	GFile* _tmp32_;
	const gchar* _tmp33_;
	orgbluezobexTransfer* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	const gchar* _tmp38_;
	GError* _tmp39_;
	GError* _tmp40_;
	GError* _inner_error1_;
	gboolean _tmp41_;
	orgbluezobexTransfer* _tmp42_;
	orgbluezobexTransfer* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	Block4Data* _data4_;
	orgbluezobexTransfer* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	GFile* _tmp51_;
	GFile* _tmp52_;
	GFile* _tmp53_;
	GError* _inner_error0_;
};

struct _FolksBackendsBlueZPersonaStoreUpdateContactsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZPersonaStore* self;
	gboolean download_photos;
	char* session_path;
	orgbluezobexPhonebookAccess* obex_pbap;
	gboolean success;
	GCancellable* _tmp0_;
	FolksInternalProfileBlock* profiling;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	FolksInternalProfileBlock* _tmp3_;
	gchar* path;
	GHashTable* props;
	GCancellable* _tmp4_;
	char* _tmp5_;
	orgbluezobexPhonebookAccess* _tmp6_;
	char* _tmp7_;
	char* _tmp8_;
	GError* e1;
	gboolean _tmp9_;
	GError* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	orgbluezDevice* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GError* _tmp17_;
	GError* _tmp18_;
	orgbluezDevice* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _tmp23_;
	const gchar* _tmp24_;
	GError* _tmp25_;
	GError* _tmp26_;
	orgbluezobexPhonebookAccess* _tmp27_;
	GHashTable* phonebook_filter;
	GHashTable* _tmp28_;
	GHashTable* _tmp29_;
	gchar* _tmp30_;
	GVariant* _tmp31_;
	GHashTable* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	gchar* _tmp41_;
	gchar** _tmp42_;
	gchar** _tmp43_;
	gint _tmp43__length1;
	GVariant* _tmp44_;
	GHashTable* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	gchar** _tmp54_;
	gchar** _tmp55_;
	gint _tmp55__length1;
	GVariant* _tmp56_;
	orgbluezobexPhonebookAccess* _tmp57_;
	GHashTable* _tmp58_;
	gchar* _tmp59_;
	GHashTable* _tmp60_;
	GError* e2;
	orgbluezDevice* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	GError* _tmp65_;
	const gchar* _tmp66_;
	GError* _tmp67_;
	GError* _tmp68_;
	const gchar* _tmp69_;
	GCancellable* _tmp70_;
	GError* e3;
	GError* _tmp71_;
	GError* _tmp72_;
	GError* _tmp73_;
	const gchar* _tmp74_;
	GError* _tmp75_;
	const gchar* _tmp76_;
	GError* _tmp77_;
	GError* e4;
	GError* _tmp78_;
	GError* _tmp79_;
	GError* e5;
	GError* _tmp80_;
	GError* _tmp81_;
	GError* _inner_error1_;
	const char* _tmp82_;
	const char* _tmp83_;
	guint _tmp84_;
	gboolean _tmp85_;
	gboolean new_download_photos;
	FolksInternalProfileBlock* _tmp86_;
	GError* _inner_error0_;
};

struct _Block5Data {
	int _ref_count_;
	FolksBackendsBlueZPersonaStore* self;
	gboolean download_photos;
};

struct _FolksBackendsBlueZPersonaStorePrepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZPersonaStore* self;
	FolksInternalProfileBlock* profiling;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	FolksInternalProfileBlock* _tmp2_;
	gboolean _tmp3_;
	orgbluezDevice* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GError* _tmp8_;
	GError* _tmp9_;
	GError* _inner_error1_;
	FolksInternalProfileBlock* _tmp10_;
	GError* _inner_error0_;
};

struct _FolksBackendsBlueZPersonaStoreRemovePersonaData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZPersonaStore* self;
	FolksPersona* persona;
	GError* _tmp0_;
	GError* _inner_error0_;
};

struct _FolksBackendsBlueZPersonaStoreAddPersonaFromDetailsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendsBlueZPersonaStore* self;
	GHashTable* details;
	FolksPersona* result;
	GError* _tmp0_;
	GError* _inner_error0_;
};

static gint FolksBackendsBlueZPersonaStore_private_offset;
static gpointer folks_backends_blue_z_persona_store_parent_class = NULL;
static gchar** folks_backends_blue_z_persona_store__always_writeable_properties;
static gint folks_backends_blue_z_persona_store__always_writeable_properties_length1;
static gchar** folks_backends_blue_z_persona_store__always_writeable_properties = NULL;
static gint folks_backends_blue_z_persona_store__always_writeable_properties_length1 = 0;
static gint _folks_backends_blue_z_persona_store__always_writeable_properties_size_ = 0;

VALA_EXTERN void folks_backends_blue_z_persona_store_set_is_trusted (FolksBackendsBlueZPersonaStore* self,
                                                         gboolean trusted);
static void _folks_backends_blue_z_persona_store_update_contacts_from_file_data_free (gpointer _data);
static void _folks_backends_blue_z_persona_store_update_contacts_from_file (FolksBackendsBlueZPersonaStore* self,
                                                                     GFile* file,
                                                                     GAsyncReadyCallback _callback_,
                                                                     gpointer _user_data_);
static void _folks_backends_blue_z_persona_store_update_contacts_from_file_finish (FolksBackendsBlueZPersonaStore* self,
                                                                            GAsyncResult* _res_,
                                                                            GError** error);
static gboolean _folks_backends_blue_z_persona_store_update_contacts_from_file_co (FolksBackendsBlueZPersonaStoreUpdateContactsFromFileData* _data_);
static void _folks_backends_blue_z_persona_store_update_contacts_from_file_ready (GObject* source_object,
                                                                           GAsyncResult* _res_,
                                                                           gpointer _user_data_);
static EVCardAttribute* _vala_EVCardAttribute_copy (EVCardAttribute* self);
VALA_EXTERN gboolean folks_backends_blue_z_persona_update_from_vcard (FolksBackendsBlueZPersona* self,
                                                          EVCard* card);
static void _vala_EVCardAttribute_free (EVCardAttribute* self);
VALA_EXTERN void folks_backends_blue_z_persona_store_set_alias (FolksBackendsBlueZPersonaStore* self,
                                                    const gchar* alias);
static void folks_backends_blue_z_persona_store_set_connection_state_data_free (gpointer _data);
VALA_EXTERN void folks_backends_blue_z_persona_store_set_connection_state (FolksBackendsBlueZPersonaStore* self,
                                                               gboolean connected,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
VALA_EXTERN void folks_backends_blue_z_persona_store_set_connection_state_finish (FolksBackendsBlueZPersonaStore* self,
                                                                      GAsyncResult* _res_,
                                                                      GError** error);
static gboolean folks_backends_blue_z_persona_store_set_connection_state_co (FolksBackendsBlueZPersonaStoreSetConnectionStateData* _data_);
static void _folks_backends_blue_z_persona_store_update_contacts (FolksBackendsBlueZPersonaStore* self,
                                                           gboolean download_photos,
                                                           GAsyncReadyCallback _callback_,
                                                           gpointer _user_data_);
static void _folks_backends_blue_z_persona_store_update_contacts_finish (FolksBackendsBlueZPersonaStore* self,
                                                                  GAsyncResult* _res_,
                                                                  GError** error);
static void folks_backends_blue_z_persona_store_set_connection_state_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_);
VALA_EXTERN void folks_backends_blue_z_persona_store_cancel_updates (FolksBackendsBlueZPersonaStore* self);
static void _folks_backends_blue_z_persona_store_new_obex_session_data_free (gpointer _data);
static void _folks_backends_blue_z_persona_store_new_obex_session (FolksBackendsBlueZPersonaStore* self,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_);
static char* _folks_backends_blue_z_persona_store_new_obex_session_finish (FolksBackendsBlueZPersonaStore* self,
                                                                    GAsyncResult* _res_,
                                                                    orgbluezobexPhonebookAccess** obex_pbap,
                                                                    GError** error);
static gboolean _folks_backends_blue_z_persona_store_new_obex_session_co (FolksBackendsBlueZPersonaStoreNewObexSessionData* _data_);
static void _g_free0_ (gpointer var);
static void _g_variant_unref0_ (gpointer var);
static GVariant* _variant_new1 (const gchar* value);
static void _folks_backends_blue_z_persona_store_new_obex_session_ready (GObject* source_object,
                                                                  GAsyncResult* _res_,
                                                                  gpointer _user_data_);
static void _folks_backends_blue_z_persona_store_remove_obex_session_data_free (gpointer _data);
static void _folks_backends_blue_z_persona_store_remove_obex_session (FolksBackendsBlueZPersonaStore* self,
                                                               const char* session_path,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
static void _folks_backends_blue_z_persona_store_remove_obex_session_finish (FolksBackendsBlueZPersonaStore* self,
                                                                      GAsyncResult* _res_);
static gboolean _folks_backends_blue_z_persona_store_remove_obex_session_co (FolksBackendsBlueZPersonaStoreRemoveObexSessionData* _data_);
static void _folks_backends_blue_z_persona_store_remove_obex_session_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_);
static void _folks_backends_blue_z_persona_store_perform_obex_transfer_data_free (gpointer _data);
static void _folks_backends_blue_z_persona_store_perform_obex_transfer (FolksBackendsBlueZPersonaStore* self,
                                                                 const gchar* path,
                                                                 GCancellable* cancellable,
                                                                 GAsyncReadyCallback _callback_,
                                                                 gpointer _user_data_);
static void _folks_backends_blue_z_persona_store_perform_obex_transfer_finish (FolksBackendsBlueZPersonaStore* self,
                                                                        GAsyncResult* _res_,
                                                                        GError** error);
static gboolean _folks_backends_blue_z_persona_store_perform_obex_transfer_co (FolksBackendsBlueZPersonaStorePerformObexTransferData* _data_);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void _folks_backends_blue_z_persona_store_perform_obex_transfer_ready (GObject* source_object,
                                                                       GAsyncResult* _res_,
                                                                       gpointer _user_data_);
static void ____lambda4_ (Block3Data* _data3_);
static void _____lambda4__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda5_ (Block3Data* _data3_,
                  GVariant* changed,
                  gchar** invalidated);
static void ____lambda5__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                     GVariant* changed_properties,
                                                     gchar** invalidated_properties,
                                                     gpointer self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void ____lambda6_ (Block4Data* _data4_,
                   GObject* o,
                   GAsyncResult* r);
static void _____lambda6__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void _folks_backends_blue_z_persona_store_update_contacts_data_free (gpointer _data);
static gboolean _folks_backends_blue_z_persona_store_update_contacts_co (FolksBackendsBlueZPersonaStoreUpdateContactsData* _data_);
static void _folks_backends_blue_z_persona_store_update_contacts_ready (GObject* source_object,
                                                                 GAsyncResult* _res_,
                                                                 gpointer _user_data_);
static GVariant* _variant_new2 (const gchar* value);
static void _folks_backends_blue_z_persona_store_schedule_update_contacts (FolksBackendsBlueZPersonaStore* self,
                                                                    gboolean download_photos);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block5Data* _data5_);
static void __lambda8_ (FolksBackendsBlueZPersonaStore* self,
                 GObject* o,
                 GAsyncResult* r);
static void ___lambda8__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
static gboolean ___lambda7__gsource_func (gpointer self);
static void folks_backends_blue_z_persona_store_real_prepare_data_free (gpointer _data);
static void folks_backends_blue_z_persona_store_real_prepare (FolksPersonaStore* base,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static gboolean folks_backends_blue_z_persona_store_real_prepare_co (FolksBackendsBlueZPersonaStorePrepareData* _data_);
static void folks_backends_blue_z_persona_store_prepare_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static void folks_backends_blue_z_persona_store_real_remove_persona_data_free (gpointer _data);
static void folks_backends_blue_z_persona_store_real_remove_persona (FolksPersonaStore* base,
                                                              FolksPersona* persona,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
static gboolean folks_backends_blue_z_persona_store_real_remove_persona_co (FolksBackendsBlueZPersonaStoreRemovePersonaData* _data_);
static void folks_backends_blue_z_persona_store_real_add_persona_from_details_data_free (gpointer _data);
static void folks_backends_blue_z_persona_store_real_add_persona_from_details (FolksPersonaStore* base,
                                                                        GHashTable* details,
                                                                        GAsyncReadyCallback _callback_,
                                                                        gpointer _user_data_);
static gboolean folks_backends_blue_z_persona_store_real_add_persona_from_details_co (FolksBackendsBlueZPersonaStoreAddPersonaFromDetailsData* _data_);
static GObject * folks_backends_blue_z_persona_store_constructor (GType type,
                                                           guint n_construct_properties,
                                                           GObjectConstructParam * construct_properties);
static void folks_backends_blue_z_persona_store_finalize (GObject * obj);
static GType folks_backends_blue_z_persona_store_get_type_once (void);
static void _vala_folks_backends_blue_z_persona_store_get_property (GObject * object,
                                                             guint property_id,
                                                             GValue * value,
                                                             GParamSpec * pspec);
static void _vala_folks_backends_blue_z_persona_store_set_property (GObject * object,
                                                             guint property_id,
                                                             const GValue * value,
                                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
folks_backends_blue_z_persona_store_get_instance_private (FolksBackendsBlueZPersonaStore* self)
{
	return G_STRUCT_MEMBER_P (self, FolksBackendsBlueZPersonaStore_private_offset);
}

/**
   * Create a new PersonaStore.
   *
   * Create a new persona store to expose the {@link Persona}s provided by the
   * device with the given Bluetooth address.
   *
   * @param device the D-Bus object for the Bluetooth device.
   * @param object_path the D-Bus path of the object for the Bluetooth device
   * @param obex_client the D-Bus obex client object.
   *
   * @since 0.9.6
   */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 240 "../backends/bluez/bluez-persona-store.vala"
	return self ? g_object_ref (self) : NULL;
#line 782 "bluez-persona-store.c"
}

FolksBackendsBlueZPersonaStore*
folks_backends_blue_z_persona_store_construct (GType object_type,
                                               orgbluezDevice* device,
                                               const gchar* object_path,
                                               orgbluezobexClient* obex_client)
{
	FolksBackendsBlueZPersonaStore * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	orgbluezDevice* _tmp6_;
	orgbluezobexClient* _tmp7_;
	orgbluezDevice* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
#line 233 "../backends/bluez/bluez-persona-store.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 233 "../backends/bluez/bluez-persona-store.vala"
	g_return_val_if_fail (object_path != NULL, NULL);
#line 233 "../backends/bluez/bluez-persona-store.vala"
	g_return_val_if_fail (obex_client != NULL, NULL);
#line 236 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = org_bluez_device_get_address (device);
#line 236 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = _tmp0_;
#line 236 "../backends/bluez/bluez-persona-store.vala"
	_tmp2_ = _tmp1_;
#line 236 "../backends/bluez/bluez-persona-store.vala"
	_tmp3_ = org_bluez_device_get_alias (device);
#line 236 "../backends/bluez/bluez-persona-store.vala"
	_tmp4_ = _tmp3_;
#line 236 "../backends/bluez/bluez-persona-store.vala"
	_tmp5_ = _tmp4_;
#line 236 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) g_object_new (object_type, "id", _tmp2_, "object-path", object_path, "display-name", _tmp5_, NULL);
#line 236 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_tmp5_);
#line 236 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_tmp2_);
#line 240 "../backends/bluez/bluez-persona-store.vala"
	_tmp6_ = _g_object_ref0 (device);
#line 240 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (self->priv->_device);
#line 240 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_device = _tmp6_;
#line 241 "../backends/bluez/bluez-persona-store.vala"
	_tmp7_ = _g_object_ref0 (obex_client);
#line 241 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (self->priv->_obex_client);
#line 241 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_obex_client = _tmp7_;
#line 243 "../backends/bluez/bluez-persona-store.vala"
	_tmp8_ = self->priv->_device;
#line 243 "../backends/bluez/bluez-persona-store.vala"
	_tmp9_ = org_bluez_device_get_trusted (_tmp8_);
#line 243 "../backends/bluez/bluez-persona-store.vala"
	_tmp10_ = _tmp9_;
#line 243 "../backends/bluez/bluez-persona-store.vala"
	folks_backends_blue_z_persona_store_set_is_trusted (self, _tmp10_);
#line 233 "../backends/bluez/bluez-persona-store.vala"
	return self;
#line 849 "bluez-persona-store.c"
}

FolksBackendsBlueZPersonaStore*
folks_backends_blue_z_persona_store_new (orgbluezDevice* device,
                                         const gchar* object_path,
                                         orgbluezobexClient* obex_client)
{
#line 233 "../backends/bluez/bluez-persona-store.vala"
	return folks_backends_blue_z_persona_store_construct (FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA_STORE, device, object_path, obex_client);
#line 859 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_update_contacts_from_file_data_free (gpointer _data)
{
	FolksBackendsBlueZPersonaStoreUpdateContactsFromFileData* _data_;
	_data_ = _data;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->file);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_slice_free (FolksBackendsBlueZPersonaStoreUpdateContactsFromFileData, _data_);
#line 873 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_update_contacts_from_file (FolksBackendsBlueZPersonaStore* self,
                                                                GFile* file,
                                                                GAsyncReadyCallback _callback_,
                                                                gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStoreUpdateContactsFromFileData* _data_;
	FolksBackendsBlueZPersonaStore* _tmp0_;
	GFile* _tmp1_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (file != NULL);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZPersonaStoreUpdateContactsFromFileData);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backends_blue_z_persona_store_update_contacts_from_file_data_free);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->self = _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->file);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->file = _tmp1_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store_update_contacts_from_file_co (_data_);
#line 907 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_update_contacts_from_file_finish (FolksBackendsBlueZPersonaStore* self,
                                                                       GAsyncResult* _res_,
                                                                       GError** error)
{
	FolksBackendsBlueZPersonaStoreUpdateContactsFromFileData* _data_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	if (NULL == _data_) {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		return;
#line 922 "bluez-persona-store.c"
	}
}

/**
   * Load contacts from a file and update the persona store.
   *
   * Load contacts from a file identified by its {@link File} and update
   * the persona store accordingly. Contacts are stored in the file as a
   * sequence of vCards, separated by blank lines.
   *
   * If a contact already exists in the store, its properties will be updated
   * from the vCard; otherwise it will be added as a new contact to the store.
   * Contacts which are in the store and not in the vCard will be removed from
   * the store.
   *
   * If this throws an error, it guarantees to leave the store’s internal state
   * unchanged, but may change the state of {@link Persona}s in the store.
   *
   * @param file the file where the contacts are stored
   * @throws IOError if there was an error communicating with D-Bus
   * @throws Error if the given file couldn’t be read
   *
   * @since 0.9.6
   */
static void
_folks_backends_blue_z_persona_store_update_contacts_from_file_ready (GObject* source_object,
                                                                      GAsyncResult* _res_,
                                                                      gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStoreUpdateContactsFromFileData* _data_;
#line 294 "../backends/bluez/bluez-persona-store.vala"
	_data_ = _user_data_;
#line 294 "../backends/bluez/bluez-persona-store.vala"
	_data_->_source_object_ = source_object;
#line 294 "../backends/bluez/bluez-persona-store.vala"
	_data_->_res_ = _res_;
#line 294 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store_update_contacts_from_file_co (_data_);
#line 961 "bluez-persona-store.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 982 "bluez-persona-store.c"
}

static EVCardAttribute*
_vala_EVCardAttribute_copy (EVCardAttribute* self)
{
#line 332 "../backends/bluez/bluez-persona-store.vala"
	return g_boxed_copy (e_vcard_attribute_get_type (), self);
#line 990 "bluez-persona-store.c"
}

static gpointer
__vala_EVCardAttribute_copy0 (gpointer self)
{
#line 332 "../backends/bluez/bluez-persona-store.vala"
	return self ? _vala_EVCardAttribute_copy (self) : NULL;
#line 998 "bluez-persona-store.c"
}

static void
_vala_EVCardAttribute_free (EVCardAttribute* self)
{
#line 309 "../backends/bluez/bluez-persona-store.vala"
	g_boxed_free (e_vcard_attribute_get_type (), self);
#line 1006 "bluez-persona-store.c"
}

static gboolean
_folks_backends_blue_z_persona_store_update_contacts_from_file_co (FolksBackendsBlueZPersonaStoreUpdateContactsFromFileData* _data_)
{
#line 273 "../backends/bluez/bluez-persona-store.vala"
	switch (_data_->_state_) {
#line 273 "../backends/bluez/bluez-persona-store.vala"
		case 0:
#line 1016 "bluez-persona-store.c"
		goto _state_0;
#line 273 "../backends/bluez/bluez-persona-store.vala"
		case 1:
#line 1020 "bluez-persona-store.c"
		goto _state_1;
		default:
#line 273 "../backends/bluez/bluez-persona-store.vala"
		g_assert_not_reached ();
#line 1025 "bluez-persona-store.c"
	}
	_state_0:
#line 275 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp0_ = gee_hash_set_new (FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 275 "../backends/bluez/bluez-persona-store.vala"
	_data_->added_personas = _data_->_tmp0_;
#line 276 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp1_ = gee_hash_set_new (FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 276 "../backends/bluez/bluez-persona-store.vala"
	_data_->removed_personas = _data_->_tmp1_;
#line 277 "../backends/bluez/bluez-persona-store.vala"
	_data_->photos_up_to_date = TRUE;
#line 279 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp2_ = g_file_get_path (_data_->file);
#line 279 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 279 "../backends/bluez/bluez-persona-store.vala"
	g_debug ("bluez-persona-store.vala:279: Parsing contacts from file ‘%s’.", _data_->_tmp3_);
#line 279 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_data_->_tmp3_);
#line 283 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp4_ = _data_->removed_personas;
#line 283 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp5_ = _data_->self->priv->_personas;
#line 283 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp6_ = gee_abstract_map_get_values ((GeeAbstractMap*) _data_->_tmp5_);
#line 283 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 283 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 283 "../backends/bluez/bluez-persona-store.vala"
	gee_collection_add_all ((GeeCollection*) _data_->_tmp4_, _data_->_tmp8_);
#line 283 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->_tmp8_);
#line 1060 "bluez-persona-store.c"
	{
#line 287 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp10_ = g_file_read (_data_->file, NULL, &_data_->_inner_error0_);
#line 287 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp9_ = _data_->_tmp10_;
#line 287 "../backends/bluez/bluez-persona-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1068 "bluez-persona-store.c"
			goto __catch0_g_error;
		}
#line 287 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp11_ = g_data_input_stream_new ((GInputStream*) _data_->_tmp9_);
#line 287 "../backends/bluez/bluez-persona-store.vala"
		_data_->dis = _data_->_tmp11_;
#line 288 "../backends/bluez/bluez-persona-store.vala"
		_data_->i = (guint) 0;
#line 289 "../backends/bluez/bluez-persona-store.vala"
		_data_->line = NULL;
#line 290 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp12_ = g_string_new ("");
#line 290 "../backends/bluez/bluez-persona-store.vala"
		_data_->vcard = _data_->_tmp12_;
#line 291 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp13_ = g_string_new ("");
#line 291 "../backends/bluez/bluez-persona-store.vala"
		_data_->vcard_without_photo = _data_->_tmp13_;
#line 294 "../backends/bluez/bluez-persona-store.vala"
		while (TRUE) {
#line 294 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp15_ = _data_->dis;
#line 294 "../backends/bluez/bluez-persona-store.vala"
			_data_->_state_ = 1;
#line 294 "../backends/bluez/bluez-persona-store.vala"
			g_data_input_stream_read_line_async (_data_->_tmp15_, G_PRIORITY_DEFAULT, NULL, _folks_backends_blue_z_persona_store_update_contacts_from_file_ready, _data_);
#line 294 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 1097 "bluez-persona-store.c"
			_state_1:
#line 294 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp16_ = g_data_input_stream_read_line_finish (_data_->_tmp15_, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 294 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp14_ = _data_->_tmp16_;
#line 294 "../backends/bluez/bluez-persona-store.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 294 "../backends/bluez/bluez-persona-store.vala"
				_g_string_free0 (_data_->vcard_without_photo);
#line 294 "../backends/bluez/bluez-persona-store.vala"
				_g_string_free0 (_data_->vcard);
#line 294 "../backends/bluez/bluez-persona-store.vala"
				_g_free0 (_data_->line);
#line 294 "../backends/bluez/bluez-persona-store.vala"
				_g_object_unref0 (_data_->dis);
#line 294 "../backends/bluez/bluez-persona-store.vala"
				_g_object_unref0 (_data_->_tmp9_);
#line 1115 "bluez-persona-store.c"
				goto __catch0_g_error;
			}
#line 294 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp17_ = _data_->_tmp14_;
#line 294 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp14_ = NULL;
#line 294 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->line);
#line 294 "../backends/bluez/bluez-persona-store.vala"
			_data_->line = _data_->_tmp17_;
#line 294 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp18_ = _data_->line;
#line 294 "../backends/bluez/bluez-persona-store.vala"
			if (!(_data_->_tmp18_ != NULL)) {
#line 294 "../backends/bluez/bluez-persona-store.vala"
				_g_free0 (_data_->_tmp14_);
#line 294 "../backends/bluez/bluez-persona-store.vala"
				break;
#line 1134 "bluez-persona-store.c"
			}
#line 297 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp20_ = _data_->vcard;
#line 297 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_tmp20_->len == ((gssize) 0)) {
#line 297 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp21_ = _data_->line;
#line 297 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp22_ = string_strip (_data_->_tmp21_);
#line 297 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp23_ = _data_->_tmp22_;
#line 297 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp19_ = g_strcmp0 (_data_->_tmp23_, "") == 0;
#line 297 "../backends/bluez/bluez-persona-store.vala"
				_g_free0 (_data_->_tmp23_);
#line 1150 "bluez-persona-store.c"
			} else {
#line 297 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp19_ = FALSE;
#line 1154 "bluez-persona-store.c"
			}
#line 297 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_tmp19_) {
#line 298 "../backends/bluez/bluez-persona-store.vala"
				_g_free0 (_data_->_tmp14_);
#line 298 "../backends/bluez/bluez-persona-store.vala"
				continue;
#line 1162 "bluez-persona-store.c"
			}
#line 300 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp24_ = _data_->vcard;
#line 300 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp25_ = _data_->line;
#line 300 "../backends/bluez/bluez-persona-store.vala"
			g_string_append (_data_->_tmp24_, _data_->_tmp25_);
#line 301 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp26_ = _data_->vcard;
#line 301 "../backends/bluez/bluez-persona-store.vala"
			g_string_append_c (_data_->_tmp26_, '\n');
#line 303 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp28_ = _data_->line;
#line 303 "../backends/bluez/bluez-persona-store.vala"
			if (!g_str_has_prefix (_data_->_tmp28_, "PHOTO:")) {
#line 303 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp29_ = _data_->line;
#line 303 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp27_ = !g_str_has_prefix (_data_->_tmp29_, "PHOTO;");
#line 1182 "bluez-persona-store.c"
			} else {
#line 303 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp27_ = FALSE;
#line 1186 "bluez-persona-store.c"
			}
#line 303 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_tmp27_) {
#line 305 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp30_ = _data_->vcard_without_photo;
#line 305 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp31_ = _data_->line;
#line 305 "../backends/bluez/bluez-persona-store.vala"
				g_string_append (_data_->_tmp30_, _data_->_tmp31_);
#line 306 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp32_ = _data_->vcard_without_photo;
#line 306 "../backends/bluez/bluez-persona-store.vala"
				g_string_append_c (_data_->_tmp32_, '\n');
#line 1200 "bluez-persona-store.c"
			}
#line 309 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp33_ = _data_->line;
#line 309 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp34_ = string_strip (_data_->_tmp33_);
#line 309 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp35_ = _data_->_tmp34_;
#line 309 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp36_ = g_strcmp0 (_data_->_tmp35_, "END:VCARD") == 0;
#line 309 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->_tmp35_);
#line 309 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_tmp36_) {
#line 311 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp37_ = _data_->vcard;
#line 311 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp38_ = _data_->_tmp37_->str;
#line 311 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp39_ = e_vcard_new_from_string (_data_->_tmp38_);
#line 311 "../backends/bluez/bluez-persona-store.vala"
				_data_->card = _data_->_tmp39_;
#line 314 "../backends/bluez/bluez-persona-store.vala"
				_data_->is_user = _data_->i == ((guint) 0);
#line 317 "../backends/bluez/bluez-persona-store.vala"
				_data_->iid_is_checksum = FALSE;
#line 332 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp40_ = _data_->card;
#line 332 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp41_ = e_vcard_get_attribute (_data_->_tmp40_, "UID");
#line 332 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp42_ = __vala_EVCardAttribute_copy0 (_data_->_tmp41_);
#line 332 "../backends/bluez/bluez-persona-store.vala"
				_data_->attribute = _data_->_tmp42_;
#line 333 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp43_ = _data_->attribute;
#line 333 "../backends/bluez/bluez-persona-store.vala"
				if (_data_->_tmp43_ != NULL) {
#line 336 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp44_ = _data_->attribute;
#line 336 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp45_ = e_vcard_attribute_get_value_decoded (_data_->_tmp44_);
#line 336 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp46_ = _data_->_tmp45_;
#line 336 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp47_ = _data_->_tmp46_->str;
#line 336 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp48_ = g_strdup (_data_->_tmp47_);
#line 336 "../backends/bluez/bluez-persona-store.vala"
					_g_free0 (_data_->iid);
#line 336 "../backends/bluez/bluez-persona-store.vala"
					_data_->iid = _data_->_tmp48_;
#line 336 "../backends/bluez/bluez-persona-store.vala"
					_g_string_free0 (_data_->_tmp46_);
#line 1254 "bluez-persona-store.c"
				} else {
#line 341 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp49_ = _data_->vcard_without_photo;
#line 341 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp50_ = _data_->_tmp49_->str;
#line 341 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp51_ = g_compute_checksum_for_string (G_CHECKSUM_SHA1, _data_->_tmp50_, (gsize) -1);
#line 341 "../backends/bluez/bluez-persona-store.vala"
					_g_free0 (_data_->iid);
#line 341 "../backends/bluez/bluez-persona-store.vala"
					_data_->iid = _data_->_tmp51_;
#line 344 "../backends/bluez/bluez-persona-store.vala"
					_data_->iid_is_checksum = TRUE;
#line 1268 "bluez-persona-store.c"
				}
#line 348 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp52_ = _data_->self->priv->_personas;
#line 348 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp53_ = _data_->iid;
#line 348 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp54_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp52_, _data_->_tmp53_);
#line 348 "../backends/bluez/bluez-persona-store.vala"
				_data_->persona = (FolksBackendsBlueZPersona*) _data_->_tmp54_;
#line 349 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp55_ = _data_->persona;
#line 349 "../backends/bluez/bluez-persona-store.vala"
				if (_data_->_tmp55_ == NULL) {
#line 351 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp56_ = _data_->vcard;
#line 351 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp57_ = _data_->_tmp56_->str;
#line 351 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp58_ = _data_->card;
#line 351 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp59_ = _data_->iid;
#line 351 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp60_ = folks_backends_blue_z_persona_new (_data_->_tmp57_, _data_->_tmp58_, (FolksPersonaStore*) _data_->self, _data_->is_user, _data_->_tmp59_);
#line 351 "../backends/bluez/bluez-persona-store.vala"
					_g_object_unref0 (_data_->persona);
#line 351 "../backends/bluez/bluez-persona-store.vala"
					_data_->persona = _data_->_tmp60_;
#line 353 "../backends/bluez/bluez-persona-store.vala"
					_data_->photos_up_to_date = FALSE;
#line 1298 "bluez-persona-store.c"
				} else {
#line 361 "../backends/bluez/bluez-persona-store.vala"
					if (_data_->iid_is_checksum == FALSE) {
#line 361 "../backends/bluez/bluez-persona-store.vala"
						_data_->_tmp61_ = TRUE;
#line 1304 "bluez-persona-store.c"
					} else {
#line 362 "../backends/bluez/bluez-persona-store.vala"
						_data_->_tmp62_ = _data_->vcard_without_photo;
#line 362 "../backends/bluez/bluez-persona-store.vala"
						_data_->_tmp63_ = _data_->vcard;
#line 362 "../backends/bluez/bluez-persona-store.vala"
						_data_->_tmp61_ = _data_->_tmp62_->len != _data_->_tmp63_->len;
#line 1312 "bluez-persona-store.c"
					}
#line 361 "../backends/bluez/bluez-persona-store.vala"
					if (_data_->_tmp61_) {
#line 366 "../backends/bluez/bluez-persona-store.vala"
						_data_->_tmp64_ = _data_->persona;
#line 366 "../backends/bluez/bluez-persona-store.vala"
						_data_->_tmp65_ = _data_->card;
#line 366 "../backends/bluez/bluez-persona-store.vala"
						if (folks_backends_blue_z_persona_update_from_vcard (_data_->_tmp64_, _data_->_tmp65_) == TRUE) {
#line 367 "../backends/bluez/bluez-persona-store.vala"
							_data_->photos_up_to_date = FALSE;
#line 1324 "bluez-persona-store.c"
						}
					}
				}
#line 371 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp66_ = _data_->removed_personas;
#line 371 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp67_ = _data_->persona;
#line 371 "../backends/bluez/bluez-persona-store.vala"
				if (gee_abstract_collection_remove ((GeeAbstractCollection*) _data_->_tmp66_, _data_->_tmp67_) == FALSE) {
#line 372 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp68_ = _data_->added_personas;
#line 372 "../backends/bluez/bluez-persona-store.vala"
					_data_->_tmp69_ = _data_->persona;
#line 372 "../backends/bluez/bluez-persona-store.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp68_, _data_->_tmp69_);
#line 1340 "bluez-persona-store.c"
				}
#line 374 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp70_ = _data_->i;
#line 374 "../backends/bluez/bluez-persona-store.vala"
				_data_->i = _data_->_tmp70_ + 1;
#line 375 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp71_ = _data_->vcard;
#line 375 "../backends/bluez/bluez-persona-store.vala"
				g_string_erase (_data_->_tmp71_, (gssize) 0, (gssize) -1);
#line 376 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp72_ = _data_->vcard_without_photo;
#line 376 "../backends/bluez/bluez-persona-store.vala"
				g_string_erase (_data_->_tmp72_, (gssize) 0, (gssize) -1);
#line 309 "../backends/bluez/bluez-persona-store.vala"
				_g_object_unref0 (_data_->persona);
#line 309 "../backends/bluez/bluez-persona-store.vala"
				__vala_EVCardAttribute_free0 (_data_->attribute);
#line 309 "../backends/bluez/bluez-persona-store.vala"
				_g_free0 (_data_->iid);
#line 309 "../backends/bluez/bluez-persona-store.vala"
				_g_object_unref0 (_data_->card);
#line 1362 "bluez-persona-store.c"
			}
#line 294 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->_tmp14_);
#line 1366 "bluez-persona-store.c"
		}
#line 285 "../backends/bluez/bluez-persona-store.vala"
		_g_string_free0 (_data_->vcard_without_photo);
#line 285 "../backends/bluez/bluez-persona-store.vala"
		_g_string_free0 (_data_->vcard);
#line 285 "../backends/bluez/bluez-persona-store.vala"
		_g_free0 (_data_->line);
#line 285 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->dis);
#line 285 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->_tmp9_);
#line 1378 "bluez-persona-store.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 285 "../backends/bluez/bluez-persona-store.vala"
		_data_->e1 = _data_->_inner_error0_;
#line 285 "../backends/bluez/bluez-persona-store.vala"
		_data_->_inner_error0_ = NULL;
#line 383 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp73_ = _data_->e1;
#line 383 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp74_ = _data_->_tmp73_->message;
#line 383 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp75_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, _ ("Error reading the transferred address book file: %s"), _data_->_tmp74_);
#line 383 "../backends/bluez/bluez-persona-store.vala"
		_data_->_inner_error0_ = _data_->_tmp75_;
#line 383 "../backends/bluez/bluez-persona-store.vala"
		_g_error_free0 (_data_->e1);
#line 1397 "bluez-persona-store.c"
		goto __finally0;
	}
	__finally0:
#line 285 "../backends/bluez/bluez-persona-store.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 285 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 285 "../backends/bluez/bluez-persona-store.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 285 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->removed_personas);
#line 285 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->added_personas);
#line 285 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 285 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 1415 "bluez-persona-store.c"
		} else {
#line 285 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->removed_personas);
#line 285 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->added_personas);
#line 285 "../backends/bluez/bluez-persona-store.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 285 "../backends/bluez/bluez-persona-store.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 285 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 285 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 1429 "bluez-persona-store.c"
		}
	}
#line 391 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp76_ = _data_->added_personas;
#line 391 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp77_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp76_);
#line 391 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp78_ = _data_->_tmp77_;
#line 391 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp79_ = _data_->removed_personas;
#line 391 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp80_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp79_);
#line 391 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp81_ = _data_->_tmp80_;
#line 391 "../backends/bluez/bluez-persona-store.vala"
	g_debug ("Finished parsing personas; now updating store state with %u " "added personas and %u removed personas.", _data_->_tmp78_, _data_->_tmp81_);
#line 1446 "bluez-persona-store.c"
	{
#line 395 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp82_ = _data_->added_personas;
#line 395 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp83_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _data_->_tmp82_);
#line 395 "../backends/bluez/bluez-persona-store.vala"
		_data_->_p_it = _data_->_tmp83_;
#line 395 "../backends/bluez/bluez-persona-store.vala"
		while (TRUE) {
#line 395 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp84_ = _data_->_p_it;
#line 395 "../backends/bluez/bluez-persona-store.vala"
			if (!gee_iterator_next (_data_->_tmp84_)) {
#line 395 "../backends/bluez/bluez-persona-store.vala"
				break;
#line 1462 "bluez-persona-store.c"
			}
#line 395 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp85_ = _data_->_p_it;
#line 395 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp86_ = gee_iterator_get (_data_->_tmp85_);
#line 395 "../backends/bluez/bluez-persona-store.vala"
			_data_->p = (FolksBackendsBlueZPersona*) _data_->_tmp86_;
#line 396 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp87_ = _data_->self->priv->_personas;
#line 396 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp88_ = _data_->p;
#line 396 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp89_ = folks_persona_get_iid ((FolksPersona*) _data_->_tmp88_);
#line 396 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp90_ = _data_->_tmp89_;
#line 396 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp91_ = _data_->p;
#line 396 "../backends/bluez/bluez-persona-store.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp87_, _data_->_tmp90_, _data_->_tmp91_);
#line 395 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->p);
#line 1484 "bluez-persona-store.c"
		}
#line 395 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->_p_it);
#line 1488 "bluez-persona-store.c"
	}
	{
#line 397 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp92_ = _data_->removed_personas;
#line 397 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp93_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _data_->_tmp92_);
#line 397 "../backends/bluez/bluez-persona-store.vala"
		_data_->_vala1__p_it = _data_->_tmp93_;
#line 397 "../backends/bluez/bluez-persona-store.vala"
		while (TRUE) {
#line 397 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp94_ = _data_->_vala1__p_it;
#line 397 "../backends/bluez/bluez-persona-store.vala"
			if (!gee_iterator_next (_data_->_tmp94_)) {
#line 397 "../backends/bluez/bluez-persona-store.vala"
				break;
#line 1505 "bluez-persona-store.c"
			}
#line 397 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp95_ = _data_->_vala1__p_it;
#line 397 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp96_ = gee_iterator_get (_data_->_tmp95_);
#line 397 "../backends/bluez/bluez-persona-store.vala"
			_data_->_vala1_p = (FolksBackendsBlueZPersona*) _data_->_tmp96_;
#line 398 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp97_ = _data_->self->priv->_personas;
#line 398 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp98_ = _data_->_vala1_p;
#line 398 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp99_ = folks_persona_get_iid ((FolksPersona*) _data_->_tmp98_);
#line 398 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp100_ = _data_->_tmp99_;
#line 398 "../backends/bluez/bluez-persona-store.vala"
			gee_abstract_map_unset ((GeeAbstractMap*) _data_->_tmp97_, _data_->_tmp100_, NULL);
#line 397 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->_vala1_p);
#line 1525 "bluez-persona-store.c"
		}
#line 397 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->_vala1__p_it);
#line 1529 "bluez-persona-store.c"
	}
#line 400 "../backends/bluez/bluez-persona-store.vala"
	_data_->self->priv->_photos_up_to_date = _data_->photos_up_to_date;
#line 402 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp102_ = _data_->added_personas;
#line 402 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp103_ = gee_collection_get_is_empty ((GeeCollection*) _data_->_tmp102_);
#line 402 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp104_ = _data_->_tmp103_;
#line 402 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_tmp104_ == FALSE) {
#line 402 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp101_ = TRUE;
#line 1543 "bluez-persona-store.c"
	} else {
#line 403 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp105_ = _data_->removed_personas;
#line 403 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp106_ = gee_collection_get_is_empty ((GeeCollection*) _data_->_tmp105_);
#line 403 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp107_ = _data_->_tmp106_;
#line 403 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp101_ = _data_->_tmp107_ == FALSE;
#line 1553 "bluez-persona-store.c"
	}
#line 402 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_tmp101_) {
#line 405 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp108_ = _data_->added_personas;
#line 405 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp109_ = _data_->removed_personas;
#line 405 "../backends/bluez/bluez-persona-store.vala"
		_folks_persona_store_emit_personas_changed ((FolksPersonaStore*) _data_->self, (GeeSet*) _data_->_tmp108_, (GeeSet*) _data_->_tmp109_, NULL, NULL, FOLKS_GROUP_DETAILS_CHANGE_REASON_NONE);
#line 1563 "bluez-persona-store.c"
	}
#line 273 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->removed_personas);
#line 273 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->added_personas);
#line 273 "../backends/bluez/bluez-persona-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 273 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_state_ != 0) {
#line 273 "../backends/bluez/bluez-persona-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 273 "../backends/bluez/bluez-persona-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1577 "bluez-persona-store.c"
		}
	}
#line 273 "../backends/bluez/bluez-persona-store.vala"
	g_object_unref (_data_->_async_result);
#line 273 "../backends/bluez/bluez-persona-store.vala"
	return FALSE;
#line 1584 "bluez-persona-store.c"
}

/**
   * Set the persona store's alias.
   *
   * This will be called in response to a property change sent to the Backend.
   *
   * @param alias the device’s new alias
   *
   * @since 0.9.6
   */
void
folks_backends_blue_z_persona_store_set_alias (FolksBackendsBlueZPersonaStore* self,
                                               const gchar* alias)
{
	const gchar* _tmp0_;
	orgbluezDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 418 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 418 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (alias != NULL);
#line 420 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = self->priv->_display_name;
#line 420 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = self->priv->_device;
#line 420 "../backends/bluez/bluez-persona-store.vala"
	_tmp2_ = org_bluez_device_get_address (_tmp1_);
#line 420 "../backends/bluez/bluez-persona-store.vala"
	_tmp3_ = _tmp2_;
#line 420 "../backends/bluez/bluez-persona-store.vala"
	_tmp4_ = _tmp3_;
#line 420 "../backends/bluez/bluez-persona-store.vala"
	g_debug ("bluez-persona-store.vala:420: Device ‘%s’ (%s) changed alias to ‘%s’.", _tmp0_, _tmp4_, alias);
#line 420 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_tmp4_);
#line 423 "../backends/bluez/bluez-persona-store.vala"
	_tmp5_ = g_strdup (alias);
#line 423 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (self->priv->_display_name);
#line 423 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_display_name = _tmp5_;
#line 424 "../backends/bluez/bluez-persona-store.vala"
	g_object_notify ((GObject*) self, "display-name");
#line 1632 "bluez-persona-store.c"
}

/**
   * Set the persona store's trust level.
   *
   * This will be called in response to a property change sent to the Backend.
   *
   * Default to partial trust. BlueZ persona UIDs are built from a SHA1
   * of the contact’s vCard, which we believe can’t be maliciously edited
   * to corrupt linking.
   *
   * The trust for each device is manually set by the user in the BlueZ
   * interface on the computer.
   *
   * @param trusted ``true`` if the user trusts the device, ``false`` otherwise
   *
   * @since 0.9.6
   */
void
folks_backends_blue_z_persona_store_set_is_trusted (FolksBackendsBlueZPersonaStore* self,
                                                    gboolean trusted)
{
	const gchar* _tmp0_ = NULL;
	orgbluezDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	orgbluezDevice* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	FolksPersonaStoreTrust _tmp9_ = 0;
#line 443 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 446 "../backends/bluez/bluez-persona-store.vala"
	if (trusted) {
#line 446 "../backends/bluez/bluez-persona-store.vala"
		_tmp0_ = "trusted";
#line 1671 "bluez-persona-store.c"
	} else {
#line 446 "../backends/bluez/bluez-persona-store.vala"
		_tmp0_ = "untrusted";
#line 1675 "bluez-persona-store.c"
	}
#line 445 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = self->priv->_device;
#line 445 "../backends/bluez/bluez-persona-store.vala"
	_tmp2_ = org_bluez_device_get_alias (_tmp1_);
#line 445 "../backends/bluez/bluez-persona-store.vala"
	_tmp3_ = _tmp2_;
#line 445 "../backends/bluez/bluez-persona-store.vala"
	_tmp4_ = _tmp3_;
#line 445 "../backends/bluez/bluez-persona-store.vala"
	_tmp5_ = self->priv->_device;
#line 445 "../backends/bluez/bluez-persona-store.vala"
	_tmp6_ = org_bluez_device_get_address (_tmp5_);
#line 445 "../backends/bluez/bluez-persona-store.vala"
	_tmp7_ = _tmp6_;
#line 445 "../backends/bluez/bluez-persona-store.vala"
	_tmp8_ = _tmp7_;
#line 445 "../backends/bluez/bluez-persona-store.vala"
	g_debug ("bluez-persona-store.vala:445: Device ‘%s’ (%s) marked as %s.", _tmp4_, _tmp8_, _tmp0_);
#line 445 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_tmp8_);
#line 445 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_tmp4_);
#line 449 "../backends/bluez/bluez-persona-store.vala"
	if (trusted) {
#line 449 "../backends/bluez/bluez-persona-store.vala"
		_tmp9_ = FOLKS_PERSONA_STORE_TRUST_FULL;
#line 1703 "bluez-persona-store.c"
	} else {
#line 449 "../backends/bluez/bluez-persona-store.vala"
		_tmp9_ = FOLKS_PERSONA_STORE_TRUST_PARTIAL;
#line 1707 "bluez-persona-store.c"
	}
#line 448 "../backends/bluez/bluez-persona-store.vala"
	folks_persona_store_set_trust_level ((FolksPersonaStore*) self, _tmp9_);
#line 1711 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_set_connection_state_data_free (gpointer _data)
{
	FolksBackendsBlueZPersonaStoreSetConnectionStateData* _data_;
	_data_ = _data;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_slice_free (FolksBackendsBlueZPersonaStoreSetConnectionStateData, _data_);
#line 1723 "bluez-persona-store.c"
}

void
folks_backends_blue_z_persona_store_set_connection_state (FolksBackendsBlueZPersonaStore* self,
                                                          gboolean connected,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStoreSetConnectionStateData* _data_;
	FolksBackendsBlueZPersonaStore* _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZPersonaStoreSetConnectionStateData);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backends_blue_z_persona_store_set_connection_state_data_free);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->self = _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->connected = connected;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	folks_backends_blue_z_persona_store_set_connection_state_co (_data_);
#line 1750 "bluez-persona-store.c"
}

void
folks_backends_blue_z_persona_store_set_connection_state_finish (FolksBackendsBlueZPersonaStore* self,
                                                                 GAsyncResult* _res_,
                                                                 GError** error)
{
	FolksBackendsBlueZPersonaStoreSetConnectionStateData* _data_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	if (NULL == _data_) {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		return;
#line 1765 "bluez-persona-store.c"
	}
}

/**
   * Set the persona store's connection state.
   *
   * This will be called in response to a property change sent to the Backend.
   *
   * If this throws an error, it guarantees to leave the store’s internal state
   * unchanged.
   *
   * @param connected ``true`` if the device is now connected, ``false``
   * otherwise
   *
   * @throws IOError if the operation was cancelled
   * (see {@link _update_contacts})
   * @throws PersonaStoreError if the contacts couldn’t be updated
   * (see {@link _update_contacts})
   *
   * @since 0.9.6
   */
static void
folks_backends_blue_z_persona_store_set_connection_state_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStoreSetConnectionStateData* _data_;
#line 478 "../backends/bluez/bluez-persona-store.vala"
	_data_ = _user_data_;
#line 478 "../backends/bluez/bluez-persona-store.vala"
	_data_->_source_object_ = source_object;
#line 478 "../backends/bluez/bluez-persona-store.vala"
	_data_->_res_ = _res_;
#line 478 "../backends/bluez/bluez-persona-store.vala"
	folks_backends_blue_z_persona_store_set_connection_state_co (_data_);
#line 1801 "bluez-persona-store.c"
}

static gboolean
folks_backends_blue_z_persona_store_set_connection_state_co (FolksBackendsBlueZPersonaStoreSetConnectionStateData* _data_)
{
#line 470 "../backends/bluez/bluez-persona-store.vala"
	switch (_data_->_state_) {
#line 470 "../backends/bluez/bluez-persona-store.vala"
		case 0:
#line 1811 "bluez-persona-store.c"
		goto _state_0;
#line 470 "../backends/bluez/bluez-persona-store.vala"
		case 1:
#line 1815 "bluez-persona-store.c"
		goto _state_1;
		default:
#line 470 "../backends/bluez/bluez-persona-store.vala"
		g_assert_not_reached ();
#line 1820 "bluez-persona-store.c"
	}
	_state_0:
#line 473 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->connected == TRUE) {
#line 475 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp0_ = _data_->self->priv->_device;
#line 475 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp1_ = org_bluez_device_get_alias (_data_->_tmp0_);
#line 475 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 475 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 475 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp4_ = _data_->self->priv->_device;
#line 475 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp5_ = org_bluez_device_get_address (_data_->_tmp4_);
#line 475 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 475 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 475 "../backends/bluez/bluez-persona-store.vala"
		g_debug ("bluez-persona-store.vala:475: Device ‘%s’ (%s) is connected.", _data_->_tmp3_, _data_->_tmp7_);
#line 475 "../backends/bluez/bluez-persona-store.vala"
		_g_free0 (_data_->_tmp7_);
#line 475 "../backends/bluez/bluez-persona-store.vala"
		_g_free0 (_data_->_tmp3_);
#line 478 "../backends/bluez/bluez-persona-store.vala"
		_data_->_state_ = 1;
#line 478 "../backends/bluez/bluez-persona-store.vala"
		_folks_backends_blue_z_persona_store_update_contacts (_data_->self, FALSE, folks_backends_blue_z_persona_store_set_connection_state_ready, _data_);
#line 478 "../backends/bluez/bluez-persona-store.vala"
		return FALSE;
#line 1853 "bluez-persona-store.c"
		_state_1:
#line 478 "../backends/bluez/bluez-persona-store.vala"
		_folks_backends_blue_z_persona_store_update_contacts_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 478 "../backends/bluez/bluez-persona-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 478 "../backends/bluez/bluez-persona-store.vala"
			if ((_data_->_inner_error0_->domain == G_IO_ERROR) || (_data_->_inner_error0_->domain == FOLKS_PERSONA_STORE_ERROR)) {
#line 478 "../backends/bluez/bluez-persona-store.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 478 "../backends/bluez/bluez-persona-store.vala"
				g_object_unref (_data_->_async_result);
#line 478 "../backends/bluez/bluez-persona-store.vala"
				return FALSE;
#line 1867 "bluez-persona-store.c"
			} else {
#line 478 "../backends/bluez/bluez-persona-store.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 478 "../backends/bluez/bluez-persona-store.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 478 "../backends/bluez/bluez-persona-store.vala"
				g_object_unref (_data_->_async_result);
#line 478 "../backends/bluez/bluez-persona-store.vala"
				return FALSE;
#line 1877 "bluez-persona-store.c"
			}
		}
	} else {
#line 482 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp8_ = _data_->self->priv->_device;
#line 482 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp9_ = org_bluez_device_get_alias (_data_->_tmp8_);
#line 482 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 482 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 482 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp12_ = _data_->self->priv->_device;
#line 482 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp13_ = org_bluez_device_get_address (_data_->_tmp12_);
#line 482 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 482 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 482 "../backends/bluez/bluez-persona-store.vala"
		g_debug ("bluez-persona-store.vala:482: Device ‘%s’ (%s) is disconnected.", _data_->_tmp11_, _data_->_tmp15_);
#line 482 "../backends/bluez/bluez-persona-store.vala"
		_g_free0 (_data_->_tmp15_);
#line 482 "../backends/bluez/bluez-persona-store.vala"
		_g_free0 (_data_->_tmp11_);
#line 486 "../backends/bluez/bluez-persona-store.vala"
		folks_backends_blue_z_persona_store_cancel_updates (_data_->self);
#line 1905 "bluez-persona-store.c"
	}
#line 470 "../backends/bluez/bluez-persona-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 470 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_state_ != 0) {
#line 470 "../backends/bluez/bluez-persona-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 470 "../backends/bluez/bluez-persona-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1915 "bluez-persona-store.c"
		}
	}
#line 470 "../backends/bluez/bluez-persona-store.vala"
	g_object_unref (_data_->_async_result);
#line 470 "../backends/bluez/bluez-persona-store.vala"
	return FALSE;
#line 1922 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_new_obex_session_data_free (gpointer _data)
{
	FolksBackendsBlueZPersonaStoreNewObexSessionData* _data_;
	_data_ = _data;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_data_->result);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_slice_free (FolksBackendsBlueZPersonaStoreNewObexSessionData, _data_);
#line 1936 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_new_obex_session (FolksBackendsBlueZPersonaStore* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStoreNewObexSessionData* _data_;
	FolksBackendsBlueZPersonaStore* _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZPersonaStoreNewObexSessionData);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backends_blue_z_persona_store_new_obex_session_data_free);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->self = _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store_new_obex_session_co (_data_);
#line 1960 "bluez-persona-store.c"
}

static char*
_folks_backends_blue_z_persona_store_new_obex_session_finish (FolksBackendsBlueZPersonaStore* self,
                                                              GAsyncResult* _res_,
                                                              orgbluezobexPhonebookAccess** obex_pbap,
                                                              GError** error)
{
	char* result;
	FolksBackendsBlueZPersonaStoreNewObexSessionData* _data_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	if (NULL == _data_) {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		return NULL;
#line 1977 "bluez-persona-store.c"
	}
#line 59 "../backends/bluez/bluez-persona-store.vala"
	if (obex_pbap) {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		*obex_pbap = _data_->obex_pbap;
#line 1983 "bluez-persona-store.c"
	} else {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->obex_pbap);
#line 1987 "bluez-persona-store.c"
	}
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->obex_pbap = NULL;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	result = _data_->result;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->result = NULL;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 1997 "bluez-persona-store.c"
}

/**
   * Create a new obex session for this Persona store.
   *
   * Create a new obex session for this Persona store if no previous session
   * already exists.
   *
   * @param obex_pbap return location for an OBEX PBAP proxy object
   * @returns the path of the OBEX session D-Bus object
   * @throws IOError if it can't connect to D-Bus
   * @throws DBusError if it can't create a new OBEX session
   *
   * @since 0.9.6
   */
static void
_g_free0_ (gpointer var)
{
#line 509 "../backends/bluez/bluez-persona-store.vala"
	var = (g_free (var), NULL);
#line 2018 "bluez-persona-store.c"
}

static void
_g_variant_unref0_ (gpointer var)
{
#line 509 "../backends/bluez/bluez-persona-store.vala"
	(var == NULL) ? NULL : (var = (g_variant_unref (var), NULL));
#line 2026 "bluez-persona-store.c"
}

static GVariant*
_variant_new1 (const gchar* value)
{
#line 510 "../backends/bluez/bluez-persona-store.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 2034 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_new_obex_session_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStoreNewObexSessionData* _data_;
#line 512 "../backends/bluez/bluez-persona-store.vala"
	_data_ = _user_data_;
#line 512 "../backends/bluez/bluez-persona-store.vala"
	_data_->_source_object_ = source_object;
#line 512 "../backends/bluez/bluez-persona-store.vala"
	_data_->_res_ = _res_;
#line 512 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store_new_obex_session_co (_data_);
#line 2051 "bluez-persona-store.c"
}

static gboolean
_folks_backends_blue_z_persona_store_new_obex_session_co (FolksBackendsBlueZPersonaStoreNewObexSessionData* _data_)
{
#line 503 "../backends/bluez/bluez-persona-store.vala"
	switch (_data_->_state_) {
#line 503 "../backends/bluez/bluez-persona-store.vala"
		case 0:
#line 2061 "bluez-persona-store.c"
		goto _state_0;
#line 503 "../backends/bluez/bluez-persona-store.vala"
		case 1:
#line 2065 "bluez-persona-store.c"
		goto _state_1;
#line 503 "../backends/bluez/bluez-persona-store.vala"
		case 2:
#line 2069 "bluez-persona-store.c"
		goto _state_2;
		default:
#line 503 "../backends/bluez/bluez-persona-store.vala"
		g_assert_not_reached ();
#line 2074 "bluez-persona-store.c"
	}
	_state_0:
#line 507 "../backends/bluez/bluez-persona-store.vala"
	g_debug ("bluez-persona-store.vala:507: Creating a new OBEX session.");
#line 509 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_variant_unref0_);
#line 509 "../backends/bluez/bluez-persona-store.vala"
	_data_->args = _data_->_tmp0_;
#line 510 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp1_ = _data_->args;
#line 510 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp2_ = g_strdup ("Target");
#line 510 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp3_ = _variant_new1 ("PBAP");
#line 510 "../backends/bluez/bluez-persona-store.vala"
	g_hash_table_insert (_data_->_tmp1_, _data_->_tmp2_, _data_->_tmp3_);
#line 512 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp4_ = _data_->self->priv->_obex_client;
#line 512 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp5_ = folks_persona_store_get_id ((FolksPersonaStore*) _data_->self);
#line 512 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 512 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp7_ = _data_->args;
#line 512 "../backends/bluez/bluez-persona-store.vala"
	_data_->_state_ = 1;
#line 512 "../backends/bluez/bluez-persona-store.vala"
	org_bluez_obex_client_create_session (_data_->_tmp4_, _data_->_tmp6_, _data_->_tmp7_, _folks_backends_blue_z_persona_store_new_obex_session_ready, _data_);
#line 512 "../backends/bluez/bluez-persona-store.vala"
	return FALSE;
#line 2105 "bluez-persona-store.c"
	_state_1:
#line 512 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp8_ = org_bluez_obex_client_create_session_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error0_);
#line 512 "../backends/bluez/bluez-persona-store.vala"
	_data_->session_path = _data_->_tmp8_;
#line 512 "../backends/bluez/bluez-persona-store.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 512 "../backends/bluez/bluez-persona-store.vala"
		if ((_data_->_inner_error0_->domain == G_DBUS_ERROR) || (_data_->_inner_error0_->domain == G_IO_ERROR)) {
#line 512 "../backends/bluez/bluez-persona-store.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 512 "../backends/bluez/bluez-persona-store.vala"
			_g_hash_table_unref0 (_data_->args);
#line 512 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->obex_pbap);
#line 512 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 512 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 2125 "bluez-persona-store.c"
		} else {
#line 512 "../backends/bluez/bluez-persona-store.vala"
			_g_hash_table_unref0 (_data_->args);
#line 512 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->obex_pbap);
#line 512 "../backends/bluez/bluez-persona-store.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 512 "../backends/bluez/bluez-persona-store.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 512 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 512 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 2139 "bluez-persona-store.c"
		}
	}
#line 514 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp9_ = _data_->session_path;
#line 514 "../backends/bluez/bluez-persona-store.vala"
	g_debug ("bluez-persona-store.vala:514:     Got OBEX session path: %s", (const gchar*) _data_->_tmp9_);
#line 517 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp11_ = _data_->session_path;
#line 517 "../backends/bluez/bluez-persona-store.vala"
	_data_->_state_ = 2;
#line 517 "../backends/bluez/bluez-persona-store.vala"
	g_async_initable_new_async (ORG_BLUEZ_OBEX_TYPE_PHONEBOOK_ACCESS_PROXY, 0, NULL, _folks_backends_blue_z_persona_store_new_obex_session_ready, _data_, "g-flags", 0, "g-name", "org.bluez.obex", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", (const gchar*) _data_->_tmp11_, "g-interface-name", "org.bluez.obex.PhonebookAccess1", NULL);
#line 517 "../backends/bluez/bluez-persona-store.vala"
	return FALSE;
#line 2154 "bluez-persona-store.c"
	_state_2:
#line 517 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp12_ = (orgbluezobexPhonebookAccess*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 517 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp10_ = (orgbluezobexPhonebookAccess*) _data_->_tmp12_;
#line 517 "../backends/bluez/bluez-persona-store.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 517 "../backends/bluez/bluez-persona-store.vala"
		if ((_data_->_inner_error0_->domain == G_DBUS_ERROR) || (_data_->_inner_error0_->domain == G_IO_ERROR)) {
#line 517 "../backends/bluez/bluez-persona-store.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 517 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->session_path);
#line 517 "../backends/bluez/bluez-persona-store.vala"
			_g_hash_table_unref0 (_data_->args);
#line 517 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->obex_pbap);
#line 517 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 517 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 2176 "bluez-persona-store.c"
		} else {
#line 517 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->session_path);
#line 517 "../backends/bluez/bluez-persona-store.vala"
			_g_hash_table_unref0 (_data_->args);
#line 517 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->obex_pbap);
#line 517 "../backends/bluez/bluez-persona-store.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 517 "../backends/bluez/bluez-persona-store.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 517 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 517 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 2192 "bluez-persona-store.c"
		}
	}
#line 516 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp13_ = _data_->_tmp10_;
#line 516 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp10_ = NULL;
#line 516 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->obex_pbap);
#line 516 "../backends/bluez/bluez-persona-store.vala"
	_data_->obex_pbap = _data_->_tmp13_;
#line 519 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp14_ = _data_->obex_pbap;
#line 519 "../backends/bluez/bluez-persona-store.vala"
	g_debug ("bluez-persona-store.vala:519:     Got OBEX PBAP proxy: %p", _data_->_tmp14_);
#line 521 "../backends/bluez/bluez-persona-store.vala"
	_data_->result = _data_->session_path;
#line 521 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->_tmp10_);
#line 521 "../backends/bluez/bluez-persona-store.vala"
	_g_hash_table_unref0 (_data_->args);
#line 521 "../backends/bluez/bluez-persona-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 521 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_state_ != 0) {
#line 521 "../backends/bluez/bluez-persona-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 521 "../backends/bluez/bluez-persona-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2221 "bluez-persona-store.c"
		}
	}
#line 521 "../backends/bluez/bluez-persona-store.vala"
	g_object_unref (_data_->_async_result);
#line 521 "../backends/bluez/bluez-persona-store.vala"
	return FALSE;
#line 2228 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_remove_obex_session_data_free (gpointer _data)
{
	FolksBackendsBlueZPersonaStoreRemoveObexSessionData* _data_;
	_data_ = _data;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_data_->session_path);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_slice_free (FolksBackendsBlueZPersonaStoreRemoveObexSessionData, _data_);
#line 2242 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_remove_obex_session (FolksBackendsBlueZPersonaStore* self,
                                                          const char* session_path,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStoreRemoveObexSessionData* _data_;
	FolksBackendsBlueZPersonaStore* _tmp0_;
	char* _tmp1_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (session_path != NULL);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZPersonaStoreRemoveObexSessionData);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backends_blue_z_persona_store_remove_obex_session_data_free);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->self = _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = g_strdup (session_path);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_data_->session_path);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->session_path = _tmp1_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store_remove_obex_session_co (_data_);
#line 2276 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_remove_obex_session_finish (FolksBackendsBlueZPersonaStore* self,
                                                                 GAsyncResult* _res_)
{
	FolksBackendsBlueZPersonaStoreRemoveObexSessionData* _data_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2286 "bluez-persona-store.c"
}

/**
   * Remove the specified OBEX session from this persona store.
   *
   * Remove the specified OBEX session for this persona store and discard its
   * transfer.
   *
   * @param session_path the path of the OBEX session D-Bus object to remove
   *
   * @since 0.9.6
   */
static void
_folks_backends_blue_z_persona_store_remove_obex_session_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStoreRemoveObexSessionData* _data_;
#line 538 "../backends/bluez/bluez-persona-store.vala"
	_data_ = _user_data_;
#line 538 "../backends/bluez/bluez-persona-store.vala"
	_data_->_source_object_ = source_object;
#line 538 "../backends/bluez/bluez-persona-store.vala"
	_data_->_res_ = _res_;
#line 538 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store_remove_obex_session_co (_data_);
#line 2313 "bluez-persona-store.c"
}

static gboolean
_folks_backends_blue_z_persona_store_remove_obex_session_co (FolksBackendsBlueZPersonaStoreRemoveObexSessionData* _data_)
{
#line 534 "../backends/bluez/bluez-persona-store.vala"
	switch (_data_->_state_) {
#line 534 "../backends/bluez/bluez-persona-store.vala"
		case 0:
#line 2323 "bluez-persona-store.c"
		goto _state_0;
#line 534 "../backends/bluez/bluez-persona-store.vala"
		case 1:
#line 2327 "bluez-persona-store.c"
		goto _state_1;
		default:
#line 534 "../backends/bluez/bluez-persona-store.vala"
		g_assert_not_reached ();
#line 2332 "bluez-persona-store.c"
	}
	_state_0:
	{
#line 538 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp0_ = _data_->self->priv->_obex_client;
#line 538 "../backends/bluez/bluez-persona-store.vala"
		_data_->_state_ = 1;
#line 538 "../backends/bluez/bluez-persona-store.vala"
		org_bluez_obex_client_remove_session (_data_->_tmp0_, _data_->session_path, _folks_backends_blue_z_persona_store_remove_obex_session_ready, _data_);
#line 538 "../backends/bluez/bluez-persona-store.vala"
		return FALSE;
#line 2344 "bluez-persona-store.c"
		_state_1:
#line 538 "../backends/bluez/bluez-persona-store.vala"
		org_bluez_obex_client_remove_session_finish (_data_->_tmp0_, _data_->_res_, &_data_->_inner_error0_);
#line 538 "../backends/bluez/bluez-persona-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 538 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 2352 "bluez-persona-store.c"
				goto __catch0_g_io_error;
			}
#line 538 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_inner_error0_->domain == G_DBUS_ERROR) {
#line 2357 "bluez-persona-store.c"
				goto __catch0_g_dbus_error;
			}
#line 538 "../backends/bluez/bluez-persona-store.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 538 "../backends/bluez/bluez-persona-store.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 538 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 538 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 2368 "bluez-persona-store.c"
		}
	}
	goto __finally0;
	__catch0_g_io_error:
	{
#line 536 "../backends/bluez/bluez-persona-store.vala"
		_data_->ie = _data_->_inner_error0_;
#line 536 "../backends/bluez/bluez-persona-store.vala"
		_data_->_inner_error0_ = NULL;
#line 544 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp2_ = _data_->ie;
#line 544 "../backends/bluez/bluez-persona-store.vala"
		if (g_error_matches (_data_->_tmp2_, G_IO_ERROR, G_IO_ERROR_CLOSED)) {
#line 544 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp1_ = TRUE;
#line 2384 "bluez-persona-store.c"
		} else {
#line 544 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp3_ = _data_->ie;
#line 544 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp1_ = g_error_matches (_data_->_tmp3_, G_IO_ERROR, G_IO_ERROR_CANCELLED);
#line 2390 "bluez-persona-store.c"
		}
#line 544 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->_tmp1_) {
#line 545 "../backends/bluez/bluez-persona-store.vala"
			_g_error_free0 (_data_->ie);
#line 545 "../backends/bluez/bluez-persona-store.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 545 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_state_ != 0) {
#line 545 "../backends/bluez/bluez-persona-store.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 545 "../backends/bluez/bluez-persona-store.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2404 "bluez-persona-store.c"
				}
			}
#line 545 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 545 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 2411 "bluez-persona-store.c"
		}
#line 546 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp5_ = _data_->ie;
#line 546 "../backends/bluez/bluez-persona-store.vala"
		if (g_error_matches (_data_->_tmp5_, G_IO_ERROR, G_IO_ERROR_DBUS_ERROR)) {
#line 547 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp6_ = _data_->ie;
#line 547 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp7_ = _data_->_tmp6_->message;
#line 547 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp4_ = g_str_has_prefix (_data_->_tmp7_, "GDBus.Error:org.freedesktop.DBus." "Python.dbus.exceptions.DBusException: " "('org.freedesktop.DBus.Mock.NameError'");
#line 2423 "bluez-persona-store.c"
		} else {
#line 546 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp4_ = FALSE;
#line 2427 "bluez-persona-store.c"
		}
#line 546 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->_tmp4_) {
#line 552 "../backends/bluez/bluez-persona-store.vala"
			_g_error_free0 (_data_->ie);
#line 552 "../backends/bluez/bluez-persona-store.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 552 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_state_ != 0) {
#line 552 "../backends/bluez/bluez-persona-store.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 552 "../backends/bluez/bluez-persona-store.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2441 "bluez-persona-store.c"
				}
			}
#line 552 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 552 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 2448 "bluez-persona-store.c"
		}
#line 555 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp8_ = _data_->ie;
#line 555 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp9_ = _data_->_tmp8_->message;
#line 555 "../backends/bluez/bluez-persona-store.vala"
		g_warning ("bluez-persona-store.vala:555: Couldn’t remove OBEX session ‘%s’: %s", (const gchar*) _data_->session_path, _data_->_tmp9_);
#line 536 "../backends/bluez/bluez-persona-store.vala"
		_g_error_free0 (_data_->ie);
#line 2458 "bluez-persona-store.c"
	}
	goto __finally0;
	__catch0_g_dbus_error:
	{
#line 536 "../backends/bluez/bluez-persona-store.vala"
		_data_->de = _data_->_inner_error0_;
#line 536 "../backends/bluez/bluez-persona-store.vala"
		_data_->_inner_error0_ = NULL;
#line 560 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp10_ = _data_->de;
#line 560 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp11_ = _data_->_tmp10_->message;
#line 560 "../backends/bluez/bluez-persona-store.vala"
		g_warning ("bluez-persona-store.vala:560: Couldn’t remove OBEX session ‘%s’: %s", (const gchar*) _data_->session_path, _data_->_tmp11_);
#line 536 "../backends/bluez/bluez-persona-store.vala"
		_g_error_free0 (_data_->de);
#line 2475 "bluez-persona-store.c"
	}
	__finally0:
#line 536 "../backends/bluez/bluez-persona-store.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 536 "../backends/bluez/bluez-persona-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 536 "../backends/bluez/bluez-persona-store.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 536 "../backends/bluez/bluez-persona-store.vala"
		g_object_unref (_data_->_async_result);
#line 536 "../backends/bluez/bluez-persona-store.vala"
		return FALSE;
#line 2488 "bluez-persona-store.c"
	}
#line 534 "../backends/bluez/bluez-persona-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 534 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_state_ != 0) {
#line 534 "../backends/bluez/bluez-persona-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 534 "../backends/bluez/bluez-persona-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2498 "bluez-persona-store.c"
		}
	}
#line 534 "../backends/bluez/bluez-persona-store.vala"
	g_object_unref (_data_->_async_result);
#line 534 "../backends/bluez/bluez-persona-store.vala"
	return FALSE;
#line 2505 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_perform_obex_transfer_data_free (gpointer _data)
{
	FolksBackendsBlueZPersonaStorePerformObexTransferData* _data_;
	_data_ = _data;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_data_->path);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->cancellable);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_slice_free (FolksBackendsBlueZPersonaStorePerformObexTransferData, _data_);
#line 2521 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_perform_obex_transfer (FolksBackendsBlueZPersonaStore* self,
                                                            const gchar* path,
                                                            GCancellable* cancellable,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStorePerformObexTransferData* _data_;
	FolksBackendsBlueZPersonaStore* _tmp0_;
	gchar* _tmp1_;
	GCancellable* _tmp2_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (path != NULL);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZPersonaStorePerformObexTransferData);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backends_blue_z_persona_store_perform_obex_transfer_data_free);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->self = _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = g_strdup (path);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_data_->path);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->path = _tmp1_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->cancellable);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->cancellable = _tmp2_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store_perform_obex_transfer_co (_data_);
#line 2563 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_perform_obex_transfer_finish (FolksBackendsBlueZPersonaStore* self,
                                                                   GAsyncResult* _res_,
                                                                   GError** error)
{
	FolksBackendsBlueZPersonaStorePerformObexTransferData* _data_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	if (NULL == _data_) {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		return;
#line 2578 "bluez-persona-store.c"
	}
}

/**
   * Watch an OBEX transfer identified by its D-Bus path.
   *
   * This only returns once the transfer is complete (or has failed) and the
   * transfer object has been destroyed.
   *
   * If this throws an error, it guarantees to leave the store’s internal state
   * unchanged.
   *
   * @param path the D-Bus transfer object path to watch.
   * @param cancellable an optional {@link Cancellable} object to cancel the
   * transfer
   *
   * @throws IOError if the operation was cancelled, or if another failure
   * occurred (unavoidable; valac generates invalid C if we try to handle
   * IOError internally here)
   * @throws PersonaStoreError if the transfer failed
   *
   * @since 0.9.6
   */
static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 585 "../backends/bluez/bluez-persona-store.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 585 "../backends/bluez/bluez-persona-store.vala"
	return _data2_;
#line 2609 "bluez-persona-store.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 585 "../backends/bluez/bluez-persona-store.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 2619 "bluez-persona-store.c"
		FolksBackendsBlueZPersonaStore* self;
#line 585 "../backends/bluez/bluez-persona-store.vala"
		self = _data2_->self;
#line 585 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (self);
#line 585 "../backends/bluez/bluez-persona-store.vala"
		g_slice_free (Block2Data, _data2_);
#line 2627 "bluez-persona-store.c"
	}
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 591 "../backends/bluez/bluez-persona-store.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 591 "../backends/bluez/bluez-persona-store.vala"
	return _data3_;
#line 2638 "bluez-persona-store.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 591 "../backends/bluez/bluez-persona-store.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2648 "bluez-persona-store.c"
		FolksBackendsBlueZPersonaStore* self;
#line 591 "../backends/bluez/bluez-persona-store.vala"
		self = _data3_->_data2_->self;
#line 591 "../backends/bluez/bluez-persona-store.vala"
		_g_free0 (_data3_->transfer_status);
#line 591 "../backends/bluez/bluez-persona-store.vala"
		block2_data_unref (_data3_->_data2_);
#line 591 "../backends/bluez/bluez-persona-store.vala"
		_data3_->_data2_ = NULL;
#line 591 "../backends/bluez/bluez-persona-store.vala"
		g_slice_free (Block3Data, _data3_);
#line 2660 "bluez-persona-store.c"
	}
}

static void
_folks_backends_blue_z_persona_store_perform_obex_transfer_ready (GObject* source_object,
                                                                  GAsyncResult* _res_,
                                                                  gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStorePerformObexTransferData* _data_;
#line 599 "../backends/bluez/bluez-persona-store.vala"
	_data_ = _user_data_;
#line 599 "../backends/bluez/bluez-persona-store.vala"
	_data_->_source_object_ = source_object;
#line 599 "../backends/bluez/bluez-persona-store.vala"
	_data_->_res_ = _res_;
#line 599 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store_perform_obex_transfer_co (_data_);
#line 2678 "bluez-persona-store.c"
}

static void
____lambda4_ (Block3Data* _data3_)
{
	Block2Data* _data2_;
	FolksBackendsBlueZPersonaStore* self;
	gchar* _tmp0_;
#line 614 "../backends/bluez/bluez-persona-store.vala"
	_data2_ = _data3_->_data2_;
#line 614 "../backends/bluez/bluez-persona-store.vala"
	self = _data2_->self;
#line 616 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = g_strdup ("error");
#line 616 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_data3_->transfer_status);
#line 616 "../backends/bluez/bluez-persona-store.vala"
	_data3_->transfer_status = _tmp0_;
#line 617 "../backends/bluez/bluez-persona-store.vala"
	if (_data3_->has_yielded == TRUE) {
#line 618 "../backends/bluez/bluez-persona-store.vala"
		_folks_backends_blue_z_persona_store_perform_obex_transfer_co (_data2_->_async_data_);
#line 2701 "bluez-persona-store.c"
	}
}

static void
_____lambda4__gfunc (gconstpointer data,
                     gpointer self)
{
#line 614 "../backends/bluez/bluez-persona-store.vala"
	____lambda4_ (self);
#line 2711 "bluez-persona-store.c"
}

static void
___lambda5_ (Block3Data* _data3_,
             GVariant* changed,
             gchar** invalidated)
{
	Block2Data* _data2_;
	FolksBackendsBlueZPersonaStore* self;
	GVariant* property = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	gchar* status = NULL;
	GVariant* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
#line 625 "../backends/bluez/bluez-persona-store.vala"
	_data2_ = _data3_->_data2_;
#line 625 "../backends/bluez/bluez-persona-store.vala"
	self = _data2_->self;
#line 625 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (changed != NULL);
#line 627 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = G_VARIANT_TYPE_STRING;
#line 627 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = g_variant_lookup_value (changed, "Status", _tmp0_);
#line 627 "../backends/bluez/bluez-persona-store.vala"
	property = _tmp1_;
#line 629 "../backends/bluez/bluez-persona-store.vala"
	_tmp2_ = property;
#line 629 "../backends/bluez/bluez-persona-store.vala"
	if (_tmp2_ == NULL) {
#line 630 "../backends/bluez/bluez-persona-store.vala"
		_g_variant_unref0 (property);
#line 630 "../backends/bluez/bluez-persona-store.vala"
		return;
#line 2753 "bluez-persona-store.c"
	}
#line 632 "../backends/bluez/bluez-persona-store.vala"
	_tmp3_ = property;
#line 632 "../backends/bluez/bluez-persona-store.vala"
	_tmp4_ = g_variant_get_string (_tmp3_, NULL);
#line 632 "../backends/bluez/bluez-persona-store.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 632 "../backends/bluez/bluez-persona-store.vala"
	status = _tmp5_;
#line 633 "../backends/bluez/bluez-persona-store.vala"
	_tmp6_ = status;
#line 633 "../backends/bluez/bluez-persona-store.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 633 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_data3_->transfer_status);
#line 633 "../backends/bluez/bluez-persona-store.vala"
	_data3_->transfer_status = _tmp7_;
#line 635 "../backends/bluez/bluez-persona-store.vala"
	_tmp9_ = status;
#line 635 "../backends/bluez/bluez-persona-store.vala"
	if (g_strcmp0 (_tmp9_, "complete") == 0) {
#line 635 "../backends/bluez/bluez-persona-store.vala"
		_tmp8_ = TRUE;
#line 2777 "bluez-persona-store.c"
	} else {
		const gchar* _tmp10_;
#line 635 "../backends/bluez/bluez-persona-store.vala"
		_tmp10_ = status;
#line 635 "../backends/bluez/bluez-persona-store.vala"
		_tmp8_ = g_strcmp0 (_tmp10_, "error") == 0;
#line 2784 "bluez-persona-store.c"
	}
#line 635 "../backends/bluez/bluez-persona-store.vala"
	if (_tmp8_) {
#line 638 "../backends/bluez/bluez-persona-store.vala"
		if (_data3_->has_yielded == TRUE) {
#line 639 "../backends/bluez/bluez-persona-store.vala"
			_folks_backends_blue_z_persona_store_perform_obex_transfer_co (_data2_->_async_data_);
#line 2792 "bluez-persona-store.c"
		}
	} else {
		gboolean _tmp11_ = FALSE;
		const gchar* _tmp12_;
#line 641 "../backends/bluez/bluez-persona-store.vala"
		_tmp12_ = status;
#line 641 "../backends/bluez/bluez-persona-store.vala"
		if (g_strcmp0 (_tmp12_, "queued") == 0) {
#line 641 "../backends/bluez/bluez-persona-store.vala"
			_tmp11_ = TRUE;
#line 2803 "bluez-persona-store.c"
		} else {
			const gchar* _tmp13_;
#line 641 "../backends/bluez/bluez-persona-store.vala"
			_tmp13_ = status;
#line 641 "../backends/bluez/bluez-persona-store.vala"
			_tmp11_ = g_strcmp0 (_tmp13_, "active") == 0;
#line 2810 "bluez-persona-store.c"
		}
#line 641 "../backends/bluez/bluez-persona-store.vala"
		if (_tmp11_) {
#line 2814 "bluez-persona-store.c"
		} else {
			const gchar* _tmp14_;
#line 647 "../backends/bluez/bluez-persona-store.vala"
			_tmp14_ = status;
#line 647 "../backends/bluez/bluez-persona-store.vala"
			g_warning ("bluez-persona-store.vala:647: Unknown OBEX transfer status ‘%s’.", _tmp14_);
#line 2821 "bluez-persona-store.c"
		}
	}
#line 625 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (status);
#line 625 "../backends/bluez/bluez-persona-store.vala"
	_g_variant_unref0 (property);
#line 2828 "bluez-persona-store.c"
}

static void
____lambda5__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                GVariant* changed_properties,
                                                gchar** invalidated_properties,
                                                gpointer self)
{
#line 624 "../backends/bluez/bluez-persona-store.vala"
	___lambda5_ (self, changed_properties, invalidated_properties);
#line 2839 "bluez-persona-store.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 711 "../backends/bluez/bluez-persona-store.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 711 "../backends/bluez/bluez-persona-store.vala"
	return _data4_;
#line 2849 "bluez-persona-store.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 711 "../backends/bluez/bluez-persona-store.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 2859 "bluez-persona-store.c"
		FolksBackendsBlueZPersonaStore* self;
#line 711 "../backends/bluez/bluez-persona-store.vala"
		self = _data4_->_data2_->self;
#line 711 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data4_->file);
#line 711 "../backends/bluez/bluez-persona-store.vala"
		block2_data_unref (_data4_->_data2_);
#line 711 "../backends/bluez/bluez-persona-store.vala"
		_data4_->_data2_ = NULL;
#line 711 "../backends/bluez/bluez-persona-store.vala"
		g_slice_free (Block4Data, _data4_);
#line 2871 "bluez-persona-store.c"
	}
}

static void
____lambda6_ (Block4Data* _data4_,
              GObject* o,
              GAsyncResult* r)
{
	Block2Data* _data2_;
	FolksBackendsBlueZPersonaStore* self;
	GError* _inner_error0_ = NULL;
#line 715 "../backends/bluez/bluez-persona-store.vala"
	_data2_ = _data4_->_data2_;
#line 715 "../backends/bluez/bluez-persona-store.vala"
	self = _data2_->self;
#line 715 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (r != NULL);
#line 2889 "bluez-persona-store.c"
	{
		GFile* _tmp0_;
#line 719 "../backends/bluez/bluez-persona-store.vala"
		_tmp0_ = _data4_->file;
#line 719 "../backends/bluez/bluez-persona-store.vala"
		g_file_delete_finish (_tmp0_, r, &_inner_error0_);
#line 719 "../backends/bluez/bluez-persona-store.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2898 "bluez-persona-store.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 717 "../backends/bluez/bluez-persona-store.vala"
		g_clear_error (&_inner_error0_);
#line 2907 "bluez-persona-store.c"
	}
	__finally0:
#line 717 "../backends/bluez/bluez-persona-store.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 717 "../backends/bluez/bluez-persona-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 717 "../backends/bluez/bluez-persona-store.vala"
		g_clear_error (&_inner_error0_);
#line 717 "../backends/bluez/bluez-persona-store.vala"
		return;
#line 2918 "bluez-persona-store.c"
	}
}

static void
_____lambda6__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 714 "../backends/bluez/bluez-persona-store.vala"
	____lambda6_ (self, source_object, res);
#line 714 "../backends/bluez/bluez-persona-store.vala"
	block4_data_unref (self);
#line 2931 "bluez-persona-store.c"
}

static gboolean
_folks_backends_blue_z_persona_store_perform_obex_transfer_co (FolksBackendsBlueZPersonaStorePerformObexTransferData* _data_)
{
#line 585 "../backends/bluez/bluez-persona-store.vala"
	switch (_data_->_state_) {
#line 585 "../backends/bluez/bluez-persona-store.vala"
		case 0:
#line 2941 "bluez-persona-store.c"
		goto _state_0;
#line 585 "../backends/bluez/bluez-persona-store.vala"
		case 1:
#line 2945 "bluez-persona-store.c"
		goto _state_1;
#line 585 "../backends/bluez/bluez-persona-store.vala"
		case 2:
#line 2949 "bluez-persona-store.c"
		goto _state_2;
#line 585 "../backends/bluez/bluez-persona-store.vala"
		case 3:
#line 2953 "bluez-persona-store.c"
		goto _state_3;
		default:
#line 585 "../backends/bluez/bluez-persona-store.vala"
		g_assert_not_reached ();
#line 2958 "bluez-persona-store.c"
	}
	_state_0:
#line 585 "../backends/bluez/bluez-persona-store.vala"
	_data_->_data2_ = g_slice_new0 (Block2Data);
#line 585 "../backends/bluez/bluez-persona-store.vala"
	_data_->_data2_->_ref_count_ = 1;
#line 585 "../backends/bluez/bluez-persona-store.vala"
	_data_->_data2_->self = g_object_ref (_data_->self);
#line 585 "../backends/bluez/bluez-persona-store.vala"
	_data_->_data2_->_async_data_ = _data_;
#line 589 "../backends/bluez/bluez-persona-store.vala"
	_data_->transfer = NULL;
#line 2971 "bluez-persona-store.c"
	{
#line 591 "../backends/bluez/bluez-persona-store.vala"
		_data_->_data3_ = g_slice_new0 (Block3Data);
#line 591 "../backends/bluez/bluez-persona-store.vala"
		_data_->_data3_->_ref_count_ = 1;
#line 591 "../backends/bluez/bluez-persona-store.vala"
		_data_->_data3_->_data2_ = block2_data_ref (_data_->_data2_);
#line 594 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->cancellable != NULL) {
#line 595 "../backends/bluez/bluez-persona-store.vala"
			g_cancellable_set_error_if_cancelled (_data_->cancellable, &_data_->_inner_error0_);
#line 595 "../backends/bluez/bluez-persona-store.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 595 "../backends/bluez/bluez-persona-store.vala"
				block3_data_unref (_data_->_data3_);
#line 595 "../backends/bluez/bluez-persona-store.vala"
				_data_->_data3_ = NULL;
#line 2989 "bluez-persona-store.c"
				goto __finally0;
			}
		}
#line 599 "../backends/bluez/bluez-persona-store.vala"
		_data_->_state_ = 1;
#line 599 "../backends/bluez/bluez-persona-store.vala"
		g_async_initable_new_async (ORG_BLUEZ_OBEX_TYPE_TRANSFER_PROXY, 0, NULL, _folks_backends_blue_z_persona_store_perform_obex_transfer_ready, _data_, "g-flags", 0, "g-name", "org.bluez.obex", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", _data_->path, "g-interface-name", "org.bluez.obex.Transfer1", NULL);
#line 599 "../backends/bluez/bluez-persona-store.vala"
		return FALSE;
#line 2999 "bluez-persona-store.c"
		_state_1:
#line 599 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp1_ = (orgbluezobexTransfer*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
#line 599 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp0_ = (orgbluezobexTransfer*) _data_->_tmp1_;
#line 599 "../backends/bluez/bluez-persona-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 599 "../backends/bluez/bluez-persona-store.vala"
			block3_data_unref (_data_->_data3_);
#line 599 "../backends/bluez/bluez-persona-store.vala"
			_data_->_data3_ = NULL;
#line 3011 "bluez-persona-store.c"
			goto __finally0;
		}
#line 598 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp2_ = _data_->_tmp0_;
#line 598 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp0_ = NULL;
#line 598 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->transfer);
#line 598 "../backends/bluez/bluez-persona-store.vala"
		_data_->transfer = _data_->_tmp2_;
#line 600 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp3_ = _data_->transfer;
#line 600 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, g_dbus_proxy_get_type (), GDBusProxy));
#line 600 "../backends/bluez/bluez-persona-store.vala"
		_data_->transfer_proxy = _data_->_tmp4_;
#line 602 "../backends/bluez/bluez-persona-store.vala"
		_data_->_data3_->has_yielded = FALSE;
#line 603 "../backends/bluez/bluez-persona-store.vala"
		_data_->_data3_->transfer_status = NULL;
#line 605 "../backends/bluez/bluez-persona-store.vala"
		_data_->cancellable_id = (gulong) 0;
#line 609 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp5_ = _data_->transfer;
#line 609 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp6_ = org_bluez_obex_transfer_get_status (_data_->_tmp5_);
#line 609 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 609 "../backends/bluez/bluez-persona-store.vala"
		_g_free0 (_data_->_data3_->transfer_status);
#line 609 "../backends/bluez/bluez-persona-store.vala"
		_data_->_data3_->transfer_status = _data_->_tmp7_;
#line 612 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->cancellable != NULL) {
#line 614 "../backends/bluez/bluez-persona-store.vala"
			_data_->cancellable_id = g_cancellable_connect (_data_->cancellable, (GCallback) _____lambda4__gfunc, block3_data_ref (_data_->_data3_), block3_data_unref);
#line 3048 "bluez-persona-store.c"
		}
#line 624 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp8_ = _data_->transfer_proxy;
#line 624 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp9_ = g_signal_connect_data (_data_->_tmp8_, "g-properties-changed", (GCallback) ____lambda5__g_dbus_proxy_g_properties_changed, block3_data_ref (_data_->_data3_), (GClosureNotify) block3_data_unref, 0);
#line 624 "../backends/bluez/bluez-persona-store.vala"
		_data_->signal_id = _data_->_tmp9_;
#line 653 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp11_ = _data_->_data3_->transfer_status;
#line 653 "../backends/bluez/bluez-persona-store.vala"
		if (g_strcmp0 (_data_->_tmp11_, "complete") != 0) {
#line 653 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp12_ = _data_->_data3_->transfer_status;
#line 653 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp10_ = g_strcmp0 (_data_->_tmp12_, "error") != 0;
#line 3064 "bluez-persona-store.c"
		} else {
#line 653 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp10_ = FALSE;
#line 3068 "bluez-persona-store.c"
		}
#line 653 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->_tmp10_) {
#line 655 "../backends/bluez/bluez-persona-store.vala"
			_data_->_data3_->has_yielded = TRUE;
#line 656 "../backends/bluez/bluez-persona-store.vala"
			_data_->_state_ = 2;
#line 656 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 3078 "bluez-persona-store.c"
			_state_2:
			;
		}
#line 659 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp13_ = _data_->transfer_proxy;
#line 659 "../backends/bluez/bluez-persona-store.vala"
		g_signal_handler_disconnect ((GObject*) _data_->_tmp13_, _data_->signal_id);
#line 661 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->cancellable_id != ((gulong) 0)) {
#line 662 "../backends/bluez/bluez-persona-store.vala"
			g_cancellable_disconnect (_data_->cancellable, _data_->cancellable_id);
#line 3090 "bluez-persona-store.c"
		}
#line 665 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp14_ = _data_->_data3_->transfer_status;
#line 665 "../backends/bluez/bluez-persona-store.vala"
		if (g_strcmp0 (_data_->_tmp14_, "complete") == 0) {
#line 667 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp15_ = _data_->transfer;
#line 667 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp16_ = org_bluez_obex_transfer_get_filename (_data_->_tmp15_);
#line 667 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 667 "../backends/bluez/bluez-persona-store.vala"
			_data_->filename = _data_->_tmp17_;
#line 668 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp18_ = _data_->filename;
#line 668 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_tmp18_ == NULL) {
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp19_ = _data_->transfer;
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp20_ = org_bluez_obex_transfer_get_name (_data_->_tmp19_);
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp21_ = _data_->_tmp20_;
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp22_ = _data_->_tmp21_;
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp23_ = _data_->self->priv->_display_name;
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp24_ = g_error_new (FOLKS_PERSONA_STORE_ERROR, FOLKS_PERSONA_STORE_ERROR_STORE_OFFLINE, _ ("Error during transfer of the address book ‘%s’ from " "Bluetooth device ‘%s’."), _data_->_tmp22_, _data_->_tmp23_);
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp25_ = _data_->_tmp24_;
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_g_free0 (_data_->_tmp22_);
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_data_->_inner_error0_ = _data_->_tmp25_;
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_g_free0 (_data_->filename);
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_g_object_unref0 (_data_->transfer_proxy);
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_g_object_unref0 (_data_->_tmp0_);
#line 672 "../backends/bluez/bluez-persona-store.vala"
				block3_data_unref (_data_->_data3_);
#line 672 "../backends/bluez/bluez-persona-store.vala"
				_data_->_data3_ = NULL;
#line 3136 "bluez-persona-store.c"
				goto __finally0;
			}
#line 681 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp26_ = _data_->filename;
#line 681 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp27_ = g_file_new_for_path ((const gchar*) _data_->_tmp26_);
#line 681 "../backends/bluez/bluez-persona-store.vala"
			_data_->file = _data_->_tmp27_;
#line 683 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp28_ = _data_->self->priv->_display_name;
#line 683 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp29_ = folks_persona_store_get_id ((FolksPersonaStore*) _data_->self);
#line 683 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp30_ = _data_->_tmp29_;
#line 683 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp31_ = _data_->filename;
#line 683 "../backends/bluez/bluez-persona-store.vala"
			g_debug ("bluez-persona-store.vala:683: vCard’s filename for device ‘%s’ (%s): %" \
"s", _data_->_tmp28_, _data_->_tmp30_, (const gchar*) _data_->_tmp31_);
#line 686 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp32_ = _data_->file;
#line 686 "../backends/bluez/bluez-persona-store.vala"
			_data_->_state_ = 3;
#line 686 "../backends/bluez/bluez-persona-store.vala"
			_folks_backends_blue_z_persona_store_update_contacts_from_file (_data_->self, _data_->_tmp32_, _folks_backends_blue_z_persona_store_perform_obex_transfer_ready, _data_);
#line 686 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 3163 "bluez-persona-store.c"
			_state_3:
#line 686 "../backends/bluez/bluez-persona-store.vala"
			_folks_backends_blue_z_persona_store_update_contacts_from_file_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 686 "../backends/bluez/bluez-persona-store.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 686 "../backends/bluez/bluez-persona-store.vala"
				_g_object_unref0 (_data_->file);
#line 686 "../backends/bluez/bluez-persona-store.vala"
				_g_free0 (_data_->filename);
#line 686 "../backends/bluez/bluez-persona-store.vala"
				_g_object_unref0 (_data_->transfer_proxy);
#line 686 "../backends/bluez/bluez-persona-store.vala"
				_g_object_unref0 (_data_->_tmp0_);
#line 686 "../backends/bluez/bluez-persona-store.vala"
				block3_data_unref (_data_->_data3_);
#line 686 "../backends/bluez/bluez-persona-store.vala"
				_data_->_data3_ = NULL;
#line 3181 "bluez-persona-store.c"
				goto __finally0;
			}
#line 665 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->file);
#line 665 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->filename);
#line 3188 "bluez-persona-store.c"
		} else {
#line 688 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp33_ = _data_->_data3_->transfer_status;
#line 688 "../backends/bluez/bluez-persona-store.vala"
			if (g_strcmp0 (_data_->_tmp33_, "error") == 0) {
#line 692 "../backends/bluez/bluez-persona-store.vala"
				if (_data_->cancellable != NULL) {
#line 693 "../backends/bluez/bluez-persona-store.vala"
					g_cancellable_set_error_if_cancelled (_data_->cancellable, &_data_->_inner_error0_);
#line 693 "../backends/bluez/bluez-persona-store.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 693 "../backends/bluez/bluez-persona-store.vala"
						_g_object_unref0 (_data_->transfer_proxy);
#line 693 "../backends/bluez/bluez-persona-store.vala"
						_g_object_unref0 (_data_->_tmp0_);
#line 693 "../backends/bluez/bluez-persona-store.vala"
						block3_data_unref (_data_->_data3_);
#line 693 "../backends/bluez/bluez-persona-store.vala"
						_data_->_data3_ = NULL;
#line 3208 "bluez-persona-store.c"
						goto __finally0;
					}
				}
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp34_ = _data_->transfer;
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp35_ = org_bluez_obex_transfer_get_name (_data_->_tmp34_);
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp36_ = _data_->_tmp35_;
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp37_ = _data_->_tmp36_;
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp38_ = _data_->self->priv->_display_name;
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp39_ = g_error_new (FOLKS_PERSONA_STORE_ERROR, FOLKS_PERSONA_STORE_ERROR_STORE_OFFLINE, _ ("Error during transfer of the address book ‘%s’ from Bluetooth device ‘" \
"%s’."), _data_->_tmp37_, _data_->_tmp38_);
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp40_ = _data_->_tmp39_;
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_g_free0 (_data_->_tmp37_);
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_data_->_inner_error0_ = _data_->_tmp40_;
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_g_object_unref0 (_data_->transfer_proxy);
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_g_object_unref0 (_data_->_tmp0_);
#line 695 "../backends/bluez/bluez-persona-store.vala"
				block3_data_unref (_data_->_data3_);
#line 695 "../backends/bluez/bluez-persona-store.vala"
				_data_->_data3_ = NULL;
#line 3238 "bluez-persona-store.c"
				goto __finally0;
			} else {
#line 703 "../backends/bluez/bluez-persona-store.vala"
				g_assert_not_reached ();
#line 3243 "bluez-persona-store.c"
			}
		}
#line 591 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->transfer_proxy);
#line 591 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 591 "../backends/bluez/bluez-persona-store.vala"
		block3_data_unref (_data_->_data3_);
#line 591 "../backends/bluez/bluez-persona-store.vala"
		_data_->_data3_ = NULL;
#line 3254 "bluez-persona-store.c"
	}
	__finally0:
	{
#line 711 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp42_ = _data_->transfer;
#line 711 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->_tmp42_ != NULL) {
#line 711 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp43_ = _data_->transfer;
#line 711 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp44_ = org_bluez_obex_transfer_get_filename (_data_->_tmp43_);
#line 711 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp45_ = _data_->_tmp44_;
#line 711 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp46_ = _data_->_tmp45_;
#line 711 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp41_ = _data_->_tmp46_ != NULL;
#line 711 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->_tmp46_);
#line 3274 "bluez-persona-store.c"
		} else {
#line 711 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp41_ = FALSE;
#line 3278 "bluez-persona-store.c"
		}
#line 711 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->_tmp41_) {
#line 711 "../backends/bluez/bluez-persona-store.vala"
			_data_->_data4_ = g_slice_new0 (Block4Data);
#line 711 "../backends/bluez/bluez-persona-store.vala"
			_data_->_data4_->_ref_count_ = 1;
#line 711 "../backends/bluez/bluez-persona-store.vala"
			_data_->_data4_->_data2_ = block2_data_ref (_data_->_data2_);
#line 713 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp47_ = _data_->transfer;
#line 713 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp48_ = org_bluez_obex_transfer_get_filename (_data_->_tmp47_);
#line 713 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp49_ = _data_->_tmp48_;
#line 713 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp50_ = _data_->_tmp49_;
#line 713 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp51_ = g_file_new_for_path (_data_->_tmp50_);
#line 713 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp52_ = _data_->_tmp51_;
#line 713 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->_tmp50_);
#line 713 "../backends/bluez/bluez-persona-store.vala"
			_data_->_data4_->file = _data_->_tmp52_;
#line 714 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp53_ = _data_->_data4_->file;
#line 714 "../backends/bluez/bluez-persona-store.vala"
			g_file_delete_async (_data_->_tmp53_, G_PRIORITY_DEFAULT, NULL, _____lambda6__gasync_ready_callback, block4_data_ref (_data_->_data4_));
#line 711 "../backends/bluez/bluez-persona-store.vala"
			block4_data_unref (_data_->_data4_);
#line 711 "../backends/bluez/bluez-persona-store.vala"
			_data_->_data4_ = NULL;
#line 3312 "bluez-persona-store.c"
		}
	}
#line 591 "../backends/bluez/bluez-persona-store.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 591 "../backends/bluez/bluez-persona-store.vala"
		if ((_data_->_inner_error0_->domain == G_IO_ERROR) || (_data_->_inner_error0_->domain == FOLKS_PERSONA_STORE_ERROR)) {
#line 591 "../backends/bluez/bluez-persona-store.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 591 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->transfer);
#line 591 "../backends/bluez/bluez-persona-store.vala"
			block2_data_unref (_data_->_data2_);
#line 591 "../backends/bluez/bluez-persona-store.vala"
			_data_->_data2_ = NULL;
#line 591 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 591 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 3331 "bluez-persona-store.c"
		} else {
#line 591 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->transfer);
#line 591 "../backends/bluez/bluez-persona-store.vala"
			block2_data_unref (_data_->_data2_);
#line 591 "../backends/bluez/bluez-persona-store.vala"
			_data_->_data2_ = NULL;
#line 591 "../backends/bluez/bluez-persona-store.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 591 "../backends/bluez/bluez-persona-store.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 591 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 591 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 3347 "bluez-persona-store.c"
		}
	}
#line 585 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->transfer);
#line 585 "../backends/bluez/bluez-persona-store.vala"
	block2_data_unref (_data_->_data2_);
#line 585 "../backends/bluez/bluez-persona-store.vala"
	_data_->_data2_ = NULL;
#line 585 "../backends/bluez/bluez-persona-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 585 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_state_ != 0) {
#line 585 "../backends/bluez/bluez-persona-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 585 "../backends/bluez/bluez-persona-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3364 "bluez-persona-store.c"
		}
	}
#line 585 "../backends/bluez/bluez-persona-store.vala"
	g_object_unref (_data_->_async_result);
#line 585 "../backends/bluez/bluez-persona-store.vala"
	return FALSE;
#line 3371 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_update_contacts_data_free (gpointer _data)
{
	FolksBackendsBlueZPersonaStoreUpdateContactsData* _data_;
	_data_ = _data;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_slice_free (FolksBackendsBlueZPersonaStoreUpdateContactsData, _data_);
#line 3383 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_update_contacts (FolksBackendsBlueZPersonaStore* self,
                                                      gboolean download_photos,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStoreUpdateContactsData* _data_;
	FolksBackendsBlueZPersonaStore* _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZPersonaStoreUpdateContactsData);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backends_blue_z_persona_store_update_contacts_data_free);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->self = _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->download_photos = download_photos;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store_update_contacts_co (_data_);
#line 3410 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_update_contacts_finish (FolksBackendsBlueZPersonaStore* self,
                                                             GAsyncResult* _res_,
                                                             GError** error)
{
	FolksBackendsBlueZPersonaStoreUpdateContactsData* _data_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	if (NULL == _data_) {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		return;
#line 3425 "bluez-persona-store.c"
	}
}

/**
   * Update contacts from this persona store.
   *
   * Update contacts from this persona store by initiating a new OBEX
   * transfer, unless one is already in progress. If a transfer is already in
   * progress, leave it running and return immediately.
   *
   * If this throws an error, it guarantees to leave the store’s internal state
   * unchanged, apart from scheduling a new update operation to happen in the
   * future. This will always happen, regardless of success or failure.
   *
   * @param download_photos whether to download photos
   * @throws IOError if the operation was cancelled
   * @throws PersonaStoreError if the contacts couldn’t be downloaded from the
   * device
   *
   * @since 0.9.6
   */
static void
_folks_backends_blue_z_persona_store_update_contacts_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStoreUpdateContactsData* _data_;
#line 781 "../backends/bluez/bluez-persona-store.vala"
	_data_ = _user_data_;
#line 781 "../backends/bluez/bluez-persona-store.vala"
	_data_->_source_object_ = source_object;
#line 781 "../backends/bluez/bluez-persona-store.vala"
	_data_->_res_ = _res_;
#line 781 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store_update_contacts_co (_data_);
#line 3461 "bluez-persona-store.c"
}

static GVariant*
_variant_new2 (const gchar* value)
{
#line 813 "../backends/bluez/bluez-persona-store.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 3469 "bluez-persona-store.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 851 "../backends/bluez/bluez-persona-store.vala"
	return self ? g_error_copy (self) : NULL;
#line 3477 "bluez-persona-store.c"
}

static gboolean
_folks_backends_blue_z_persona_store_update_contacts_co (FolksBackendsBlueZPersonaStoreUpdateContactsData* _data_)
{
#line 748 "../backends/bluez/bluez-persona-store.vala"
	switch (_data_->_state_) {
#line 748 "../backends/bluez/bluez-persona-store.vala"
		case 0:
#line 3487 "bluez-persona-store.c"
		goto _state_0;
#line 748 "../backends/bluez/bluez-persona-store.vala"
		case 1:
#line 3491 "bluez-persona-store.c"
		goto _state_1;
#line 748 "../backends/bluez/bluez-persona-store.vala"
		case 2:
#line 3495 "bluez-persona-store.c"
		goto _state_2;
		default:
#line 748 "../backends/bluez/bluez-persona-store.vala"
		g_assert_not_reached ();
#line 3500 "bluez-persona-store.c"
	}
	_state_0:
#line 751 "../backends/bluez/bluez-persona-store.vala"
	_data_->session_path = NULL;
#line 752 "../backends/bluez/bluez-persona-store.vala"
	_data_->obex_pbap = NULL;
#line 753 "../backends/bluez/bluez-persona-store.vala"
	_data_->success = TRUE;
#line 755 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp0_ = _data_->self->priv->_update_contacts_cancellable;
#line 755 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_tmp0_ != NULL) {
#line 761 "../backends/bluez/bluez-persona-store.vala"
		g_debug ("bluez-persona-store.vala:761: Not updating contacts due to ongoing upd" \
"ate operation.");
#line 762 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->obex_pbap);
#line 762 "../backends/bluez/bluez-persona-store.vala"
		_g_free0 (_data_->session_path);
#line 762 "../backends/bluez/bluez-persona-store.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 762 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->_state_ != 0) {
#line 762 "../backends/bluez/bluez-persona-store.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 762 "../backends/bluez/bluez-persona-store.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3527 "bluez-persona-store.c"
			}
		}
#line 762 "../backends/bluez/bluez-persona-store.vala"
		g_object_unref (_data_->_async_result);
#line 762 "../backends/bluez/bluez-persona-store.vala"
		return FALSE;
#line 3534 "bluez-persona-store.c"
	}
#line 765 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp1_ = folks_persona_store_get_id ((FolksPersonaStore*) _data_->self);
#line 765 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 765 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp3_ = folks_internal_profiling_start ("updating BlueZ.PersonaStore (ID: %s) " "contacts", _data_->_tmp2_, NULL);
#line 765 "../backends/bluez/bluez-persona-store.vala"
	_data_->profiling = _data_->_tmp3_;
#line 768 "../backends/bluez/bluez-persona-store.vala"
	g_debug ("bluez-persona-store.vala:768: Updating contacts.");
#line 3546 "bluez-persona-store.c"
	{
#line 776 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp4_ = g_cancellable_new ();
#line 776 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->self->priv->_update_contacts_cancellable);
#line 776 "../backends/bluez/bluez-persona-store.vala"
		_data_->self->priv->_update_contacts_cancellable = _data_->_tmp4_;
#line 3554 "bluez-persona-store.c"
		{
#line 781 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp6_ = NULL;
#line 781 "../backends/bluez/bluez-persona-store.vala"
			_data_->_state_ = 1;
#line 781 "../backends/bluez/bluez-persona-store.vala"
			_folks_backends_blue_z_persona_store_new_obex_session (_data_->self, _folks_backends_blue_z_persona_store_update_contacts_ready, _data_);
#line 781 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 3564 "bluez-persona-store.c"
			_state_1:
#line 781 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp7_ = _folks_backends_blue_z_persona_store_new_obex_session_finish (_data_->self, _data_->_res_, &_data_->_tmp6_, &_data_->_inner_error0_);
#line 781 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->obex_pbap);
#line 781 "../backends/bluez/bluez-persona-store.vala"
			_data_->obex_pbap = _data_->_tmp6_;
#line 781 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp5_ = _data_->_tmp7_;
#line 781 "../backends/bluez/bluez-persona-store.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3576 "bluez-persona-store.c"
				goto __catch1_g_error;
			}
#line 781 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp8_ = _data_->_tmp5_;
#line 781 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp5_ = NULL;
#line 781 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->session_path);
#line 781 "../backends/bluez/bluez-persona-store.vala"
			_data_->session_path = _data_->_tmp8_;
#line 779 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->_tmp5_);
#line 3589 "bluez-persona-store.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 779 "../backends/bluez/bluez-persona-store.vala"
			_data_->e1 = _data_->_inner_error0_;
#line 779 "../backends/bluez/bluez-persona-store.vala"
			_data_->_inner_error0_ = NULL;
#line 785 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp10_ = _data_->e1;
#line 785 "../backends/bluez/bluez-persona-store.vala"
			if (g_error_matches (_data_->_tmp10_, G_IO_ERROR, G_IO_ERROR_DBUS_ERROR)) {
#line 786 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp11_ = _data_->e1;
#line 786 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp12_ = _data_->_tmp11_->message;
#line 786 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp9_ = g_str_has_suffix (_data_->_tmp12_, "OBEX Connect failed with 0x43");
#line 3608 "bluez-persona-store.c"
			} else {
#line 785 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp9_ = FALSE;
#line 3612 "bluez-persona-store.c"
			}
#line 785 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_tmp9_) {
#line 791 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp13_ = _data_->self->priv->_device;
#line 791 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp14_ = org_bluez_device_get_alias (_data_->_tmp13_);
#line 791 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp15_ = _data_->_tmp14_;
#line 791 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp16_ = _data_->_tmp15_;
#line 791 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp17_ = g_error_new (FOLKS_PERSONA_STORE_ERROR, FOLKS_PERSONA_STORE_ERROR_PERMISSION_DENIED, _ ("Permission to access the address book on Bluetooth device ‘%s’ was den" \
"ied by the user."), _data_->_tmp16_);
#line 791 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp18_ = _data_->_tmp17_;
#line 791 "../backends/bluez/bluez-persona-store.vala"
				_g_free0 (_data_->_tmp16_);
#line 791 "../backends/bluez/bluez-persona-store.vala"
				_data_->_inner_error0_ = _data_->_tmp18_;
#line 791 "../backends/bluez/bluez-persona-store.vala"
				_g_error_free0 (_data_->e1);
#line 3634 "bluez-persona-store.c"
				goto __finally1;
			}
#line 796 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp19_ = _data_->self->priv->_device;
#line 796 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp20_ = org_bluez_device_get_alias (_data_->_tmp19_);
#line 796 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp21_ = _data_->_tmp20_;
#line 796 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp22_ = _data_->_tmp21_;
#line 796 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp23_ = _data_->e1;
#line 796 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp24_ = _data_->_tmp23_->message;
#line 796 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp25_ = g_error_new (FOLKS_PERSONA_STORE_ERROR, FOLKS_PERSONA_STORE_ERROR_STORE_OFFLINE, _ ("An OBEX address book transfer from device ‘%s’ could not be started: %" \
"s"), _data_->_tmp22_, _data_->_tmp24_);
#line 796 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp26_ = _data_->_tmp25_;
#line 796 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->_tmp22_);
#line 796 "../backends/bluez/bluez-persona-store.vala"
			_data_->_inner_error0_ = _data_->_tmp26_;
#line 796 "../backends/bluez/bluez-persona-store.vala"
			_g_error_free0 (_data_->e1);
#line 3659 "bluez-persona-store.c"
			goto __finally1;
		}
		__finally1:
#line 779 "../backends/bluez/bluez-persona-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 779 "../backends/bluez/bluez-persona-store.vala"
			_g_hash_table_unref0 (_data_->props);
#line 779 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->path);
#line 779 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 3671 "bluez-persona-store.c"
				goto __catch0_g_io_error;
			}
#line 779 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_inner_error0_->domain == FOLKS_PERSONA_STORE_ERROR) {
#line 3676 "bluez-persona-store.c"
				goto __catch0_folks_persona_store_error;
			}
#line 779 "../backends/bluez/bluez-persona-store.vala"
			_folks_internal_profile_block_free0 (_data_->profiling);
#line 779 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->obex_pbap);
#line 779 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->session_path);
#line 779 "../backends/bluez/bluez-persona-store.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 779 "../backends/bluez/bluez-persona-store.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 779 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 779 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 3693 "bluez-persona-store.c"
		}
		{
#line 807 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp27_ = _data_->obex_pbap;
#line 807 "../backends/bluez/bluez-persona-store.vala"
			org_bluez_obex_phonebook_access_select (_data_->_tmp27_, "int", "PB", &_data_->_inner_error0_);
#line 807 "../backends/bluez/bluez-persona-store.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3702 "bluez-persona-store.c"
				goto __catch2_g_error;
			}
#line 811 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp28_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_variant_unref0_);
#line 811 "../backends/bluez/bluez-persona-store.vala"
			_data_->phonebook_filter = _data_->_tmp28_;
#line 813 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp29_ = _data_->phonebook_filter;
#line 813 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp30_ = g_strdup ("Format");
#line 813 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp31_ = _variant_new2 ("Vcard30");
#line 813 "../backends/bluez/bluez-persona-store.vala"
			g_hash_table_insert (_data_->_tmp29_, _data_->_tmp30_, _data_->_tmp31_);
#line 814 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->download_photos == TRUE) {
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp32_ = _data_->phonebook_filter;
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp33_ = g_strdup ("Fields");
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp34_ = g_strdup ("UID");
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp35_ = g_strdup ("N");
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp36_ = g_strdup ("FN");
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp37_ = g_strdup ("NICKNAME");
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp38_ = g_strdup ("TEL");
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp39_ = g_strdup ("URL");
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp40_ = g_strdup ("EMAIL");
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp41_ = g_strdup ("PHOTO");
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp42_ = g_new0 (gchar*, 8 + 1);
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp42_[0] = _data_->_tmp34_;
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp42_[1] = _data_->_tmp35_;
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp42_[2] = _data_->_tmp36_;
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp42_[3] = _data_->_tmp37_;
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp42_[4] = _data_->_tmp38_;
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp42_[5] = _data_->_tmp39_;
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp42_[6] = _data_->_tmp40_;
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp42_[7] = _data_->_tmp41_;
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp43_ = _data_->_tmp42_;
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp43__length1 = 8;
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp44_ = g_variant_new_strv (_data_->_tmp43_, 8);
#line 817 "../backends/bluez/bluez-persona-store.vala"
				g_variant_ref_sink (_data_->_tmp44_);
#line 817 "../backends/bluez/bluez-persona-store.vala"
				g_hash_table_insert (_data_->_tmp32_, _data_->_tmp33_, _data_->_tmp44_);
#line 817 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp43_ = (_vala_array_free (_data_->_tmp43_, _data_->_tmp43__length1, (GDestroyNotify) g_free), NULL);
#line 3769 "bluez-persona-store.c"
			} else {
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp45_ = _data_->phonebook_filter;
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp46_ = g_strdup ("Fields");
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp47_ = g_strdup ("UID");
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp48_ = g_strdup ("N");
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp49_ = g_strdup ("FN");
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp50_ = g_strdup ("NICKNAME");
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp51_ = g_strdup ("TEL");
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp52_ = g_strdup ("URL");
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp53_ = g_strdup ("EMAIL");
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp54_ = g_new0 (gchar*, 7 + 1);
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp54_[0] = _data_->_tmp47_;
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp54_[1] = _data_->_tmp48_;
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp54_[2] = _data_->_tmp49_;
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp54_[3] = _data_->_tmp50_;
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp54_[4] = _data_->_tmp51_;
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp54_[5] = _data_->_tmp52_;
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp54_[6] = _data_->_tmp53_;
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp55_ = _data_->_tmp54_;
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp55__length1 = 7;
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp56_ = g_variant_new_strv (_data_->_tmp55_, 7);
#line 826 "../backends/bluez/bluez-persona-store.vala"
				g_variant_ref_sink (_data_->_tmp56_);
#line 826 "../backends/bluez/bluez-persona-store.vala"
				g_hash_table_insert (_data_->_tmp45_, _data_->_tmp46_, _data_->_tmp56_);
#line 826 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp55_ = (_vala_array_free (_data_->_tmp55_, _data_->_tmp55__length1, (GDestroyNotify) g_free), NULL);
#line 3817 "bluez-persona-store.c"
			}
#line 832 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp57_ = _data_->obex_pbap;
#line 832 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp58_ = _data_->phonebook_filter;
#line 832 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp59_ = NULL;
#line 832 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp60_ = NULL;
#line 832 "../backends/bluez/bluez-persona-store.vala"
			org_bluez_obex_phonebook_access_pull_all (_data_->_tmp57_, "", _data_->_tmp58_, &_data_->_tmp59_, &_data_->_tmp60_, &_data_->_inner_error0_);
#line 832 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->path);
#line 832 "../backends/bluez/bluez-persona-store.vala"
			_data_->path = _data_->_tmp59_;
#line 832 "../backends/bluez/bluez-persona-store.vala"
			_g_hash_table_unref0 (_data_->props);
#line 832 "../backends/bluez/bluez-persona-store.vala"
			_data_->props = _data_->_tmp60_;
#line 832 "../backends/bluez/bluez-persona-store.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 832 "../backends/bluez/bluez-persona-store.vala"
				_g_hash_table_unref0 (_data_->phonebook_filter);
#line 3841 "bluez-persona-store.c"
				goto __catch2_g_error;
			}
#line 803 "../backends/bluez/bluez-persona-store.vala"
			_g_hash_table_unref0 (_data_->phonebook_filter);
#line 3846 "bluez-persona-store.c"
		}
		goto __finally2;
		__catch2_g_error:
		{
#line 803 "../backends/bluez/bluez-persona-store.vala"
			_data_->e2 = _data_->_inner_error0_;
#line 803 "../backends/bluez/bluez-persona-store.vala"
			_data_->_inner_error0_ = NULL;
#line 836 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp61_ = _data_->self->priv->_device;
#line 836 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp62_ = org_bluez_device_get_alias (_data_->_tmp61_);
#line 836 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp63_ = _data_->_tmp62_;
#line 836 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp64_ = _data_->_tmp63_;
#line 836 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp65_ = _data_->e2;
#line 836 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp66_ = _data_->_tmp65_->message;
#line 836 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp67_ = g_error_new (FOLKS_PERSONA_STORE_ERROR, FOLKS_PERSONA_STORE_ERROR_STORE_OFFLINE, _ ("The OBEX address book transfer from device ‘%s’ failed: %s"), _data_->_tmp64_, _data_->_tmp66_);
#line 836 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp68_ = _data_->_tmp67_;
#line 836 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->_tmp64_);
#line 836 "../backends/bluez/bluez-persona-store.vala"
			_data_->_inner_error0_ = _data_->_tmp68_;
#line 836 "../backends/bluez/bluez-persona-store.vala"
			_g_error_free0 (_data_->e2);
#line 3877 "bluez-persona-store.c"
			goto __finally2;
		}
		__finally2:
#line 803 "../backends/bluez/bluez-persona-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 803 "../backends/bluez/bluez-persona-store.vala"
			_g_hash_table_unref0 (_data_->props);
#line 803 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->path);
#line 803 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 3889 "bluez-persona-store.c"
				goto __catch0_g_io_error;
			}
#line 803 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_inner_error0_->domain == FOLKS_PERSONA_STORE_ERROR) {
#line 3894 "bluez-persona-store.c"
				goto __catch0_folks_persona_store_error;
			}
#line 803 "../backends/bluez/bluez-persona-store.vala"
			_folks_internal_profile_block_free0 (_data_->profiling);
#line 803 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->obex_pbap);
#line 803 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->session_path);
#line 803 "../backends/bluez/bluez-persona-store.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 803 "../backends/bluez/bluez-persona-store.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 803 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 803 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 3911 "bluez-persona-store.c"
		}
		{
#line 845 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp69_ = _data_->path;
#line 845 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp70_ = _data_->self->priv->_update_contacts_cancellable;
#line 845 "../backends/bluez/bluez-persona-store.vala"
			_data_->_state_ = 2;
#line 845 "../backends/bluez/bluez-persona-store.vala"
			_folks_backends_blue_z_persona_store_perform_obex_transfer (_data_->self, _data_->_tmp69_, _data_->_tmp70_, _folks_backends_blue_z_persona_store_update_contacts_ready, _data_);
#line 845 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 3924 "bluez-persona-store.c"
			_state_2:
#line 845 "../backends/bluez/bluez-persona-store.vala"
			_folks_backends_blue_z_persona_store_perform_obex_transfer_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 845 "../backends/bluez/bluez-persona-store.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 845 "../backends/bluez/bluez-persona-store.vala"
				if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 3932 "bluez-persona-store.c"
					goto __catch3_g_io_error;
				}
				goto __finally3;
			}
		}
		goto __finally3;
		__catch3_g_io_error:
		{
#line 843 "../backends/bluez/bluez-persona-store.vala"
			_data_->e3 = _data_->_inner_error0_;
#line 843 "../backends/bluez/bluez-persona-store.vala"
			_data_->_inner_error0_ = NULL;
#line 850 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp71_ = _data_->e3;
#line 850 "../backends/bluez/bluez-persona-store.vala"
			if (g_error_matches (_data_->_tmp71_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 851 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp72_ = _data_->e3;
#line 851 "../backends/bluez/bluez-persona-store.vala"
				_data_->_tmp73_ = _g_error_copy0 (_data_->_tmp72_);
#line 851 "../backends/bluez/bluez-persona-store.vala"
				_data_->_inner_error0_ = _data_->_tmp73_;
#line 851 "../backends/bluez/bluez-persona-store.vala"
				_g_error_free0 (_data_->e3);
#line 3957 "bluez-persona-store.c"
				goto __finally3;
			}
#line 853 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp74_ = _data_->self->priv->_display_name;
#line 853 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp75_ = _data_->e3;
#line 853 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp76_ = _data_->_tmp75_->message;
#line 853 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp77_ = g_error_new (FOLKS_PERSONA_STORE_ERROR, FOLKS_PERSONA_STORE_ERROR_STORE_OFFLINE, _ ("Error during transfer of the address book from Bluetooth device ‘%s’: " \
"%s"), _data_->_tmp74_, _data_->_tmp76_);
#line 853 "../backends/bluez/bluez-persona-store.vala"
			_data_->_inner_error0_ = _data_->_tmp77_;
#line 853 "../backends/bluez/bluez-persona-store.vala"
			_g_error_free0 (_data_->e3);
#line 3972 "bluez-persona-store.c"
			goto __finally3;
		}
		__finally3:
#line 843 "../backends/bluez/bluez-persona-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 843 "../backends/bluez/bluez-persona-store.vala"
			_g_hash_table_unref0 (_data_->props);
#line 843 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->path);
#line 843 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 3984 "bluez-persona-store.c"
				goto __catch0_g_io_error;
			}
#line 843 "../backends/bluez/bluez-persona-store.vala"
			if (_data_->_inner_error0_->domain == FOLKS_PERSONA_STORE_ERROR) {
#line 3989 "bluez-persona-store.c"
				goto __catch0_folks_persona_store_error;
			}
#line 843 "../backends/bluez/bluez-persona-store.vala"
			_folks_internal_profile_block_free0 (_data_->profiling);
#line 843 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->obex_pbap);
#line 843 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->session_path);
#line 843 "../backends/bluez/bluez-persona-store.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 843 "../backends/bluez/bluez-persona-store.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 843 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 843 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 4006 "bluez-persona-store.c"
		}
#line 770 "../backends/bluez/bluez-persona-store.vala"
		_g_hash_table_unref0 (_data_->props);
#line 770 "../backends/bluez/bluez-persona-store.vala"
		_g_free0 (_data_->path);
#line 4012 "bluez-persona-store.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
#line 770 "../backends/bluez/bluez-persona-store.vala"
		_data_->e4 = _data_->_inner_error0_;
#line 770 "../backends/bluez/bluez-persona-store.vala"
		_data_->_inner_error0_ = NULL;
#line 863 "../backends/bluez/bluez-persona-store.vala"
		_data_->success = FALSE;
#line 864 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp78_ = _data_->e4;
#line 864 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp79_ = _g_error_copy0 (_data_->_tmp78_);
#line 864 "../backends/bluez/bluez-persona-store.vala"
		_data_->_inner_error0_ = _data_->_tmp79_;
#line 864 "../backends/bluez/bluez-persona-store.vala"
		_g_error_free0 (_data_->e4);
#line 4031 "bluez-persona-store.c"
		goto __finally0;
	}
	goto __finally0;
	__catch0_folks_persona_store_error:
	{
#line 770 "../backends/bluez/bluez-persona-store.vala"
		_data_->e5 = _data_->_inner_error0_;
#line 770 "../backends/bluez/bluez-persona-store.vala"
		_data_->_inner_error0_ = NULL;
#line 869 "../backends/bluez/bluez-persona-store.vala"
		_data_->success = FALSE;
#line 870 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp80_ = _data_->e5;
#line 870 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp81_ = _g_error_copy0 (_data_->_tmp80_);
#line 870 "../backends/bluez/bluez-persona-store.vala"
		_data_->_inner_error0_ = _data_->_tmp81_;
#line 870 "../backends/bluez/bluez-persona-store.vala"
		_g_error_free0 (_data_->e5);
#line 4051 "bluez-persona-store.c"
		goto __finally0;
	}
	__finally0:
	{
#line 875 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp82_ = _data_->session_path;
#line 875 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->_tmp82_ != NULL) {
#line 876 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp83_ = _data_->session_path;
#line 876 "../backends/bluez/bluez-persona-store.vala"
			_folks_backends_blue_z_persona_store_remove_obex_session (_data_->self, _data_->_tmp83_, NULL, NULL);
#line 4064 "bluez-persona-store.c"
		}
#line 877 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->obex_pbap);
#line 877 "../backends/bluez/bluez-persona-store.vala"
		_data_->obex_pbap = NULL;
#line 879 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (_data_->self->priv->_update_contacts_cancellable);
#line 879 "../backends/bluez/bluez-persona-store.vala"
		_data_->self->priv->_update_contacts_cancellable = NULL;
#line 882 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->success == TRUE) {
#line 883 "../backends/bluez/bluez-persona-store.vala"
			_data_->self->priv->_update_contacts_failures = (guint) 0;
#line 4078 "bluez-persona-store.c"
		} else {
#line 885 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp84_ = _data_->self->priv->_update_contacts_failures;
#line 885 "../backends/bluez/bluez-persona-store.vala"
			_data_->self->priv->_update_contacts_failures = _data_->_tmp84_ + 1;
#line 4084 "bluez-persona-store.c"
		}
#line 890 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->success == TRUE) {
#line 890 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp85_ = _data_->self->priv->_photos_up_to_date == FALSE;
#line 4090 "bluez-persona-store.c"
		} else {
#line 890 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp85_ = FALSE;
#line 4094 "bluez-persona-store.c"
		}
#line 889 "../backends/bluez/bluez-persona-store.vala"
		_data_->new_download_photos = _data_->_tmp85_;
#line 891 "../backends/bluez/bluez-persona-store.vala"
		_folks_backends_blue_z_persona_store_schedule_update_contacts (_data_->self, _data_->new_download_photos);
#line 893 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp86_ = _data_->profiling;
#line 893 "../backends/bluez/bluez-persona-store.vala"
		_data_->profiling = NULL;
#line 893 "../backends/bluez/bluez-persona-store.vala"
		folks_internal_profiling_end (_data_->_tmp86_);
#line 4106 "bluez-persona-store.c"
	}
#line 770 "../backends/bluez/bluez-persona-store.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 770 "../backends/bluez/bluez-persona-store.vala"
		if ((_data_->_inner_error0_->domain == G_IO_ERROR) || (_data_->_inner_error0_->domain == FOLKS_PERSONA_STORE_ERROR)) {
#line 770 "../backends/bluez/bluez-persona-store.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 770 "../backends/bluez/bluez-persona-store.vala"
			_folks_internal_profile_block_free0 (_data_->profiling);
#line 770 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->obex_pbap);
#line 770 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->session_path);
#line 770 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 770 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 4124 "bluez-persona-store.c"
		} else {
#line 770 "../backends/bluez/bluez-persona-store.vala"
			_folks_internal_profile_block_free0 (_data_->profiling);
#line 770 "../backends/bluez/bluez-persona-store.vala"
			_g_object_unref0 (_data_->obex_pbap);
#line 770 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->session_path);
#line 770 "../backends/bluez/bluez-persona-store.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 770 "../backends/bluez/bluez-persona-store.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 770 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 770 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 4140 "bluez-persona-store.c"
		}
	}
#line 748 "../backends/bluez/bluez-persona-store.vala"
	_folks_internal_profile_block_free0 (_data_->profiling);
#line 748 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->obex_pbap);
#line 748 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (_data_->session_path);
#line 748 "../backends/bluez/bluez-persona-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 748 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_state_ != 0) {
#line 748 "../backends/bluez/bluez-persona-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 748 "../backends/bluez/bluez-persona-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4157 "bluez-persona-store.c"
		}
	}
#line 748 "../backends/bluez/bluez-persona-store.vala"
	g_object_unref (_data_->_async_result);
#line 748 "../backends/bluez/bluez-persona-store.vala"
	return FALSE;
#line 4164 "bluez-persona-store.c"
}

/**
   * Schedule the next call to {@link _update_contacts}.
   *
   * This calculates a suitable timeout value and schedules the next timeout
   * for updating the contacts.
   *
   * The update scheme is as follows:
   *  1. Download the contacts (without photos) as soon as connected to the
   *     phone.
   *  2. Schedule a second download attempt for a few seconds after the first
   *     one completes. If the first one completes successfully, this second
   *     download will include photos; otherwise, it won’t.
   *  3. Schedule subsequent download attempts for exponentially increasing
   *     timeouts, up to a maximum timeout (at which point the timeouts enter a
   *     linear region and repeat indefinitely). Subsequent download attempts
   *     will include photos only if they have not been successfully downloaded
   *     already, or if the previous download attempt caused other property
   *     changes in a persona (indicating that the address book has been edited
   *     on the phone).
   *  4. If updates fail a certain number of consecutive times, give up
   *     completely and leave the persona store in a prepared but empty
   *     quiescent state. Update attempts will only restart if the phone is then
   *     disconnected and reconnected.
   *
   * The rationale for this design is to:
   *  A. Allow for the user accidentally denying the first connection request on
   *     the phone, or not noticing it and it timing out. Attempting a second
   *     download after a timeout gives them an opportunity to fix the problem.
   *  B. If the user explicitly denies the connection request on the phone, the
   *     phone should remember this and automatically deny all future connection
   *     attempts until the consecutive failure limit is reached. The user
   *     shouldn’t be pestered to accept again.
   *  C. Watch for changes in the user’s address book and update the persona
   *     store accordingly. Unfortunately this has to be done by polling, since
   *     neither PBAP not OBEX itself support push notifications.
   *
   * @param download_photos whether to download photos
   *
   * @since 0.9.7
   */
static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 937 "../backends/bluez/bluez-persona-store.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 937 "../backends/bluez/bluez-persona-store.vala"
	return _data5_;
#line 4214 "bluez-persona-store.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 937 "../backends/bluez/bluez-persona-store.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 4224 "bluez-persona-store.c"
		FolksBackendsBlueZPersonaStore* self;
#line 937 "../backends/bluez/bluez-persona-store.vala"
		self = _data5_->self;
#line 937 "../backends/bluez/bluez-persona-store.vala"
		_g_object_unref0 (self);
#line 937 "../backends/bluez/bluez-persona-store.vala"
		g_slice_free (Block5Data, _data5_);
#line 4232 "bluez-persona-store.c"
	}
}

static gboolean
uint64_try_parse (const gchar* str,
                  guint64* _result_,
                  const gchar** unparsed,
                  guint _base)
{
	guint64 _vala__result_ = 0ULL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result;
#line 843 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 845 "glib-2.0.vapi"
	errno = 0;
#line 846 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoull (str, &_tmp0_, _base);
#line 846 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 846 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 847 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 847 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 847 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 847 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 4269 "bluez-persona-store.c"
		gboolean _tmp5_ = FALSE;
#line 848 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 849 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 849 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 4277 "bluez-persona-store.c"
		} else {
#line 849 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 4281 "bluez-persona-store.c"
		}
#line 849 "glib-2.0.vapi"
		result = _tmp5_;
#line 849 "glib-2.0.vapi"
		if (_result_) {
#line 849 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 4289 "bluez-persona-store.c"
		}
#line 849 "glib-2.0.vapi"
		if (unparsed) {
#line 849 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 4295 "bluez-persona-store.c"
		}
#line 849 "glib-2.0.vapi"
		return result;
#line 4299 "bluez-persona-store.c"
	} else {
		gchar* _tmp6_;
#line 851 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 851 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 852 "glib-2.0.vapi"
		result = FALSE;
#line 852 "glib-2.0.vapi"
		if (_result_) {
#line 852 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 4312 "bluez-persona-store.c"
		}
#line 852 "glib-2.0.vapi"
		if (unparsed) {
#line 852 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 4318 "bluez-persona-store.c"
		}
#line 852 "glib-2.0.vapi"
		return result;
#line 4322 "bluez-persona-store.c"
	}
}

static void
__lambda8_ (FolksBackendsBlueZPersonaStore* self,
            GObject* o,
            GAsyncResult* r)
{
	GError* _inner_error0_ = NULL;
#line 978 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (r != NULL);
#line 4334 "bluez-persona-store.c"
	{
#line 982 "../backends/bluez/bluez-persona-store.vala"
		_folks_backends_blue_z_persona_store_update_contacts_finish (self, r, &_inner_error0_);
#line 982 "../backends/bluez/bluez-persona-store.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4340 "bluez-persona-store.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e4 = NULL;
		GError* _tmp0_;
		GError* _tmp1_;
#line 980 "../backends/bluez/bluez-persona-store.vala"
		e4 = _inner_error0_;
#line 980 "../backends/bluez/bluez-persona-store.vala"
		_inner_error0_ = NULL;
#line 987 "../backends/bluez/bluez-persona-store.vala"
		_tmp0_ = e4;
#line 987 "../backends/bluez/bluez-persona-store.vala"
		if (g_error_matches (_tmp0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 988 "../backends/bluez/bluez-persona-store.vala"
			_g_error_free0 (e4);
#line 988 "../backends/bluez/bluez-persona-store.vala"
			return;
#line 4362 "bluez-persona-store.c"
		}
#line 991 "../backends/bluez/bluez-persona-store.vala"
		_tmp1_ = e4;
#line 991 "../backends/bluez/bluez-persona-store.vala"
		if (g_error_matches (_tmp1_, FOLKS_PERSONA_STORE_ERROR, FOLKS_PERSONA_STORE_ERROR_STORE_OFFLINE)) {
#line 4368 "bluez-persona-store.c"
			GError* _tmp2_;
			const gchar* _tmp3_;
#line 993 "../backends/bluez/bluez-persona-store.vala"
			_tmp2_ = e4;
#line 993 "../backends/bluez/bluez-persona-store.vala"
			_tmp3_ = _tmp2_->message;
#line 993 "../backends/bluez/bluez-persona-store.vala"
			g_debug ("Not updating persona store from BlueZ due to " "store being offline: %s", _tmp3_);
#line 4377 "bluez-persona-store.c"
		} else {
			GError* _tmp4_;
			const gchar* _tmp5_;
#line 998 "../backends/bluez/bluez-persona-store.vala"
			_tmp4_ = e4;
#line 998 "../backends/bluez/bluez-persona-store.vala"
			_tmp5_ = _tmp4_->message;
#line 998 "../backends/bluez/bluez-persona-store.vala"
			g_warning ("bluez-persona-store.vala:998: Error updating persona store from BlueZ:" \
" %s", _tmp5_);
#line 4387 "bluez-persona-store.c"
		}
#line 980 "../backends/bluez/bluez-persona-store.vala"
		_g_error_free0 (e4);
#line 4391 "bluez-persona-store.c"
	}
	__finally0:
#line 980 "../backends/bluez/bluez-persona-store.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 980 "../backends/bluez/bluez-persona-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 980 "../backends/bluez/bluez-persona-store.vala"
		g_clear_error (&_inner_error0_);
#line 980 "../backends/bluez/bluez-persona-store.vala"
		return;
#line 4402 "bluez-persona-store.c"
	}
}

static void
___lambda8__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 978 "../backends/bluez/bluez-persona-store.vala"
	__lambda8_ ((FolksBackendsBlueZPersonaStore*) self, source_object, res);
#line 978 "../backends/bluez/bluez-persona-store.vala"
	g_object_unref (self);
#line 4415 "bluez-persona-store.c"
}

static gboolean
__lambda7_ (Block5Data* _data5_)
{
	FolksBackendsBlueZPersonaStore* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
#line 971 "../backends/bluez/bluez-persona-store.vala"
	self = _data5_->self;
#line 973 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = folks_persona_store_get_id ((FolksPersonaStore*) self);
#line 973 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = _tmp0_;
#line 973 "../backends/bluez/bluez-persona-store.vala"
	g_debug ("bluez-persona-store.vala:973: Scheduled update firing for BlueZ store " \
"‘%s’.", _tmp1_);
#line 976 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_update_contacts_id = (guint) 0;
#line 978 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store_update_contacts (self, _data5_->download_photos, ___lambda8__gasync_ready_callback, g_object_ref (self));
#line 1004 "../backends/bluez/bluez-persona-store.vala"
	result = FALSE;
#line 1004 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 4441 "bluez-persona-store.c"
}

static gboolean
___lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda7_ (self);
#line 971 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 4451 "bluez-persona-store.c"
}

static void
_folks_backends_blue_z_persona_store_schedule_update_contacts (FolksBackendsBlueZPersonaStore* self,
                                                               gboolean download_photos)
{
	Block5Data* _data5_;
	guint timeout = 0U;
	guint _tmp0_;
	gchar* divisor_str = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	GSourceFunc fn = NULL;
	gpointer fn_target;
	GDestroyNotify fn_target_destroy_notify;
#line 937 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 937 "../backends/bluez/bluez-persona-store.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 937 "../backends/bluez/bluez-persona-store.vala"
	_data5_->_ref_count_ = 1;
#line 937 "../backends/bluez/bluez-persona-store.vala"
	_data5_->self = g_object_ref (self);
#line 937 "../backends/bluez/bluez-persona-store.vala"
	_data5_->download_photos = download_photos;
#line 940 "../backends/bluez/bluez-persona-store.vala"
	if (self->priv->_update_contacts_id != ((guint) 0)) {
#line 941 "../backends/bluez/bluez-persona-store.vala"
		block5_data_unref (_data5_);
#line 941 "../backends/bluez/bluez-persona-store.vala"
		_data5_ = NULL;
#line 941 "../backends/bluez/bluez-persona-store.vala"
		return;
#line 4486 "bluez-persona-store.c"
	}
#line 945 "../backends/bluez/bluez-persona-store.vala"
	if (self->priv->_update_contacts_failures >= FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE__MAX_CONSECUTIVE_FAILURES) {
#line 947 "../backends/bluez/bluez-persona-store.vala"
		block5_data_unref (_data5_);
#line 947 "../backends/bluez/bluez-persona-store.vala"
		_data5_ = NULL;
#line 947 "../backends/bluez/bluez-persona-store.vala"
		return;
#line 4496 "bluez-persona-store.c"
	}
#line 951 "../backends/bluez/bluez-persona-store.vala"
	timeout = MIN (FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE__TIMEOUT_MIN + ((guint) pow ((gdouble) FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE__TIMEOUT_BASE, (gdouble) self->priv->_update_contacts_n)), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE__TIMEOUT_MAX);
#line 956 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = self->priv->_update_contacts_n;
#line 956 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_update_contacts_n = _tmp0_ + 1;
#line 958 "../backends/bluez/bluez-persona-store.vala"
	timeout *= (guint) 1000;
#line 961 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = g_getenv ("FOLKS_BLUEZ_TIMEOUT_DIVISOR");
#line 961 "../backends/bluez/bluez-persona-store.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 961 "../backends/bluez/bluez-persona-store.vala"
	divisor_str = _tmp2_;
#line 963 "../backends/bluez/bluez-persona-store.vala"
	_tmp3_ = divisor_str;
#line 963 "../backends/bluez/bluez-persona-store.vala"
	if (_tmp3_ != NULL) {
#line 4516 "bluez-persona-store.c"
		guint64 divisor = 0ULL;
		const gchar* _tmp4_;
		guint64 _tmp5_ = 0ULL;
		gboolean _tmp6_;
#line 966 "../backends/bluez/bluez-persona-store.vala"
		_tmp4_ = divisor_str;
#line 966 "../backends/bluez/bluez-persona-store.vala"
		_tmp6_ = uint64_try_parse (_tmp4_, &_tmp5_, NULL, (guint) 0);
#line 966 "../backends/bluez/bluez-persona-store.vala"
		divisor = _tmp5_;
#line 966 "../backends/bluez/bluez-persona-store.vala"
		if (_tmp6_ == TRUE) {
#line 967 "../backends/bluez/bluez-persona-store.vala"
			timeout /= (guint) divisor;
#line 4531 "bluez-persona-store.c"
		}
	}
#line 971 "../backends/bluez/bluez-persona-store.vala"
	fn = ___lambda7__gsource_func;
#line 971 "../backends/bluez/bluez-persona-store.vala"
	fn_target = block5_data_ref (_data5_);
#line 971 "../backends/bluez/bluez-persona-store.vala"
	fn_target_destroy_notify = block5_data_unref;
#line 1007 "../backends/bluez/bluez-persona-store.vala"
	if ((timeout % 1000) == ((guint) 0)) {
#line 4542 "bluez-persona-store.c"
		GSourceFunc _tmp7_;
		gpointer _tmp7__target;
		GDestroyNotify _tmp7__target_destroy_notify;
#line 1009 "../backends/bluez/bluez-persona-store.vala"
		_tmp7_ = fn;
#line 1009 "../backends/bluez/bluez-persona-store.vala"
		_tmp7__target = fn_target;
#line 1009 "../backends/bluez/bluez-persona-store.vala"
		_tmp7__target_destroy_notify = fn_target_destroy_notify;
#line 1009 "../backends/bluez/bluez-persona-store.vala"
		fn = NULL;
#line 1009 "../backends/bluez/bluez-persona-store.vala"
		fn_target = NULL;
#line 1009 "../backends/bluez/bluez-persona-store.vala"
		fn_target_destroy_notify = NULL;
#line 1009 "../backends/bluez/bluez-persona-store.vala"
		self->priv->_update_contacts_id = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, timeout / 1000, _tmp7_, _tmp7__target, _tmp7__target_destroy_notify);
#line 4560 "bluez-persona-store.c"
	} else {
		GSourceFunc _tmp8_;
		gpointer _tmp8__target;
		GDestroyNotify _tmp8__target_destroy_notify;
#line 1014 "../backends/bluez/bluez-persona-store.vala"
		_tmp8_ = fn;
#line 1014 "../backends/bluez/bluez-persona-store.vala"
		_tmp8__target = fn_target;
#line 1014 "../backends/bluez/bluez-persona-store.vala"
		_tmp8__target_destroy_notify = fn_target_destroy_notify;
#line 1014 "../backends/bluez/bluez-persona-store.vala"
		fn = NULL;
#line 1014 "../backends/bluez/bluez-persona-store.vala"
		fn_target = NULL;
#line 1014 "../backends/bluez/bluez-persona-store.vala"
		fn_target_destroy_notify = NULL;
#line 1014 "../backends/bluez/bluez-persona-store.vala"
		self->priv->_update_contacts_id = g_timeout_add_full (G_PRIORITY_DEFAULT, timeout, _tmp8_, _tmp8__target, _tmp8__target_destroy_notify);
#line 4579 "bluez-persona-store.c"
	}
#line 937 "../backends/bluez/bluez-persona-store.vala"
	(fn_target_destroy_notify == NULL) ? NULL : (fn_target_destroy_notify (fn_target), NULL);
#line 937 "../backends/bluez/bluez-persona-store.vala"
	fn = NULL;
#line 937 "../backends/bluez/bluez-persona-store.vala"
	fn_target = NULL;
#line 937 "../backends/bluez/bluez-persona-store.vala"
	fn_target_destroy_notify = NULL;
#line 937 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (divisor_str);
#line 937 "../backends/bluez/bluez-persona-store.vala"
	block5_data_unref (_data5_);
#line 937 "../backends/bluez/bluez-persona-store.vala"
	_data5_ = NULL;
#line 4595 "bluez-persona-store.c"
}

/**
   * Cancel ongoing and scheduled updates from the device.
   *
   * This doesn't remove the store, but does cancel all ongoing updates and
   * future scheduled updates, in preparation for removing the store. This is
   * necessary to avoid the store maintaining a reference to itself (through the
   * closure for the next scheduled update) and thus never being finalised.
   *
   * @since 0.9.7
   */
void
folks_backends_blue_z_persona_store_cancel_updates (FolksBackendsBlueZPersonaStore* self)
{
	GCancellable* _tmp0_;
#line 1029 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 1031 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = self->priv->_update_contacts_cancellable;
#line 1031 "../backends/bluez/bluez-persona-store.vala"
	if (_tmp0_ != NULL) {
#line 4618 "bluez-persona-store.c"
		GCancellable* _tmp1_;
#line 1032 "../backends/bluez/bluez-persona-store.vala"
		_tmp1_ = self->priv->_update_contacts_cancellable;
#line 1032 "../backends/bluez/bluez-persona-store.vala"
		g_cancellable_cancel (_tmp1_);
#line 4624 "bluez-persona-store.c"
	}
#line 1033 "../backends/bluez/bluez-persona-store.vala"
	if (self->priv->_update_contacts_id != ((guint) 0)) {
#line 1035 "../backends/bluez/bluez-persona-store.vala"
		g_source_remove (self->priv->_update_contacts_id);
#line 1036 "../backends/bluez/bluez-persona-store.vala"
		self->priv->_update_contacts_id = (guint) 0;
#line 4632 "bluez-persona-store.c"
	}
}

static void
folks_backends_blue_z_persona_store_real_prepare_data_free (gpointer _data)
{
	FolksBackendsBlueZPersonaStorePrepareData* _data_;
	_data_ = _data;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_slice_free (FolksBackendsBlueZPersonaStorePrepareData, _data_);
#line 4645 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_real_prepare (FolksPersonaStore* base,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStore * self;
	FolksBackendsBlueZPersonaStorePrepareData* _data_;
	FolksBackendsBlueZPersonaStore* _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZPersonaStorePrepareData);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backends_blue_z_persona_store_real_prepare_data_free);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->self = _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	folks_backends_blue_z_persona_store_real_prepare_co (_data_);
#line 4670 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_prepare_finish (FolksPersonaStore* base,
                                                    GAsyncResult* _res_,
                                                    GError** error)
{
	FolksBackendsBlueZPersonaStorePrepareData* _data_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	if (NULL == _data_) {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		return;
#line 4685 "bluez-persona-store.c"
	}
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.6
   */
static void
folks_backends_blue_z_persona_store_prepare_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStorePrepareData* _data_;
#line 1064 "../backends/bluez/bluez-persona-store.vala"
	_data_ = _user_data_;
#line 1064 "../backends/bluez/bluez-persona-store.vala"
	_data_->_source_object_ = source_object;
#line 1064 "../backends/bluez/bluez-persona-store.vala"
	_data_->_res_ = _res_;
#line 1064 "../backends/bluez/bluez-persona-store.vala"
	folks_backends_blue_z_persona_store_real_prepare_co (_data_);
#line 4708 "bluez-persona-store.c"
}

static gboolean
folks_backends_blue_z_persona_store_real_prepare_co (FolksBackendsBlueZPersonaStorePrepareData* _data_)
{
#line 1045 "../backends/bluez/bluez-persona-store.vala"
	switch (_data_->_state_) {
#line 1045 "../backends/bluez/bluez-persona-store.vala"
		case 0:
#line 4718 "bluez-persona-store.c"
		goto _state_0;
#line 1045 "../backends/bluez/bluez-persona-store.vala"
		case 1:
#line 4722 "bluez-persona-store.c"
		goto _state_1;
		default:
#line 1045 "../backends/bluez/bluez-persona-store.vala"
		g_assert_not_reached ();
#line 4727 "bluez-persona-store.c"
	}
	_state_0:
#line 1047 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp0_ = folks_persona_store_get_id ((FolksPersonaStore*) _data_->self);
#line 1047 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 1047 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp2_ = folks_internal_profiling_start ("preparing BlueZ.PersonaStore (ID: %s)", _data_->_tmp1_, NULL);
#line 1047 "../backends/bluez/bluez-persona-store.vala"
	_data_->profiling = _data_->_tmp2_;
#line 1050 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->self->priv->_is_prepared) {
#line 1050 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp3_ = TRUE;
#line 4742 "bluez-persona-store.c"
	} else {
#line 1050 "../backends/bluez/bluez-persona-store.vala"
		_data_->_tmp3_ = _data_->self->priv->_prepare_pending;
#line 4746 "bluez-persona-store.c"
	}
#line 1050 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_tmp3_) {
#line 1052 "../backends/bluez/bluez-persona-store.vala"
		_folks_internal_profile_block_free0 (_data_->profiling);
#line 1052 "../backends/bluez/bluez-persona-store.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1052 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->_state_ != 0) {
#line 1052 "../backends/bluez/bluez-persona-store.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 1052 "../backends/bluez/bluez-persona-store.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4760 "bluez-persona-store.c"
			}
		}
#line 1052 "../backends/bluez/bluez-persona-store.vala"
		g_object_unref (_data_->_async_result);
#line 1052 "../backends/bluez/bluez-persona-store.vala"
		return FALSE;
#line 4767 "bluez-persona-store.c"
	}
	{
#line 1057 "../backends/bluez/bluez-persona-store.vala"
		_data_->self->priv->_prepare_pending = TRUE;
#line 4772 "bluez-persona-store.c"
		{
#line 1064 "../backends/bluez/bluez-persona-store.vala"
			_data_->_state_ = 1;
#line 1064 "../backends/bluez/bluez-persona-store.vala"
			_folks_backends_blue_z_persona_store_update_contacts (_data_->self, FALSE, folks_backends_blue_z_persona_store_prepare_ready, _data_);
#line 1064 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 4780 "bluez-persona-store.c"
			_state_1:
#line 1064 "../backends/bluez/bluez-persona-store.vala"
			_folks_backends_blue_z_persona_store_update_contacts_finish (_data_->self, _data_->_res_, &_data_->_inner_error0_);
#line 1064 "../backends/bluez/bluez-persona-store.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1064 "../backends/bluez/bluez-persona-store.vala"
				if (_data_->_inner_error0_->domain == G_IO_ERROR) {
#line 4788 "bluez-persona-store.c"
					goto __catch1_g_io_error;
				}
				goto __finally1;
			}
		}
		goto __finally1;
		__catch1_g_io_error:
		{
#line 1062 "../backends/bluez/bluez-persona-store.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 1072 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp4_ = _data_->self->priv->_device;
#line 1072 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp5_ = org_bluez_device_get_alias (_data_->_tmp4_);
#line 1072 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 1072 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 1072 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp8_ = g_error_new (FOLKS_PERSONA_STORE_ERROR, FOLKS_PERSONA_STORE_ERROR_STORE_OFFLINE, _ ("Bluetooth device ‘%s’ disappeared during address book transfer."), _data_->_tmp7_);
#line 1072 "../backends/bluez/bluez-persona-store.vala"
			_data_->_tmp9_ = _data_->_tmp8_;
#line 1072 "../backends/bluez/bluez-persona-store.vala"
			_g_free0 (_data_->_tmp7_);
#line 1072 "../backends/bluez/bluez-persona-store.vala"
			_data_->_inner_error0_ = _data_->_tmp9_;
#line 4815 "bluez-persona-store.c"
			goto __finally1;
		}
		__finally1:
		{
#line 1099 "../backends/bluez/bluez-persona-store.vala"
			_data_->self->priv->_is_prepared = TRUE;
#line 1100 "../backends/bluez/bluez-persona-store.vala"
			g_object_notify ((GObject*) _data_->self, "is-prepared");
#line 1102 "../backends/bluez/bluez-persona-store.vala"
			_data_->self->priv->_is_quiescent = TRUE;
#line 1103 "../backends/bluez/bluez-persona-store.vala"
			g_object_notify ((GObject*) _data_->self, "is-quiescent");
#line 4828 "bluez-persona-store.c"
		}
#line 1062 "../backends/bluez/bluez-persona-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4832 "bluez-persona-store.c"
			goto __finally0;
		}
	}
	__finally0:
	{
#line 1108 "../backends/bluez/bluez-persona-store.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 4840 "bluez-persona-store.c"
	}
#line 1055 "../backends/bluez/bluez-persona-store.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1055 "../backends/bluez/bluez-persona-store.vala"
		if (_data_->_inner_error0_->domain == FOLKS_PERSONA_STORE_ERROR) {
#line 1055 "../backends/bluez/bluez-persona-store.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1055 "../backends/bluez/bluez-persona-store.vala"
			_folks_internal_profile_block_free0 (_data_->profiling);
#line 1055 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 1055 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 4854 "bluez-persona-store.c"
		} else {
#line 1055 "../backends/bluez/bluez-persona-store.vala"
			_folks_internal_profile_block_free0 (_data_->profiling);
#line 1055 "../backends/bluez/bluez-persona-store.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1055 "../backends/bluez/bluez-persona-store.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 1055 "../backends/bluez/bluez-persona-store.vala"
			g_object_unref (_data_->_async_result);
#line 1055 "../backends/bluez/bluez-persona-store.vala"
			return FALSE;
#line 4866 "bluez-persona-store.c"
		}
	}
#line 1111 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp10_ = _data_->profiling;
#line 1111 "../backends/bluez/bluez-persona-store.vala"
	_data_->profiling = NULL;
#line 1111 "../backends/bluez/bluez-persona-store.vala"
	folks_internal_profiling_end (_data_->_tmp10_);
#line 1045 "../backends/bluez/bluez-persona-store.vala"
	_folks_internal_profile_block_free0 (_data_->profiling);
#line 1045 "../backends/bluez/bluez-persona-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1045 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_state_ != 0) {
#line 1045 "../backends/bluez/bluez-persona-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1045 "../backends/bluez/bluez-persona-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4885 "bluez-persona-store.c"
		}
	}
#line 1045 "../backends/bluez/bluez-persona-store.vala"
	g_object_unref (_data_->_async_result);
#line 1045 "../backends/bluez/bluez-persona-store.vala"
	return FALSE;
#line 4892 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_real_remove_persona_data_free (gpointer _data)
{
	FolksBackendsBlueZPersonaStoreRemovePersonaData* _data_;
	_data_ = _data;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->persona);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_slice_free (FolksBackendsBlueZPersonaStoreRemovePersonaData, _data_);
#line 4906 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_real_remove_persona (FolksPersonaStore* base,
                                                         FolksPersona* persona,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStore * self;
	FolksBackendsBlueZPersonaStoreRemovePersonaData* _data_;
	FolksBackendsBlueZPersonaStore* _tmp0_;
	FolksPersona* _tmp1_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (persona != NULL);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZPersonaStoreRemovePersonaData);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backends_blue_z_persona_store_real_remove_persona_data_free);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->self = _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = _g_object_ref0 (persona);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->persona);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->persona = _tmp1_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	folks_backends_blue_z_persona_store_real_remove_persona_co (_data_);
#line 4941 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_remove_persona_finish (FolksPersonaStore* base,
                                                           GAsyncResult* _res_,
                                                           GError** error)
{
	FolksBackendsBlueZPersonaStoreRemovePersonaData* _data_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	if (NULL == _data_) {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		return;
#line 4956 "bluez-persona-store.c"
	}
}

/**
   * Remove a {@link Persona} from the PersonaStore.
   *
   * See {@link Folks.PersonaStore.remove_persona}.
   *
   * @param persona the {@link Persona} to remove
   * @throws Folks.PersonaStoreError.READ_ONLY every time since the
   * BlueZ backend is read-only.
   *
   * @since 0.9.6
   */
static gboolean
folks_backends_blue_z_persona_store_real_remove_persona_co (FolksBackendsBlueZPersonaStoreRemovePersonaData* _data_)
{
#line 1125 "../backends/bluez/bluez-persona-store.vala"
	switch (_data_->_state_) {
#line 1125 "../backends/bluez/bluez-persona-store.vala"
		case 0:
#line 4978 "bluez-persona-store.c"
		goto _state_0;
		default:
#line 1125 "../backends/bluez/bluez-persona-store.vala"
		g_assert_not_reached ();
#line 4983 "bluez-persona-store.c"
	}
	_state_0:
#line 1128 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp0_ = g_error_new_literal (FOLKS_PERSONA_STORE_ERROR, FOLKS_PERSONA_STORE_ERROR_READ_ONLY, "Personas cannot be removed from this store.");
#line 1128 "../backends/bluez/bluez-persona-store.vala"
	_data_->_inner_error0_ = _data_->_tmp0_;
#line 1128 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_inner_error0_->domain == FOLKS_PERSONA_STORE_ERROR) {
#line 1128 "../backends/bluez/bluez-persona-store.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1128 "../backends/bluez/bluez-persona-store.vala"
		g_object_unref (_data_->_async_result);
#line 1128 "../backends/bluez/bluez-persona-store.vala"
		return FALSE;
#line 4998 "bluez-persona-store.c"
	} else {
#line 1128 "../backends/bluez/bluez-persona-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1128 "../backends/bluez/bluez-persona-store.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1128 "../backends/bluez/bluez-persona-store.vala"
		g_object_unref (_data_->_async_result);
#line 1128 "../backends/bluez/bluez-persona-store.vala"
		return FALSE;
#line 5008 "bluez-persona-store.c"
	}
#line 1125 "../backends/bluez/bluez-persona-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 1125 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_state_ != 0) {
#line 1125 "../backends/bluez/bluez-persona-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 1125 "../backends/bluez/bluez-persona-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5018 "bluez-persona-store.c"
		}
	}
#line 1125 "../backends/bluez/bluez-persona-store.vala"
	g_object_unref (_data_->_async_result);
#line 1125 "../backends/bluez/bluez-persona-store.vala"
	return FALSE;
#line 5025 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_real_add_persona_from_details_data_free (gpointer _data)
{
	FolksBackendsBlueZPersonaStoreAddPersonaFromDetailsData* _data_;
	_data_ = _data;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_hash_table_unref0 (_data_->details);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->result);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (_data_->self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_slice_free (FolksBackendsBlueZPersonaStoreAddPersonaFromDetailsData, _data_);
#line 5041 "bluez-persona-store.c"
}

static gpointer
_g_hash_table_ref0 (gpointer self)
{
#line 59 "../backends/bluez/bluez-persona-store.vala"
	return self ? g_hash_table_ref (self) : NULL;
#line 5049 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_real_add_persona_from_details (FolksPersonaStore* base,
                                                                   GHashTable* details,
                                                                   GAsyncReadyCallback _callback_,
                                                                   gpointer _user_data_)
{
	FolksBackendsBlueZPersonaStore * self;
	FolksBackendsBlueZPersonaStoreAddPersonaFromDetailsData* _data_;
	FolksBackendsBlueZPersonaStore* _tmp0_;
	GHashTable* _tmp1_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (details != NULL);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_slice_new0 (FolksBackendsBlueZPersonaStoreAddPersonaFromDetailsData);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backends_blue_z_persona_store_real_add_persona_from_details_data_free);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->self = _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = _g_hash_table_ref0 (details);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_g_hash_table_unref0 (_data_->details);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->details = _tmp1_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	folks_backends_blue_z_persona_store_real_add_persona_from_details_co (_data_);
#line 5084 "bluez-persona-store.c"
}

static FolksPersona*
folks_backends_blue_z_persona_store_add_persona_from_details_finish (FolksPersonaStore* base,
                                                                     GAsyncResult* _res_,
                                                                     GError** error)
{
	FolksPersona* result;
	FolksBackendsBlueZPersonaStoreAddPersonaFromDetailsData* _data_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	if (NULL == _data_) {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		return NULL;
#line 5100 "bluez-persona-store.c"
	}
#line 59 "../backends/bluez/bluez-persona-store.vala"
	result = _data_->result;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	_data_->result = NULL;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5108 "bluez-persona-store.c"
}

/**
   * Add a new {@link Persona} to the PersonaStore.
   *
   * See {@link Folks.PersonaStore.add_persona_from_details}.
   *
   * @param details a map of keys to values giving the persona’s initial details
   * @throws Folks.PersonaStoreError.READ_ONLY every time since the
   * BlueZ backend is read-only.
   *
   * @since 0.9.6
   */
static gboolean
folks_backends_blue_z_persona_store_real_add_persona_from_details_co (FolksBackendsBlueZPersonaStoreAddPersonaFromDetailsData* _data_)
{
#line 1143 "../backends/bluez/bluez-persona-store.vala"
	switch (_data_->_state_) {
#line 1143 "../backends/bluez/bluez-persona-store.vala"
		case 0:
#line 5129 "bluez-persona-store.c"
		goto _state_0;
		default:
#line 1143 "../backends/bluez/bluez-persona-store.vala"
		g_assert_not_reached ();
#line 5134 "bluez-persona-store.c"
	}
	_state_0:
#line 1146 "../backends/bluez/bluez-persona-store.vala"
	_data_->_tmp0_ = g_error_new_literal (FOLKS_PERSONA_STORE_ERROR, FOLKS_PERSONA_STORE_ERROR_READ_ONLY, "Personas cannot be added to this store.");
#line 1146 "../backends/bluez/bluez-persona-store.vala"
	_data_->_inner_error0_ = _data_->_tmp0_;
#line 1146 "../backends/bluez/bluez-persona-store.vala"
	if (_data_->_inner_error0_->domain == FOLKS_PERSONA_STORE_ERROR) {
#line 1146 "../backends/bluez/bluez-persona-store.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 1146 "../backends/bluez/bluez-persona-store.vala"
		g_object_unref (_data_->_async_result);
#line 1146 "../backends/bluez/bluez-persona-store.vala"
		return FALSE;
#line 5149 "bluez-persona-store.c"
	} else {
#line 1146 "../backends/bluez/bluez-persona-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 1146 "../backends/bluez/bluez-persona-store.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 1146 "../backends/bluez/bluez-persona-store.vala"
		g_object_unref (_data_->_async_result);
#line 1146 "../backends/bluez/bluez-persona-store.vala"
		return FALSE;
#line 5159 "bluez-persona-store.c"
	}
}

static const gchar*
folks_backends_blue_z_persona_store_real_get_type_id (FolksPersonaStore* base)
{
	const gchar* result;
	FolksBackendsBlueZPersonaStore* self;
#line 100 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 100 "../backends/bluez/bluez-persona-store.vala"
	result = BACKEND_NAME;
#line 100 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5174 "bluez-persona-store.c"
}

static FolksMaybeBool
folks_backends_blue_z_persona_store_real_get_can_add_personas (FolksPersonaStore* base)
{
	FolksMaybeBool result;
	FolksBackendsBlueZPersonaStore* self;
#line 111 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 111 "../backends/bluez/bluez-persona-store.vala"
	result = FOLKS_MAYBE_BOOL_FALSE;
#line 111 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5188 "bluez-persona-store.c"
}

static FolksMaybeBool
folks_backends_blue_z_persona_store_real_get_can_alias_personas (FolksPersonaStore* base)
{
	FolksMaybeBool result;
	FolksBackendsBlueZPersonaStore* self;
#line 123 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 123 "../backends/bluez/bluez-persona-store.vala"
	result = FOLKS_MAYBE_BOOL_FALSE;
#line 123 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5202 "bluez-persona-store.c"
}

static FolksMaybeBool
folks_backends_blue_z_persona_store_real_get_can_group_personas (FolksPersonaStore* base)
{
	FolksMaybeBool result;
	FolksBackendsBlueZPersonaStore* self;
#line 135 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 135 "../backends/bluez/bluez-persona-store.vala"
	result = FOLKS_MAYBE_BOOL_FALSE;
#line 135 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5216 "bluez-persona-store.c"
}

static FolksMaybeBool
folks_backends_blue_z_persona_store_real_get_can_remove_personas (FolksPersonaStore* base)
{
	FolksMaybeBool result;
	FolksBackendsBlueZPersonaStore* self;
#line 147 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 147 "../backends/bluez/bluez-persona-store.vala"
	result = FOLKS_MAYBE_BOOL_FALSE;
#line 147 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5230 "bluez-persona-store.c"
}

static gboolean
folks_backends_blue_z_persona_store_real_get_is_prepared (FolksPersonaStore* base)
{
	gboolean result;
	FolksBackendsBlueZPersonaStore* self;
#line 159 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 159 "../backends/bluez/bluez-persona-store.vala"
	result = self->priv->_is_prepared;
#line 159 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5244 "bluez-persona-store.c"
}

static gboolean
folks_backends_blue_z_persona_store_real_get_is_quiescent (FolksPersonaStore* base)
{
	gboolean result;
	FolksBackendsBlueZPersonaStore* self;
#line 171 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 171 "../backends/bluez/bluez-persona-store.vala"
	result = self->priv->_is_quiescent;
#line 171 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5258 "bluez-persona-store.c"
}

static gchar**
folks_backends_blue_z_persona_store_real_get_always_writeable_properties (FolksPersonaStore* base,
                                                                          gint* result_length1)
{
	gchar** result;
	FolksBackendsBlueZPersonaStore* self;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 181 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 181 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = folks_backends_blue_z_persona_store__always_writeable_properties;
#line 181 "../backends/bluez/bluez-persona-store.vala"
	_tmp0__length1 = folks_backends_blue_z_persona_store__always_writeable_properties_length1;
#line 181 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = _tmp0_;
#line 181 "../backends/bluez/bluez-persona-store.vala"
	_tmp1__length1 = _tmp0__length1;
#line 181 "../backends/bluez/bluez-persona-store.vala"
	if (result_length1) {
#line 181 "../backends/bluez/bluez-persona-store.vala"
		*result_length1 = _tmp1__length1;
#line 5285 "bluez-persona-store.c"
	}
#line 181 "../backends/bluez/bluez-persona-store.vala"
	result = _tmp1_;
#line 181 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5291 "bluez-persona-store.c"
}

static GeeMap*
folks_backends_blue_z_persona_store_real_get_personas (FolksPersonaStore* base)
{
	GeeMap* result;
	FolksBackendsBlueZPersonaStore* self;
	GeeMap* _tmp0_;
#line 191 "../backends/bluez/bluez-persona-store.vala"
	self = (FolksBackendsBlueZPersonaStore*) base;
#line 191 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = self->priv->_personas_ro;
#line 191 "../backends/bluez/bluez-persona-store.vala"
	result = _tmp0_;
#line 191 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5308 "bluez-persona-store.c"
}

const gchar*
folks_backends_blue_z_persona_store_get_display_name (FolksBackendsBlueZPersonaStore* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 203 "../backends/bluez/bluez-persona-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 203 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = self->priv->_display_name;
#line 203 "../backends/bluez/bluez-persona-store.vala"
	result = _tmp0_;
#line 203 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5324 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_set_display_name (FolksBackendsBlueZPersonaStore* self,
                                                      const gchar* value)
{
	gchar* _tmp0_;
#line 204 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 204 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = g_strdup (value);
#line 204 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (self->priv->_display_name);
#line 204 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_display_name = _tmp0_;
#line 204 "../backends/bluez/bluez-persona-store.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_DISPLAY_NAME_PROPERTY]);
#line 5342 "bluez-persona-store.c"
}

const gchar*
folks_backends_blue_z_persona_store_get_object_path (FolksBackendsBlueZPersonaStore* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 217 "../backends/bluez/bluez-persona-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 217 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = self->priv->_object_path;
#line 217 "../backends/bluez/bluez-persona-store.vala"
	result = _tmp0_;
#line 217 "../backends/bluez/bluez-persona-store.vala"
	return result;
#line 5358 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_set_object_path (FolksBackendsBlueZPersonaStore* self,
                                                     const gchar* value)
{
	gchar* _tmp0_;
#line 218 "../backends/bluez/bluez-persona-store.vala"
	g_return_if_fail (self != NULL);
#line 218 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = g_strdup (value);
#line 218 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (self->priv->_object_path);
#line 218 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_object_path = _tmp0_;
#line 218 "../backends/bluez/bluez-persona-store.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_OBJECT_PATH_PROPERTY]);
#line 5376 "bluez-persona-store.c"
}

static GObject *
folks_backends_blue_z_persona_store_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FolksBackendsBlueZPersonaStore * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeMap* _tmp2_;
	GeeMap* _tmp3_;
#line 246 "../backends/bluez/bluez-persona-store.vala"
	parent_class = G_OBJECT_CLASS (folks_backends_blue_z_persona_store_parent_class);
#line 246 "../backends/bluez/bluez-persona-store.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 246 "../backends/bluez/bluez-persona-store.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA_STORE, FolksBackendsBlueZPersonaStore);
#line 248 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 248 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (self->priv->_personas);
#line 248 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_personas = _tmp0_;
#line 249 "../backends/bluez/bluez-persona-store.vala"
	_tmp1_ = self->priv->_personas;
#line 249 "../backends/bluez/bluez-persona-store.vala"
	_tmp2_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp1_);
#line 249 "../backends/bluez/bluez-persona-store.vala"
	_tmp3_ = _tmp2_;
#line 249 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (self->priv->_personas_ro);
#line 249 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_personas_ro = _tmp3_;
#line 246 "../backends/bluez/bluez-persona-store.vala"
	return obj;
#line 5415 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_class_init (FolksBackendsBlueZPersonaStoreClass * klass,
                                                gpointer klass_data)
{
	gchar** _tmp0_;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	folks_backends_blue_z_persona_store_parent_class = g_type_class_peek_parent (klass);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_type_class_adjust_private_offset (klass, &FolksBackendsBlueZPersonaStore_private_offset);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	((FolksPersonaStoreClass *) klass)->prepare = (void (*) (FolksPersonaStore*, GAsyncReadyCallback, gpointer)) folks_backends_blue_z_persona_store_real_prepare;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	((FolksPersonaStoreClass *) klass)->prepare_finish = (void (*) (FolksPersonaStore*, GAsyncResult*, GError**)) folks_backends_blue_z_persona_store_prepare_finish;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	((FolksPersonaStoreClass *) klass)->remove_persona = (void (*) (FolksPersonaStore*, FolksPersona*, GAsyncReadyCallback, gpointer)) folks_backends_blue_z_persona_store_real_remove_persona;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	((FolksPersonaStoreClass *) klass)->remove_persona_finish = (void (*) (FolksPersonaStore*, GAsyncResult*, GError**)) folks_backends_blue_z_persona_store_remove_persona_finish;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	((FolksPersonaStoreClass *) klass)->add_persona_from_details = (void (*) (FolksPersonaStore*, GHashTable*, GAsyncReadyCallback, gpointer)) folks_backends_blue_z_persona_store_real_add_persona_from_details;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	((FolksPersonaStoreClass *) klass)->add_persona_from_details_finish = (FolksPersona* (*) (FolksPersonaStore*, GAsyncResult*, GError**)) folks_backends_blue_z_persona_store_add_persona_from_details_finish;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	FOLKS_PERSONA_STORE_CLASS (klass)->get_type_id = (const gchar* (*) (FolksPersonaStore*)) folks_backends_blue_z_persona_store_real_get_type_id;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	FOLKS_PERSONA_STORE_CLASS (klass)->get_can_add_personas = (FolksMaybeBool (*) (FolksPersonaStore*)) folks_backends_blue_z_persona_store_real_get_can_add_personas;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	FOLKS_PERSONA_STORE_CLASS (klass)->get_can_alias_personas = (FolksMaybeBool (*) (FolksPersonaStore*)) folks_backends_blue_z_persona_store_real_get_can_alias_personas;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	FOLKS_PERSONA_STORE_CLASS (klass)->get_can_group_personas = (FolksMaybeBool (*) (FolksPersonaStore*)) folks_backends_blue_z_persona_store_real_get_can_group_personas;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	FOLKS_PERSONA_STORE_CLASS (klass)->get_can_remove_personas = (FolksMaybeBool (*) (FolksPersonaStore*)) folks_backends_blue_z_persona_store_real_get_can_remove_personas;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	FOLKS_PERSONA_STORE_CLASS (klass)->get_is_prepared = (gboolean (*) (FolksPersonaStore*)) folks_backends_blue_z_persona_store_real_get_is_prepared;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	FOLKS_PERSONA_STORE_CLASS (klass)->get_is_quiescent = (gboolean (*) (FolksPersonaStore*)) folks_backends_blue_z_persona_store_real_get_is_quiescent;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	FOLKS_PERSONA_STORE_CLASS (klass)->get_always_writeable_properties = (gchar** (*) (FolksPersonaStore*, gint*)) folks_backends_blue_z_persona_store_real_get_always_writeable_properties;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	FOLKS_PERSONA_STORE_CLASS (klass)->get_personas = (GeeMap* (*) (FolksPersonaStore*)) folks_backends_blue_z_persona_store_real_get_personas;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folks_backends_blue_z_persona_store_get_property;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_folks_backends_blue_z_persona_store_set_property;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	G_OBJECT_CLASS (klass)->constructor = folks_backends_blue_z_persona_store_constructor;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_backends_blue_z_persona_store_finalize;
#line 5465 "bluez-persona-store.c"
	/**
	   * {@inheritDoc}
	   *
	   * @since 0.9.6
	   */
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_TYPE_ID_PROPERTY, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_TYPE_ID_PROPERTY] = g_param_spec_string ("type-id", "type-id", "type-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5473 "bluez-persona-store.c"
	/**
	   * Whether this PersonaStore can add {@link Folks.Persona}s.
	   *
	   * See {@link Folks.PersonaStore.can_add_personas}.
	   *
	   * @since 0.9.6
	   */
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_ADD_PERSONAS_PROPERTY, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_ADD_PERSONAS_PROPERTY] = g_param_spec_enum ("can-add-personas", "can-add-personas", "can-add-personas", FOLKS_TYPE_MAYBE_BOOL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5483 "bluez-persona-store.c"
	/**
	   * Whether this PersonaStore can set the alias of {@link Folks.Persona}s.
	   *
	   * See {@link Folks.PersonaStore.can_alias_personas}.
	   *
	   * @since 0.9.6
	   */
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_ALIAS_PERSONAS_PROPERTY, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_ALIAS_PERSONAS_PROPERTY] = g_param_spec_enum ("can-alias-personas", "can-alias-personas", "can-alias-personas", FOLKS_TYPE_MAYBE_BOOL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5493 "bluez-persona-store.c"
	/**
	   * Whether this PersonaStore can set the groups of {@link Folks.Persona}s.
	   *
	   * See {@link Folks.PersonaStore.can_group_personas}.
	   *
	   * @since 0.9.6
	   */
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_GROUP_PERSONAS_PROPERTY, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_GROUP_PERSONAS_PROPERTY] = g_param_spec_enum ("can-group-personas", "can-group-personas", "can-group-personas", FOLKS_TYPE_MAYBE_BOOL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5503 "bluez-persona-store.c"
	/**
	   * Whether this PersonaStore can remove {@link Folks.Persona}s.
	   *
	   * See {@link Folks.PersonaStore.can_remove_personas}.
	   *
	   * @since 0.9.6
	   */
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_REMOVE_PERSONAS_PROPERTY, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_REMOVE_PERSONAS_PROPERTY] = g_param_spec_enum ("can-remove-personas", "can-remove-personas", "can-remove-personas", FOLKS_TYPE_MAYBE_BOOL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5513 "bluez-persona-store.c"
	/**
	   * Whether this PersonaStore has been prepared.
	   *
	   * See {@link Folks.PersonaStore.is_prepared}.
	   *
	   * @since 0.9.6
	   */
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_IS_PREPARED_PROPERTY, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_IS_PREPARED_PROPERTY] = g_param_spec_boolean ("is-prepared", "is-prepared", "is-prepared", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5523 "bluez-persona-store.c"
	/**
	   * Whether this PersonaStore has reached a quiescent state.
	   *
	   * See {@link Folks.PersonaStore.is_quiescent}.
	   *
	   * @since 0.9.6
	   */
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_IS_QUIESCENT_PROPERTY, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_IS_QUIESCENT_PROPERTY] = g_param_spec_boolean ("is-quiescent", "is-quiescent", "is-quiescent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5533 "bluez-persona-store.c"
	/**
	   * {@inheritDoc}
	   *
	   * @since 0.9.6
	   */
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_ALWAYS_WRITEABLE_PROPERTIES_PROPERTY, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_ALWAYS_WRITEABLE_PROPERTIES_PROPERTY] = g_param_spec_boxed ("always-writeable-properties", "always-writeable-properties", "always-writeable-properties", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5541 "bluez-persona-store.c"
	/**
	   * {@inheritDoc}
	   *
	   * @since 0.9.6
	   */
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_PERSONAS_PROPERTY, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_PERSONAS_PROPERTY] = g_param_spec_object ("personas", "personas", "personas", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5549 "bluez-persona-store.c"
	/**
	   * {@inheritDoc}
	   *
	   * @since 0.9.6
	   */
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_DISPLAY_NAME_PROPERTY, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 5557 "bluez-persona-store.c"
	/**
	   * Path of the D-Bus object backing this {@link PersonaStore}.
	   *
	   * This is the path of the BlueZ device object on D-Bus which provides the
	   * contacts in this store.
	   *
	   * @since 0.9.6
	   */
#line 59 "../backends/bluez/bluez-persona-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_OBJECT_PATH_PROPERTY, folks_backends_blue_z_persona_store_properties[FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_OBJECT_PATH_PROPERTY] = g_param_spec_string ("object-path", "object-path", "object-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 67 "../backends/bluez/bluez-persona-store.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 67 "../backends/bluez/bluez-persona-store.vala"
	folks_backends_blue_z_persona_store__always_writeable_properties = _tmp0_;
#line 67 "../backends/bluez/bluez-persona-store.vala"
	folks_backends_blue_z_persona_store__always_writeable_properties_length1 = 0;
#line 67 "../backends/bluez/bluez-persona-store.vala"
	_folks_backends_blue_z_persona_store__always_writeable_properties_size_ = folks_backends_blue_z_persona_store__always_writeable_properties_length1;
#line 5576 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_instance_init (FolksBackendsBlueZPersonaStore * self,
                                                   gpointer klass)
{
#line 59 "../backends/bluez/bluez-persona-store.vala"
	self->priv = folks_backends_blue_z_persona_store_get_instance_private (self);
#line 63 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_is_prepared = FALSE;
#line 64 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_prepare_pending = FALSE;
#line 65 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_is_quiescent = FALSE;
#line 75 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_update_contacts_cancellable = NULL;
#line 77 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_update_contacts_id = (guint) 0;
#line 78 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_photos_up_to_date = TRUE;
#line 81 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_update_contacts_n = (guint) 0;
#line 83 "../backends/bluez/bluez-persona-store.vala"
	self->priv->_update_contacts_failures = (guint) 0;
#line 5601 "bluez-persona-store.c"
}

static void
folks_backends_blue_z_persona_store_finalize (GObject * obj)
{
	FolksBackendsBlueZPersonaStore * self;
#line 59 "../backends/bluez/bluez-persona-store.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA_STORE, FolksBackendsBlueZPersonaStore);
#line 61 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (self->priv->_personas);
#line 62 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (self->priv->_personas_ro);
#line 69 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (self->priv->_obex_client);
#line 70 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (self->priv->_object_path);
#line 71 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (self->priv->_device);
#line 72 "../backends/bluez/bluez-persona-store.vala"
	_g_free0 (self->priv->_display_name);
#line 75 "../backends/bluez/bluez-persona-store.vala"
	_g_object_unref0 (self->priv->_update_contacts_cancellable);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	G_OBJECT_CLASS (folks_backends_blue_z_persona_store_parent_class)->finalize (obj);
#line 5626 "bluez-persona-store.c"
}

/**
 * A persona store which is associated with a single BlueZ PBAP server (i.e.
 * one {@link PersonaStore} per device). It will create a {@link Persona} for
 * each contact on the device.
 *
 * Since large contact lists can take a long time to download in full (on the
 * order of 1s per 10 contacts), contacts are downloaded in two phases:
 * # Phase 1 downloads all non-PHOTO data. This is very fast (on the order of
 * 1s per 400 contacts)
 * # Phase 2 downloads all PHOTO data for those contacts. This is slow, but
 * happens later, in the background.
 *
 * Subsequent download attempts happen on an exponentially increasing interval,
 * up to a limit (once this limit is reached, updates occur on a regular
 * interval; the linear region). Download attempts repeat indefinitely unless a
 * certain number of consecutive attempts end in failure. See the documentation
 * for {@link _schedule_update_contacts} for details.
 *
 * @since 0.9.6
 */
static GType
folks_backends_blue_z_persona_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksBackendsBlueZPersonaStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_backends_blue_z_persona_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksBackendsBlueZPersonaStore), 0, (GInstanceInitFunc) folks_backends_blue_z_persona_store_instance_init, NULL };
	GType folks_backends_blue_z_persona_store_type_id;
	folks_backends_blue_z_persona_store_type_id = g_type_register_static (FOLKS_TYPE_PERSONA_STORE, "FolksBackendsBlueZPersonaStore", &g_define_type_info, 0);
	FolksBackendsBlueZPersonaStore_private_offset = g_type_add_instance_private (folks_backends_blue_z_persona_store_type_id, sizeof (FolksBackendsBlueZPersonaStorePrivate));
	return folks_backends_blue_z_persona_store_type_id;
}

GType
folks_backends_blue_z_persona_store_get_type (void)
{
	static volatile gsize folks_backends_blue_z_persona_store_type_id__once = 0;
	if (g_once_init_enter (&folks_backends_blue_z_persona_store_type_id__once)) {
		GType folks_backends_blue_z_persona_store_type_id;
		folks_backends_blue_z_persona_store_type_id = folks_backends_blue_z_persona_store_get_type_once ();
		g_once_init_leave (&folks_backends_blue_z_persona_store_type_id__once, folks_backends_blue_z_persona_store_type_id);
	}
	return folks_backends_blue_z_persona_store_type_id__once;
}

static void
_vala_folks_backends_blue_z_persona_store_get_property (GObject * object,
                                                        guint property_id,
                                                        GValue * value,
                                                        GParamSpec * pspec)
{
	FolksBackendsBlueZPersonaStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA_STORE, FolksBackendsBlueZPersonaStore);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	switch (property_id) {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_TYPE_ID_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		g_value_set_string (value, folks_persona_store_get_type_id ((FolksPersonaStore*) self));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_ADD_PERSONAS_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		g_value_set_enum (value, folks_persona_store_get_can_add_personas ((FolksPersonaStore*) self));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_ALIAS_PERSONAS_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		g_value_set_enum (value, folks_persona_store_get_can_alias_personas ((FolksPersonaStore*) self));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_GROUP_PERSONAS_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		g_value_set_enum (value, folks_persona_store_get_can_group_personas ((FolksPersonaStore*) self));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_CAN_REMOVE_PERSONAS_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		g_value_set_enum (value, folks_persona_store_get_can_remove_personas ((FolksPersonaStore*) self));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_IS_PREPARED_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		g_value_set_boolean (value, folks_persona_store_get_is_prepared ((FolksPersonaStore*) self));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_IS_QUIESCENT_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		g_value_set_boolean (value, folks_persona_store_get_is_quiescent ((FolksPersonaStore*) self));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_ALWAYS_WRITEABLE_PROPERTIES_PROPERTY:
#line 5725 "bluez-persona-store.c"
		{
			int length;
#line 59 "../backends/bluez/bluez-persona-store.vala"
			g_value_set_boxed (value, folks_persona_store_get_always_writeable_properties ((FolksPersonaStore*) self, &length));
#line 5730 "bluez-persona-store.c"
		}
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_PERSONAS_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		g_value_set_object (value, folks_persona_store_get_personas ((FolksPersonaStore*) self));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_DISPLAY_NAME_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		g_value_set_string (value, folks_backends_blue_z_persona_store_get_display_name (self));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_OBJECT_PATH_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		g_value_set_string (value, folks_backends_blue_z_persona_store_get_object_path (self));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 5752 "bluez-persona-store.c"
		default:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 5758 "bluez-persona-store.c"
	}
}

static void
_vala_folks_backends_blue_z_persona_store_set_property (GObject * object,
                                                        guint property_id,
                                                        const GValue * value,
                                                        GParamSpec * pspec)
{
	FolksBackendsBlueZPersonaStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_BACKENDS_BLUE_Z_TYPE_PERSONA_STORE, FolksBackendsBlueZPersonaStore);
#line 59 "../backends/bluez/bluez-persona-store.vala"
	switch (property_id) {
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_DISPLAY_NAME_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		folks_backends_blue_z_persona_store_set_display_name (self, g_value_get_string (value));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 59 "../backends/bluez/bluez-persona-store.vala"
		case FOLKS_BACKENDS_BLUE_Z_PERSONA_STORE_OBJECT_PATH_PROPERTY:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		folks_backends_blue_z_persona_store_set_object_path (self, g_value_get_string (value));
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 5784 "bluez-persona-store.c"
		default:
#line 59 "../backends/bluez/bluez-persona-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 59 "../backends/bluez/bluez-persona-store.vala"
		break;
#line 5790 "bluez-persona-store.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

