/* backend-store.c generated by valac 0.56.17, the Vala compiler
 * generated from backend-store.vala, do not modify */

/*
 * Copyright (C) 2008 Nokia Corporation.
 * Copyright (C) 2008 Zeeshan Ali (Khattak) <zeeshanak@gnome.org>.
 * Copyright (C) 2010 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Zeeshan Ali (Khattak) <zeeshanak@gnome.org>
 *          Travis Reitter <travis.reitter@collabora.co.uk>
 *
 * This file was originally part of Rygel.
 */

#include "folks/folks.h"
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "folks/small-set.h"
#include <gio/gio.h>
#include <gmodule.h>
#include "folks-internal.h"
#include "config.h"
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FOLKS_BACKEND_STORE_0_PROPERTY,
	FOLKS_BACKEND_STORE_ENABLED_BACKENDS_PROPERTY,
	FOLKS_BACKEND_STORE_IS_PREPARED_PROPERTY,
	FOLKS_BACKEND_STORE_NUM_PROPERTIES
};
static GParamSpec* folks_backend_store_properties[FOLKS_BACKEND_STORE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef void (*FolksBackendStoreModuleFinalizeFunc) (FolksBackendStore* store);
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _folks_internal_profile_block_free0(var) ((var == NULL) ? NULL : (var = (folks_internal_profile_block_free (var), NULL)))
typedef struct _FolksBackendStorePrepareData FolksBackendStorePrepareData;
typedef struct _Block1Data Block1Data;
typedef struct _FolksBackendStoreLoadBackendsData FolksBackendStoreLoadBackendsData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _FolksBackendStoreBackendLoadIfNeededData FolksBackendStoreBackendLoadIfNeededData;
typedef struct _FolksBackendStoreBackendUnloadIfNeededData FolksBackendStoreBackendUnloadIfNeededData;
typedef struct _FolksBackendStoreEnableBackendData FolksBackendStoreEnableBackendData;
typedef struct _FolksBackendStoreDisableBackendData FolksBackendStoreDisableBackendData;
typedef struct _FolksBackendStoreGetModulesFromDirData FolksBackendStoreGetModulesFromDirData;
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))
typedef void (*FolksBackendStoreModuleInitFunc) (FolksBackendStore* store);
typedef struct _FolksBackendStoreGetFileInfoData FolksBackendStoreGetFileInfoData;
typedef struct _FolksBackendStoreLoadDisabledBackendNamesData FolksBackendStoreLoadDisabledBackendNamesData;
typedef struct _FolksBackendStoreSaveKeyFileData FolksBackendStoreSaveKeyFileData;
enum  {
	FOLKS_BACKEND_STORE_BACKEND_AVAILABLE_SIGNAL,
	FOLKS_BACKEND_STORE_NUM_SIGNALS
};
static guint folks_backend_store_signals[FOLKS_BACKEND_STORE_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FolksBackendStorePrivate {
	GeeHashMap* _backend_hash;
	FolksSmallSet* _backends_allowed;
	FolksSmallSet* _backends_disabled;
	GeeHashMap* _prepared_backends;
	GeeMap* _prepared_backends_ro;
	GFile* _config_file;
	GKeyFile* _backends_key_file;
	GeeHashMap* _modules;
	gboolean _is_prepared;
	FolksDebug* _debug;
};

struct _FolksBackendStorePrepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendStore* self;
	FolksInternalProfileBlock* profiling;
	FolksInternalProfileBlock* _tmp0_;
	FolksInternalProfileBlock* _tmp1_;
};

struct _Block1Data {
	int _ref_count_;
	FolksBackendStore* self;
	gint backends_remaining;
	gpointer _async_data_;
};

struct _FolksBackendStoreLoadBackendsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendStore* self;
	Block1Data* _data1_;
	FolksInternalProfileBlock* profiling;
	FolksInternalProfileBlock* _tmp0_;
	GeeIterator* _backend_existing_it;
	GeeHashMap* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeIterator* _tmp5_;
	GeeIterator* _tmp6_;
	GeeIterator* _tmp7_;
	FolksBackend* backend_existing;
	GeeIterator* _tmp8_;
	gpointer _tmp9_;
	FolksBackend* _tmp10_;
	gchar* _path;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* path;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	GeeHashMap* modules;
	GeeHashMap* _tmp19_;
	gchar** path_split;
	const gchar* _tmp20_;
	gchar** _tmp21_;
	gchar** _tmp22_;
	gint path_split_length1;
	gint _path_split_size_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	gchar** subpath_collection;
	gint subpath_collection_length1;
	gint _subpath_collection_size_;
	gint subpath_it;
	const gchar* subpath;
	GFile* file;
	const gchar* _tmp24_;
	GFile* _tmp25_;
	gboolean is_file;
	gboolean is_dir;
	GFile* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	GeeHashMap* _tmp29_;
	const gchar* _tmp30_;
	GFile* _tmp31_;
	GeeHashMap* cur_modules;
	GFile* _tmp32_;
	GeeHashMap* _tmp33_;
	GeeHashMap* _tmp34_;
	GeeIterator* _entry_it;
	GeeHashMap* _tmp35_;
	GeeSet* _tmp36_;
	GeeSet* _tmp37_;
	GeeSet* _tmp38_;
	GeeIterator* _tmp39_;
	GeeIterator* _tmp40_;
	GeeIterator* _tmp41_;
	GeeMapEntry* entry;
	GeeIterator* _tmp42_;
	gpointer _tmp43_;
	GeeHashMap* _tmp44_;
	GeeMapEntry* _tmp45_;
	gconstpointer _tmp46_;
	gconstpointer _tmp47_;
	GeeMapEntry* _tmp48_;
	gconstpointer _tmp49_;
	gconstpointer _tmp50_;
	const gchar* _tmp51_;
	GeeIterator* _module_it;
	GeeHashMap* _tmp52_;
	GeeCollection* _tmp53_;
	GeeCollection* _tmp54_;
	GeeCollection* _tmp55_;
	GeeIterator* _tmp56_;
	GeeIterator* _tmp57_;
	GeeIterator* _tmp58_;
	GFile* module;
	GeeIterator* _tmp59_;
	gpointer _tmp60_;
	GFile* _tmp61_;
	GeeIterator* _backend_it;
	GeeHashMap* _tmp62_;
	GeeCollection* _tmp63_;
	GeeCollection* _tmp64_;
	GeeCollection* _tmp65_;
	GeeIterator* _tmp66_;
	GeeIterator* _tmp67_;
	GeeIterator* _tmp68_;
	FolksBackend* backend;
	GeeIterator* _tmp69_;
	gpointer _tmp70_;
	gint _tmp71_;
	FolksBackend* _tmp72_;
	gint _tmp73_;
	FolksInternalProfileBlock* _tmp74_;
};

struct _FolksBackendStoreBackendLoadIfNeededData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendStore* self;
	FolksBackend* backend;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GeeHashMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GeeHashMap* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GError* e;
	GError* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GError* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	GError* _tmp17_;
	const gchar* _tmp18_;
	GError* _inner_error0_;
};

struct _FolksBackendStoreBackendUnloadIfNeededData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendStore* self;
	FolksBackend* backend;
	gboolean result;
	gboolean unloaded;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	FolksBackend* backend_existing;
	GeeHashMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gpointer _tmp5_;
	FolksBackend* _tmp6_;
	FolksBackend* _tmp7_;
	GError* e;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GError* _tmp10_;
	const gchar* _tmp11_;
	GeeHashMap* _tmp12_;
	FolksBackend* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	GError* _inner_error0_;
};

struct _FolksBackendStoreEnableBackendData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendStore* self;
	gchar* name;
	GKeyFile* _tmp0_;
};

struct _FolksBackendStoreDisableBackendData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendStore* self;
	gchar* name;
	GKeyFile* _tmp0_;
};

struct _FolksBackendStoreGetModulesFromDirData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendStore* self;
	GFile* dir;
	GeeHashMap* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* attributes;
	gchar* _tmp2_;
	GList* infos;
	GFileEnumerator* enumerator;
	const gchar* _tmp3_;
	GFileEnumerator* _tmp4_;
	GList* _tmp5_;
	GFileEnumerator* _tmp6_;
	GList* _tmp7_;
	GList* _tmp8_;
	GError* _error_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GeeHashMap* modules_final;
	GeeHashMap* _tmp13_;
	gchar* _path;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	GList* _tmp16_;
	GList* info_collection;
	GList* info_it;
	GFileInfo* _tmp17_;
	GFileInfo* info;
	GFile* file;
	GFileInfo* _tmp18_;
	const gchar* _tmp19_;
	GFile* _tmp20_;
	GFileInfo* _tmp21_;
	GFile* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	GFileInfo* _tmp25_;
	const gchar* _tmp26_;
	GFile* old_file;
	GFile* _tmp27_;
	GFile* _tmp28_;
	GFileInfo* _tmp29_;
	const gchar* _tmp30_;
	GFile* _tmp31_;
	GFileInfo* _tmp32_;
	GFile* _tmp33_;
	const gchar* _tmp34_;
	GFileInfo* _tmp35_;
	GFileInfo* _tmp36_;
	GError* _vala1__error_;
	GFile* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	GFile* _tmp40_;
	gchar* _tmp41_;
	gchar* _tmp42_;
	GError* _tmp43_;
	const gchar* _tmp44_;
	GFileType file_type;
	GFileInfo* _tmp45_;
	const gchar* content_type;
	GFileInfo* _tmp46_;
	const gchar* _tmp47_;
	gchar* mime;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	GeeHashMap* modules;
	GFile* _tmp50_;
	GeeHashMap* _tmp51_;
	GeeHashMap* _tmp52_;
	GeeIterator* _entry_it;
	GeeHashMap* _tmp53_;
	GeeSet* _tmp54_;
	GeeSet* _tmp55_;
	GeeSet* _tmp56_;
	GeeIterator* _tmp57_;
	GeeIterator* _tmp58_;
	GeeIterator* _tmp59_;
	GeeMapEntry* entry;
	GeeIterator* _tmp60_;
	gpointer _tmp61_;
	GeeHashMap* _tmp62_;
	GeeMapEntry* _tmp63_;
	gconstpointer _tmp64_;
	gconstpointer _tmp65_;
	GeeMapEntry* _tmp66_;
	gconstpointer _tmp67_;
	gconstpointer _tmp68_;
	const gchar* _tmp69_;
	gchar* path;
	GFile* _tmp70_;
	gchar* _tmp71_;
	const gchar* _tmp72_;
	GeeHashMap* _tmp73_;
	const gchar* _tmp74_;
	GFile* _tmp75_;
	const gchar* _tmp76_;
	GFile* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	gboolean _tmp80_;
	gboolean _tmp81_;
	gboolean _tmp82_;
	const gchar* _tmp83_;
	const gchar* _tmp84_;
	const gchar* _tmp85_;
	const gchar* _tmp86_;
	GFile* _tmp87_;
	gchar* _tmp88_;
	gchar* _tmp89_;
	const gchar* _tmp90_;
	gchar* _tmp91_;
	gchar* _tmp92_;
	GError* _inner_error0_;
};

struct _FolksBackendStoreGetFileInfoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GFile* file;
	gboolean is_file;
	gboolean is_dir;
	GFileInfo* file_info;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	GFileInfo* _tmp2_;
	GError* _error_;
	GError* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GFileInfo* _tmp8_;
	GFileInfo* _tmp9_;
	GError* _inner_error0_;
};

struct _FolksBackendStoreLoadDisabledBackendNamesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendStore* self;
	gchar* envvar;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar** tokens;
	const gchar* _tmp3_;
	gchar** _tmp4_;
	gchar** _tmp5_;
	gint tokens_length1;
	gint _tokens_size_;
	FolksSmallSet* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar** s_collection;
	gint s_collection_length1;
	gint _s_collection_size_;
	gint s_it;
	const gchar* s;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	FolksSmallSet* _tmp10_;
	const gchar* _tmp11_;
	FolksSmallSet* _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar** _vala1_s_collection;
	gint _vala1_s_collection_length1;
	gint __vala1_s_collection_size_;
	gint _vala1_s_it;
	const gchar* _vala1_s;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar** _vala1_tokens;
	const gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gint _vala1_tokens_length1;
	gint __vala1_tokens_size_;
	FolksSmallSet* _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	gchar** _vala2_s_collection;
	gint _vala2_s_collection_length1;
	gint __vala2_s_collection_size_;
	gint _vala2_s_it;
	const gchar* _vala2_s;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	FolksSmallSet* _tmp25_;
	const gchar* _tmp26_;
	GFile* file;
	const gchar* path;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	GFile* _tmp30_;
	GFile* _tmp31_;
	GFile* _tmp32_;
	GFile* _tmp33_;
	GFile* _tmp34_;
	GFile* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	const gchar* _tmp38_;
	GFile* _tmp39_;
	const gchar* _tmp40_;
	GFile* _tmp41_;
	GFile* _tmp42_;
	GKeyFile* key_file;
	GKeyFile* _tmp43_;
	guint8* contents;
	gint contents_length1;
	gint _contents_size_;
	GFile* _tmp44_;
	guint8* _tmp45_;
	gsize _tmp46_;
	const gchar* contents_s;
	guint8* _tmp47_;
	gint _tmp47__length1;
	const gchar* _tmp48_;
	gint _tmp49_;
	gint _tmp50_;
	GKeyFile* _tmp51_;
	const gchar* _tmp52_;
	const gchar* _tmp53_;
	gint _tmp54_;
	gint _tmp55_;
	GError* e1;
	GError* _tmp56_;
	GFile* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	GError* _tmp60_;
	const gchar* _tmp61_;
	GKeyFile* _tmp62_;
	GError* _inner_error1_;
	GKeyFile* _tmp63_;
	GError* _inner_error0_;
};

struct _FolksBackendStoreSaveKeyFileData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksBackendStore* self;
	gchar* key_file_data;
	GKeyFile* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GFile* _tmp5_;
	guint8* _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	GError* e;
	GFile* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GError* _tmp12_;
	const gchar* _tmp13_;
	GError* _inner_error0_;
};

static gint FolksBackendStore_private_offset;
static gpointer folks_backend_store_parent_class = NULL;
static FolksBackendStore* folks_backend_store__instance;
static FolksBackendStore* folks_backend_store__instance = NULL;
gchar* folks_backend_store_KEY_FILE_GROUP_ALL_OTHERS = NULL;

static void _folks_backend_store_debug_print_status (FolksBackendStore* self,
                                              FolksDebug* debug);
static void __folks_backend_store_debug_print_status_folks_debug_print_status (FolksDebug* _sender,
                                                                        gpointer self);
static FolksBackendStore* folks_backend_store_new (void);
static FolksBackendStore* folks_backend_store_construct (GType object_type);
static void folks_backend_store_prepare_data_free (gpointer _data);
static gboolean folks_backend_store_prepare_co (FolksBackendStorePrepareData* _data_);
static void _folks_backend_store_load_disabled_backend_names (FolksBackendStore* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_);
static void _folks_backend_store_load_disabled_backend_names_finish (FolksBackendStore* self,
                                                              GAsyncResult* _res_);
static void folks_backend_store_prepare_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_);
static void folks_backend_store_load_backends_data_free (gpointer _data);
static gboolean folks_backend_store_load_backends_co (FolksBackendStoreLoadBackendsData* _data_);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void folks_backend_store_load_backends_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void _folks_backend_store_backend_unload_if_needed (FolksBackendStore* self,
                                                    FolksBackend* backend,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
static gboolean _folks_backend_store_backend_unload_if_needed_finish (FolksBackendStore* self,
                                                               GAsyncResult* _res_);
static void _folks_backend_store_get_file_info (GFile* file,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void _folks_backend_store_get_file_info_finish (GAsyncResult* _res_,
                                                gboolean* is_file,
                                                gboolean* is_dir);
static void _folks_backend_store_get_modules_from_dir (FolksBackendStore* self,
                                                GFile* dir,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
static GeeHashMap* _folks_backend_store_get_modules_from_dir_finish (FolksBackendStore* self,
                                                              GAsyncResult* _res_);
static void _folks_backend_store_load_module_from_file (FolksBackendStore* self,
                                                 GFile* file);
static void _folks_backend_store_backend_load_if_needed (FolksBackendStore* self,
                                                  FolksBackend* backend,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static void _folks_backend_store_backend_load_if_needed_finish (FolksBackendStore* self,
                                                         GAsyncResult* _res_);
static void ____lambda66_ (Block1Data* _data1_,
                    GObject* o,
                    GAsyncResult* r);
static void _____lambda66__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void _folks_backend_store_backend_load_if_needed_data_free (gpointer _data);
static gboolean _folks_backend_store_backend_load_if_needed_co (FolksBackendStoreBackendLoadIfNeededData* _data_);
static gboolean _folks_backend_store_backend_is_enabled (FolksBackendStore* self,
                                                  const gchar* name);
static void _folks_backend_store_backend_load_if_needed_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static void _folks_backend_store_backend_unload_if_needed_data_free (gpointer _data);
static gboolean _folks_backend_store_backend_unload_if_needed_co (FolksBackendStoreBackendUnloadIfNeededData* _data_);
static void _folks_backend_store_backend_unload_if_needed_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
VALA_EXTERN void _folks_debug_register_domain (FolksDebug* self,
                                   const gchar* domain);
static void folks_backend_store_enable_backend_data_free (gpointer _data);
static gboolean folks_backend_store_enable_backend_co (FolksBackendStoreEnableBackendData* _data_);
static void _folks_backend_store_save_key_file (FolksBackendStore* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void _folks_backend_store_save_key_file_finish (FolksBackendStore* self,
                                                GAsyncResult* _res_);
static void folks_backend_store_enable_backend_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void folks_backend_store_disable_backend_data_free (gpointer _data);
static gboolean folks_backend_store_disable_backend_co (FolksBackendStoreDisableBackendData* _data_);
static void folks_backend_store_disable_backend_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void _folks_backend_store_get_modules_from_dir_data_free (gpointer _data);
static gboolean _folks_backend_store_get_modules_from_dir_co (FolksBackendStoreGetModulesFromDirData* _data_);
static void _folks_backend_store_get_modules_from_dir_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _folks_backend_store_get_file_info_data_free (gpointer _data);
static gboolean _folks_backend_store_get_file_info_co (FolksBackendStoreGetFileInfoData* _data_);
static void _folks_backend_store_get_file_info_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void _folks_backend_store_load_disabled_backend_names_data_free (gpointer _data);
static gboolean _folks_backend_store_load_disabled_backend_names_co (FolksBackendStoreLoadDisabledBackendNamesData* _data_);
static void _folks_backend_store_load_disabled_backend_names_ready (GObject* source_object,
                                                             GAsyncResult* _res_,
                                                             gpointer _user_data_);
static void _folks_backend_store_save_key_file_data_free (gpointer _data);
static gboolean _folks_backend_store_save_key_file_co (FolksBackendStoreSaveKeyFileData* _data_);
static void _folks_backend_store_save_key_file_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void folks_backend_store_set_enabled_backends (FolksBackendStore* self,
                                               GeeMap* value);
static void folks_backend_store_set_is_prepared (FolksBackendStore* self,
                                          gboolean value);
static GObject * folks_backend_store_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void folks_backend_store_finalize (GObject * obj);
static GType folks_backend_store_get_type_once (void);
static void _vala_folks_backend_store_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_folks_backend_store_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
folks_backend_store_get_instance_private (FolksBackendStore* self)
{
	return G_STRUCT_MEMBER_P (self, FolksBackendStore_private_offset);
}

static void
__folks_backend_store_debug_print_status_folks_debug_print_status (FolksDebug* _sender,
                                                                   gpointer self)
{
#line 187 "../folks/backend-store.vala"
	_folks_backend_store_debug_print_status ((FolksBackendStore*) self, _sender);
#line 737 "backend-store.c"
}

/**
   * Create a new BackendStore.
   */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 132 "../folks/backend-store.vala"
	return self ? g_object_ref (self) : NULL;
#line 748 "backend-store.c"
}

FolksBackendStore*
folks_backend_store_dup (void)
{
	FolksBackendStore* _tmp0_;
	FolksBackendStore* _tmp3_;
	FolksBackendStore* _tmp4_;
	FolksBackendStore* result;
#line 123 "../folks/backend-store.vala"
	_tmp0_ = folks_backend_store__instance;
#line 123 "../folks/backend-store.vala"
	if (_tmp0_ == NULL) {
#line 762 "backend-store.c"
		FolksBackendStore* new_instance = NULL;
		FolksBackendStore* _tmp1_;
		FolksBackendStore* _tmp2_;
#line 126 "../folks/backend-store.vala"
		_tmp1_ = folks_backend_store_new ();
#line 126 "../folks/backend-store.vala"
		new_instance = _tmp1_;
#line 127 "../folks/backend-store.vala"
		_tmp2_ = new_instance;
#line 127 "../folks/backend-store.vala"
		folks_backend_store__instance = _tmp2_;
#line 129 "../folks/backend-store.vala"
		result = new_instance;
#line 129 "../folks/backend-store.vala"
		return result;
#line 778 "backend-store.c"
	}
#line 132 "../folks/backend-store.vala"
	_tmp3_ = folks_backend_store__instance;
#line 132 "../folks/backend-store.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, FOLKS_TYPE_BACKEND_STORE, FolksBackendStore));
#line 132 "../folks/backend-store.vala"
	result = _tmp4_;
#line 132 "../folks/backend-store.vala"
	return result;
#line 788 "backend-store.c"
}

static FolksBackendStore*
folks_backend_store_construct (GType object_type)
{
	FolksBackendStore * self = NULL;
#line 137 "../folks/backend-store.vala"
	self = (FolksBackendStore*) g_object_new (object_type, NULL);
#line 135 "../folks/backend-store.vala"
	return self;
#line 799 "backend-store.c"
}

static FolksBackendStore*
folks_backend_store_new (void)
{
#line 135 "../folks/backend-store.vala"
	return folks_backend_store_construct (FOLKS_TYPE_BACKEND_STORE);
#line 807 "backend-store.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 821 "backend-store.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 825 "backend-store.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 831 "backend-store.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 836 "backend-store.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 842 "backend-store.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 846 "backend-store.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 850 "backend-store.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 854 "backend-store.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 858 "backend-store.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 862 "backend-store.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 877 "backend-store.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 886 "backend-store.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 893 "backend-store.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 899 "backend-store.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 907 "backend-store.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 911 "backend-store.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 917 "backend-store.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 922 "backend-store.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 928 "backend-store.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 932 "backend-store.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 936 "backend-store.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 942 "backend-store.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 948 "backend-store.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 960 "backend-store.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 964 "backend-store.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 968 "backend-store.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 973 "backend-store.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 981 "backend-store.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 999 "backend-store.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 1005 "backend-store.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 1009 "backend-store.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 1017 "backend-store.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 1026 "backend-store.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 1035 "backend-store.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 1041 "backend-store.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 1049 "backend-store.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 1061 "backend-store.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 1067 "backend-store.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 1071 "backend-store.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 1079 "backend-store.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 1090 "backend-store.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 1099 "backend-store.c"
	}
}

static void
_folks_backend_store_debug_print_status (FolksBackendStore* self,
                                         FolksDebug* debug)
{
#line 195 "../folks/backend-store.vala"
	static const char domain[] = FOLKS_DEBUG_STATUS_LOG_DOMAIN;
#line 196 "../folks/backend-store.vala"
	static const GLogLevelFlags level = G_LOG_LEVEL_INFO;
#line 1111 "backend-store.c"
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 193 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 193 "../folks/backend-store.vala"
	g_return_if_fail (debug != NULL);
#line 198 "../folks/backend-store.vala"
	folks_debug_print_heading (debug, domain, level, "BackendStore (%p)", self);
#line 199 "../folks/backend-store.vala"
	_tmp0_ = self->priv->_backend_hash;
#line 199 "../folks/backend-store.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 199 "../folks/backend-store.vala"
	_tmp2_ = _tmp1_;
#line 199 "../folks/backend-store.vala"
	folks_debug_print_line (debug, domain, level, "%u Backends:", (guint) _tmp2_);
#line 202 "../folks/backend-store.vala"
	folks_debug_indent (debug);
#line 1131 "backend-store.c"
	{
		GeeIterator* _backend_it = NULL;
		GeeHashMap* _tmp3_;
		GeeCollection* _tmp4_;
		GeeCollection* _tmp5_;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_;
		GeeIterator* _tmp8_;
#line 204 "../folks/backend-store.vala"
		_tmp3_ = self->priv->_backend_hash;
#line 204 "../folks/backend-store.vala"
		_tmp4_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp3_);
#line 204 "../folks/backend-store.vala"
		_tmp5_ = _tmp4_;
#line 204 "../folks/backend-store.vala"
		_tmp6_ = _tmp5_;
#line 204 "../folks/backend-store.vala"
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 204 "../folks/backend-store.vala"
		_tmp8_ = _tmp7_;
#line 204 "../folks/backend-store.vala"
		_g_object_unref0 (_tmp6_);
#line 204 "../folks/backend-store.vala"
		_backend_it = _tmp8_;
#line 204 "../folks/backend-store.vala"
		while (TRUE) {
#line 1158 "backend-store.c"
			GeeIterator* _tmp9_;
			FolksBackend* backend = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			FolksBackend* _tmp12_;
			const gchar* _tmp13_ = NULL;
			FolksBackend* _tmp14_;
			gboolean _tmp15_;
			gboolean _tmp16_;
			const gchar* _tmp17_ = NULL;
			FolksBackend* _tmp18_;
			gboolean _tmp19_;
			gboolean _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			FolksBackend* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			FolksBackend* _tmp26_;
			GeeMap* _tmp27_;
			GeeMap* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
#line 204 "../folks/backend-store.vala"
			_tmp9_ = _backend_it;
#line 204 "../folks/backend-store.vala"
			if (!gee_iterator_next (_tmp9_)) {
#line 204 "../folks/backend-store.vala"
				break;
#line 1188 "backend-store.c"
			}
#line 204 "../folks/backend-store.vala"
			_tmp10_ = _backend_it;
#line 204 "../folks/backend-store.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 204 "../folks/backend-store.vala"
			backend = (FolksBackend*) _tmp11_;
#line 206 "../folks/backend-store.vala"
			_tmp12_ = backend;
#line 206 "../folks/backend-store.vala"
			folks_debug_print_heading (debug, domain, level, "Backend (%p)", _tmp12_);
#line 210 "../folks/backend-store.vala"
			_tmp14_ = backend;
#line 210 "../folks/backend-store.vala"
			_tmp15_ = folks_backend_get_is_prepared (_tmp14_);
#line 210 "../folks/backend-store.vala"
			_tmp16_ = _tmp15_;
#line 210 "../folks/backend-store.vala"
			if (_tmp16_) {
#line 210 "../folks/backend-store.vala"
				_tmp13_ = "yes";
#line 1210 "backend-store.c"
			} else {
#line 210 "../folks/backend-store.vala"
				_tmp13_ = "no";
#line 1214 "backend-store.c"
			}
#line 211 "../folks/backend-store.vala"
			_tmp18_ = backend;
#line 211 "../folks/backend-store.vala"
			_tmp19_ = folks_backend_get_is_quiescent (_tmp18_);
#line 211 "../folks/backend-store.vala"
			_tmp20_ = _tmp19_;
#line 211 "../folks/backend-store.vala"
			if (_tmp20_) {
#line 211 "../folks/backend-store.vala"
				_tmp17_ = "yes";
#line 1226 "backend-store.c"
			} else {
#line 211 "../folks/backend-store.vala"
				_tmp17_ = "no";
#line 1230 "backend-store.c"
			}
#line 207 "../folks/backend-store.vala"
			_tmp21_ = g_strdup_printf ("%u", ((GObject*) self)->ref_count);
#line 207 "../folks/backend-store.vala"
			_tmp22_ = _tmp21_;
#line 207 "../folks/backend-store.vala"
			_tmp23_ = backend;
#line 207 "../folks/backend-store.vala"
			_tmp24_ = folks_backend_get_name (_tmp23_);
#line 207 "../folks/backend-store.vala"
			_tmp25_ = _tmp24_;
#line 207 "../folks/backend-store.vala"
			folks_debug_print_key_value_pairs (debug, domain, level, "Ref. count", _tmp22_, "Name", _tmp25_, "Prepared?", _tmp13_, "Quiescent?", _tmp17_, NULL);
#line 207 "../folks/backend-store.vala"
			_g_free0 (_tmp22_);
#line 213 "../folks/backend-store.vala"
			_tmp26_ = backend;
#line 213 "../folks/backend-store.vala"
			_tmp27_ = folks_backend_get_persona_stores (_tmp26_);
#line 213 "../folks/backend-store.vala"
			_tmp28_ = _tmp27_;
#line 213 "../folks/backend-store.vala"
			_tmp29_ = gee_map_get_size (_tmp28_);
#line 213 "../folks/backend-store.vala"
			_tmp30_ = _tmp29_;
#line 213 "../folks/backend-store.vala"
			folks_debug_print_line (debug, domain, level, "%u PersonaStores:", (guint) _tmp30_);
#line 216 "../folks/backend-store.vala"
			folks_debug_indent (debug);
#line 1260 "backend-store.c"
			{
				GeeIterator* _persona_store_it = NULL;
				FolksBackend* _tmp31_;
				GeeMap* _tmp32_;
				GeeMap* _tmp33_;
				GeeCollection* _tmp34_;
				GeeCollection* _tmp35_;
				GeeCollection* _tmp36_;
				GeeIterator* _tmp37_;
				GeeIterator* _tmp38_;
#line 218 "../folks/backend-store.vala"
				_tmp31_ = backend;
#line 218 "../folks/backend-store.vala"
				_tmp32_ = folks_backend_get_persona_stores (_tmp31_);
#line 218 "../folks/backend-store.vala"
				_tmp33_ = _tmp32_;
#line 218 "../folks/backend-store.vala"
				_tmp34_ = gee_map_get_values (_tmp33_);
#line 218 "../folks/backend-store.vala"
				_tmp35_ = _tmp34_;
#line 218 "../folks/backend-store.vala"
				_tmp36_ = _tmp35_;
#line 218 "../folks/backend-store.vala"
				_tmp37_ = gee_iterable_iterator ((GeeIterable*) _tmp36_);
#line 218 "../folks/backend-store.vala"
				_tmp38_ = _tmp37_;
#line 218 "../folks/backend-store.vala"
				_g_object_unref0 (_tmp36_);
#line 218 "../folks/backend-store.vala"
				_persona_store_it = _tmp38_;
#line 218 "../folks/backend-store.vala"
				while (TRUE) {
#line 1293 "backend-store.c"
					GeeIterator* _tmp39_;
					FolksPersonaStore* persona_store = NULL;
					GeeIterator* _tmp40_;
					gpointer _tmp41_;
					gchar* trust_level = NULL;
					FolksPersonaStore* _tmp42_;
					FolksPersonaStoreTrust _tmp43_;
					FolksPersonaStoreTrust _tmp44_;
					gchar* writeable_props = NULL;
					FolksPersonaStore* _tmp48_;
					gchar** _tmp49_;
					gint _tmp49__length1;
					gint _tmp50_ = 0;
					gchar** _tmp51_;
					gint _tmp51__length1;
					gchar* _tmp52_;
					FolksPersonaStore* _tmp53_;
					const gchar* _tmp54_ = NULL;
					FolksPersonaStore* _tmp55_;
					gboolean _tmp56_;
					gboolean _tmp57_;
					const gchar* _tmp58_ = NULL;
					FolksPersonaStore* _tmp59_;
					gboolean _tmp60_;
					gboolean _tmp61_;
					const gchar* _tmp62_ = NULL;
					FolksPersonaStore* _tmp63_;
					gboolean _tmp64_;
					gboolean _tmp65_;
					gchar* _tmp66_;
					gchar* _tmp67_;
					FolksPersonaStore* _tmp68_;
					const gchar* _tmp69_;
					const gchar* _tmp70_;
					const gchar* _tmp71_;
					const gchar* _tmp72_;
					FolksPersonaStore* _tmp73_;
					GeeMap* _tmp74_;
					GeeMap* _tmp75_;
					gint _tmp76_;
					gint _tmp77_;
					gchar* _tmp78_;
					gchar* _tmp79_;
#line 218 "../folks/backend-store.vala"
					_tmp39_ = _persona_store_it;
#line 218 "../folks/backend-store.vala"
					if (!gee_iterator_next (_tmp39_)) {
#line 218 "../folks/backend-store.vala"
						break;
#line 1343 "backend-store.c"
					}
#line 218 "../folks/backend-store.vala"
					_tmp40_ = _persona_store_it;
#line 218 "../folks/backend-store.vala"
					_tmp41_ = gee_iterator_get (_tmp40_);
#line 218 "../folks/backend-store.vala"
					persona_store = (FolksPersonaStore*) _tmp41_;
#line 220 "../folks/backend-store.vala"
					trust_level = NULL;
#line 222 "../folks/backend-store.vala"
					_tmp42_ = persona_store;
#line 222 "../folks/backend-store.vala"
					_tmp43_ = folks_persona_store_get_trust_level (_tmp42_);
#line 222 "../folks/backend-store.vala"
					_tmp44_ = _tmp43_;
#line 222 "../folks/backend-store.vala"
					switch (_tmp44_) {
#line 222 "../folks/backend-store.vala"
						case FOLKS_PERSONA_STORE_TRUST_NONE:
#line 1363 "backend-store.c"
						{
							gchar* _tmp45_;
#line 225 "../folks/backend-store.vala"
							_tmp45_ = g_strdup ("none");
#line 225 "../folks/backend-store.vala"
							_g_free0 (trust_level);
#line 225 "../folks/backend-store.vala"
							trust_level = _tmp45_;
#line 226 "../folks/backend-store.vala"
							break;
#line 1374 "backend-store.c"
						}
#line 222 "../folks/backend-store.vala"
						case FOLKS_PERSONA_STORE_TRUST_PARTIAL:
#line 1378 "backend-store.c"
						{
							gchar* _tmp46_;
#line 228 "../folks/backend-store.vala"
							_tmp46_ = g_strdup ("partial");
#line 228 "../folks/backend-store.vala"
							_g_free0 (trust_level);
#line 228 "../folks/backend-store.vala"
							trust_level = _tmp46_;
#line 229 "../folks/backend-store.vala"
							break;
#line 1389 "backend-store.c"
						}
#line 222 "../folks/backend-store.vala"
						case FOLKS_PERSONA_STORE_TRUST_FULL:
#line 1393 "backend-store.c"
						{
							gchar* _tmp47_;
#line 231 "../folks/backend-store.vala"
							_tmp47_ = g_strdup ("full");
#line 231 "../folks/backend-store.vala"
							_g_free0 (trust_level);
#line 231 "../folks/backend-store.vala"
							trust_level = _tmp47_;
#line 232 "../folks/backend-store.vala"
							break;
#line 1404 "backend-store.c"
						}
						default:
						{
#line 234 "../folks/backend-store.vala"
							g_assert_not_reached ();
#line 1410 "backend-store.c"
						}
					}
#line 237 "../folks/backend-store.vala"
					_tmp48_ = persona_store;
#line 237 "../folks/backend-store.vala"
					_tmp49_ = folks_persona_store_get_always_writeable_properties (_tmp48_, &_tmp50_);
#line 237 "../folks/backend-store.vala"
					_tmp49__length1 = _tmp50_;
#line 237 "../folks/backend-store.vala"
					_tmp51_ = _tmp49_;
#line 237 "../folks/backend-store.vala"
					_tmp51__length1 = _tmp49__length1;
#line 237 "../folks/backend-store.vala"
					_tmp52_ = _vala_g_strjoinv (",", _tmp51_, (gint) _tmp51__length1);
#line 237 "../folks/backend-store.vala"
					writeable_props = _tmp52_;
#line 240 "../folks/backend-store.vala"
					_tmp53_ = persona_store;
#line 240 "../folks/backend-store.vala"
					folks_debug_print_heading (debug, domain, level, "PersonaStore (%p)", _tmp53_);
#line 245 "../folks/backend-store.vala"
					_tmp55_ = persona_store;
#line 245 "../folks/backend-store.vala"
					_tmp56_ = folks_persona_store_get_is_prepared (_tmp55_);
#line 245 "../folks/backend-store.vala"
					_tmp57_ = _tmp56_;
#line 245 "../folks/backend-store.vala"
					if (_tmp57_) {
#line 245 "../folks/backend-store.vala"
						_tmp54_ = "yes";
#line 1441 "backend-store.c"
					} else {
#line 245 "../folks/backend-store.vala"
						_tmp54_ = "no";
#line 1445 "backend-store.c"
					}
#line 247 "../folks/backend-store.vala"
					_tmp59_ = persona_store;
#line 247 "../folks/backend-store.vala"
					_tmp60_ = folks_persona_store_get_is_primary_store (_tmp59_);
#line 247 "../folks/backend-store.vala"
					_tmp61_ = _tmp60_;
#line 247 "../folks/backend-store.vala"
					if (_tmp61_) {
#line 247 "../folks/backend-store.vala"
						_tmp58_ = "yes";
#line 1457 "backend-store.c"
					} else {
#line 247 "../folks/backend-store.vala"
						_tmp58_ = "no";
#line 1461 "backend-store.c"
					}
#line 249 "../folks/backend-store.vala"
					_tmp63_ = persona_store;
#line 249 "../folks/backend-store.vala"
					_tmp64_ = folks_persona_store_get_is_quiescent (_tmp63_);
#line 249 "../folks/backend-store.vala"
					_tmp65_ = _tmp64_;
#line 249 "../folks/backend-store.vala"
					if (_tmp65_) {
#line 249 "../folks/backend-store.vala"
						_tmp62_ = "yes";
#line 1473 "backend-store.c"
					} else {
#line 249 "../folks/backend-store.vala"
						_tmp62_ = "no";
#line 1477 "backend-store.c"
					}
#line 242 "../folks/backend-store.vala"
					_tmp66_ = g_strdup_printf ("%u", ((GObject*) self)->ref_count);
#line 242 "../folks/backend-store.vala"
					_tmp67_ = _tmp66_;
#line 242 "../folks/backend-store.vala"
					_tmp68_ = persona_store;
#line 242 "../folks/backend-store.vala"
					_tmp69_ = folks_persona_store_get_id (_tmp68_);
#line 242 "../folks/backend-store.vala"
					_tmp70_ = _tmp69_;
#line 242 "../folks/backend-store.vala"
					_tmp71_ = writeable_props;
#line 242 "../folks/backend-store.vala"
					_tmp72_ = trust_level;
#line 242 "../folks/backend-store.vala"
					_tmp73_ = persona_store;
#line 242 "../folks/backend-store.vala"
					_tmp74_ = folks_persona_store_get_personas (_tmp73_);
#line 242 "../folks/backend-store.vala"
					_tmp75_ = _tmp74_;
#line 242 "../folks/backend-store.vala"
					_tmp76_ = gee_map_get_size (_tmp75_);
#line 242 "../folks/backend-store.vala"
					_tmp77_ = _tmp76_;
#line 242 "../folks/backend-store.vala"
					_tmp78_ = g_strdup_printf ("%i", _tmp77_);
#line 242 "../folks/backend-store.vala"
					_tmp79_ = _tmp78_;
#line 242 "../folks/backend-store.vala"
					folks_debug_print_key_value_pairs (debug, domain, level, "Ref. count", _tmp67_, "ID", _tmp70_, "Prepared?", _tmp54_, "Is primary store?", _tmp58_, "Always writeable properties", _tmp71_, "Quiescent?", _tmp62_, "Trust level", _tmp72_, "Persona count", _tmp79_, NULL);
#line 242 "../folks/backend-store.vala"
					_g_free0 (_tmp79_);
#line 242 "../folks/backend-store.vala"
					_g_free0 (_tmp67_);
#line 218 "../folks/backend-store.vala"
					_g_free0 (writeable_props);
#line 218 "../folks/backend-store.vala"
					_g_free0 (trust_level);
#line 218 "../folks/backend-store.vala"
					_g_object_unref0 (persona_store);
#line 1519 "backend-store.c"
				}
#line 218 "../folks/backend-store.vala"
				_g_object_unref0 (_persona_store_it);
#line 1523 "backend-store.c"
			}
#line 255 "../folks/backend-store.vala"
			folks_debug_unindent (debug);
#line 204 "../folks/backend-store.vala"
			_g_object_unref0 (backend);
#line 1529 "backend-store.c"
		}
#line 204 "../folks/backend-store.vala"
		_g_object_unref0 (_backend_it);
#line 1533 "backend-store.c"
	}
#line 258 "../folks/backend-store.vala"
	folks_debug_unindent (debug);
#line 261 "../folks/backend-store.vala"
	folks_debug_print_line (debug, domain, level, "%s", "");
#line 1539 "backend-store.c"
}

static void
folks_backend_store_prepare_data_free (gpointer _data)
{
	FolksBackendStorePrepareData* _data_;
	_data_ = _data;
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../folks/backend-store.vala"
	g_slice_free (FolksBackendStorePrepareData, _data_);
#line 1551 "backend-store.c"
}

void
folks_backend_store_prepare (FolksBackendStore* self,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_)
{
	FolksBackendStorePrepareData* _data_;
	FolksBackendStore* _tmp0_;
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 38 "../folks/backend-store.vala"
	_data_ = g_slice_new0 (FolksBackendStorePrepareData);
#line 38 "../folks/backend-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 38 "../folks/backend-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backend_store_prepare_data_free);
#line 38 "../folks/backend-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../folks/backend-store.vala"
	_data_->self = _tmp0_;
#line 38 "../folks/backend-store.vala"
	folks_backend_store_prepare_co (_data_);
#line 1575 "backend-store.c"
}

void
folks_backend_store_prepare_finish (FolksBackendStore* self,
                                    GAsyncResult* _res_)
{
	FolksBackendStorePrepareData* _data_;
#line 38 "../folks/backend-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1585 "backend-store.c"
}

/**
   * Prepare the BackendStore for use.
   *
   * This must only ever be called before {@link BackendStore.load_backends} is
   * called for the first time. If it isn't called explicitly,
   * {@link BackendStore.load_backends} will call it.
   *
   * This method is safe to call multiple times concurrently (e.g. an
   * asynchronous call may begin between a subsequent asynchronous call
   * beginning and finishing).
   *
   * @since 0.3.0
   */
static void
folks_backend_store_prepare_ready (GObject* source_object,
                                   GAsyncResult* _res_,
                                   gpointer _user_data_)
{
	FolksBackendStorePrepareData* _data_;
#line 282 "../folks/backend-store.vala"
	_data_ = _user_data_;
#line 282 "../folks/backend-store.vala"
	_data_->_source_object_ = source_object;
#line 282 "../folks/backend-store.vala"
	_data_->_res_ = _res_;
#line 282 "../folks/backend-store.vala"
	folks_backend_store_prepare_co (_data_);
#line 1615 "backend-store.c"
}

static gboolean
folks_backend_store_prepare_co (FolksBackendStorePrepareData* _data_)
{
#line 277 "../folks/backend-store.vala"
	switch (_data_->_state_) {
#line 277 "../folks/backend-store.vala"
		case 0:
#line 1625 "backend-store.c"
		goto _state_0;
#line 277 "../folks/backend-store.vala"
		case 1:
#line 1629 "backend-store.c"
		goto _state_1;
		default:
#line 277 "../folks/backend-store.vala"
		g_assert_not_reached ();
#line 1634 "backend-store.c"
	}
	_state_0:
#line 279 "../folks/backend-store.vala"
	_data_->_tmp0_ = folks_internal_profiling_start ("preparing BackendStore", NULL);
#line 279 "../folks/backend-store.vala"
	_data_->profiling = _data_->_tmp0_;
#line 282 "../folks/backend-store.vala"
	_data_->_state_ = 1;
#line 282 "../folks/backend-store.vala"
	_folks_backend_store_load_disabled_backend_names (_data_->self, folks_backend_store_prepare_ready, _data_);
#line 282 "../folks/backend-store.vala"
	return FALSE;
#line 1647 "backend-store.c"
	_state_1:
#line 282 "../folks/backend-store.vala"
	_folks_backend_store_load_disabled_backend_names_finish (_data_->self, _data_->_res_);
#line 284 "../folks/backend-store.vala"
	if (_data_->self->priv->_is_prepared == FALSE) {
#line 286 "../folks/backend-store.vala"
		_data_->self->priv->_is_prepared = TRUE;
#line 287 "../folks/backend-store.vala"
		g_object_notify ((GObject*) _data_->self, "is-prepared");
#line 1657 "backend-store.c"
	}
#line 290 "../folks/backend-store.vala"
	_data_->_tmp1_ = _data_->profiling;
#line 290 "../folks/backend-store.vala"
	_data_->profiling = NULL;
#line 290 "../folks/backend-store.vala"
	folks_internal_profiling_end (_data_->_tmp1_);
#line 277 "../folks/backend-store.vala"
	_folks_internal_profile_block_free0 (_data_->profiling);
#line 277 "../folks/backend-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 277 "../folks/backend-store.vala"
	if (_data_->_state_ != 0) {
#line 277 "../folks/backend-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 277 "../folks/backend-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1675 "backend-store.c"
		}
	}
#line 277 "../folks/backend-store.vala"
	g_object_unref (_data_->_async_result);
#line 277 "../folks/backend-store.vala"
	return FALSE;
#line 1682 "backend-store.c"
}

static void
folks_backend_store_load_backends_data_free (gpointer _data)
{
	FolksBackendStoreLoadBackendsData* _data_;
	_data_ = _data;
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../folks/backend-store.vala"
	g_slice_free (FolksBackendStoreLoadBackendsData, _data_);
#line 1694 "backend-store.c"
}

void
folks_backend_store_load_backends (FolksBackendStore* self,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	FolksBackendStoreLoadBackendsData* _data_;
	FolksBackendStore* _tmp0_;
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 38 "../folks/backend-store.vala"
	_data_ = g_slice_new0 (FolksBackendStoreLoadBackendsData);
#line 38 "../folks/backend-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 38 "../folks/backend-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backend_store_load_backends_data_free);
#line 38 "../folks/backend-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../folks/backend-store.vala"
	_data_->self = _tmp0_;
#line 38 "../folks/backend-store.vala"
	folks_backend_store_load_backends_co (_data_);
#line 1718 "backend-store.c"
}

void
folks_backend_store_load_backends_finish (FolksBackendStore* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	FolksBackendStoreLoadBackendsData* _data_;
#line 38 "../folks/backend-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 38 "../folks/backend-store.vala"
	if (NULL == _data_) {
#line 38 "../folks/backend-store.vala"
		return;
#line 1733 "backend-store.c"
	}
}

/**
   * Find, load, and prepare all backends which are not disabled.
   *
   * Backends will be searched for in the path given by the
   * ``FOLKS_BACKEND_PATH`` environment variable, if it's set. If it's not set,
   * backends will be searched for in a path set at compilation time.
   *
   * This method is not safe to call multiple times concurrently.
   *
   * @throws GLib.Error currently unused
   */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 304 "../folks/backend-store.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 304 "../folks/backend-store.vala"
	return _data1_;
#line 1755 "backend-store.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 304 "../folks/backend-store.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 1765 "backend-store.c"
		FolksBackendStore* self;
#line 304 "../folks/backend-store.vala"
		self = _data1_->self;
#line 304 "../folks/backend-store.vala"
		_g_object_unref0 (self);
#line 304 "../folks/backend-store.vala"
		g_slice_free (Block1Data, _data1_);
#line 1773 "backend-store.c"
	}
}

static void
folks_backend_store_load_backends_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	FolksBackendStoreLoadBackendsData* _data_;
#line 310 "../folks/backend-store.vala"
	_data_ = _user_data_;
#line 310 "../folks/backend-store.vala"
	_data_->_source_object_ = source_object;
#line 310 "../folks/backend-store.vala"
	_data_->_res_ = _res_;
#line 310 "../folks/backend-store.vala"
	folks_backend_store_load_backends_co (_data_);
#line 1791 "backend-store.c"
}

static void
____lambda66_ (Block1Data* _data1_,
               GObject* o,
               GAsyncResult* r)
{
	FolksBackendStore* self;
	gint _tmp0_;
#line 386 "../folks/backend-store.vala"
	self = _data1_->self;
#line 386 "../folks/backend-store.vala"
	g_return_if_fail (r != NULL);
#line 388 "../folks/backend-store.vala"
	_folks_backend_store_backend_load_if_needed_finish (self, r);
#line 389 "../folks/backend-store.vala"
	_tmp0_ = _data1_->backends_remaining;
#line 389 "../folks/backend-store.vala"
	_data1_->backends_remaining = _tmp0_ - 1;
#line 391 "../folks/backend-store.vala"
	if (_data1_->backends_remaining == 0) {
#line 393 "../folks/backend-store.vala"
		folks_backend_store_load_backends_co (_data1_->_async_data_);
#line 1815 "backend-store.c"
	}
}

static void
_____lambda66__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 386 "../folks/backend-store.vala"
	____lambda66_ (self, source_object, res);
#line 386 "../folks/backend-store.vala"
	block1_data_unref (self);
#line 1828 "backend-store.c"
}

static gboolean
folks_backend_store_load_backends_co (FolksBackendStoreLoadBackendsData* _data_)
{
#line 304 "../folks/backend-store.vala"
	switch (_data_->_state_) {
#line 304 "../folks/backend-store.vala"
		case 0:
#line 1838 "backend-store.c"
		goto _state_0;
#line 304 "../folks/backend-store.vala"
		case 1:
#line 1842 "backend-store.c"
		goto _state_1;
#line 304 "../folks/backend-store.vala"
		case 2:
#line 1846 "backend-store.c"
		goto _state_2;
#line 304 "../folks/backend-store.vala"
		case 3:
#line 1850 "backend-store.c"
		goto _state_3;
#line 304 "../folks/backend-store.vala"
		case 4:
#line 1854 "backend-store.c"
		goto _state_4;
#line 304 "../folks/backend-store.vala"
		case 5:
#line 1858 "backend-store.c"
		goto _state_5;
		default:
#line 304 "../folks/backend-store.vala"
		g_assert_not_reached ();
#line 1863 "backend-store.c"
	}
	_state_0:
#line 304 "../folks/backend-store.vala"
	_data_->_data1_ = g_slice_new0 (Block1Data);
#line 304 "../folks/backend-store.vala"
	_data_->_data1_->_ref_count_ = 1;
#line 304 "../folks/backend-store.vala"
	_data_->_data1_->self = g_object_ref (_data_->self);
#line 304 "../folks/backend-store.vala"
	_data_->_data1_->_async_data_ = _data_;
#line 306 "../folks/backend-store.vala"
	_vala_assert (g_module_supported (), "Module.supported()");
#line 308 "../folks/backend-store.vala"
	_data_->_tmp0_ = folks_internal_profiling_start ("loading backends in BackendStore", NULL);
#line 308 "../folks/backend-store.vala"
	_data_->profiling = _data_->_tmp0_;
#line 310 "../folks/backend-store.vala"
	_data_->_state_ = 1;
#line 310 "../folks/backend-store.vala"
	folks_backend_store_prepare (_data_->self, folks_backend_store_load_backends_ready, _data_);
#line 310 "../folks/backend-store.vala"
	return FALSE;
#line 1886 "backend-store.c"
	_state_1:
#line 310 "../folks/backend-store.vala"
	folks_backend_store_prepare_finish (_data_->self, _data_->_res_);
#line 1890 "backend-store.c"
	{
#line 313 "../folks/backend-store.vala"
		_data_->_tmp1_ = _data_->self->priv->_backend_hash;
#line 313 "../folks/backend-store.vala"
		_data_->_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _data_->_tmp1_);
#line 313 "../folks/backend-store.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 313 "../folks/backend-store.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 313 "../folks/backend-store.vala"
		_data_->_tmp5_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp4_);
#line 313 "../folks/backend-store.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 313 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->_tmp4_);
#line 313 "../folks/backend-store.vala"
		_data_->_backend_existing_it = _data_->_tmp6_;
#line 313 "../folks/backend-store.vala"
		while (TRUE) {
#line 313 "../folks/backend-store.vala"
			_data_->_tmp7_ = _data_->_backend_existing_it;
#line 313 "../folks/backend-store.vala"
			if (!gee_iterator_next (_data_->_tmp7_)) {
#line 313 "../folks/backend-store.vala"
				break;
#line 1916 "backend-store.c"
			}
#line 313 "../folks/backend-store.vala"
			_data_->_tmp8_ = _data_->_backend_existing_it;
#line 313 "../folks/backend-store.vala"
			_data_->_tmp9_ = gee_iterator_get (_data_->_tmp8_);
#line 313 "../folks/backend-store.vala"
			_data_->backend_existing = (FolksBackend*) _data_->_tmp9_;
#line 315 "../folks/backend-store.vala"
			_data_->_tmp10_ = _data_->backend_existing;
#line 315 "../folks/backend-store.vala"
			_data_->_state_ = 2;
#line 315 "../folks/backend-store.vala"
			_folks_backend_store_backend_unload_if_needed (_data_->self, _data_->_tmp10_, folks_backend_store_load_backends_ready, _data_);
#line 315 "../folks/backend-store.vala"
			return FALSE;
#line 1932 "backend-store.c"
			_state_2:
#line 315 "../folks/backend-store.vala"
			_folks_backend_store_backend_unload_if_needed_finish (_data_->self, _data_->_res_);
#line 313 "../folks/backend-store.vala"
			_g_object_unref0 (_data_->backend_existing);
#line 1938 "backend-store.c"
		}
#line 313 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->_backend_existing_it);
#line 1942 "backend-store.c"
	}
#line 318 "../folks/backend-store.vala"
	folks_internal_profiling_point ("unloaded backends in BackendStore");
#line 320 "../folks/backend-store.vala"
	_data_->_tmp11_ = g_getenv ("FOLKS_BACKEND_PATH");
#line 320 "../folks/backend-store.vala"
	_data_->_tmp12_ = g_strdup (_data_->_tmp11_);
#line 320 "../folks/backend-store.vala"
	_data_->_path = _data_->_tmp12_;
#line 323 "../folks/backend-store.vala"
	_data_->_tmp13_ = _data_->_path;
#line 323 "../folks/backend-store.vala"
	if (_data_->_tmp13_ == NULL) {
#line 325 "../folks/backend-store.vala"
		_data_->_tmp14_ = g_strdup (BACKEND_DIR);
#line 325 "../folks/backend-store.vala"
		_g_free0 (_data_->path);
#line 325 "../folks/backend-store.vala"
		_data_->path = _data_->_tmp14_;
#line 327 "../folks/backend-store.vala"
		_data_->_tmp15_ = _data_->path;
#line 327 "../folks/backend-store.vala"
		g_debug ("Using built-in backend dir '%s' (override with " "environment variable FOLKS_BACKEND_PATH)", _data_->_tmp15_);
#line 1966 "backend-store.c"
	} else {
#line 332 "../folks/backend-store.vala"
		_data_->_tmp16_ = _data_->_path;
#line 332 "../folks/backend-store.vala"
		_data_->_tmp17_ = g_strdup ((const gchar*) _data_->_tmp16_);
#line 332 "../folks/backend-store.vala"
		_g_free0 (_data_->path);
#line 332 "../folks/backend-store.vala"
		_data_->path = _data_->_tmp17_;
#line 334 "../folks/backend-store.vala"
		_data_->_tmp18_ = _data_->path;
#line 334 "../folks/backend-store.vala"
		g_debug ("Using environment variable FOLKS_BACKEND_PATH = " "'%s' to look for backends", _data_->_tmp18_);
#line 1980 "backend-store.c"
	}
#line 338 "../folks/backend-store.vala"
	_data_->_tmp19_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 338 "../folks/backend-store.vala"
	_data_->modules = _data_->_tmp19_;
#line 339 "../folks/backend-store.vala"
	_data_->_tmp20_ = _data_->path;
#line 339 "../folks/backend-store.vala"
	_data_->_tmp22_ = _data_->_tmp21_ = g_strsplit (_data_->_tmp20_, ":", 0);
#line 339 "../folks/backend-store.vala"
	_data_->path_split = _data_->_tmp22_;
#line 339 "../folks/backend-store.vala"
	_data_->path_split_length1 = _vala_array_length (_data_->_tmp21_);
#line 339 "../folks/backend-store.vala"
	_data_->_path_split_size_ = _data_->path_split_length1;
#line 340 "../folks/backend-store.vala"
	_data_->_tmp23_ = _data_->path_split;
#line 340 "../folks/backend-store.vala"
	_data_->_tmp23__length1 = _data_->path_split_length1;
#line 2000 "backend-store.c"
	{
#line 340 "../folks/backend-store.vala"
		_data_->subpath_collection_length1 = 0;
#line 340 "../folks/backend-store.vala"
		_data_->_subpath_collection_size_ = 0;
#line 340 "../folks/backend-store.vala"
		_data_->subpath_collection = _data_->_tmp23_;
#line 340 "../folks/backend-store.vala"
		_data_->subpath_collection_length1 = _data_->_tmp23__length1;
#line 340 "../folks/backend-store.vala"
		for (_data_->subpath_it = 0; _data_->subpath_it < _data_->subpath_collection_length1; _data_->subpath_it = _data_->subpath_it + 1) {
#line 340 "../folks/backend-store.vala"
			_data_->subpath = _data_->subpath_collection[_data_->subpath_it];
#line 2014 "backend-store.c"
			{
#line 342 "../folks/backend-store.vala"
				_data_->_tmp24_ = _data_->subpath;
#line 342 "../folks/backend-store.vala"
				_data_->_tmp25_ = g_file_new_for_path (_data_->_tmp24_);
#line 342 "../folks/backend-store.vala"
				_data_->file = _data_->_tmp25_;
#line 346 "../folks/backend-store.vala"
				_data_->_tmp26_ = _data_->file;
#line 346 "../folks/backend-store.vala"
				_data_->_tmp27_ = FALSE;
#line 346 "../folks/backend-store.vala"
				_data_->_tmp28_ = FALSE;
#line 346 "../folks/backend-store.vala"
				_data_->_state_ = 3;
#line 346 "../folks/backend-store.vala"
				_folks_backend_store_get_file_info (_data_->_tmp26_, folks_backend_store_load_backends_ready, _data_);
#line 346 "../folks/backend-store.vala"
				return FALSE;
#line 2034 "backend-store.c"
				_state_3:
#line 346 "../folks/backend-store.vala"
				_folks_backend_store_get_file_info_finish (_data_->_res_, &_data_->_tmp27_, &_data_->_tmp28_);
#line 346 "../folks/backend-store.vala"
				_data_->is_file = _data_->_tmp27_;
#line 346 "../folks/backend-store.vala"
				_data_->is_dir = _data_->_tmp28_;
#line 347 "../folks/backend-store.vala"
				if (_data_->is_file) {
#line 349 "../folks/backend-store.vala"
					_data_->_tmp29_ = _data_->modules;
#line 349 "../folks/backend-store.vala"
					_data_->_tmp30_ = _data_->subpath;
#line 349 "../folks/backend-store.vala"
					_data_->_tmp31_ = _data_->file;
#line 349 "../folks/backend-store.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp29_, _data_->_tmp30_, _data_->_tmp31_);
#line 2052 "backend-store.c"
				} else {
#line 351 "../folks/backend-store.vala"
					if (_data_->is_dir) {
#line 353 "../folks/backend-store.vala"
						_data_->_tmp32_ = _data_->file;
#line 353 "../folks/backend-store.vala"
						_data_->_state_ = 4;
#line 353 "../folks/backend-store.vala"
						_folks_backend_store_get_modules_from_dir (_data_->self, _data_->_tmp32_, folks_backend_store_load_backends_ready, _data_);
#line 353 "../folks/backend-store.vala"
						return FALSE;
#line 2064 "backend-store.c"
						_state_4:
#line 353 "../folks/backend-store.vala"
						_data_->_tmp33_ = _folks_backend_store_get_modules_from_dir_finish (_data_->self, _data_->_res_);
#line 353 "../folks/backend-store.vala"
						_data_->cur_modules = _data_->_tmp33_;
#line 354 "../folks/backend-store.vala"
						_data_->_tmp34_ = _data_->cur_modules;
#line 354 "../folks/backend-store.vala"
						if (_data_->_tmp34_ != NULL) {
#line 2074 "backend-store.c"
							{
#line 356 "../folks/backend-store.vala"
								_data_->_tmp35_ = _data_->cur_modules;
#line 356 "../folks/backend-store.vala"
								_data_->_tmp36_ = gee_abstract_map_get_entries ((GeeAbstractMap*) G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp35_, GEE_TYPE_HASH_MAP, GeeHashMap));
#line 356 "../folks/backend-store.vala"
								_data_->_tmp37_ = _data_->_tmp36_;
#line 356 "../folks/backend-store.vala"
								_data_->_tmp38_ = _data_->_tmp37_;
#line 356 "../folks/backend-store.vala"
								_data_->_tmp39_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp38_);
#line 356 "../folks/backend-store.vala"
								_data_->_tmp40_ = _data_->_tmp39_;
#line 356 "../folks/backend-store.vala"
								_g_object_unref0 (_data_->_tmp38_);
#line 356 "../folks/backend-store.vala"
								_data_->_entry_it = _data_->_tmp40_;
#line 356 "../folks/backend-store.vala"
								while (TRUE) {
#line 356 "../folks/backend-store.vala"
									_data_->_tmp41_ = _data_->_entry_it;
#line 356 "../folks/backend-store.vala"
									if (!gee_iterator_next (_data_->_tmp41_)) {
#line 356 "../folks/backend-store.vala"
										break;
#line 2100 "backend-store.c"
									}
#line 356 "../folks/backend-store.vala"
									_data_->_tmp42_ = _data_->_entry_it;
#line 356 "../folks/backend-store.vala"
									_data_->_tmp43_ = gee_iterator_get (_data_->_tmp42_);
#line 356 "../folks/backend-store.vala"
									_data_->entry = (GeeMapEntry*) _data_->_tmp43_;
#line 358 "../folks/backend-store.vala"
									_data_->_tmp44_ = _data_->modules;
#line 358 "../folks/backend-store.vala"
									_data_->_tmp45_ = _data_->entry;
#line 358 "../folks/backend-store.vala"
									_data_->_tmp46_ = gee_map_entry_get_key (_data_->_tmp45_);
#line 358 "../folks/backend-store.vala"
									_data_->_tmp47_ = _data_->_tmp46_;
#line 358 "../folks/backend-store.vala"
									_data_->_tmp48_ = _data_->entry;
#line 358 "../folks/backend-store.vala"
									_data_->_tmp49_ = gee_map_entry_get_value (_data_->_tmp48_);
#line 358 "../folks/backend-store.vala"
									_data_->_tmp50_ = _data_->_tmp49_;
#line 358 "../folks/backend-store.vala"
									gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp44_, (const gchar*) _data_->_tmp47_, (GFile*) _data_->_tmp50_);
#line 356 "../folks/backend-store.vala"
									_g_object_unref0 (_data_->entry);
#line 2126 "backend-store.c"
								}
#line 356 "../folks/backend-store.vala"
								_g_object_unref0 (_data_->_entry_it);
#line 2130 "backend-store.c"
							}
						}
#line 351 "../folks/backend-store.vala"
						_g_object_unref0 (_data_->cur_modules);
#line 2135 "backend-store.c"
					} else {
#line 364 "../folks/backend-store.vala"
						_data_->_tmp51_ = _data_->subpath;
#line 364 "../folks/backend-store.vala"
						g_critical ("FOLKS_BACKEND_PATH component '%s' is not a regular " "file or directory; ignoring...", _data_->_tmp51_);
#line 367 "../folks/backend-store.vala"
						g_assert_not_reached ();
#line 2143 "backend-store.c"
					}
				}
#line 340 "../folks/backend-store.vala"
				_g_object_unref0 (_data_->file);
#line 2148 "backend-store.c"
			}
		}
	}
#line 371 "../folks/backend-store.vala"
	folks_internal_profiling_point ("found modules in BackendStore");
#line 2154 "backend-store.c"
	{
#line 376 "../folks/backend-store.vala"
		_data_->_tmp52_ = _data_->modules;
#line 376 "../folks/backend-store.vala"
		_data_->_tmp53_ = gee_abstract_map_get_values ((GeeAbstractMap*) _data_->_tmp52_);
#line 376 "../folks/backend-store.vala"
		_data_->_tmp54_ = _data_->_tmp53_;
#line 376 "../folks/backend-store.vala"
		_data_->_tmp55_ = _data_->_tmp54_;
#line 376 "../folks/backend-store.vala"
		_data_->_tmp56_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp55_);
#line 376 "../folks/backend-store.vala"
		_data_->_tmp57_ = _data_->_tmp56_;
#line 376 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->_tmp55_);
#line 376 "../folks/backend-store.vala"
		_data_->_module_it = _data_->_tmp57_;
#line 376 "../folks/backend-store.vala"
		while (TRUE) {
#line 376 "../folks/backend-store.vala"
			_data_->_tmp58_ = _data_->_module_it;
#line 376 "../folks/backend-store.vala"
			if (!gee_iterator_next (_data_->_tmp58_)) {
#line 376 "../folks/backend-store.vala"
				break;
#line 2180 "backend-store.c"
			}
#line 376 "../folks/backend-store.vala"
			_data_->_tmp59_ = _data_->_module_it;
#line 376 "../folks/backend-store.vala"
			_data_->_tmp60_ = gee_iterator_get (_data_->_tmp59_);
#line 376 "../folks/backend-store.vala"
			_data_->module = (GFile*) _data_->_tmp60_;
#line 377 "../folks/backend-store.vala"
			_data_->_tmp61_ = _data_->module;
#line 377 "../folks/backend-store.vala"
			_folks_backend_store_load_module_from_file (_data_->self, _data_->_tmp61_);
#line 376 "../folks/backend-store.vala"
			_g_object_unref0 (_data_->module);
#line 2194 "backend-store.c"
		}
#line 376 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->_module_it);
#line 2198 "backend-store.c"
	}
#line 379 "../folks/backend-store.vala"
	folks_internal_profiling_point ("loaded modules in BackendStore");
#line 382 "../folks/backend-store.vala"
	_data_->_data1_->backends_remaining = 1;
#line 2204 "backend-store.c"
	{
#line 383 "../folks/backend-store.vala"
		_data_->_tmp62_ = _data_->self->priv->_backend_hash;
#line 383 "../folks/backend-store.vala"
		_data_->_tmp63_ = gee_abstract_map_get_values ((GeeAbstractMap*) _data_->_tmp62_);
#line 383 "../folks/backend-store.vala"
		_data_->_tmp64_ = _data_->_tmp63_;
#line 383 "../folks/backend-store.vala"
		_data_->_tmp65_ = _data_->_tmp64_;
#line 383 "../folks/backend-store.vala"
		_data_->_tmp66_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp65_);
#line 383 "../folks/backend-store.vala"
		_data_->_tmp67_ = _data_->_tmp66_;
#line 383 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->_tmp65_);
#line 383 "../folks/backend-store.vala"
		_data_->_backend_it = _data_->_tmp67_;
#line 383 "../folks/backend-store.vala"
		while (TRUE) {
#line 383 "../folks/backend-store.vala"
			_data_->_tmp68_ = _data_->_backend_it;
#line 383 "../folks/backend-store.vala"
			if (!gee_iterator_next (_data_->_tmp68_)) {
#line 383 "../folks/backend-store.vala"
				break;
#line 2230 "backend-store.c"
			}
#line 383 "../folks/backend-store.vala"
			_data_->_tmp69_ = _data_->_backend_it;
#line 383 "../folks/backend-store.vala"
			_data_->_tmp70_ = gee_iterator_get (_data_->_tmp69_);
#line 383 "../folks/backend-store.vala"
			_data_->backend = (FolksBackend*) _data_->_tmp70_;
#line 385 "../folks/backend-store.vala"
			_data_->_tmp71_ = _data_->_data1_->backends_remaining;
#line 385 "../folks/backend-store.vala"
			_data_->_data1_->backends_remaining = _data_->_tmp71_ + 1;
#line 386 "../folks/backend-store.vala"
			_data_->_tmp72_ = _data_->backend;
#line 386 "../folks/backend-store.vala"
			_folks_backend_store_backend_load_if_needed (_data_->self, _data_->_tmp72_, _____lambda66__gasync_ready_callback, block1_data_ref (_data_->_data1_));
#line 383 "../folks/backend-store.vala"
			_g_object_unref0 (_data_->backend);
#line 2248 "backend-store.c"
		}
#line 383 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->_backend_it);
#line 2252 "backend-store.c"
	}
#line 397 "../folks/backend-store.vala"
	_data_->_tmp73_ = _data_->_data1_->backends_remaining;
#line 397 "../folks/backend-store.vala"
	_data_->_data1_->backends_remaining = _data_->_tmp73_ - 1;
#line 398 "../folks/backend-store.vala"
	if (_data_->_data1_->backends_remaining > 0) {
#line 400 "../folks/backend-store.vala"
		_data_->_state_ = 5;
#line 400 "../folks/backend-store.vala"
		return FALSE;
#line 2264 "backend-store.c"
		_state_5:
		;
	}
#line 403 "../folks/backend-store.vala"
	_data_->_tmp74_ = _data_->profiling;
#line 403 "../folks/backend-store.vala"
	_data_->profiling = NULL;
#line 403 "../folks/backend-store.vala"
	folks_internal_profiling_end (_data_->_tmp74_);
#line 304 "../folks/backend-store.vala"
	_data_->path_split = (_vala_array_free (_data_->path_split, _data_->path_split_length1, (GDestroyNotify) g_free), NULL);
#line 304 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->modules);
#line 304 "../folks/backend-store.vala"
	_g_free0 (_data_->path);
#line 304 "../folks/backend-store.vala"
	_g_free0 (_data_->_path);
#line 304 "../folks/backend-store.vala"
	_folks_internal_profile_block_free0 (_data_->profiling);
#line 304 "../folks/backend-store.vala"
	block1_data_unref (_data_->_data1_);
#line 304 "../folks/backend-store.vala"
	_data_->_data1_ = NULL;
#line 304 "../folks/backend-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 304 "../folks/backend-store.vala"
	if (_data_->_state_ != 0) {
#line 304 "../folks/backend-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 304 "../folks/backend-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2296 "backend-store.c"
		}
	}
#line 304 "../folks/backend-store.vala"
	g_object_unref (_data_->_async_result);
#line 304 "../folks/backend-store.vala"
	return FALSE;
#line 2303 "backend-store.c"
}

static void
_folks_backend_store_backend_load_if_needed_data_free (gpointer _data)
{
	FolksBackendStoreBackendLoadIfNeededData* _data_;
	_data_ = _data;
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->backend);
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../folks/backend-store.vala"
	g_slice_free (FolksBackendStoreBackendLoadIfNeededData, _data_);
#line 2317 "backend-store.c"
}

static void
_folks_backend_store_backend_load_if_needed (FolksBackendStore* self,
                                             FolksBackend* backend,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	FolksBackendStoreBackendLoadIfNeededData* _data_;
	FolksBackendStore* _tmp0_;
	FolksBackend* _tmp1_;
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (backend != NULL);
#line 38 "../folks/backend-store.vala"
	_data_ = g_slice_new0 (FolksBackendStoreBackendLoadIfNeededData);
#line 38 "../folks/backend-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 38 "../folks/backend-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backend_store_backend_load_if_needed_data_free);
#line 38 "../folks/backend-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../folks/backend-store.vala"
	_data_->self = _tmp0_;
#line 38 "../folks/backend-store.vala"
	_tmp1_ = _g_object_ref0 (backend);
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->backend);
#line 38 "../folks/backend-store.vala"
	_data_->backend = _tmp1_;
#line 38 "../folks/backend-store.vala"
	_folks_backend_store_backend_load_if_needed_co (_data_);
#line 2351 "backend-store.c"
}

static void
_folks_backend_store_backend_load_if_needed_finish (FolksBackendStore* self,
                                                    GAsyncResult* _res_)
{
	FolksBackendStoreBackendLoadIfNeededData* _data_;
#line 38 "../folks/backend-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2361 "backend-store.c"
}

static void
_folks_backend_store_backend_load_if_needed_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	FolksBackendStoreBackendLoadIfNeededData* _data_;
#line 416 "../folks/backend-store.vala"
	_data_ = _user_data_;
#line 416 "../folks/backend-store.vala"
	_data_->_source_object_ = source_object;
#line 416 "../folks/backend-store.vala"
	_data_->_res_ = _res_;
#line 416 "../folks/backend-store.vala"
	_folks_backend_store_backend_load_if_needed_co (_data_);
#line 2378 "backend-store.c"
}

static gboolean
_folks_backend_store_backend_load_if_needed_co (FolksBackendStoreBackendLoadIfNeededData* _data_)
{
#line 408 "../folks/backend-store.vala"
	switch (_data_->_state_) {
#line 408 "../folks/backend-store.vala"
		case 0:
#line 2388 "backend-store.c"
		goto _state_0;
#line 408 "../folks/backend-store.vala"
		case 1:
#line 2392 "backend-store.c"
		goto _state_1;
		default:
#line 408 "../folks/backend-store.vala"
		g_assert_not_reached ();
#line 2397 "backend-store.c"
	}
	_state_0:
#line 410 "../folks/backend-store.vala"
	_data_->_tmp0_ = folks_backend_get_name (_data_->backend);
#line 410 "../folks/backend-store.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 410 "../folks/backend-store.vala"
	if (_folks_backend_store_backend_is_enabled (_data_->self, _data_->_tmp1_)) {
#line 412 "../folks/backend-store.vala"
		_data_->_tmp2_ = _data_->self->priv->_prepared_backends;
#line 412 "../folks/backend-store.vala"
		_data_->_tmp3_ = folks_backend_get_name (_data_->backend);
#line 412 "../folks/backend-store.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 412 "../folks/backend-store.vala"
		if (!gee_abstract_map_has_key ((GeeAbstractMap*) _data_->_tmp2_, _data_->_tmp4_)) {
#line 2414 "backend-store.c"
			{
#line 416 "../folks/backend-store.vala"
				_data_->_state_ = 1;
#line 416 "../folks/backend-store.vala"
				folks_backend_prepare (_data_->backend, _folks_backend_store_backend_load_if_needed_ready, _data_);
#line 416 "../folks/backend-store.vala"
				return FALSE;
#line 2422 "backend-store.c"
				_state_1:
#line 416 "../folks/backend-store.vala"
				folks_backend_prepare_finish (_data_->backend, _data_->_res_, &_data_->_inner_error0_);
#line 416 "../folks/backend-store.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2428 "backend-store.c"
					goto __catch0_g_error;
				}
#line 418 "../folks/backend-store.vala"
				_data_->_tmp5_ = folks_backend_get_name (_data_->backend);
#line 418 "../folks/backend-store.vala"
				_data_->_tmp6_ = _data_->_tmp5_;
#line 418 "../folks/backend-store.vala"
				g_debug ("backend-store.vala:418: New backend '%s' prepared", _data_->_tmp6_);
#line 419 "../folks/backend-store.vala"
				_data_->_tmp7_ = _data_->self->priv->_prepared_backends;
#line 419 "../folks/backend-store.vala"
				_data_->_tmp8_ = folks_backend_get_name (_data_->backend);
#line 419 "../folks/backend-store.vala"
				_data_->_tmp9_ = _data_->_tmp8_;
#line 419 "../folks/backend-store.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp7_, _data_->_tmp9_, _data_->backend);
#line 420 "../folks/backend-store.vala"
				g_signal_emit (_data_->self, folks_backend_store_signals[FOLKS_BACKEND_STORE_BACKEND_AVAILABLE_SIGNAL], 0, _data_->backend);
#line 2447 "backend-store.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 414 "../folks/backend-store.vala"
				_data_->e = _data_->_inner_error0_;
#line 414 "../folks/backend-store.vala"
				_data_->_inner_error0_ = NULL;
#line 424 "../folks/backend-store.vala"
				_data_->_tmp10_ = _data_->e;
#line 424 "../folks/backend-store.vala"
				if (g_error_matches (_data_->_tmp10_, G_DBUS_ERROR, G_DBUS_ERROR_SERVICE_UNKNOWN)) {
#line 430 "../folks/backend-store.vala"
					_data_->_tmp11_ = folks_backend_get_name (_data_->backend);
#line 430 "../folks/backend-store.vala"
					_data_->_tmp12_ = _data_->_tmp11_;
#line 430 "../folks/backend-store.vala"
					_data_->_tmp13_ = _data_->e;
#line 430 "../folks/backend-store.vala"
					_data_->_tmp14_ = _data_->_tmp13_->message;
#line 430 "../folks/backend-store.vala"
					g_debug ("backend-store.vala:430: Error preparing Backend '%s': %s", _data_->_tmp12_, _data_->_tmp14_);
#line 2470 "backend-store.c"
				} else {
#line 435 "../folks/backend-store.vala"
					_data_->_tmp15_ = folks_backend_get_name (_data_->backend);
#line 435 "../folks/backend-store.vala"
					_data_->_tmp16_ = _data_->_tmp15_;
#line 435 "../folks/backend-store.vala"
					_data_->_tmp17_ = _data_->e;
#line 435 "../folks/backend-store.vala"
					_data_->_tmp18_ = _data_->_tmp17_->message;
#line 435 "../folks/backend-store.vala"
					g_warning ("backend-store.vala:435: Error preparing Backend '%s': %s", _data_->_tmp16_, _data_->_tmp18_);
#line 2482 "backend-store.c"
				}
#line 414 "../folks/backend-store.vala"
				_g_error_free0 (_data_->e);
#line 2486 "backend-store.c"
			}
			__finally0:
#line 414 "../folks/backend-store.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 414 "../folks/backend-store.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 414 "../folks/backend-store.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 414 "../folks/backend-store.vala"
				g_object_unref (_data_->_async_result);
#line 414 "../folks/backend-store.vala"
				return FALSE;
#line 2499 "backend-store.c"
			}
		}
	}
#line 408 "../folks/backend-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 408 "../folks/backend-store.vala"
	if (_data_->_state_ != 0) {
#line 408 "../folks/backend-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 408 "../folks/backend-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2511 "backend-store.c"
		}
	}
#line 408 "../folks/backend-store.vala"
	g_object_unref (_data_->_async_result);
#line 408 "../folks/backend-store.vala"
	return FALSE;
#line 2518 "backend-store.c"
}

static void
_folks_backend_store_backend_unload_if_needed_data_free (gpointer _data)
{
	FolksBackendStoreBackendUnloadIfNeededData* _data_;
	_data_ = _data;
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->backend);
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../folks/backend-store.vala"
	g_slice_free (FolksBackendStoreBackendUnloadIfNeededData, _data_);
#line 2532 "backend-store.c"
}

static void
_folks_backend_store_backend_unload_if_needed (FolksBackendStore* self,
                                               FolksBackend* backend,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	FolksBackendStoreBackendUnloadIfNeededData* _data_;
	FolksBackendStore* _tmp0_;
	FolksBackend* _tmp1_;
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (backend != NULL);
#line 38 "../folks/backend-store.vala"
	_data_ = g_slice_new0 (FolksBackendStoreBackendUnloadIfNeededData);
#line 38 "../folks/backend-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 38 "../folks/backend-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backend_store_backend_unload_if_needed_data_free);
#line 38 "../folks/backend-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../folks/backend-store.vala"
	_data_->self = _tmp0_;
#line 38 "../folks/backend-store.vala"
	_tmp1_ = _g_object_ref0 (backend);
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->backend);
#line 38 "../folks/backend-store.vala"
	_data_->backend = _tmp1_;
#line 38 "../folks/backend-store.vala"
	_folks_backend_store_backend_unload_if_needed_co (_data_);
#line 2566 "backend-store.c"
}

static gboolean
_folks_backend_store_backend_unload_if_needed_finish (FolksBackendStore* self,
                                                      GAsyncResult* _res_)
{
	gboolean result;
	FolksBackendStoreBackendUnloadIfNeededData* _data_;
#line 38 "../folks/backend-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 38 "../folks/backend-store.vala"
	result = _data_->result;
#line 38 "../folks/backend-store.vala"
	return result;
#line 2581 "backend-store.c"
}

static void
_folks_backend_store_backend_unload_if_needed_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	FolksBackendStoreBackendUnloadIfNeededData* _data_;
#line 456 "../folks/backend-store.vala"
	_data_ = _user_data_;
#line 456 "../folks/backend-store.vala"
	_data_->_source_object_ = source_object;
#line 456 "../folks/backend-store.vala"
	_data_->_res_ = _res_;
#line 456 "../folks/backend-store.vala"
	_folks_backend_store_backend_unload_if_needed_co (_data_);
#line 2598 "backend-store.c"
}

static gboolean
_folks_backend_store_backend_unload_if_needed_co (FolksBackendStoreBackendUnloadIfNeededData* _data_)
{
#line 445 "../folks/backend-store.vala"
	switch (_data_->_state_) {
#line 445 "../folks/backend-store.vala"
		case 0:
#line 2608 "backend-store.c"
		goto _state_0;
#line 445 "../folks/backend-store.vala"
		case 1:
#line 2612 "backend-store.c"
		goto _state_1;
		default:
#line 445 "../folks/backend-store.vala"
		g_assert_not_reached ();
#line 2617 "backend-store.c"
	}
	_state_0:
#line 447 "../folks/backend-store.vala"
	_data_->unloaded = FALSE;
#line 449 "../folks/backend-store.vala"
	_data_->_tmp0_ = folks_backend_get_name (_data_->backend);
#line 449 "../folks/backend-store.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 449 "../folks/backend-store.vala"
	if (!_folks_backend_store_backend_is_enabled (_data_->self, _data_->_tmp1_)) {
#line 451 "../folks/backend-store.vala"
		_data_->_tmp2_ = _data_->self->priv->_backend_hash;
#line 451 "../folks/backend-store.vala"
		_data_->_tmp3_ = folks_backend_get_name (_data_->backend);
#line 451 "../folks/backend-store.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 451 "../folks/backend-store.vala"
		_data_->_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp2_, _data_->_tmp4_);
#line 451 "../folks/backend-store.vala"
		_data_->backend_existing = (FolksBackend*) _data_->_tmp5_;
#line 452 "../folks/backend-store.vala"
		_data_->_tmp6_ = _data_->backend_existing;
#line 452 "../folks/backend-store.vala"
		if (_data_->_tmp6_ != NULL) {
#line 2642 "backend-store.c"
			{
#line 456 "../folks/backend-store.vala"
				_data_->_tmp7_ = _data_->backend_existing;
#line 456 "../folks/backend-store.vala"
				_data_->_state_ = 1;
#line 456 "../folks/backend-store.vala"
				folks_backend_unprepare (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, FOLKS_TYPE_BACKEND, FolksBackend), _folks_backend_store_backend_unload_if_needed_ready, _data_);
#line 456 "../folks/backend-store.vala"
				return FALSE;
#line 2652 "backend-store.c"
				_state_1:
#line 456 "../folks/backend-store.vala"
				folks_backend_unprepare_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, FOLKS_TYPE_BACKEND, FolksBackend), _data_->_res_, &_data_->_inner_error0_);
#line 456 "../folks/backend-store.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2658 "backend-store.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
#line 454 "../folks/backend-store.vala"
				_data_->e = _data_->_inner_error0_;
#line 454 "../folks/backend-store.vala"
				_data_->_inner_error0_ = NULL;
#line 460 "../folks/backend-store.vala"
				_data_->_tmp8_ = folks_backend_get_name (_data_->backend);
#line 460 "../folks/backend-store.vala"
				_data_->_tmp9_ = _data_->_tmp8_;
#line 460 "../folks/backend-store.vala"
				_data_->_tmp10_ = _data_->e;
#line 460 "../folks/backend-store.vala"
				_data_->_tmp11_ = _data_->_tmp10_->message;
#line 460 "../folks/backend-store.vala"
				g_warning ("backend-store.vala:460: Error unpreparing Backend '%s': %s", _data_->_tmp9_, _data_->_tmp11_);
#line 454 "../folks/backend-store.vala"
				_g_error_free0 (_data_->e);
#line 2681 "backend-store.c"
			}
			__finally0:
#line 454 "../folks/backend-store.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 454 "../folks/backend-store.vala"
				_g_object_unref0 (_data_->backend_existing);
#line 454 "../folks/backend-store.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 454 "../folks/backend-store.vala"
				g_clear_error (&_data_->_inner_error0_);
#line 454 "../folks/backend-store.vala"
				g_object_unref (_data_->_async_result);
#line 454 "../folks/backend-store.vala"
				return FALSE;
#line 2696 "backend-store.c"
			}
#line 464 "../folks/backend-store.vala"
			_data_->_tmp12_ = _data_->self->priv->_prepared_backends;
#line 464 "../folks/backend-store.vala"
			_data_->_tmp13_ = _data_->backend_existing;
#line 464 "../folks/backend-store.vala"
			_data_->_tmp14_ = folks_backend_get_name (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp13_, FOLKS_TYPE_BACKEND, FolksBackend));
#line 464 "../folks/backend-store.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 464 "../folks/backend-store.vala"
			gee_abstract_map_unset ((GeeAbstractMap*) _data_->_tmp12_, _data_->_tmp15_, NULL);
#line 466 "../folks/backend-store.vala"
			_data_->unloaded = TRUE;
#line 2710 "backend-store.c"
		}
#line 449 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->backend_existing);
#line 2714 "backend-store.c"
	}
#line 470 "../folks/backend-store.vala"
	_data_->result = _data_->unloaded;
#line 470 "../folks/backend-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 470 "../folks/backend-store.vala"
	if (_data_->_state_ != 0) {
#line 470 "../folks/backend-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 470 "../folks/backend-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2726 "backend-store.c"
		}
	}
#line 470 "../folks/backend-store.vala"
	g_object_unref (_data_->_async_result);
#line 470 "../folks/backend-store.vala"
	return FALSE;
#line 2733 "backend-store.c"
}

/**
   * Add a new {@link Backend} to the BackendStore.
   *
   * @param backend the {@link Backend} to add
   */
void
folks_backend_store_add_backend (FolksBackendStore* self,
                                 FolksBackend* backend)
{
	FolksBackend* backend_existing = NULL;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gpointer _tmp3_;
	gboolean _tmp4_ = FALSE;
	FolksBackend* _tmp5_;
	FolksDebug* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GeeHashMap* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
#line 478 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 478 "../folks/backend-store.vala"
	g_return_if_fail (backend != NULL);
#line 481 "../folks/backend-store.vala"
	_tmp0_ = self->priv->_backend_hash;
#line 481 "../folks/backend-store.vala"
	_tmp1_ = folks_backend_get_name (backend);
#line 481 "../folks/backend-store.vala"
	_tmp2_ = _tmp1_;
#line 481 "../folks/backend-store.vala"
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp2_);
#line 481 "../folks/backend-store.vala"
	backend_existing = (FolksBackend*) _tmp3_;
#line 482 "../folks/backend-store.vala"
	_tmp5_ = backend_existing;
#line 482 "../folks/backend-store.vala"
	if (_tmp5_ != NULL) {
#line 2776 "backend-store.c"
		FolksBackend* _tmp6_;
#line 482 "../folks/backend-store.vala"
		_tmp6_ = backend_existing;
#line 482 "../folks/backend-store.vala"
		_tmp4_ = _tmp6_ != backend;
#line 2782 "backend-store.c"
	} else {
#line 482 "../folks/backend-store.vala"
		_tmp4_ = FALSE;
#line 2786 "backend-store.c"
	}
#line 482 "../folks/backend-store.vala"
	if (_tmp4_) {
#line 2790 "backend-store.c"
		FolksBackend* _tmp7_;
		GeeHashMap* _tmp8_;
		FolksBackend* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 484 "../folks/backend-store.vala"
		_tmp7_ = backend_existing;
#line 484 "../folks/backend-store.vala"
		folks_backend_unprepare (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, FOLKS_TYPE_BACKEND, FolksBackend), NULL, NULL);
#line 485 "../folks/backend-store.vala"
		_tmp8_ = self->priv->_prepared_backends;
#line 485 "../folks/backend-store.vala"
		_tmp9_ = backend_existing;
#line 485 "../folks/backend-store.vala"
		_tmp10_ = folks_backend_get_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, FOLKS_TYPE_BACKEND, FolksBackend));
#line 485 "../folks/backend-store.vala"
		_tmp11_ = _tmp10_;
#line 485 "../folks/backend-store.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp8_, _tmp11_, NULL);
#line 2810 "backend-store.c"
	}
#line 488 "../folks/backend-store.vala"
	_tmp12_ = self->priv->_debug;
#line 488 "../folks/backend-store.vala"
	_tmp13_ = folks_backend_get_name (backend);
#line 488 "../folks/backend-store.vala"
	_tmp14_ = _tmp13_;
#line 488 "../folks/backend-store.vala"
	_folks_debug_register_domain (_tmp12_, _tmp14_);
#line 490 "../folks/backend-store.vala"
	_tmp15_ = self->priv->_backend_hash;
#line 490 "../folks/backend-store.vala"
	_tmp16_ = folks_backend_get_name (backend);
#line 490 "../folks/backend-store.vala"
	_tmp17_ = _tmp16_;
#line 490 "../folks/backend-store.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, _tmp17_, backend);
#line 478 "../folks/backend-store.vala"
	_g_object_unref0 (backend_existing);
#line 2830 "backend-store.c"
}

static gboolean
_folks_backend_store_backend_is_enabled (FolksBackendStore* self,
                                         const gchar* name)
{
	gboolean all_others_enabled = FALSE;
	gboolean _tmp0_ = FALSE;
	FolksSmallSet* _tmp1_;
	gboolean _tmp3_ = FALSE;
	FolksSmallSet* _tmp4_;
	gboolean enabled = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 493 "../folks/backend-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 493 "../folks/backend-store.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 495 "../folks/backend-store.vala"
	all_others_enabled = TRUE;
#line 497 "../folks/backend-store.vala"
	_tmp1_ = self->priv->_backends_allowed;
#line 497 "../folks/backend-store.vala"
	if (_tmp1_ != NULL) {
#line 2855 "backend-store.c"
		FolksSmallSet* _tmp2_;
#line 498 "../folks/backend-store.vala"
		_tmp2_ = self->priv->_backends_allowed;
#line 498 "../folks/backend-store.vala"
		_tmp0_ = !gee_abstract_collection_contains ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, FOLKS_TYPE_SMALL_SET, FolksSmallSet), name);
#line 2861 "backend-store.c"
	} else {
#line 497 "../folks/backend-store.vala"
		_tmp0_ = FALSE;
#line 2865 "backend-store.c"
	}
#line 497 "../folks/backend-store.vala"
	if (_tmp0_) {
#line 499 "../folks/backend-store.vala"
		result = FALSE;
#line 499 "../folks/backend-store.vala"
		return result;
#line 2873 "backend-store.c"
	}
#line 501 "../folks/backend-store.vala"
	_tmp4_ = self->priv->_backends_disabled;
#line 501 "../folks/backend-store.vala"
	if (_tmp4_ != NULL) {
#line 2879 "backend-store.c"
		FolksSmallSet* _tmp5_;
#line 502 "../folks/backend-store.vala"
		_tmp5_ = self->priv->_backends_disabled;
#line 502 "../folks/backend-store.vala"
		_tmp3_ = gee_abstract_collection_contains ((GeeAbstractCollection*) G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, FOLKS_TYPE_SMALL_SET, FolksSmallSet), name);
#line 2885 "backend-store.c"
	} else {
#line 501 "../folks/backend-store.vala"
		_tmp3_ = FALSE;
#line 2889 "backend-store.c"
	}
#line 501 "../folks/backend-store.vala"
	if (_tmp3_) {
#line 503 "../folks/backend-store.vala"
		result = FALSE;
#line 503 "../folks/backend-store.vala"
		return result;
#line 2897 "backend-store.c"
	}
	{
		gboolean _tmp6_ = FALSE;
		GKeyFile* _tmp7_;
		const gchar* _tmp8_;
#line 507 "../folks/backend-store.vala"
		_tmp7_ = self->priv->_backends_key_file;
#line 507 "../folks/backend-store.vala"
		_tmp8_ = folks_backend_store_KEY_FILE_GROUP_ALL_OTHERS;
#line 507 "../folks/backend-store.vala"
		_tmp6_ = g_key_file_get_boolean (_tmp7_, _tmp8_, "enabled", &_inner_error0_);
#line 507 "../folks/backend-store.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2911 "backend-store.c"
			gboolean _tmp9_ = FALSE;
#line 507 "../folks/backend-store.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 2915 "backend-store.c"
				goto __catch0_g_key_file_error;
			}
#line 507 "../folks/backend-store.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 507 "../folks/backend-store.vala"
			g_clear_error (&_inner_error0_);
#line 507 "../folks/backend-store.vala"
			return _tmp9_;
#line 2924 "backend-store.c"
		}
#line 507 "../folks/backend-store.vala"
		all_others_enabled = _tmp6_;
#line 2928 "backend-store.c"
	}
	goto __finally0;
	__catch0_g_key_file_error:
	{
		GError* e = NULL;
		gboolean _tmp10_ = FALSE;
		GError* _tmp11_;
#line 505 "../folks/backend-store.vala"
		e = _inner_error0_;
#line 505 "../folks/backend-store.vala"
		_inner_error0_ = NULL;
#line 512 "../folks/backend-store.vala"
		_tmp11_ = e;
#line 512 "../folks/backend-store.vala"
		if (!g_error_matches (_tmp11_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
#line 2944 "backend-store.c"
			GError* _tmp12_;
#line 513 "../folks/backend-store.vala"
			_tmp12_ = e;
#line 513 "../folks/backend-store.vala"
			_tmp10_ = !g_error_matches (_tmp12_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
#line 2950 "backend-store.c"
		} else {
#line 512 "../folks/backend-store.vala"
			_tmp10_ = FALSE;
#line 2954 "backend-store.c"
		}
#line 512 "../folks/backend-store.vala"
		if (_tmp10_) {
#line 2958 "backend-store.c"
			const gchar* _tmp13_ = NULL;
#line 517 "../folks/backend-store.vala"
			if (all_others_enabled) {
#line 517 "../folks/backend-store.vala"
				_tmp13_ = "enabled";
#line 2964 "backend-store.c"
			} else {
#line 517 "../folks/backend-store.vala"
				_tmp13_ = "disabled";
#line 2968 "backend-store.c"
			}
#line 515 "../folks/backend-store.vala"
			g_warning ("Couldn't determine whether to enable or disable " "backends not listed in backend key file. Defaulting to %s.", _tmp13_);
#line 2972 "backend-store.c"
		} else {
			const gchar* _tmp14_ = NULL;
#line 523 "../folks/backend-store.vala"
			if (all_others_enabled) {
#line 523 "../folks/backend-store.vala"
				_tmp14_ = "Enabling";
#line 2979 "backend-store.c"
			} else {
#line 523 "../folks/backend-store.vala"
				_tmp14_ = "Disabling";
#line 2983 "backend-store.c"
			}
#line 521 "../folks/backend-store.vala"
			g_debug ("No catch-all entry in the backend key file. %s " "unlisted backends.", _tmp14_);
#line 2987 "backend-store.c"
		}
#line 505 "../folks/backend-store.vala"
		_g_error_free0 (e);
#line 2991 "backend-store.c"
	}
	__finally0:
#line 505 "../folks/backend-store.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2996 "backend-store.c"
		gboolean _tmp15_ = FALSE;
#line 505 "../folks/backend-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 505 "../folks/backend-store.vala"
		g_clear_error (&_inner_error0_);
#line 505 "../folks/backend-store.vala"
		return _tmp15_;
#line 3004 "backend-store.c"
	}
#line 529 "../folks/backend-store.vala"
	enabled = TRUE;
#line 3008 "backend-store.c"
	{
		gboolean _tmp16_ = FALSE;
		GKeyFile* _tmp17_;
#line 532 "../folks/backend-store.vala"
		_tmp17_ = self->priv->_backends_key_file;
#line 532 "../folks/backend-store.vala"
		_tmp16_ = g_key_file_get_boolean (_tmp17_, name, "enabled", &_inner_error0_);
#line 532 "../folks/backend-store.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3018 "backend-store.c"
			gboolean _tmp18_ = FALSE;
#line 532 "../folks/backend-store.vala"
			if (_inner_error0_->domain == G_KEY_FILE_ERROR) {
#line 3022 "backend-store.c"
				goto __catch1_g_key_file_error;
			}
#line 532 "../folks/backend-store.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 532 "../folks/backend-store.vala"
			g_clear_error (&_inner_error0_);
#line 532 "../folks/backend-store.vala"
			return _tmp18_;
#line 3031 "backend-store.c"
		}
#line 532 "../folks/backend-store.vala"
		enabled = _tmp16_;
#line 3035 "backend-store.c"
	}
	goto __finally1;
	__catch1_g_key_file_error:
	{
		GError* e = NULL;
		gboolean _tmp19_ = FALSE;
		GError* _tmp20_;
#line 530 "../folks/backend-store.vala"
		e = _inner_error0_;
#line 530 "../folks/backend-store.vala"
		_inner_error0_ = NULL;
#line 537 "../folks/backend-store.vala"
		_tmp20_ = e;
#line 537 "../folks/backend-store.vala"
		if (g_error_matches (_tmp20_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
#line 537 "../folks/backend-store.vala"
			_tmp19_ = TRUE;
#line 3053 "backend-store.c"
		} else {
			GError* _tmp21_;
#line 538 "../folks/backend-store.vala"
			_tmp21_ = e;
#line 538 "../folks/backend-store.vala"
			_tmp19_ = g_error_matches (_tmp21_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
#line 3060 "backend-store.c"
		}
#line 537 "../folks/backend-store.vala"
		if (_tmp19_) {
#line 3064 "backend-store.c"
			const gchar* _tmp22_ = NULL;
			const gchar* _tmp23_;
#line 543 "../folks/backend-store.vala"
			if (all_others_enabled) {
#line 543 "../folks/backend-store.vala"
				_tmp22_ = "Enabling";
#line 3071 "backend-store.c"
			} else {
#line 543 "../folks/backend-store.vala"
				_tmp22_ = "Disabling";
#line 3075 "backend-store.c"
			}
#line 540 "../folks/backend-store.vala"
			_tmp23_ = folks_backend_store_KEY_FILE_GROUP_ALL_OTHERS;
#line 540 "../folks/backend-store.vala"
			g_debug ("Found no entry for backend '%s'.enabled in backend " "keyfile. %s according to '%s' setting.", name, _tmp22_, _tmp23_);
#line 545 "../folks/backend-store.vala"
			enabled = all_others_enabled;
#line 3083 "backend-store.c"
		} else {
			gboolean _tmp24_ = FALSE;
			GError* _tmp25_;
#line 547 "../folks/backend-store.vala"
			_tmp25_ = e;
#line 547 "../folks/backend-store.vala"
			if (!g_error_matches (_tmp25_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_GROUP_NOT_FOUND)) {
#line 3091 "backend-store.c"
				GError* _tmp26_;
#line 548 "../folks/backend-store.vala"
				_tmp26_ = e;
#line 548 "../folks/backend-store.vala"
				_tmp24_ = !g_error_matches (_tmp26_, G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_KEY_NOT_FOUND);
#line 3097 "backend-store.c"
			} else {
#line 547 "../folks/backend-store.vala"
				_tmp24_ = FALSE;
#line 3101 "backend-store.c"
			}
#line 547 "../folks/backend-store.vala"
			if (_tmp24_) {
#line 3105 "backend-store.c"
				GError* _tmp27_;
				const gchar* _tmp28_;
#line 550 "../folks/backend-store.vala"
				_tmp27_ = e;
#line 550 "../folks/backend-store.vala"
				_tmp28_ = _tmp27_->message;
#line 550 "../folks/backend-store.vala"
				g_warning ("Couldn't check enabled state of backend '%s': %s\n" "Disabling backend.", name, _tmp28_);
#line 553 "../folks/backend-store.vala"
				enabled = FALSE;
#line 3116 "backend-store.c"
			}
		}
#line 530 "../folks/backend-store.vala"
		_g_error_free0 (e);
#line 3121 "backend-store.c"
	}
	__finally1:
#line 530 "../folks/backend-store.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3126 "backend-store.c"
		gboolean _tmp29_ = FALSE;
#line 530 "../folks/backend-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 530 "../folks/backend-store.vala"
		g_clear_error (&_inner_error0_);
#line 530 "../folks/backend-store.vala"
		return _tmp29_;
#line 3134 "backend-store.c"
	}
#line 557 "../folks/backend-store.vala"
	result = enabled;
#line 557 "../folks/backend-store.vala"
	return result;
#line 3140 "backend-store.c"
}

/**
   * Get a backend from the store by name. If a backend is returned, its
   * reference count is increased.
   *
   * @param name the backend name to retrieve
   * @return the backend, or ``null`` if none could be found
   *
   * @since 0.3.5
   */
FolksBackend*
folks_backend_store_dup_backend_by_name (FolksBackendStore* self,
                                         const gchar* name)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	FolksBackend* result;
#line 569 "../folks/backend-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 569 "../folks/backend-store.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 571 "../folks/backend-store.vala"
	_tmp0_ = self->priv->_backend_hash;
#line 571 "../folks/backend-store.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, name);
#line 571 "../folks/backend-store.vala"
	result = (FolksBackend*) _tmp1_;
#line 571 "../folks/backend-store.vala"
	return result;
#line 3171 "backend-store.c"
}

/**
   * List the currently loaded backends.
   *
   * @return a list of the backends currently in the BackendStore
   */
GeeCollection*
folks_backend_store_list_backends (FolksBackendStore* self)
{
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* result;
#line 579 "../folks/backend-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 581 "../folks/backend-store.vala"
	_tmp0_ = self->priv->_backend_hash;
#line 581 "../folks/backend-store.vala"
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 581 "../folks/backend-store.vala"
	_tmp2_ = _tmp1_;
#line 581 "../folks/backend-store.vala"
	_tmp3_ = _tmp2_;
#line 581 "../folks/backend-store.vala"
	_tmp4_ = gee_collection_get_read_only_view (_tmp3_);
#line 581 "../folks/backend-store.vala"
	_tmp5_ = _tmp4_;
#line 581 "../folks/backend-store.vala"
	_tmp6_ = _tmp5_;
#line 581 "../folks/backend-store.vala"
	_g_object_unref0 (_tmp3_);
#line 581 "../folks/backend-store.vala"
	result = _tmp6_;
#line 581 "../folks/backend-store.vala"
	return result;
#line 3212 "backend-store.c"
}

static void
folks_backend_store_enable_backend_data_free (gpointer _data)
{
	FolksBackendStoreEnableBackendData* _data_;
	_data_ = _data;
#line 38 "../folks/backend-store.vala"
	_g_free0 (_data_->name);
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../folks/backend-store.vala"
	g_slice_free (FolksBackendStoreEnableBackendData, _data_);
#line 3226 "backend-store.c"
}

void
folks_backend_store_enable_backend (FolksBackendStore* self,
                                    const gchar* name,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	FolksBackendStoreEnableBackendData* _data_;
	FolksBackendStore* _tmp0_;
	gchar* _tmp1_;
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (name != NULL);
#line 38 "../folks/backend-store.vala"
	_data_ = g_slice_new0 (FolksBackendStoreEnableBackendData);
#line 38 "../folks/backend-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 38 "../folks/backend-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backend_store_enable_backend_data_free);
#line 38 "../folks/backend-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../folks/backend-store.vala"
	_data_->self = _tmp0_;
#line 38 "../folks/backend-store.vala"
	_tmp1_ = g_strdup (name);
#line 38 "../folks/backend-store.vala"
	_g_free0 (_data_->name);
#line 38 "../folks/backend-store.vala"
	_data_->name = _tmp1_;
#line 38 "../folks/backend-store.vala"
	folks_backend_store_enable_backend_co (_data_);
#line 3260 "backend-store.c"
}

void
folks_backend_store_enable_backend_finish (FolksBackendStore* self,
                                           GAsyncResult* _res_)
{
	FolksBackendStoreEnableBackendData* _data_;
#line 38 "../folks/backend-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3270 "backend-store.c"
}

/**
   * Enable a backend.
   *
   * Mark a backend as enabled, such that the BackendStore will always attempt
   * to load it when {@link BackendStore.load_backends} is called. This will
   * not load the backend if it's not currently loaded.
   *
   * This method is safe to call multiple times concurrently (e.g. an
   * asynchronous call may begin after a previous asynchronous call for the same
   * backend name has begun and before it has finished).
   *
   * If the backend is disallowed by the FOLKS_BACKENDS_ALLOWED
   * and/or FOLKS_BACKENDS_DISABLED environment variables, this method
   * will store the fact that it should be enabled in future, but will
   * not enable it during this application run.
   *
   * @param name the name of the backend to enable
   * @since 0.3.2
   */
static void
folks_backend_store_enable_backend_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	FolksBackendStoreEnableBackendData* _data_;
#line 606 "../folks/backend-store.vala"
	_data_ = _user_data_;
#line 606 "../folks/backend-store.vala"
	_data_->_source_object_ = source_object;
#line 606 "../folks/backend-store.vala"
	_data_->_res_ = _res_;
#line 606 "../folks/backend-store.vala"
	folks_backend_store_enable_backend_co (_data_);
#line 3306 "backend-store.c"
}

static gboolean
folks_backend_store_enable_backend_co (FolksBackendStoreEnableBackendData* _data_)
{
#line 603 "../folks/backend-store.vala"
	switch (_data_->_state_) {
#line 603 "../folks/backend-store.vala"
		case 0:
#line 3316 "backend-store.c"
		goto _state_0;
#line 603 "../folks/backend-store.vala"
		case 1:
#line 3320 "backend-store.c"
		goto _state_1;
		default:
#line 603 "../folks/backend-store.vala"
		g_assert_not_reached ();
#line 3325 "backend-store.c"
	}
	_state_0:
#line 605 "../folks/backend-store.vala"
	_data_->_tmp0_ = _data_->self->priv->_backends_key_file;
#line 605 "../folks/backend-store.vala"
	g_key_file_set_boolean (_data_->_tmp0_, _data_->name, "enabled", TRUE);
#line 606 "../folks/backend-store.vala"
	_data_->_state_ = 1;
#line 606 "../folks/backend-store.vala"
	_folks_backend_store_save_key_file (_data_->self, folks_backend_store_enable_backend_ready, _data_);
#line 606 "../folks/backend-store.vala"
	return FALSE;
#line 3338 "backend-store.c"
	_state_1:
#line 606 "../folks/backend-store.vala"
	_folks_backend_store_save_key_file_finish (_data_->self, _data_->_res_);
#line 603 "../folks/backend-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 603 "../folks/backend-store.vala"
	if (_data_->_state_ != 0) {
#line 603 "../folks/backend-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 603 "../folks/backend-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3350 "backend-store.c"
		}
	}
#line 603 "../folks/backend-store.vala"
	g_object_unref (_data_->_async_result);
#line 603 "../folks/backend-store.vala"
	return FALSE;
#line 3357 "backend-store.c"
}

static void
folks_backend_store_disable_backend_data_free (gpointer _data)
{
	FolksBackendStoreDisableBackendData* _data_;
	_data_ = _data;
#line 38 "../folks/backend-store.vala"
	_g_free0 (_data_->name);
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../folks/backend-store.vala"
	g_slice_free (FolksBackendStoreDisableBackendData, _data_);
#line 3371 "backend-store.c"
}

void
folks_backend_store_disable_backend (FolksBackendStore* self,
                                     const gchar* name,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	FolksBackendStoreDisableBackendData* _data_;
	FolksBackendStore* _tmp0_;
	gchar* _tmp1_;
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (name != NULL);
#line 38 "../folks/backend-store.vala"
	_data_ = g_slice_new0 (FolksBackendStoreDisableBackendData);
#line 38 "../folks/backend-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 38 "../folks/backend-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_backend_store_disable_backend_data_free);
#line 38 "../folks/backend-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../folks/backend-store.vala"
	_data_->self = _tmp0_;
#line 38 "../folks/backend-store.vala"
	_tmp1_ = g_strdup (name);
#line 38 "../folks/backend-store.vala"
	_g_free0 (_data_->name);
#line 38 "../folks/backend-store.vala"
	_data_->name = _tmp1_;
#line 38 "../folks/backend-store.vala"
	folks_backend_store_disable_backend_co (_data_);
#line 3405 "backend-store.c"
}

void
folks_backend_store_disable_backend_finish (FolksBackendStore* self,
                                            GAsyncResult* _res_)
{
	FolksBackendStoreDisableBackendData* _data_;
#line 38 "../folks/backend-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3415 "backend-store.c"
}

/**
   * Disable a backend.
   *
   * Mark a backend as disabled, such that it won't be loaded even when the
   * client application is restarted. This will not remove the backend if it's
   * already loaded.
   *
   * This method is safe to call multiple times concurrently (e.g. an
   * asynchronous call may begin after a previous asynchronous call for the same
   * backend name has begun and before it has finished).
   *
   * @param name the name of the backend to disable
   * @since 0.3.2
   */
static void
folks_backend_store_disable_backend_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	FolksBackendStoreDisableBackendData* _data_;
#line 626 "../folks/backend-store.vala"
	_data_ = _user_data_;
#line 626 "../folks/backend-store.vala"
	_data_->_source_object_ = source_object;
#line 626 "../folks/backend-store.vala"
	_data_->_res_ = _res_;
#line 626 "../folks/backend-store.vala"
	folks_backend_store_disable_backend_co (_data_);
#line 3446 "backend-store.c"
}

static gboolean
folks_backend_store_disable_backend_co (FolksBackendStoreDisableBackendData* _data_)
{
#line 623 "../folks/backend-store.vala"
	switch (_data_->_state_) {
#line 623 "../folks/backend-store.vala"
		case 0:
#line 3456 "backend-store.c"
		goto _state_0;
#line 623 "../folks/backend-store.vala"
		case 1:
#line 3460 "backend-store.c"
		goto _state_1;
		default:
#line 623 "../folks/backend-store.vala"
		g_assert_not_reached ();
#line 3465 "backend-store.c"
	}
	_state_0:
#line 625 "../folks/backend-store.vala"
	_data_->_tmp0_ = _data_->self->priv->_backends_key_file;
#line 625 "../folks/backend-store.vala"
	g_key_file_set_boolean (_data_->_tmp0_, _data_->name, "enabled", FALSE);
#line 626 "../folks/backend-store.vala"
	_data_->_state_ = 1;
#line 626 "../folks/backend-store.vala"
	_folks_backend_store_save_key_file (_data_->self, folks_backend_store_disable_backend_ready, _data_);
#line 626 "../folks/backend-store.vala"
	return FALSE;
#line 3478 "backend-store.c"
	_state_1:
#line 626 "../folks/backend-store.vala"
	_folks_backend_store_save_key_file_finish (_data_->self, _data_->_res_);
#line 623 "../folks/backend-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 623 "../folks/backend-store.vala"
	if (_data_->_state_ != 0) {
#line 623 "../folks/backend-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 623 "../folks/backend-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3490 "backend-store.c"
		}
	}
#line 623 "../folks/backend-store.vala"
	g_object_unref (_data_->_async_result);
#line 623 "../folks/backend-store.vala"
	return FALSE;
#line 3497 "backend-store.c"
}

static void
_folks_backend_store_get_modules_from_dir_data_free (gpointer _data)
{
	FolksBackendStoreGetModulesFromDirData* _data_;
	_data_ = _data;
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->dir);
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->result);
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../folks/backend-store.vala"
	g_slice_free (FolksBackendStoreGetModulesFromDirData, _data_);
#line 3513 "backend-store.c"
}

static void
_folks_backend_store_get_modules_from_dir (FolksBackendStore* self,
                                           GFile* dir,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	FolksBackendStoreGetModulesFromDirData* _data_;
	FolksBackendStore* _tmp0_;
	GFile* _tmp1_;
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (dir != NULL);
#line 38 "../folks/backend-store.vala"
	_data_ = g_slice_new0 (FolksBackendStoreGetModulesFromDirData);
#line 38 "../folks/backend-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 38 "../folks/backend-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backend_store_get_modules_from_dir_data_free);
#line 38 "../folks/backend-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../folks/backend-store.vala"
	_data_->self = _tmp0_;
#line 38 "../folks/backend-store.vala"
	_tmp1_ = _g_object_ref0 (dir);
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->dir);
#line 38 "../folks/backend-store.vala"
	_data_->dir = _tmp1_;
#line 38 "../folks/backend-store.vala"
	_folks_backend_store_get_modules_from_dir_co (_data_);
#line 3547 "backend-store.c"
}

static GeeHashMap*
_folks_backend_store_get_modules_from_dir_finish (FolksBackendStore* self,
                                                  GAsyncResult* _res_)
{
	GeeHashMap* result;
	FolksBackendStoreGetModulesFromDirData* _data_;
#line 38 "../folks/backend-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 38 "../folks/backend-store.vala"
	result = _data_->result;
#line 38 "../folks/backend-store.vala"
	_data_->result = NULL;
#line 38 "../folks/backend-store.vala"
	return result;
#line 3564 "backend-store.c"
}

static void
_folks_backend_store_get_modules_from_dir_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	FolksBackendStoreGetModulesFromDirData* _data_;
#line 644 "../folks/backend-store.vala"
	_data_ = _user_data_;
#line 644 "../folks/backend-store.vala"
	_data_->_source_object_ = source_object;
#line 644 "../folks/backend-store.vala"
	_data_->_res_ = _res_;
#line 644 "../folks/backend-store.vala"
	_folks_backend_store_get_modules_from_dir_co (_data_);
#line 3581 "backend-store.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 648 "../folks/backend-store.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 3589 "backend-store.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 648 "../folks/backend-store.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 3597 "backend-store.c"
}

static gboolean
_folks_backend_store_get_modules_from_dir_co (FolksBackendStoreGetModulesFromDirData* _data_)
{
#line 630 "../folks/backend-store.vala"
	switch (_data_->_state_) {
#line 630 "../folks/backend-store.vala"
		case 0:
#line 3607 "backend-store.c"
		goto _state_0;
#line 630 "../folks/backend-store.vala"
		case 1:
#line 3611 "backend-store.c"
		goto _state_1;
#line 630 "../folks/backend-store.vala"
		case 2:
#line 3615 "backend-store.c"
		goto _state_2;
#line 630 "../folks/backend-store.vala"
		case 3:
#line 3619 "backend-store.c"
		goto _state_3;
#line 630 "../folks/backend-store.vala"
		case 4:
#line 3623 "backend-store.c"
		goto _state_4;
		default:
#line 630 "../folks/backend-store.vala"
		g_assert_not_reached ();
#line 3628 "backend-store.c"
	}
	_state_0:
#line 632 "../folks/backend-store.vala"
	_data_->_tmp0_ = g_file_get_path (_data_->dir);
#line 632 "../folks/backend-store.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 632 "../folks/backend-store.vala"
	g_debug ("backend-store.vala:632: Searching for modules in folder '%s' ..", _data_->_tmp1_);
#line 632 "../folks/backend-store.vala"
	_g_free0 (_data_->_tmp1_);
#line 634 "../folks/backend-store.vala"
	_data_->_tmp2_ = g_strdup (G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_IS_SYMLINK "," G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE);
#line 634 "../folks/backend-store.vala"
	_data_->attributes = _data_->_tmp2_;
#line 3643 "backend-store.c"
	{
#line 644 "../folks/backend-store.vala"
		_data_->_tmp3_ = _data_->attributes;
#line 644 "../folks/backend-store.vala"
		_data_->_state_ = 1;
#line 644 "../folks/backend-store.vala"
		g_file_enumerate_children_async (_data_->dir, _data_->_tmp3_, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, _folks_backend_store_get_modules_from_dir_ready, _data_);
#line 644 "../folks/backend-store.vala"
		return FALSE;
#line 3653 "backend-store.c"
		_state_1:
#line 644 "../folks/backend-store.vala"
		_data_->_tmp4_ = g_file_enumerate_children_finish (_data_->dir, _data_->_res_, &_data_->_inner_error0_);
#line 644 "../folks/backend-store.vala"
		_data_->enumerator = _data_->_tmp4_;
#line 644 "../folks/backend-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3661 "backend-store.c"
			goto __catch0_g_error;
		}
#line 648 "../folks/backend-store.vala"
		_data_->_tmp6_ = _data_->enumerator;
#line 648 "../folks/backend-store.vala"
		_data_->_state_ = 2;
#line 648 "../folks/backend-store.vala"
		g_file_enumerator_next_files_async (_data_->_tmp6_, G_MAXINT, G_PRIORITY_DEFAULT, NULL, _folks_backend_store_get_modules_from_dir_ready, _data_);
#line 648 "../folks/backend-store.vala"
		return FALSE;
#line 3672 "backend-store.c"
		_state_2:
#line 648 "../folks/backend-store.vala"
		_data_->_tmp7_ = g_file_enumerator_next_files_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error0_);
#line 648 "../folks/backend-store.vala"
		_data_->_tmp5_ = _data_->_tmp7_;
#line 648 "../folks/backend-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 648 "../folks/backend-store.vala"
			_g_object_unref0 (_data_->enumerator);
#line 3682 "backend-store.c"
			goto __catch0_g_error;
		}
#line 648 "../folks/backend-store.vala"
		_data_->_tmp8_ = _data_->_tmp5_;
#line 648 "../folks/backend-store.vala"
		_data_->_tmp5_ = NULL;
#line 648 "../folks/backend-store.vala"
		(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 648 "../folks/backend-store.vala"
		_data_->infos = _data_->_tmp8_;
#line 642 "../folks/backend-store.vala"
		(_data_->_tmp5_ == NULL) ? NULL : (_data_->_tmp5_ = (_g_list_free__g_object_unref0_ (_data_->_tmp5_), NULL));
#line 642 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->enumerator);
#line 3697 "backend-store.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 642 "../folks/backend-store.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 642 "../folks/backend-store.vala"
		_data_->_inner_error0_ = NULL;
#line 655 "../folks/backend-store.vala"
		_data_->_tmp9_ = g_file_get_path (_data_->dir);
#line 655 "../folks/backend-store.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 655 "../folks/backend-store.vala"
		_data_->_tmp11_ = _data_->_error_;
#line 655 "../folks/backend-store.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 655 "../folks/backend-store.vala"
		g_critical (_ ("Error listing contents of folder ‘%s’: %s"), _data_->_tmp10_, _data_->_tmp12_);
#line 655 "../folks/backend-store.vala"
		_g_free0 (_data_->_tmp10_);
#line 658 "../folks/backend-store.vala"
		_data_->result = NULL;
#line 658 "../folks/backend-store.vala"
		_g_error_free0 (_data_->_error_);
#line 658 "../folks/backend-store.vala"
		(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 658 "../folks/backend-store.vala"
		_g_free0 (_data_->attributes);
#line 658 "../folks/backend-store.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 658 "../folks/backend-store.vala"
		if (_data_->_state_ != 0) {
#line 658 "../folks/backend-store.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 658 "../folks/backend-store.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3734 "backend-store.c"
			}
		}
#line 658 "../folks/backend-store.vala"
		g_object_unref (_data_->_async_result);
#line 658 "../folks/backend-store.vala"
		return FALSE;
#line 3741 "backend-store.c"
	}
	__finally0:
#line 642 "../folks/backend-store.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 642 "../folks/backend-store.vala"
		(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 642 "../folks/backend-store.vala"
		_g_free0 (_data_->attributes);
#line 642 "../folks/backend-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 642 "../folks/backend-store.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 642 "../folks/backend-store.vala"
		g_object_unref (_data_->_async_result);
#line 642 "../folks/backend-store.vala"
		return FALSE;
#line 3758 "backend-store.c"
	}
#line 661 "../folks/backend-store.vala"
	_data_->_tmp13_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 661 "../folks/backend-store.vala"
	_data_->modules_final = _data_->_tmp13_;
#line 663 "../folks/backend-store.vala"
	_data_->_tmp14_ = g_getenv ("FOLKS_BACKEND_PATH");
#line 663 "../folks/backend-store.vala"
	_data_->_tmp15_ = g_strdup (_data_->_tmp14_);
#line 663 "../folks/backend-store.vala"
	_data_->_path = _data_->_tmp15_;
#line 664 "../folks/backend-store.vala"
	_data_->_tmp16_ = _data_->infos;
#line 3772 "backend-store.c"
	{
#line 664 "../folks/backend-store.vala"
		_data_->info_collection = _data_->_tmp16_;
#line 664 "../folks/backend-store.vala"
		for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
#line 664 "../folks/backend-store.vala"
			_data_->_tmp17_ = _g_object_ref0 ((GFileInfo*) _data_->info_it->data);
#line 664 "../folks/backend-store.vala"
			_data_->info = _data_->_tmp17_;
#line 3782 "backend-store.c"
			{
#line 666 "../folks/backend-store.vala"
				_data_->_tmp18_ = _data_->info;
#line 666 "../folks/backend-store.vala"
				_data_->_tmp19_ = g_file_info_get_name (_data_->_tmp18_);
#line 666 "../folks/backend-store.vala"
				_data_->_tmp20_ = g_file_get_child (_data_->dir, _data_->_tmp19_);
#line 666 "../folks/backend-store.vala"
				_data_->file = _data_->_tmp20_;
#line 678 "../folks/backend-store.vala"
				_data_->_tmp21_ = _data_->info;
#line 678 "../folks/backend-store.vala"
				if (g_file_info_get_is_symlink (_data_->_tmp21_)) {
#line 680 "../folks/backend-store.vala"
					_data_->_tmp22_ = _data_->file;
#line 680 "../folks/backend-store.vala"
					_data_->_tmp23_ = g_file_get_path (_data_->_tmp22_);
#line 680 "../folks/backend-store.vala"
					_data_->_tmp24_ = _data_->_tmp23_;
#line 680 "../folks/backend-store.vala"
					_data_->_tmp25_ = _data_->info;
#line 680 "../folks/backend-store.vala"
					_data_->_tmp26_ = g_file_info_get_symlink_target (_data_->_tmp25_);
#line 680 "../folks/backend-store.vala"
					g_debug ("backend-store.vala:680: Handling symlink ‘%s’ to ‘%s’.", _data_->_tmp24_, _data_->_tmp26_);
#line 680 "../folks/backend-store.vala"
					_g_free0 (_data_->_tmp24_);
#line 683 "../folks/backend-store.vala"
					_data_->_tmp27_ = _data_->file;
#line 683 "../folks/backend-store.vala"
					_data_->_tmp28_ = _g_object_ref0 (_data_->_tmp27_);
#line 683 "../folks/backend-store.vala"
					_data_->old_file = _data_->_tmp28_;
#line 684 "../folks/backend-store.vala"
					_data_->_tmp29_ = _data_->info;
#line 684 "../folks/backend-store.vala"
					_data_->_tmp30_ = g_file_info_get_symlink_target (_data_->_tmp29_);
#line 684 "../folks/backend-store.vala"
					_data_->_tmp31_ = g_file_resolve_relative_path (_data_->dir, _data_->_tmp30_);
#line 684 "../folks/backend-store.vala"
					_g_object_unref0 (_data_->file);
#line 684 "../folks/backend-store.vala"
					_data_->file = _data_->_tmp31_;
#line 3826 "backend-store.c"
					{
#line 689 "../folks/backend-store.vala"
						_data_->_tmp33_ = _data_->file;
#line 689 "../folks/backend-store.vala"
						_data_->_tmp34_ = _data_->attributes;
#line 689 "../folks/backend-store.vala"
						_data_->_state_ = 3;
#line 689 "../folks/backend-store.vala"
						g_file_query_info_async (_data_->_tmp33_, _data_->_tmp34_, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, _folks_backend_store_get_modules_from_dir_ready, _data_);
#line 689 "../folks/backend-store.vala"
						return FALSE;
#line 3838 "backend-store.c"
						_state_3:
#line 689 "../folks/backend-store.vala"
						_data_->_tmp35_ = g_file_query_info_finish (_data_->_tmp33_, _data_->_res_, &_data_->_inner_error0_);
#line 689 "../folks/backend-store.vala"
						_data_->_tmp32_ = _data_->_tmp35_;
#line 689 "../folks/backend-store.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 3846 "backend-store.c"
							goto __catch1_g_error;
						}
#line 688 "../folks/backend-store.vala"
						_data_->_tmp36_ = _data_->_tmp32_;
#line 688 "../folks/backend-store.vala"
						_data_->_tmp32_ = NULL;
#line 688 "../folks/backend-store.vala"
						_g_object_unref0 (_data_->info);
#line 688 "../folks/backend-store.vala"
						_data_->info = _data_->_tmp36_;
#line 686 "../folks/backend-store.vala"
						_g_object_unref0 (_data_->_tmp32_);
#line 3859 "backend-store.c"
					}
					goto __finally1;
					__catch1_g_error:
					{
#line 686 "../folks/backend-store.vala"
						_data_->_vala1__error_ = _data_->_inner_error0_;
#line 686 "../folks/backend-store.vala"
						_data_->_inner_error0_ = NULL;
#line 696 "../folks/backend-store.vala"
						_data_->_tmp37_ = _data_->file;
#line 696 "../folks/backend-store.vala"
						_data_->_tmp38_ = g_file_get_path (_data_->_tmp37_);
#line 696 "../folks/backend-store.vala"
						_data_->_tmp39_ = _data_->_tmp38_;
#line 696 "../folks/backend-store.vala"
						_data_->_tmp40_ = _data_->old_file;
#line 696 "../folks/backend-store.vala"
						_data_->_tmp41_ = g_file_get_path (_data_->_tmp40_);
#line 696 "../folks/backend-store.vala"
						_data_->_tmp42_ = _data_->_tmp41_;
#line 696 "../folks/backend-store.vala"
						_data_->_tmp43_ = _data_->_vala1__error_;
#line 696 "../folks/backend-store.vala"
						_data_->_tmp44_ = _data_->_tmp43_->message;
#line 696 "../folks/backend-store.vala"
						g_warning (_ ("Error querying info for target ‘%s’ of symlink ‘%s’: %s"), _data_->_tmp39_, _data_->_tmp42_, _data_->_tmp44_);
#line 696 "../folks/backend-store.vala"
						_g_free0 (_data_->_tmp42_);
#line 696 "../folks/backend-store.vala"
						_g_free0 (_data_->_tmp39_);
#line 699 "../folks/backend-store.vala"
						_g_error_free0 (_data_->_vala1__error_);
#line 699 "../folks/backend-store.vala"
						_g_object_unref0 (_data_->old_file);
#line 699 "../folks/backend-store.vala"
						_g_object_unref0 (_data_->file);
#line 699 "../folks/backend-store.vala"
						_g_object_unref0 (_data_->info);
#line 699 "../folks/backend-store.vala"
						continue;
#line 3900 "backend-store.c"
					}
					__finally1:
#line 686 "../folks/backend-store.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 686 "../folks/backend-store.vala"
						_g_object_unref0 (_data_->old_file);
#line 686 "../folks/backend-store.vala"
						_g_object_unref0 (_data_->file);
#line 686 "../folks/backend-store.vala"
						_g_object_unref0 (_data_->info);
#line 686 "../folks/backend-store.vala"
						_g_free0 (_data_->_path);
#line 686 "../folks/backend-store.vala"
						_g_object_unref0 (_data_->modules_final);
#line 686 "../folks/backend-store.vala"
						(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 686 "../folks/backend-store.vala"
						_g_free0 (_data_->attributes);
#line 686 "../folks/backend-store.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 686 "../folks/backend-store.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 686 "../folks/backend-store.vala"
						g_object_unref (_data_->_async_result);
#line 686 "../folks/backend-store.vala"
						return FALSE;
#line 3927 "backend-store.c"
					}
#line 678 "../folks/backend-store.vala"
					_g_object_unref0 (_data_->old_file);
#line 3931 "backend-store.c"
				}
#line 704 "../folks/backend-store.vala"
				_data_->_tmp45_ = _data_->info;
#line 704 "../folks/backend-store.vala"
				_data_->file_type = g_file_info_get_file_type (_data_->_tmp45_);
#line 705 "../folks/backend-store.vala"
				_data_->_tmp46_ = _data_->info;
#line 705 "../folks/backend-store.vala"
				_data_->_tmp47_ = g_file_info_get_content_type (_data_->_tmp46_);
#line 705 "../folks/backend-store.vala"
				_data_->content_type = _data_->_tmp47_;
#line 707 "../folks/backend-store.vala"
				_data_->_tmp48_ = _data_->content_type;
#line 707 "../folks/backend-store.vala"
				_data_->_tmp49_ = g_content_type_get_mime_type (_data_->_tmp48_);
#line 707 "../folks/backend-store.vala"
				_data_->mime = _data_->_tmp49_;
#line 709 "../folks/backend-store.vala"
				if (_data_->file_type == G_FILE_TYPE_DIRECTORY) {
#line 711 "../folks/backend-store.vala"
					_data_->_tmp50_ = _data_->file;
#line 711 "../folks/backend-store.vala"
					_data_->_state_ = 4;
#line 711 "../folks/backend-store.vala"
					_folks_backend_store_get_modules_from_dir (_data_->self, _data_->_tmp50_, _folks_backend_store_get_modules_from_dir_ready, _data_);
#line 711 "../folks/backend-store.vala"
					return FALSE;
#line 3959 "backend-store.c"
					_state_4:
#line 711 "../folks/backend-store.vala"
					_data_->_tmp51_ = _folks_backend_store_get_modules_from_dir_finish (_data_->self, _data_->_res_);
#line 711 "../folks/backend-store.vala"
					_data_->modules = _data_->_tmp51_;
#line 712 "../folks/backend-store.vala"
					_data_->_tmp52_ = _data_->modules;
#line 712 "../folks/backend-store.vala"
					if (_data_->_tmp52_ != NULL) {
#line 3969 "backend-store.c"
						{
#line 714 "../folks/backend-store.vala"
							_data_->_tmp53_ = _data_->modules;
#line 714 "../folks/backend-store.vala"
							_data_->_tmp54_ = gee_abstract_map_get_entries ((GeeAbstractMap*) G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp53_, GEE_TYPE_HASH_MAP, GeeHashMap));
#line 714 "../folks/backend-store.vala"
							_data_->_tmp55_ = _data_->_tmp54_;
#line 714 "../folks/backend-store.vala"
							_data_->_tmp56_ = _data_->_tmp55_;
#line 714 "../folks/backend-store.vala"
							_data_->_tmp57_ = gee_iterable_iterator ((GeeIterable*) _data_->_tmp56_);
#line 714 "../folks/backend-store.vala"
							_data_->_tmp58_ = _data_->_tmp57_;
#line 714 "../folks/backend-store.vala"
							_g_object_unref0 (_data_->_tmp56_);
#line 714 "../folks/backend-store.vala"
							_data_->_entry_it = _data_->_tmp58_;
#line 714 "../folks/backend-store.vala"
							while (TRUE) {
#line 714 "../folks/backend-store.vala"
								_data_->_tmp59_ = _data_->_entry_it;
#line 714 "../folks/backend-store.vala"
								if (!gee_iterator_next (_data_->_tmp59_)) {
#line 714 "../folks/backend-store.vala"
									break;
#line 3995 "backend-store.c"
								}
#line 714 "../folks/backend-store.vala"
								_data_->_tmp60_ = _data_->_entry_it;
#line 714 "../folks/backend-store.vala"
								_data_->_tmp61_ = gee_iterator_get (_data_->_tmp60_);
#line 714 "../folks/backend-store.vala"
								_data_->entry = (GeeMapEntry*) _data_->_tmp61_;
#line 716 "../folks/backend-store.vala"
								_data_->_tmp62_ = _data_->modules_final;
#line 716 "../folks/backend-store.vala"
								_data_->_tmp63_ = _data_->entry;
#line 716 "../folks/backend-store.vala"
								_data_->_tmp64_ = gee_map_entry_get_key (_data_->_tmp63_);
#line 716 "../folks/backend-store.vala"
								_data_->_tmp65_ = _data_->_tmp64_;
#line 716 "../folks/backend-store.vala"
								_data_->_tmp66_ = _data_->entry;
#line 716 "../folks/backend-store.vala"
								_data_->_tmp67_ = gee_map_entry_get_value (_data_->_tmp66_);
#line 716 "../folks/backend-store.vala"
								_data_->_tmp68_ = _data_->_tmp67_;
#line 716 "../folks/backend-store.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp62_, (const gchar*) _data_->_tmp65_, (GFile*) _data_->_tmp68_);
#line 714 "../folks/backend-store.vala"
								_g_object_unref0 (_data_->entry);
#line 4021 "backend-store.c"
							}
#line 714 "../folks/backend-store.vala"
							_g_object_unref0 (_data_->_entry_it);
#line 4025 "backend-store.c"
						}
					}
#line 709 "../folks/backend-store.vala"
					_g_object_unref0 (_data_->modules);
#line 4030 "backend-store.c"
				} else {
#line 720 "../folks/backend-store.vala"
					_data_->_tmp69_ = _data_->mime;
#line 720 "../folks/backend-store.vala"
					if (g_strcmp0 (_data_->_tmp69_, "application/x-sharedlib") == 0) {
#line 722 "../folks/backend-store.vala"
						_data_->_tmp70_ = _data_->file;
#line 722 "../folks/backend-store.vala"
						_data_->_tmp71_ = g_file_get_path (_data_->_tmp70_);
#line 722 "../folks/backend-store.vala"
						_data_->path = _data_->_tmp71_;
#line 723 "../folks/backend-store.vala"
						_data_->_tmp72_ = _data_->path;
#line 723 "../folks/backend-store.vala"
						if (_data_->_tmp72_ != NULL) {
#line 725 "../folks/backend-store.vala"
							_data_->_tmp73_ = _data_->modules_final;
#line 725 "../folks/backend-store.vala"
							_data_->_tmp74_ = _data_->path;
#line 725 "../folks/backend-store.vala"
							_data_->_tmp75_ = _data_->file;
#line 725 "../folks/backend-store.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp73_, (const gchar*) _data_->_tmp74_, _data_->_tmp75_);
#line 4054 "backend-store.c"
						}
#line 720 "../folks/backend-store.vala"
						_g_free0 (_data_->path);
#line 4058 "backend-store.c"
					} else {
#line 728 "../folks/backend-store.vala"
						_data_->_tmp76_ = _data_->mime;
#line 728 "../folks/backend-store.vala"
						if (_data_->_tmp76_ == NULL) {
#line 730 "../folks/backend-store.vala"
							_data_->_tmp77_ = _data_->file;
#line 730 "../folks/backend-store.vala"
							_data_->_tmp78_ = g_file_get_path (_data_->_tmp77_);
#line 730 "../folks/backend-store.vala"
							_data_->_tmp79_ = _data_->_tmp78_;
#line 730 "../folks/backend-store.vala"
							g_warning ("backend-store.vala:730: The content type of '%s' could not be determin" \
"ed. Have you installed shared-mime-info?", _data_->_tmp79_);
#line 730 "../folks/backend-store.vala"
							_g_free0 (_data_->_tmp79_);
#line 4074 "backend-store.c"
						} else {
#line 738 "../folks/backend-store.vala"
							_data_->_tmp83_ = _data_->_path;
#line 738 "../folks/backend-store.vala"
							if (_data_->_tmp83_ == NULL) {
#line 739 "../folks/backend-store.vala"
								_data_->_tmp84_ = _data_->mime;
#line 739 "../folks/backend-store.vala"
								_data_->_tmp82_ = g_strcmp0 (_data_->_tmp84_, "application/x-sharedlib") != 0;
#line 4084 "backend-store.c"
							} else {
#line 738 "../folks/backend-store.vala"
								_data_->_tmp82_ = FALSE;
#line 4088 "backend-store.c"
							}
#line 738 "../folks/backend-store.vala"
							if (_data_->_tmp82_) {
#line 740 "../folks/backend-store.vala"
								_data_->_tmp85_ = _data_->mime;
#line 740 "../folks/backend-store.vala"
								_data_->_tmp81_ = g_strcmp0 (_data_->_tmp85_, "application/x-shared-library-la") != 0;
#line 4096 "backend-store.c"
							} else {
#line 738 "../folks/backend-store.vala"
								_data_->_tmp81_ = FALSE;
#line 4100 "backend-store.c"
							}
#line 738 "../folks/backend-store.vala"
							if (_data_->_tmp81_) {
#line 741 "../folks/backend-store.vala"
								_data_->_tmp86_ = _data_->mime;
#line 741 "../folks/backend-store.vala"
								_data_->_tmp80_ = g_strcmp0 (_data_->_tmp86_, "inode/directory") != 0;
#line 4108 "backend-store.c"
							} else {
#line 738 "../folks/backend-store.vala"
								_data_->_tmp80_ = FALSE;
#line 4112 "backend-store.c"
							}
#line 738 "../folks/backend-store.vala"
							if (_data_->_tmp80_) {
#line 743 "../folks/backend-store.vala"
								_data_->_tmp87_ = _data_->file;
#line 743 "../folks/backend-store.vala"
								_data_->_tmp88_ = g_file_get_path (_data_->_tmp87_);
#line 743 "../folks/backend-store.vala"
								_data_->_tmp89_ = _data_->_tmp88_;
#line 743 "../folks/backend-store.vala"
								_data_->_tmp90_ = _data_->mime;
#line 743 "../folks/backend-store.vala"
								g_warning ("backend-store.vala:743: The content type of '%s' appears to be '%s' wh" \
"ich looks suspicious. Have you installed shared-mime-info?", _data_->_tmp89_, _data_->_tmp90_);
#line 743 "../folks/backend-store.vala"
								_g_free0 (_data_->_tmp89_);
#line 4128 "backend-store.c"
							}
						}
					}
				}
#line 664 "../folks/backend-store.vala"
				_g_free0 (_data_->mime);
#line 664 "../folks/backend-store.vala"
				_g_object_unref0 (_data_->file);
#line 664 "../folks/backend-store.vala"
				_g_object_unref0 (_data_->info);
#line 4139 "backend-store.c"
			}
		}
	}
#line 747 "../folks/backend-store.vala"
	_data_->_tmp91_ = g_file_get_path (_data_->dir);
#line 747 "../folks/backend-store.vala"
	_data_->_tmp92_ = _data_->_tmp91_;
#line 747 "../folks/backend-store.vala"
	g_debug ("backend-store.vala:747: Finished searching for modules in folder '%s'", _data_->_tmp92_);
#line 747 "../folks/backend-store.vala"
	_g_free0 (_data_->_tmp92_);
#line 750 "../folks/backend-store.vala"
	_data_->result = _data_->modules_final;
#line 750 "../folks/backend-store.vala"
	_g_free0 (_data_->_path);
#line 750 "../folks/backend-store.vala"
	(_data_->infos == NULL) ? NULL : (_data_->infos = (_g_list_free__g_object_unref0_ (_data_->infos), NULL));
#line 750 "../folks/backend-store.vala"
	_g_free0 (_data_->attributes);
#line 750 "../folks/backend-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 750 "../folks/backend-store.vala"
	if (_data_->_state_ != 0) {
#line 750 "../folks/backend-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 750 "../folks/backend-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4167 "backend-store.c"
		}
	}
#line 750 "../folks/backend-store.vala"
	g_object_unref (_data_->_async_result);
#line 750 "../folks/backend-store.vala"
	return FALSE;
#line 4174 "backend-store.c"
}

static void
_folks_backend_store_load_module_from_file (FolksBackendStore* self,
                                            GFile* file)
{
	gchar* _file_path = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* file_path = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GeeHashMap* _tmp4_;
	const gchar* _tmp5_;
	GModule* _module = NULL;
	const gchar* _tmp6_;
	GModule* _tmp7_;
	GModule* _tmp8_;
	GModule* module = NULL;
	GModule* _tmp11_;
	void* function = NULL;
	GModule* _tmp12_;
	void* _tmp13_ = NULL;
	gboolean _tmp14_;
	FolksBackendStoreModuleInitFunc module_init = NULL;
	void* _tmp17_;
	FolksBackendStoreModuleInitFunc _tmp18_;
	GeeHashMap* _tmp19_;
	const gchar* _tmp20_;
	GModule* _tmp21_;
	GModule* _tmp22_;
	FolksBackendStoreModuleInitFunc _tmp23_;
	GModule* _tmp24_;
	const gchar* _tmp25_;
#line 753 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 753 "../folks/backend-store.vala"
	g_return_if_fail (file != NULL);
#line 755 "../folks/backend-store.vala"
	_tmp0_ = g_file_get_path (file);
#line 755 "../folks/backend-store.vala"
	_file_path = _tmp0_;
#line 756 "../folks/backend-store.vala"
	_tmp1_ = _file_path;
#line 756 "../folks/backend-store.vala"
	if (_tmp1_ == NULL) {
#line 758 "../folks/backend-store.vala"
		_g_free0 (_file_path);
#line 758 "../folks/backend-store.vala"
		return;
#line 4225 "backend-store.c"
	}
#line 760 "../folks/backend-store.vala"
	_tmp2_ = _file_path;
#line 760 "../folks/backend-store.vala"
	_tmp3_ = g_strdup ((const gchar*) _tmp2_);
#line 760 "../folks/backend-store.vala"
	file_path = _tmp3_;
#line 762 "../folks/backend-store.vala"
	_tmp4_ = self->priv->_modules;
#line 762 "../folks/backend-store.vala"
	_tmp5_ = file_path;
#line 762 "../folks/backend-store.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp4_, _tmp5_)) {
#line 763 "../folks/backend-store.vala"
		_g_free0 (file_path);
#line 763 "../folks/backend-store.vala"
		_g_free0 (_file_path);
#line 763 "../folks/backend-store.vala"
		return;
#line 4245 "backend-store.c"
	}
#line 765 "../folks/backend-store.vala"
	_tmp6_ = file_path;
#line 765 "../folks/backend-store.vala"
	_tmp7_ = g_module_open (_tmp6_, G_MODULE_BIND_LOCAL);
#line 765 "../folks/backend-store.vala"
	_module = _tmp7_;
#line 766 "../folks/backend-store.vala"
	_tmp8_ = _module;
#line 766 "../folks/backend-store.vala"
	if (_tmp8_ == NULL) {
#line 4257 "backend-store.c"
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 768 "../folks/backend-store.vala"
		_tmp9_ = file_path;
#line 768 "../folks/backend-store.vala"
		_tmp10_ = g_module_error ();
#line 768 "../folks/backend-store.vala"
		g_warning ("backend-store.vala:768: Failed to load module from path '%s': %s", _tmp9_, _tmp10_);
#line 771 "../folks/backend-store.vala"
		_g_module_close0 (_module);
#line 771 "../folks/backend-store.vala"
		_g_free0 (file_path);
#line 771 "../folks/backend-store.vala"
		_g_free0 (_file_path);
#line 771 "../folks/backend-store.vala"
		return;
#line 4274 "backend-store.c"
	}
#line 773 "../folks/backend-store.vala"
	_tmp11_ = _module;
#line 773 "../folks/backend-store.vala"
	module = (GModule*) _tmp11_;
#line 780 "../folks/backend-store.vala"
	_tmp12_ = module;
#line 780 "../folks/backend-store.vala"
	_tmp14_ = g_module_symbol (_tmp12_, "module_init", &_tmp13_);
#line 780 "../folks/backend-store.vala"
	function = _tmp13_;
#line 780 "../folks/backend-store.vala"
	if (!_tmp14_) {
#line 4288 "backend-store.c"
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 782 "../folks/backend-store.vala"
		_tmp15_ = file_path;
#line 782 "../folks/backend-store.vala"
		_tmp16_ = g_module_error ();
#line 782 "../folks/backend-store.vala"
		g_warning ("backend-store.vala:782: Failed to find entry point function '%s' in '%" \
"s': %s", "module_init", _tmp15_, _tmp16_);
#line 787 "../folks/backend-store.vala"
		_g_module_close0 (_module);
#line 787 "../folks/backend-store.vala"
		_g_free0 (file_path);
#line 787 "../folks/backend-store.vala"
		_g_free0 (_file_path);
#line 787 "../folks/backend-store.vala"
		return;
#line 4305 "backend-store.c"
	}
#line 790 "../folks/backend-store.vala"
	_tmp17_ = function;
#line 790 "../folks/backend-store.vala"
	module_init = (FolksBackendStoreModuleInitFunc) _tmp17_;
#line 791 "../folks/backend-store.vala"
	_tmp18_ = module_init;
#line 791 "../folks/backend-store.vala"
	_vala_assert (_tmp18_ != NULL, "module_init != null");
#line 793 "../folks/backend-store.vala"
	_tmp19_ = self->priv->_modules;
#line 793 "../folks/backend-store.vala"
	_tmp20_ = file_path;
#line 793 "../folks/backend-store.vala"
	_tmp21_ = module;
#line 793 "../folks/backend-store.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, _tmp20_, _tmp21_);
#line 796 "../folks/backend-store.vala"
	_tmp22_ = module;
#line 796 "../folks/backend-store.vala"
	g_module_make_resident (_tmp22_);
#line 798 "../folks/backend-store.vala"
	_tmp23_ = module_init;
#line 798 "../folks/backend-store.vala"
	_tmp23_ (self);
#line 800 "../folks/backend-store.vala"
	_tmp24_ = module;
#line 800 "../folks/backend-store.vala"
	_tmp25_ = g_module_name (_tmp24_);
#line 800 "../folks/backend-store.vala"
	g_debug ("backend-store.vala:800: Loaded module source: '%s'", _tmp25_);
#line 753 "../folks/backend-store.vala"
	_g_module_close0 (_module);
#line 753 "../folks/backend-store.vala"
	_g_free0 (file_path);
#line 753 "../folks/backend-store.vala"
	_g_free0 (_file_path);
#line 4343 "backend-store.c"
}

static void
_folks_backend_store_get_file_info_data_free (gpointer _data)
{
	FolksBackendStoreGetFileInfoData* _data_;
	_data_ = _data;
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->file);
#line 38 "../folks/backend-store.vala"
	g_slice_free (FolksBackendStoreGetFileInfoData, _data_);
#line 4355 "backend-store.c"
}

static void
_folks_backend_store_get_file_info (GFile* file,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	FolksBackendStoreGetFileInfoData* _data_;
	GFile* _tmp0_;
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (file != NULL);
#line 38 "../folks/backend-store.vala"
	_data_ = g_slice_new0 (FolksBackendStoreGetFileInfoData);
#line 38 "../folks/backend-store.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 38 "../folks/backend-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backend_store_get_file_info_data_free);
#line 38 "../folks/backend-store.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->file);
#line 38 "../folks/backend-store.vala"
	_data_->file = _tmp0_;
#line 38 "../folks/backend-store.vala"
	_folks_backend_store_get_file_info_co (_data_);
#line 4381 "backend-store.c"
}

static void
_folks_backend_store_get_file_info_finish (GAsyncResult* _res_,
                                           gboolean* is_file,
                                           gboolean* is_dir)
{
	FolksBackendStoreGetFileInfoData* _data_;
#line 38 "../folks/backend-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 38 "../folks/backend-store.vala"
	if (is_file) {
#line 38 "../folks/backend-store.vala"
		*is_file = _data_->is_file;
#line 4396 "backend-store.c"
	}
#line 38 "../folks/backend-store.vala"
	if (is_dir) {
#line 38 "../folks/backend-store.vala"
		*is_dir = _data_->is_dir;
#line 4402 "backend-store.c"
	}
}

static void
_folks_backend_store_get_file_info_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	FolksBackendStoreGetFileInfoData* _data_;
#line 816 "../folks/backend-store.vala"
	_data_ = _user_data_;
#line 816 "../folks/backend-store.vala"
	_data_->_source_object_ = source_object;
#line 816 "../folks/backend-store.vala"
	_data_->_res_ = _res_;
#line 816 "../folks/backend-store.vala"
	_folks_backend_store_get_file_info_co (_data_);
#line 4420 "backend-store.c"
}

static gboolean
_folks_backend_store_get_file_info_co (FolksBackendStoreGetFileInfoData* _data_)
{
#line 804 "../folks/backend-store.vala"
	switch (_data_->_state_) {
#line 804 "../folks/backend-store.vala"
		case 0:
#line 4430 "backend-store.c"
		goto _state_0;
#line 804 "../folks/backend-store.vala"
		case 1:
#line 4434 "backend-store.c"
		goto _state_1;
		default:
#line 804 "../folks/backend-store.vala"
		g_assert_not_reached ();
#line 4439 "backend-store.c"
	}
	_state_0:
#line 809 "../folks/backend-store.vala"
	_data_->is_file = FALSE;
#line 810 "../folks/backend-store.vala"
	_data_->is_dir = FALSE;
#line 4446 "backend-store.c"
	{
#line 816 "../folks/backend-store.vala"
		_data_->_state_ = 1;
#line 816 "../folks/backend-store.vala"
		g_file_query_info_async (_data_->file, G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, _folks_backend_store_get_file_info_ready, _data_);
#line 816 "../folks/backend-store.vala"
		return FALSE;
#line 4454 "backend-store.c"
		_state_1:
#line 816 "../folks/backend-store.vala"
		_data_->_tmp1_ = g_file_query_info_finish (_data_->file, _data_->_res_, &_data_->_inner_error0_);
#line 816 "../folks/backend-store.vala"
		_data_->_tmp0_ = _data_->_tmp1_;
#line 816 "../folks/backend-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 4462 "backend-store.c"
			goto __catch0_g_error;
		}
#line 816 "../folks/backend-store.vala"
		_data_->_tmp2_ = _data_->_tmp0_;
#line 816 "../folks/backend-store.vala"
		_data_->_tmp0_ = NULL;
#line 816 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->file_info);
#line 816 "../folks/backend-store.vala"
		_data_->file_info = _data_->_tmp2_;
#line 812 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 4475 "backend-store.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 812 "../folks/backend-store.vala"
		_data_->_error_ = _data_->_inner_error0_;
#line 812 "../folks/backend-store.vala"
		_data_->_inner_error0_ = NULL;
#line 821 "../folks/backend-store.vala"
		_data_->_tmp3_ = _data_->_error_;
#line 821 "../folks/backend-store.vala"
		if (g_error_matches (_data_->_tmp3_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 824 "../folks/backend-store.vala"
			_data_->_tmp4_ = g_file_get_path (_data_->file);
#line 824 "../folks/backend-store.vala"
			_data_->_tmp5_ = _data_->_tmp4_;
#line 824 "../folks/backend-store.vala"
			g_critical (_ ("File or directory ‘%s’ does not exist."), _data_->_tmp5_);
#line 824 "../folks/backend-store.vala"
			_g_free0 (_data_->_tmp5_);
#line 4496 "backend-store.c"
		} else {
#line 830 "../folks/backend-store.vala"
			_data_->_tmp6_ = g_file_get_path (_data_->file);
#line 830 "../folks/backend-store.vala"
			_data_->_tmp7_ = _data_->_tmp6_;
#line 830 "../folks/backend-store.vala"
			g_critical (_ ("Failed to get content type for ‘%s’."), _data_->_tmp7_);
#line 830 "../folks/backend-store.vala"
			_g_free0 (_data_->_tmp7_);
#line 4506 "backend-store.c"
		}
#line 834 "../folks/backend-store.vala"
		_g_error_free0 (_data_->_error_);
#line 834 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->file_info);
#line 834 "../folks/backend-store.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 834 "../folks/backend-store.vala"
		if (_data_->_state_ != 0) {
#line 834 "../folks/backend-store.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 834 "../folks/backend-store.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4520 "backend-store.c"
			}
		}
#line 834 "../folks/backend-store.vala"
		g_object_unref (_data_->_async_result);
#line 834 "../folks/backend-store.vala"
		return FALSE;
#line 4527 "backend-store.c"
	}
	__finally0:
#line 812 "../folks/backend-store.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 812 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->file_info);
#line 812 "../folks/backend-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 812 "../folks/backend-store.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 812 "../folks/backend-store.vala"
		g_object_unref (_data_->_async_result);
#line 812 "../folks/backend-store.vala"
		return FALSE;
#line 4542 "backend-store.c"
	}
#line 837 "../folks/backend-store.vala"
	_data_->_tmp8_ = _data_->file_info;
#line 837 "../folks/backend-store.vala"
	_data_->is_file = g_file_info_get_file_type (_data_->_tmp8_) == G_FILE_TYPE_REGULAR;
#line 838 "../folks/backend-store.vala"
	_data_->_tmp9_ = _data_->file_info;
#line 838 "../folks/backend-store.vala"
	_data_->is_dir = g_file_info_get_file_type (_data_->_tmp9_) == G_FILE_TYPE_DIRECTORY;
#line 804 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->file_info);
#line 804 "../folks/backend-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 804 "../folks/backend-store.vala"
	if (_data_->_state_ != 0) {
#line 804 "../folks/backend-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 804 "../folks/backend-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4562 "backend-store.c"
		}
	}
#line 804 "../folks/backend-store.vala"
	g_object_unref (_data_->_async_result);
#line 804 "../folks/backend-store.vala"
	return FALSE;
#line 4569 "backend-store.c"
}

static void
_folks_backend_store_load_disabled_backend_names_data_free (gpointer _data)
{
	FolksBackendStoreLoadDisabledBackendNamesData* _data_;
	_data_ = _data;
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../folks/backend-store.vala"
	g_slice_free (FolksBackendStoreLoadDisabledBackendNamesData, _data_);
#line 4581 "backend-store.c"
}

static void
_folks_backend_store_load_disabled_backend_names (FolksBackendStore* self,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_)
{
	FolksBackendStoreLoadDisabledBackendNamesData* _data_;
	FolksBackendStore* _tmp0_;
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 38 "../folks/backend-store.vala"
	_data_ = g_slice_new0 (FolksBackendStoreLoadDisabledBackendNamesData);
#line 38 "../folks/backend-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 38 "../folks/backend-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backend_store_load_disabled_backend_names_data_free);
#line 38 "../folks/backend-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../folks/backend-store.vala"
	_data_->self = _tmp0_;
#line 38 "../folks/backend-store.vala"
	_folks_backend_store_load_disabled_backend_names_co (_data_);
#line 4605 "backend-store.c"
}

static void
_folks_backend_store_load_disabled_backend_names_finish (FolksBackendStore* self,
                                                         GAsyncResult* _res_)
{
	FolksBackendStoreLoadDisabledBackendNamesData* _data_;
#line 38 "../folks/backend-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4615 "backend-store.c"
}

static void
_folks_backend_store_load_disabled_backend_names_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_)
{
	FolksBackendStoreLoadDisabledBackendNamesData* _data_;
#line 933 "../folks/backend-store.vala"
	_data_ = _user_data_;
#line 933 "../folks/backend-store.vala"
	_data_->_source_object_ = source_object;
#line 933 "../folks/backend-store.vala"
	_data_->_res_ = _res_;
#line 933 "../folks/backend-store.vala"
	_folks_backend_store_load_disabled_backend_names_co (_data_);
#line 4632 "backend-store.c"
}

static gboolean
_folks_backend_store_load_disabled_backend_names_co (FolksBackendStoreLoadDisabledBackendNamesData* _data_)
{
#line 842 "../folks/backend-store.vala"
	switch (_data_->_state_) {
#line 842 "../folks/backend-store.vala"
		case 0:
#line 4642 "backend-store.c"
		goto _state_0;
#line 842 "../folks/backend-store.vala"
		case 1:
#line 4646 "backend-store.c"
		goto _state_1;
		default:
#line 842 "../folks/backend-store.vala"
		g_assert_not_reached ();
#line 4651 "backend-store.c"
	}
	_state_0:
#line 851 "../folks/backend-store.vala"
	_data_->_tmp0_ = g_getenv ("FOLKS_BACKENDS_ALLOWED");
#line 851 "../folks/backend-store.vala"
	_data_->_tmp1_ = g_strdup (_data_->_tmp0_);
#line 851 "../folks/backend-store.vala"
	_data_->envvar = _data_->_tmp1_;
#line 853 "../folks/backend-store.vala"
	_data_->_tmp2_ = _data_->envvar;
#line 853 "../folks/backend-store.vala"
	if (_data_->_tmp2_ != NULL) {
#line 857 "../folks/backend-store.vala"
		_data_->_tmp3_ = _data_->envvar;
#line 857 "../folks/backend-store.vala"
		_data_->_tmp5_ = _data_->_tmp4_ = g_strsplit_set (_data_->_tmp3_, " ,:", 0);
#line 857 "../folks/backend-store.vala"
		_data_->tokens = _data_->_tmp5_;
#line 857 "../folks/backend-store.vala"
		_data_->tokens_length1 = _vala_array_length (_data_->_tmp4_);
#line 857 "../folks/backend-store.vala"
		_data_->_tokens_size_ = _data_->tokens_length1;
#line 859 "../folks/backend-store.vala"
		_data_->_tmp6_ = folks_small_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 859 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->self->priv->_backends_allowed);
#line 859 "../folks/backend-store.vala"
		_data_->self->priv->_backends_allowed = _data_->_tmp6_;
#line 861 "../folks/backend-store.vala"
		_data_->_tmp7_ = _data_->tokens;
#line 861 "../folks/backend-store.vala"
		_data_->_tmp7__length1 = _data_->tokens_length1;
#line 4684 "backend-store.c"
		{
#line 861 "../folks/backend-store.vala"
			_data_->s_collection_length1 = 0;
#line 861 "../folks/backend-store.vala"
			_data_->_s_collection_size_ = 0;
#line 861 "../folks/backend-store.vala"
			_data_->s_collection = _data_->_tmp7_;
#line 861 "../folks/backend-store.vala"
			_data_->s_collection_length1 = _data_->_tmp7__length1;
#line 861 "../folks/backend-store.vala"
			for (_data_->s_it = 0; _data_->s_it < _data_->s_collection_length1; _data_->s_it = _data_->s_it + 1) {
#line 861 "../folks/backend-store.vala"
				_data_->s = _data_->s_collection[_data_->s_it];
#line 4698 "backend-store.c"
				{
#line 863 "../folks/backend-store.vala"
					_data_->_tmp8_ = _data_->s;
#line 863 "../folks/backend-store.vala"
					if (g_strcmp0 (_data_->_tmp8_, "all") == 0) {
#line 865 "../folks/backend-store.vala"
						_g_object_unref0 (_data_->self->priv->_backends_allowed);
#line 865 "../folks/backend-store.vala"
						_data_->self->priv->_backends_allowed = NULL;
#line 866 "../folks/backend-store.vala"
						break;
#line 4710 "backend-store.c"
					}
#line 869 "../folks/backend-store.vala"
					_data_->_tmp9_ = _data_->s;
#line 869 "../folks/backend-store.vala"
					if (g_strcmp0 (_data_->_tmp9_, "") != 0) {
#line 870 "../folks/backend-store.vala"
						_data_->_tmp10_ = _data_->self->priv->_backends_allowed;
#line 870 "../folks/backend-store.vala"
						_data_->_tmp11_ = _data_->s;
#line 870 "../folks/backend-store.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp10_, _data_->_tmp11_);
#line 4722 "backend-store.c"
					}
				}
			}
		}
#line 873 "../folks/backend-store.vala"
		_data_->_tmp12_ = _data_->self->priv->_backends_allowed;
#line 873 "../folks/backend-store.vala"
		if (_data_->_tmp12_ != NULL) {
#line 875 "../folks/backend-store.vala"
			g_debug ("backend-store.vala:875: Backends limited by FOLKS_BACKENDS_ALLOWED:");
#line 877 "../folks/backend-store.vala"
			_data_->_tmp13_ = _data_->tokens;
#line 877 "../folks/backend-store.vala"
			_data_->_tmp13__length1 = _data_->tokens_length1;
#line 4737 "backend-store.c"
			{
#line 877 "../folks/backend-store.vala"
				_data_->_vala1_s_collection_length1 = 0;
#line 877 "../folks/backend-store.vala"
				_data_->__vala1_s_collection_size_ = 0;
#line 877 "../folks/backend-store.vala"
				_data_->_vala1_s_collection = _data_->_tmp13_;
#line 877 "../folks/backend-store.vala"
				_data_->_vala1_s_collection_length1 = _data_->_tmp13__length1;
#line 877 "../folks/backend-store.vala"
				for (_data_->_vala1_s_it = 0; _data_->_vala1_s_it < _data_->_vala1_s_collection_length1; _data_->_vala1_s_it = _data_->_vala1_s_it + 1) {
#line 877 "../folks/backend-store.vala"
					_data_->_vala1_s = _data_->_vala1_s_collection[_data_->_vala1_s_it];
#line 4751 "backend-store.c"
					{
#line 878 "../folks/backend-store.vala"
						_data_->_tmp14_ = _data_->_vala1_s;
#line 878 "../folks/backend-store.vala"
						g_debug ("backend-store.vala:878: Backend '%s' is allowed", _data_->_tmp14_);
#line 4757 "backend-store.c"
					}
				}
			}
#line 880 "../folks/backend-store.vala"
			g_debug ("backend-store.vala:880: All other backends disabled by FOLKS_BACKENDS_" \
"ALLOWED");
#line 4763 "backend-store.c"
		}
#line 853 "../folks/backend-store.vala"
		_data_->tokens = (_vala_array_free (_data_->tokens, _data_->tokens_length1, (GDestroyNotify) g_free), NULL);
#line 4767 "backend-store.c"
	}
#line 886 "../folks/backend-store.vala"
	_data_->_tmp15_ = g_getenv ("FOLKS_BACKENDS_DISABLED");
#line 886 "../folks/backend-store.vala"
	_data_->_tmp16_ = g_strdup (_data_->_tmp15_);
#line 886 "../folks/backend-store.vala"
	_g_free0 (_data_->envvar);
#line 886 "../folks/backend-store.vala"
	_data_->envvar = _data_->_tmp16_;
#line 888 "../folks/backend-store.vala"
	_data_->_tmp17_ = _data_->envvar;
#line 888 "../folks/backend-store.vala"
	if (_data_->_tmp17_ != NULL) {
#line 890 "../folks/backend-store.vala"
		_data_->_tmp18_ = _data_->envvar;
#line 890 "../folks/backend-store.vala"
		_data_->_tmp20_ = _data_->_tmp19_ = g_strsplit_set (_data_->_tmp18_, " ,:", 0);
#line 890 "../folks/backend-store.vala"
		_data_->_vala1_tokens = _data_->_tmp20_;
#line 890 "../folks/backend-store.vala"
		_data_->_vala1_tokens_length1 = _vala_array_length (_data_->_tmp19_);
#line 890 "../folks/backend-store.vala"
		_data_->__vala1_tokens_size_ = _data_->_vala1_tokens_length1;
#line 892 "../folks/backend-store.vala"
		_data_->_tmp21_ = folks_small_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 892 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->self->priv->_backends_disabled);
#line 892 "../folks/backend-store.vala"
		_data_->self->priv->_backends_disabled = _data_->_tmp21_;
#line 894 "../folks/backend-store.vala"
		_data_->_tmp22_ = _data_->_vala1_tokens;
#line 894 "../folks/backend-store.vala"
		_data_->_tmp22__length1 = _data_->_vala1_tokens_length1;
#line 4801 "backend-store.c"
		{
#line 894 "../folks/backend-store.vala"
			_data_->_vala2_s_collection_length1 = 0;
#line 894 "../folks/backend-store.vala"
			_data_->__vala2_s_collection_size_ = 0;
#line 894 "../folks/backend-store.vala"
			_data_->_vala2_s_collection = _data_->_tmp22_;
#line 894 "../folks/backend-store.vala"
			_data_->_vala2_s_collection_length1 = _data_->_tmp22__length1;
#line 894 "../folks/backend-store.vala"
			for (_data_->_vala2_s_it = 0; _data_->_vala2_s_it < _data_->_vala2_s_collection_length1; _data_->_vala2_s_it = _data_->_vala2_s_it + 1) {
#line 894 "../folks/backend-store.vala"
				_data_->_vala2_s = _data_->_vala2_s_collection[_data_->_vala2_s_it];
#line 4815 "backend-store.c"
				{
#line 896 "../folks/backend-store.vala"
					_data_->_tmp23_ = _data_->_vala2_s;
#line 896 "../folks/backend-store.vala"
					if (g_strcmp0 (_data_->_tmp23_, "") != 0) {
#line 898 "../folks/backend-store.vala"
						_data_->_tmp24_ = _data_->_vala2_s;
#line 898 "../folks/backend-store.vala"
						g_debug ("backend-store.vala:898: Backend '%s' disabled by FOLKS_BACKENDS_DISABL" \
"ED", _data_->_tmp24_);
#line 899 "../folks/backend-store.vala"
						_data_->_tmp25_ = _data_->self->priv->_backends_disabled;
#line 899 "../folks/backend-store.vala"
						_data_->_tmp26_ = _data_->_vala2_s;
#line 899 "../folks/backend-store.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp25_, _data_->_tmp26_);
#line 4831 "backend-store.c"
					}
				}
			}
		}
#line 888 "../folks/backend-store.vala"
		_data_->_vala1_tokens = (_vala_array_free (_data_->_vala1_tokens, _data_->_vala1_tokens_length1, (GDestroyNotify) g_free), NULL);
#line 4838 "backend-store.c"
	}
#line 905 "../folks/backend-store.vala"
	_data_->_tmp27_ = g_getenv ("FOLKS_BACKEND_STORE_KEY_FILE_PATH");
#line 905 "../folks/backend-store.vala"
	_data_->path = _data_->_tmp27_;
#line 907 "../folks/backend-store.vala"
	_data_->_tmp28_ = _data_->path;
#line 907 "../folks/backend-store.vala"
	if (_data_->_tmp28_ == NULL) {
#line 909 "../folks/backend-store.vala"
		_data_->_tmp29_ = g_get_user_data_dir ();
#line 909 "../folks/backend-store.vala"
		_data_->_tmp30_ = g_file_new_for_path (_data_->_tmp29_);
#line 909 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->file);
#line 909 "../folks/backend-store.vala"
		_data_->file = _data_->_tmp30_;
#line 910 "../folks/backend-store.vala"
		_data_->_tmp31_ = _data_->file;
#line 910 "../folks/backend-store.vala"
		_data_->_tmp32_ = g_file_get_child (_data_->_tmp31_, "folks");
#line 910 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->file);
#line 910 "../folks/backend-store.vala"
		_data_->file = _data_->_tmp32_;
#line 911 "../folks/backend-store.vala"
		_data_->_tmp33_ = _data_->file;
#line 911 "../folks/backend-store.vala"
		_data_->_tmp34_ = g_file_get_child (_data_->_tmp33_, "backends.ini");
#line 911 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->file);
#line 911 "../folks/backend-store.vala"
		_data_->file = _data_->_tmp34_;
#line 913 "../folks/backend-store.vala"
		_data_->_tmp35_ = _data_->file;
#line 913 "../folks/backend-store.vala"
		_data_->_tmp36_ = g_file_get_path (_data_->_tmp35_);
#line 913 "../folks/backend-store.vala"
		_data_->_tmp37_ = _data_->_tmp36_;
#line 913 "../folks/backend-store.vala"
		g_debug ("Using built-in backends key file '%s' (override with " "environment variable FOLKS_BACKEND_STORE_KEY_FILE_PATH)", _data_->_tmp37_);
#line 913 "../folks/backend-store.vala"
		_g_free0 (_data_->_tmp37_);
#line 4882 "backend-store.c"
	} else {
#line 919 "../folks/backend-store.vala"
		_data_->_tmp38_ = _data_->path;
#line 919 "../folks/backend-store.vala"
		_data_->_tmp39_ = g_file_new_for_path ((const gchar*) _data_->_tmp38_);
#line 919 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->file);
#line 919 "../folks/backend-store.vala"
		_data_->file = _data_->_tmp39_;
#line 920 "../folks/backend-store.vala"
		_data_->_tmp40_ = _data_->path;
#line 920 "../folks/backend-store.vala"
		g_debug ("Using environment variable " "FOLKS_BACKEND_STORE_KEY_FILE_PATH = '%s' to load the backends " "key file.", (const gchar*) _data_->_tmp40_);
#line 4896 "backend-store.c"
	}
#line 925 "../folks/backend-store.vala"
	_data_->_tmp41_ = _data_->file;
#line 925 "../folks/backend-store.vala"
	_data_->_tmp42_ = _g_object_ref0 (_data_->_tmp41_);
#line 925 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->self->priv->_config_file);
#line 925 "../folks/backend-store.vala"
	_data_->self->priv->_config_file = _data_->_tmp42_;
#line 928 "../folks/backend-store.vala"
	_data_->_tmp43_ = g_key_file_new ();
#line 928 "../folks/backend-store.vala"
	_data_->key_file = _data_->_tmp43_;
#line 4910 "backend-store.c"
	{
#line 931 "../folks/backend-store.vala"
		_data_->contents_length1 = 0;
#line 931 "../folks/backend-store.vala"
		_data_->_contents_size_ = 0;
#line 933 "../folks/backend-store.vala"
		_data_->_tmp44_ = _data_->file;
#line 933 "../folks/backend-store.vala"
		_data_->_tmp45_ = NULL;
#line 933 "../folks/backend-store.vala"
		_data_->_tmp46_ = 0;
#line 933 "../folks/backend-store.vala"
		_data_->_state_ = 1;
#line 933 "../folks/backend-store.vala"
		g_file_load_contents_async (_data_->_tmp44_, NULL, _folks_backend_store_load_disabled_backend_names_ready, _data_);
#line 933 "../folks/backend-store.vala"
		return FALSE;
#line 4928 "backend-store.c"
		_state_1:
#line 933 "../folks/backend-store.vala"
		g_file_load_contents_finish (_data_->_tmp44_, _data_->_res_, &_data_->_tmp45_, &_data_->_tmp46_, NULL, &_data_->_inner_error0_);
#line 933 "../folks/backend-store.vala"
		_data_->contents = (g_free (_data_->contents), NULL);
#line 933 "../folks/backend-store.vala"
		_data_->contents = _data_->_tmp45_;
#line 933 "../folks/backend-store.vala"
		_data_->contents_length1 = _data_->_tmp46_;
#line 933 "../folks/backend-store.vala"
		_data_->_contents_size_ = _data_->contents_length1;
#line 933 "../folks/backend-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 933 "../folks/backend-store.vala"
			_data_->contents = (g_free (_data_->contents), NULL);
#line 4944 "backend-store.c"
			goto __catch0_g_error;
		}
#line 934 "../folks/backend-store.vala"
		_data_->_tmp47_ = _data_->contents;
#line 934 "../folks/backend-store.vala"
		_data_->_tmp47__length1 = _data_->contents_length1;
#line 934 "../folks/backend-store.vala"
		_data_->contents_s = (const gchar*) _data_->_tmp47_;
#line 936 "../folks/backend-store.vala"
		_data_->_tmp48_ = _data_->contents_s;
#line 936 "../folks/backend-store.vala"
		_data_->_tmp49_ = strlen (_data_->_tmp48_);
#line 936 "../folks/backend-store.vala"
		_data_->_tmp50_ = _data_->_tmp49_;
#line 936 "../folks/backend-store.vala"
		if (_data_->_tmp50_ > 0) {
#line 938 "../folks/backend-store.vala"
			_data_->_tmp51_ = _data_->key_file;
#line 938 "../folks/backend-store.vala"
			_data_->_tmp52_ = _data_->contents_s;
#line 938 "../folks/backend-store.vala"
			_data_->_tmp53_ = _data_->contents_s;
#line 938 "../folks/backend-store.vala"
			_data_->_tmp54_ = strlen (_data_->_tmp53_);
#line 938 "../folks/backend-store.vala"
			_data_->_tmp55_ = _data_->_tmp54_;
#line 938 "../folks/backend-store.vala"
			g_key_file_load_from_data (_data_->_tmp51_, _data_->_tmp52_, (gsize) _data_->_tmp55_, G_KEY_FILE_KEEP_COMMENTS, &_data_->_inner_error0_);
#line 938 "../folks/backend-store.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 938 "../folks/backend-store.vala"
				_data_->contents = (g_free (_data_->contents), NULL);
#line 4977 "backend-store.c"
				goto __catch0_g_error;
			}
		}
#line 929 "../folks/backend-store.vala"
		_data_->contents = (g_free (_data_->contents), NULL);
#line 4983 "backend-store.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 929 "../folks/backend-store.vala"
		_data_->e1 = _data_->_inner_error0_;
#line 929 "../folks/backend-store.vala"
		_data_->_inner_error0_ = NULL;
#line 944 "../folks/backend-store.vala"
		_data_->_tmp56_ = _data_->e1;
#line 944 "../folks/backend-store.vala"
		if (!g_error_matches (_data_->_tmp56_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 946 "../folks/backend-store.vala"
			_data_->_tmp57_ = _data_->file;
#line 946 "../folks/backend-store.vala"
			_data_->_tmp58_ = g_file_get_path (_data_->_tmp57_);
#line 946 "../folks/backend-store.vala"
			_data_->_tmp59_ = _data_->_tmp58_;
#line 946 "../folks/backend-store.vala"
			_data_->_tmp60_ = _data_->e1;
#line 946 "../folks/backend-store.vala"
			_data_->_tmp61_ = _data_->_tmp60_->message;
#line 946 "../folks/backend-store.vala"
			g_warning ("backend-store.vala:946: The backends key file '%s' could not be loaded" \
": %s", _data_->_tmp59_, _data_->_tmp61_);
#line 946 "../folks/backend-store.vala"
			_g_free0 (_data_->_tmp59_);
#line 948 "../folks/backend-store.vala"
			_g_error_free0 (_data_->e1);
#line 5012 "backend-store.c"
			{
#line 955 "../folks/backend-store.vala"
				_data_->_tmp62_ = _data_->key_file;
#line 955 "../folks/backend-store.vala"
				_data_->key_file = NULL;
#line 955 "../folks/backend-store.vala"
				_g_key_file_unref0 (_data_->self->priv->_backends_key_file);
#line 955 "../folks/backend-store.vala"
				_data_->self->priv->_backends_key_file = _data_->_tmp62_;
#line 5022 "backend-store.c"
			}
#line 948 "../folks/backend-store.vala"
			_g_key_file_unref0 (_data_->key_file);
#line 948 "../folks/backend-store.vala"
			_g_object_unref0 (_data_->file);
#line 948 "../folks/backend-store.vala"
			_g_free0 (_data_->envvar);
#line 948 "../folks/backend-store.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 948 "../folks/backend-store.vala"
			if (_data_->_state_ != 0) {
#line 948 "../folks/backend-store.vala"
				while (!g_task_get_completed (_data_->_async_result)) {
#line 948 "../folks/backend-store.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5038 "backend-store.c"
				}
			}
#line 948 "../folks/backend-store.vala"
			g_object_unref (_data_->_async_result);
#line 948 "../folks/backend-store.vala"
			return FALSE;
#line 5045 "backend-store.c"
		}
#line 929 "../folks/backend-store.vala"
		_g_error_free0 (_data_->e1);
#line 5049 "backend-store.c"
	}
	__finally0:
	{
#line 955 "../folks/backend-store.vala"
		_data_->_tmp63_ = _data_->key_file;
#line 955 "../folks/backend-store.vala"
		_data_->key_file = NULL;
#line 955 "../folks/backend-store.vala"
		_g_key_file_unref0 (_data_->self->priv->_backends_key_file);
#line 955 "../folks/backend-store.vala"
		_data_->self->priv->_backends_key_file = _data_->_tmp63_;
#line 5061 "backend-store.c"
	}
#line 929 "../folks/backend-store.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 929 "../folks/backend-store.vala"
		_g_key_file_unref0 (_data_->key_file);
#line 929 "../folks/backend-store.vala"
		_g_object_unref0 (_data_->file);
#line 929 "../folks/backend-store.vala"
		_g_free0 (_data_->envvar);
#line 929 "../folks/backend-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 929 "../folks/backend-store.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 929 "../folks/backend-store.vala"
		g_object_unref (_data_->_async_result);
#line 929 "../folks/backend-store.vala"
		return FALSE;
#line 5079 "backend-store.c"
	}
#line 842 "../folks/backend-store.vala"
	_g_key_file_unref0 (_data_->key_file);
#line 842 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->file);
#line 842 "../folks/backend-store.vala"
	_g_free0 (_data_->envvar);
#line 842 "../folks/backend-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 842 "../folks/backend-store.vala"
	if (_data_->_state_ != 0) {
#line 842 "../folks/backend-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 842 "../folks/backend-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5095 "backend-store.c"
		}
	}
#line 842 "../folks/backend-store.vala"
	g_object_unref (_data_->_async_result);
#line 842 "../folks/backend-store.vala"
	return FALSE;
#line 5102 "backend-store.c"
}

static void
_folks_backend_store_save_key_file_data_free (gpointer _data)
{
	FolksBackendStoreSaveKeyFileData* _data_;
	_data_ = _data;
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (_data_->self);
#line 38 "../folks/backend-store.vala"
	g_slice_free (FolksBackendStoreSaveKeyFileData, _data_);
#line 5114 "backend-store.c"
}

static void
_folks_backend_store_save_key_file (FolksBackendStore* self,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	FolksBackendStoreSaveKeyFileData* _data_;
	FolksBackendStore* _tmp0_;
#line 38 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 38 "../folks/backend-store.vala"
	_data_ = g_slice_new0 (FolksBackendStoreSaveKeyFileData);
#line 38 "../folks/backend-store.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 38 "../folks/backend-store.vala"
	g_task_set_task_data (_data_->_async_result, _data_, _folks_backend_store_save_key_file_data_free);
#line 38 "../folks/backend-store.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 38 "../folks/backend-store.vala"
	_data_->self = _tmp0_;
#line 38 "../folks/backend-store.vala"
	_folks_backend_store_save_key_file_co (_data_);
#line 5138 "backend-store.c"
}

static void
_folks_backend_store_save_key_file_finish (FolksBackendStore* self,
                                           GAsyncResult* _res_)
{
	FolksBackendStoreSaveKeyFileData* _data_;
#line 38 "../folks/backend-store.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 5148 "backend-store.c"
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 5185 "backend-store.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 5191 "backend-store.c"
}

static void
_folks_backend_store_save_key_file_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	FolksBackendStoreSaveKeyFileData* _data_;
#line 975 "../folks/backend-store.vala"
	_data_ = _user_data_;
#line 975 "../folks/backend-store.vala"
	_data_->_source_object_ = source_object;
#line 975 "../folks/backend-store.vala"
	_data_->_res_ = _res_;
#line 975 "../folks/backend-store.vala"
	_folks_backend_store_save_key_file_co (_data_);
#line 5208 "backend-store.c"
}

static gboolean
_folks_backend_store_save_key_file_co (FolksBackendStoreSaveKeyFileData* _data_)
{
#line 960 "../folks/backend-store.vala"
	switch (_data_->_state_) {
#line 960 "../folks/backend-store.vala"
		case 0:
#line 5218 "backend-store.c"
		goto _state_0;
#line 960 "../folks/backend-store.vala"
		case 1:
#line 5222 "backend-store.c"
		goto _state_1;
		default:
#line 960 "../folks/backend-store.vala"
		g_assert_not_reached ();
#line 5227 "backend-store.c"
	}
	_state_0:
#line 962 "../folks/backend-store.vala"
	_data_->_tmp0_ = _data_->self->priv->_backends_key_file;
#line 962 "../folks/backend-store.vala"
	_data_->_tmp1_ = g_key_file_to_data (_data_->_tmp0_, NULL, NULL);
#line 962 "../folks/backend-store.vala"
	_data_->key_file_data = _data_->_tmp1_;
#line 964 "../folks/backend-store.vala"
	_data_->_tmp2_ = _data_->self->priv->_config_file;
#line 964 "../folks/backend-store.vala"
	_data_->_tmp3_ = g_file_get_path (_data_->_tmp2_);
#line 964 "../folks/backend-store.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 964 "../folks/backend-store.vala"
	g_debug ("backend-store.vala:964: Saving backend key file '%s'.", _data_->_tmp4_);
#line 964 "../folks/backend-store.vala"
	_g_free0 (_data_->_tmp4_);
#line 5246 "backend-store.c"
	{
#line 975 "../folks/backend-store.vala"
		_data_->_tmp5_ = _data_->self->priv->_config_file;
#line 975 "../folks/backend-store.vala"
		_data_->_tmp7_ = 0;
#line 975 "../folks/backend-store.vala"
		_data_->_tmp6_ = string_get_data (_data_->key_file_data, &_data_->_tmp7_);
#line 975 "../folks/backend-store.vala"
		_data_->_tmp6__length1 = _data_->_tmp7_;
#line 975 "../folks/backend-store.vala"
		_data_->_tmp8_ = _data_->_tmp6_;
#line 975 "../folks/backend-store.vala"
		_data_->_tmp8__length1 = _data_->_tmp6__length1;
#line 975 "../folks/backend-store.vala"
		_data_->_state_ = 1;
#line 975 "../folks/backend-store.vala"
		g_file_replace_contents_async (_data_->_tmp5_, (const char*) _data_->_tmp8_, (gsize) _data_->_tmp8__length1, NULL, FALSE, G_FILE_CREATE_PRIVATE, NULL, _folks_backend_store_save_key_file_ready, _data_);
#line 975 "../folks/backend-store.vala"
		return FALSE;
#line 5266 "backend-store.c"
		_state_1:
#line 975 "../folks/backend-store.vala"
		g_file_replace_contents_finish (_data_->_tmp5_, _data_->_res_, NULL, &_data_->_inner_error0_);
#line 975 "../folks/backend-store.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 5272 "backend-store.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 966 "../folks/backend-store.vala"
		_data_->e = _data_->_inner_error0_;
#line 966 "../folks/backend-store.vala"
		_data_->_inner_error0_ = NULL;
#line 981 "../folks/backend-store.vala"
		_data_->_tmp9_ = _data_->self->priv->_config_file;
#line 981 "../folks/backend-store.vala"
		_data_->_tmp10_ = g_file_get_path (_data_->_tmp9_);
#line 981 "../folks/backend-store.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 981 "../folks/backend-store.vala"
		_data_->_tmp12_ = _data_->e;
#line 981 "../folks/backend-store.vala"
		_data_->_tmp13_ = _data_->_tmp12_->message;
#line 981 "../folks/backend-store.vala"
		g_warning ("backend-store.vala:981: Could not write updated backend key file '%s':" \
" %s", _data_->_tmp11_, _data_->_tmp13_);
#line 981 "../folks/backend-store.vala"
		_g_free0 (_data_->_tmp11_);
#line 966 "../folks/backend-store.vala"
		_g_error_free0 (_data_->e);
#line 5299 "backend-store.c"
	}
	__finally0:
#line 966 "../folks/backend-store.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 966 "../folks/backend-store.vala"
		_g_free0 (_data_->key_file_data);
#line 966 "../folks/backend-store.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 966 "../folks/backend-store.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 966 "../folks/backend-store.vala"
		g_object_unref (_data_->_async_result);
#line 966 "../folks/backend-store.vala"
		return FALSE;
#line 5314 "backend-store.c"
	}
#line 960 "../folks/backend-store.vala"
	_g_free0 (_data_->key_file_data);
#line 960 "../folks/backend-store.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 960 "../folks/backend-store.vala"
	if (_data_->_state_ != 0) {
#line 960 "../folks/backend-store.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 960 "../folks/backend-store.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5326 "backend-store.c"
		}
	}
#line 960 "../folks/backend-store.vala"
	g_object_unref (_data_->_async_result);
#line 960 "../folks/backend-store.vala"
	return FALSE;
#line 5333 "backend-store.c"
}

GeeMap*
folks_backend_store_get_enabled_backends (FolksBackendStore* self)
{
	GeeMap* result;
	GeeMap* _tmp0_;
#line 100 "../folks/backend-store.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 100 "../folks/backend-store.vala"
	_tmp0_ = self->priv->_prepared_backends_ro;
#line 100 "../folks/backend-store.vala"
	result = _tmp0_;
#line 100 "../folks/backend-store.vala"
	return result;
#line 5349 "backend-store.c"
}

static void
folks_backend_store_set_enabled_backends (FolksBackendStore* self,
                                          GeeMap* value)
{
#line 102 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 102 "../folks/backend-store.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_backend_store_properties[FOLKS_BACKEND_STORE_ENABLED_BACKENDS_PROPERTY]);
#line 5360 "backend-store.c"
}

gboolean
folks_backend_store_get_is_prepared (FolksBackendStore* self)
{
	gboolean result;
#line 113 "../folks/backend-store.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 113 "../folks/backend-store.vala"
	result = self->priv->_is_prepared;
#line 113 "../folks/backend-store.vala"
	return result;
#line 5373 "backend-store.c"
}

static void
folks_backend_store_set_is_prepared (FolksBackendStore* self,
                                     gboolean value)
{
#line 115 "../folks/backend-store.vala"
	g_return_if_fail (self != NULL);
#line 115 "../folks/backend-store.vala"
	g_object_notify_by_pspec ((GObject *) self, folks_backend_store_properties[FOLKS_BACKEND_STORE_IS_PREPARED_PROPERTY]);
#line 5384 "backend-store.c"
}

static GObject *
folks_backend_store_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FolksBackendStore * self;
	gchar* debug_no_colour = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* debug_no_color = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	const gchar* _tmp11_;
	FolksDebug* _tmp12_;
	FolksDebug* _tmp13_;
	FolksDebug* _tmp14_;
	GeeHashMap* _tmp15_;
	GeeHashMap* _tmp16_;
	GeeHashMap* _tmp17_;
	GeeHashMap* _tmp18_;
	GeeMap* _tmp19_;
	GeeMap* _tmp20_;
#line 140 "../folks/backend-store.vala"
	parent_class = G_OBJECT_CLASS (folks_backend_store_parent_class);
#line 140 "../folks/backend-store.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 140 "../folks/backend-store.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_TYPE_BACKEND_STORE, FolksBackendStore);
#line 143 "../folks/backend-store.vala"
	_tmp0_ = g_getenv ("FOLKS_DEBUG_NO_COLOUR");
#line 143 "../folks/backend-store.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 143 "../folks/backend-store.vala"
	debug_no_colour = _tmp1_;
#line 144 "../folks/backend-store.vala"
	_tmp2_ = g_getenv ("FOLKS_DEBUG_NO_COLOR");
#line 144 "../folks/backend-store.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 144 "../folks/backend-store.vala"
	debug_no_color = _tmp3_;
#line 147 "../folks/backend-store.vala"
	_tmp6_ = debug_no_colour;
#line 147 "../folks/backend-store.vala"
	if (_tmp6_ == NULL) {
#line 147 "../folks/backend-store.vala"
		_tmp5_ = TRUE;
#line 5438 "backend-store.c"
	} else {
		const gchar* _tmp7_;
#line 147 "../folks/backend-store.vala"
		_tmp7_ = debug_no_colour;
#line 147 "../folks/backend-store.vala"
		_tmp5_ = g_strcmp0 (_tmp7_, "0") == 0;
#line 5445 "backend-store.c"
	}
#line 147 "../folks/backend-store.vala"
	if (_tmp5_) {
#line 5449 "backend-store.c"
		gboolean _tmp8_ = FALSE;
		const gchar* _tmp9_;
#line 148 "../folks/backend-store.vala"
		_tmp9_ = debug_no_color;
#line 148 "../folks/backend-store.vala"
		if (_tmp9_ == NULL) {
#line 148 "../folks/backend-store.vala"
			_tmp8_ = TRUE;
#line 5458 "backend-store.c"
		} else {
			const gchar* _tmp10_;
#line 148 "../folks/backend-store.vala"
			_tmp10_ = debug_no_color;
#line 148 "../folks/backend-store.vala"
			_tmp8_ = g_strcmp0 (_tmp10_, "0") == 0;
#line 5465 "backend-store.c"
		}
#line 148 "../folks/backend-store.vala"
		_tmp4_ = _tmp8_;
#line 5469 "backend-store.c"
	} else {
#line 147 "../folks/backend-store.vala"
		_tmp4_ = FALSE;
#line 5473 "backend-store.c"
	}
#line 145 "../folks/backend-store.vala"
	_tmp11_ = g_getenv ("G_MESSAGES_DEBUG");
#line 145 "../folks/backend-store.vala"
	_tmp12_ = folks_debug_dup_with_flags (_tmp11_, _tmp4_);
#line 145 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_debug);
#line 145 "../folks/backend-store.vala"
	self->priv->_debug = _tmp12_;
#line 151 "../folks/backend-store.vala"
	_tmp13_ = self->priv->_debug;
#line 151 "../folks/backend-store.vala"
	_folks_debug_register_domain (_tmp13_, G_LOG_DOMAIN);
#line 153 "../folks/backend-store.vala"
	_tmp14_ = self->priv->_debug;
#line 153 "../folks/backend-store.vala"
	g_signal_connect_object (_tmp14_, "print-status", (GCallback) __folks_backend_store_debug_print_status_folks_debug_print_status, self, 0);
#line 155 "../folks/backend-store.vala"
	_tmp15_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_POINTER, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 155 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_modules);
#line 155 "../folks/backend-store.vala"
	self->priv->_modules = _tmp15_;
#line 156 "../folks/backend-store.vala"
	_tmp16_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_TYPE_BACKEND, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 156 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_backend_hash);
#line 156 "../folks/backend-store.vala"
	self->priv->_backend_hash = _tmp16_;
#line 157 "../folks/backend-store.vala"
	_tmp17_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_TYPE_BACKEND, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 157 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_prepared_backends);
#line 157 "../folks/backend-store.vala"
	self->priv->_prepared_backends = _tmp17_;
#line 158 "../folks/backend-store.vala"
	_tmp18_ = self->priv->_prepared_backends;
#line 158 "../folks/backend-store.vala"
	_tmp19_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp18_);
#line 158 "../folks/backend-store.vala"
	_tmp20_ = _tmp19_;
#line 158 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_prepared_backends_ro);
#line 158 "../folks/backend-store.vala"
	self->priv->_prepared_backends_ro = _tmp20_;
#line 140 "../folks/backend-store.vala"
	_g_free0 (debug_no_color);
#line 140 "../folks/backend-store.vala"
	_g_free0 (debug_no_colour);
#line 140 "../folks/backend-store.vala"
	return obj;
#line 5525 "backend-store.c"
}

static void
folks_backend_store_class_init (FolksBackendStoreClass * klass,
                                gpointer klass_data)
{
	gchar* _tmp0_;
#line 38 "../folks/backend-store.vala"
	folks_backend_store_parent_class = g_type_class_peek_parent (klass);
#line 38 "../folks/backend-store.vala"
	g_type_class_adjust_private_offset (klass, &FolksBackendStore_private_offset);
#line 38 "../folks/backend-store.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folks_backend_store_get_property;
#line 38 "../folks/backend-store.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_folks_backend_store_set_property;
#line 38 "../folks/backend-store.vala"
	G_OBJECT_CLASS (klass)->constructor = folks_backend_store_constructor;
#line 38 "../folks/backend-store.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_backend_store_finalize;
#line 5545 "backend-store.c"
	/**
	   * The list of backends visible to this store which have not been explicitly
	   * disabled.
	   *
	   * This list will be empty before {@link BackendStore.load_backends} has been
	   * called.
	   *
	   * The backends in this list have been prepared and are ready to use.
	   *
	   * @since 0.5.1
	   */
#line 38 "../folks/backend-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKEND_STORE_ENABLED_BACKENDS_PROPERTY, folks_backend_store_properties[FOLKS_BACKEND_STORE_ENABLED_BACKENDS_PROPERTY] = g_param_spec_object ("enabled-backends", "enabled-backends", "enabled-backends", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5559 "backend-store.c"
	/**
	   * Whether {@link BackendStore.prepare} has successfully completed for this
	   * store.
	   *
	   * @since 0.3.0
	   */
#line 38 "../folks/backend-store.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_BACKEND_STORE_IS_PREPARED_PROPERTY, folks_backend_store_properties[FOLKS_BACKEND_STORE_IS_PREPARED_PROPERTY] = g_param_spec_boolean ("is-prepared", "is-prepared", "is-prepared", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 5568 "backend-store.c"
	/**
	   * Emitted when a backend has been added to the BackendStore.
	   *
	   * This will not be emitted until after {@link BackendStore.load_backends}
	   * has been called.
	   *
	   * {@link Backend}s referenced in this signal are also included in
	   * {@link BackendStore.enabled_backends}.
	   *
	   * @param backend the new {@link Backend}
	   */
#line 38 "../folks/backend-store.vala"
	folks_backend_store_signals[FOLKS_BACKEND_STORE_BACKEND_AVAILABLE_SIGNAL] = g_signal_new ("backend-available", FOLKS_TYPE_BACKEND_STORE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, FOLKS_TYPE_BACKEND);
#line 71 "../folks/backend-store.vala"
	_tmp0_ = g_strdup ("all-others");
#line 71 "../folks/backend-store.vala"
	folks_backend_store_KEY_FILE_GROUP_ALL_OTHERS = _tmp0_;
#line 5586 "backend-store.c"
}

static void
folks_backend_store_instance_init (FolksBackendStore * self,
                                   gpointer klass)
{
#line 38 "../folks/backend-store.vala"
	self->priv = folks_backend_store_get_instance_private (self);
#line 56 "../folks/backend-store.vala"
	self->priv->_is_prepared = FALSE;
#line 5597 "backend-store.c"
}

static void
folks_backend_store_finalize (GObject * obj)
{
	FolksBackendStore * self;
	GeeMapIterator* iter = NULL;
	GeeHashMap* _tmp0_;
	GeeMapIterator* _tmp1_;
	GeeHashMap* _tmp6_;
	GeeHashMap* _tmp21_;
	FolksDebug* _tmp22_;
	guint _tmp23_;
#line 38 "../folks/backend-store.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_TYPE_BACKEND_STORE, FolksBackendStore);
#line 164 "../folks/backend-store.vala"
	_tmp0_ = self->priv->_prepared_backends;
#line 164 "../folks/backend-store.vala"
	_tmp1_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp0_);
#line 164 "../folks/backend-store.vala"
	iter = _tmp1_;
#line 165 "../folks/backend-store.vala"
	while (TRUE) {
#line 5621 "backend-store.c"
		GeeMapIterator* _tmp2_;
		FolksBackend* backend = NULL;
		GeeMapIterator* _tmp3_;
		gpointer _tmp4_;
		FolksBackend* _tmp5_;
#line 165 "../folks/backend-store.vala"
		_tmp2_ = iter;
#line 165 "../folks/backend-store.vala"
		if (!(gee_map_iterator_next (_tmp2_) == TRUE)) {
#line 165 "../folks/backend-store.vala"
			break;
#line 5633 "backend-store.c"
		}
#line 167 "../folks/backend-store.vala"
		_tmp3_ = iter;
#line 167 "../folks/backend-store.vala"
		_tmp4_ = gee_map_iterator_get_value (_tmp3_);
#line 167 "../folks/backend-store.vala"
		backend = (FolksBackend*) _tmp4_;
#line 168 "../folks/backend-store.vala"
		_tmp5_ = backend;
#line 168 "../folks/backend-store.vala"
		folks_backend_unprepare (_tmp5_, NULL, NULL);
#line 165 "../folks/backend-store.vala"
		_g_object_unref0 (backend);
#line 5647 "backend-store.c"
	}
#line 171 "../folks/backend-store.vala"
	_tmp6_ = self->priv->_prepared_backends;
#line 171 "../folks/backend-store.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp6_);
#line 5653 "backend-store.c"
	{
		GeeIterator* _module_it = NULL;
		GeeHashMap* _tmp7_;
		GeeCollection* _tmp8_;
		GeeCollection* _tmp9_;
		GeeCollection* _tmp10_;
		GeeIterator* _tmp11_;
		GeeIterator* _tmp12_;
#line 174 "../folks/backend-store.vala"
		_tmp7_ = self->priv->_modules;
#line 174 "../folks/backend-store.vala"
		_tmp8_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp7_);
#line 174 "../folks/backend-store.vala"
		_tmp9_ = _tmp8_;
#line 174 "../folks/backend-store.vala"
		_tmp10_ = _tmp9_;
#line 174 "../folks/backend-store.vala"
		_tmp11_ = gee_iterable_iterator ((GeeIterable*) _tmp10_);
#line 174 "../folks/backend-store.vala"
		_tmp12_ = _tmp11_;
#line 174 "../folks/backend-store.vala"
		_g_object_unref0 (_tmp10_);
#line 174 "../folks/backend-store.vala"
		_module_it = _tmp12_;
#line 174 "../folks/backend-store.vala"
		while (TRUE) {
#line 5680 "backend-store.c"
			GeeIterator* _tmp13_;
			GModule* module = NULL;
			GeeIterator* _tmp14_;
			gpointer _tmp15_;
			void* func = NULL;
			GModule* _tmp16_;
			void* _tmp17_ = NULL;
			gboolean _tmp18_;
#line 174 "../folks/backend-store.vala"
			_tmp13_ = _module_it;
#line 174 "../folks/backend-store.vala"
			if (!gee_iterator_next (_tmp13_)) {
#line 174 "../folks/backend-store.vala"
				break;
#line 5695 "backend-store.c"
			}
#line 174 "../folks/backend-store.vala"
			_tmp14_ = _module_it;
#line 174 "../folks/backend-store.vala"
			_tmp15_ = gee_iterator_get (_tmp14_);
#line 174 "../folks/backend-store.vala"
			module = (GModule*) _tmp15_;
#line 177 "../folks/backend-store.vala"
			_tmp16_ = module;
#line 177 "../folks/backend-store.vala"
			_tmp18_ = g_module_symbol (_tmp16_, "module_finalize", &_tmp17_);
#line 177 "../folks/backend-store.vala"
			func = _tmp17_;
#line 177 "../folks/backend-store.vala"
			if (_tmp18_) {
#line 5711 "backend-store.c"
				FolksBackendStoreModuleFinalizeFunc module_finalize = NULL;
				void* _tmp19_;
				FolksBackendStoreModuleFinalizeFunc _tmp20_;
#line 179 "../folks/backend-store.vala"
				_tmp19_ = func;
#line 179 "../folks/backend-store.vala"
				module_finalize = (FolksBackendStoreModuleFinalizeFunc) _tmp19_;
#line 180 "../folks/backend-store.vala"
				_tmp20_ = module_finalize;
#line 180 "../folks/backend-store.vala"
				_tmp20_ (self);
#line 5723 "backend-store.c"
			}
		}
#line 174 "../folks/backend-store.vala"
		_g_object_unref0 (_module_it);
#line 5728 "backend-store.c"
	}
#line 184 "../folks/backend-store.vala"
	_tmp21_ = self->priv->_modules;
#line 184 "../folks/backend-store.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp21_);
#line 187 "../folks/backend-store.vala"
	_tmp22_ = self->priv->_debug;
#line 187 "../folks/backend-store.vala"
	g_signal_parse_name ("print-status", FOLKS_TYPE_DEBUG, &_tmp23_, NULL, FALSE);
#line 187 "../folks/backend-store.vala"
	g_signal_handlers_disconnect_matched (_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) __folks_backend_store_debug_print_status_folks_debug_print_status, self);
#line 190 "../folks/backend-store.vala"
	folks_backend_store__instance = NULL;
#line 38 "../folks/backend-store.vala"
	_g_object_unref0 (iter);
#line 45 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_backend_hash);
#line 47 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_backends_allowed);
#line 49 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_backends_disabled);
#line 50 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_prepared_backends);
#line 51 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_prepared_backends_ro);
#line 52 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_config_file);
#line 53 "../folks/backend-store.vala"
	_g_key_file_unref0 (self->priv->_backends_key_file);
#line 54 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_modules);
#line 57 "../folks/backend-store.vala"
	_g_object_unref0 (self->priv->_debug);
#line 38 "../folks/backend-store.vala"
	G_OBJECT_CLASS (folks_backend_store_parent_class)->finalize (obj);
#line 5764 "backend-store.c"
}

/**
 * Responsible for backend loading.
 *
 * The BackendStore manages the set of available Folks backends. The
 * {@link BackendStore.load_backends} function loads all compatible and enabled
 * backends and the {@link BackendStore.backend_available} signal notifies when
 * these backends are ready.
 */
static GType
folks_backend_store_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksBackendStoreClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_backend_store_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksBackendStore), 0, (GInstanceInitFunc) folks_backend_store_instance_init, NULL };
	GType folks_backend_store_type_id;
	folks_backend_store_type_id = g_type_register_static (G_TYPE_OBJECT, "FolksBackendStore", &g_define_type_info, 0);
	FolksBackendStore_private_offset = g_type_add_instance_private (folks_backend_store_type_id, sizeof (FolksBackendStorePrivate));
	return folks_backend_store_type_id;
}

GType
folks_backend_store_get_type (void)
{
	static volatile gsize folks_backend_store_type_id__once = 0;
	if (g_once_init_enter (&folks_backend_store_type_id__once)) {
		GType folks_backend_store_type_id;
		folks_backend_store_type_id = folks_backend_store_get_type_once ();
		g_once_init_leave (&folks_backend_store_type_id__once, folks_backend_store_type_id);
	}
	return folks_backend_store_type_id__once;
}

static void
_vala_folks_backend_store_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	FolksBackendStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_BACKEND_STORE, FolksBackendStore);
#line 38 "../folks/backend-store.vala"
	switch (property_id) {
#line 38 "../folks/backend-store.vala"
		case FOLKS_BACKEND_STORE_ENABLED_BACKENDS_PROPERTY:
#line 38 "../folks/backend-store.vala"
		g_value_set_object (value, folks_backend_store_get_enabled_backends (self));
#line 38 "../folks/backend-store.vala"
		break;
#line 38 "../folks/backend-store.vala"
		case FOLKS_BACKEND_STORE_IS_PREPARED_PROPERTY:
#line 38 "../folks/backend-store.vala"
		g_value_set_boolean (value, folks_backend_store_get_is_prepared (self));
#line 38 "../folks/backend-store.vala"
		break;
#line 5819 "backend-store.c"
		default:
#line 38 "../folks/backend-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "../folks/backend-store.vala"
		break;
#line 5825 "backend-store.c"
	}
}

static void
_vala_folks_backend_store_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	FolksBackendStore * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_TYPE_BACKEND_STORE, FolksBackendStore);
#line 38 "../folks/backend-store.vala"
	switch (property_id) {
#line 38 "../folks/backend-store.vala"
		case FOLKS_BACKEND_STORE_ENABLED_BACKENDS_PROPERTY:
#line 38 "../folks/backend-store.vala"
		folks_backend_store_set_enabled_backends (self, g_value_get_object (value));
#line 38 "../folks/backend-store.vala"
		break;
#line 38 "../folks/backend-store.vala"
		case FOLKS_BACKEND_STORE_IS_PREPARED_PROPERTY:
#line 38 "../folks/backend-store.vala"
		folks_backend_store_set_is_prepared (self, g_value_get_boolean (value));
#line 38 "../folks/backend-store.vala"
		break;
#line 5851 "backend-store.c"
		default:
#line 38 "../folks/backend-store.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "../folks/backend-store.vala"
		break;
#line 5857 "backend-store.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

